!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:46             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 169

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(533)
  integer, parameter :: nGC_4331 = 1
  integer, parameter :: nGC_4332 = 2
  integer, parameter :: nGC_4333 = 3
  integer, parameter :: nGC_4334 = 4
  integer, parameter :: nGC_28 = 5
  integer, parameter :: nGC_29 = 6
  integer, parameter :: nGC_22 = 7
  integer, parameter :: nGC_23 = 8
  integer, parameter :: nGC_20 = 9
  integer, parameter :: nGC_21 = 10
  integer, parameter :: nGC_26 = 11
  integer, parameter :: nGC_27 = 12
  integer, parameter :: nGC_24 = 13
  integer, parameter :: nGC_25 = 14
  integer, parameter :: nGC_153 = 15
  integer, parameter :: nGC_152 = 16
  integer, parameter :: nGC_151 = 17
  integer, parameter :: nGC_150 = 18
  integer, parameter :: nGC_157 = 19
  integer, parameter :: nGC_156 = 20
  integer, parameter :: nGC_159 = 21
  integer, parameter :: nGC_158 = 22
  integer, parameter :: nGC_126 = 23
  integer, parameter :: nGC_127 = 24
  integer, parameter :: nGC_124 = 25
  integer, parameter :: nGC_125 = 26
  integer, parameter :: nGC_122 = 27
  integer, parameter :: nGC_123 = 28
  integer, parameter :: nGC_120 = 29
  integer, parameter :: nGC_121 = 30
  integer, parameter :: nGC_128 = 31
  integer, parameter :: nGC_129 = 32
  integer, parameter :: nGC_71 = 33
  integer, parameter :: nGC_4288 = 34
  integer, parameter :: nGC_4289 = 35
  integer, parameter :: nGC_4285 = 36
  integer, parameter :: nGC_4286 = 37
  integer, parameter :: nGC_4287 = 38
  integer, parameter :: nGC_4283 = 39
  integer, parameter :: nGC_3 = 40
  integer, parameter :: nGC_2 = 41
  integer, parameter :: nGC_1 = 42
  integer, parameter :: nGC_7 = 43
  integer, parameter :: nGC_6 = 44
  integer, parameter :: nGC_5 = 45
  integer, parameter :: nGC_4 = 46
  integer, parameter :: nGC_9 = 47
  integer, parameter :: nGC_8 = 48
  integer, parameter :: nGC_53 = 49
  integer, parameter :: nGC_52 = 50
  integer, parameter :: nGC_51 = 51
  integer, parameter :: nGC_50 = 52
  integer, parameter :: nGC_57 = 53
  integer, parameter :: nGC_56 = 54
  integer, parameter :: nGC_55 = 55
  integer, parameter :: nGC_54 = 56
  integer, parameter :: nGC_59 = 57
  integer, parameter :: nGC_58 = 58
  integer, parameter :: nGC_169 = 59
  integer, parameter :: nGC_160 = 60
  integer, parameter :: nGC_2895 = 61
  integer, parameter :: nGC_4301 = 62
  integer, parameter :: nGC_4303 = 63
  integer, parameter :: nGC_4302 = 64
  integer, parameter :: nGC_17 = 65
  integer, parameter :: nGC_16 = 66
  integer, parameter :: nGC_15 = 67
  integer, parameter :: nGC_14 = 68
  integer, parameter :: nGC_13 = 69
  integer, parameter :: nGC_12 = 70
  integer, parameter :: nGC_11 = 71
  integer, parameter :: nGC_10 = 72
  integer, parameter :: nGC_19 = 73
  integer, parameter :: nGC_18 = 74
  integer, parameter :: nGC_4089 = 75
  integer, parameter :: nGC_4086 = 76
  integer, parameter :: nGC_4087 = 77
  integer, parameter :: nGC_4084 = 78
  integer, parameter :: nGC_4085 = 79
  integer, parameter :: nGC_4083 = 80
  integer, parameter :: nGC_135 = 81
  integer, parameter :: nGC_134 = 82
  integer, parameter :: nGC_137 = 83
  integer, parameter :: nGC_136 = 84
  integer, parameter :: nGC_647 = 85
  integer, parameter :: nGC_130 = 86
  integer, parameter :: nGC_133 = 87
  integer, parameter :: nGC_132 = 88
  integer, parameter :: nGC_2295 = 89
  integer, parameter :: nGC_139 = 90
  integer, parameter :: nGC_138 = 91
  integer, parameter :: nGC_2293 = 92
  integer, parameter :: nGC_6487 = 93
  integer, parameter :: nGC_6489 = 94
  integer, parameter :: nGC_1515 = 95
  integer, parameter :: nGC_4355 = 96
  integer, parameter :: nGC_2977 = 97
  integer, parameter :: nGC_6141 = 98
  integer, parameter :: nGC_6140 = 99
  integer, parameter :: nGC_6145 = 100
  integer, parameter :: nGC_6144 = 101
  integer, parameter :: nGC_6146 = 102
  integer, parameter :: nGC_6148 = 103
  integer, parameter :: nGC_6310 = 104
  integer, parameter :: nGC_6313 = 105
  integer, parameter :: nGC_6231 = 106
  integer, parameter :: nGC_6367 = 107
  integer, parameter :: nGC_2121 = 108
  integer, parameter :: nGC_48 = 109
  integer, parameter :: nGC_49 = 110
  integer, parameter :: nGC_44 = 111
  integer, parameter :: nGC_45 = 112
  integer, parameter :: nGC_46 = 113
  integer, parameter :: nGC_47 = 114
  integer, parameter :: nGC_40 = 115
  integer, parameter :: nGC_41 = 116
  integer, parameter :: nGC_42 = 117
  integer, parameter :: nGC_43 = 118
  integer, parameter :: nGC_681 = 119
  integer, parameter :: nGC_131 = 120
  integer, parameter :: nGC_4319 = 121
  integer, parameter :: nGC_827 = 122
  integer, parameter :: nGC_4317 = 123
  integer, parameter :: nGC_2429 = 124
  integer, parameter :: nGC_2427 = 125
  integer, parameter :: nGC_6103 = 126
  integer, parameter :: nGC_6119 = 127
  integer, parameter :: nGC_4168 = 128
  integer, parameter :: nGC_4165 = 129
  integer, parameter :: nGC_4164 = 130
  integer, parameter :: nGC_4167 = 131
  integer, parameter :: nGC_4166 = 132
  integer, parameter :: nGC_4163 = 133
  integer, parameter :: nGC_4369 = 134
  integer, parameter :: nGC_4368 = 135
  integer, parameter :: nGC_4367 = 136
  integer, parameter :: nGC_4366 = 137
  integer, parameter :: nGC_4365 = 138
  integer, parameter :: nGC_4364 = 139
  integer, parameter :: nGC_851 = 140
  integer, parameter :: nGC_1305 = 141
  integer, parameter :: nGC_1303 = 142
  integer, parameter :: nGC_6211 = 143
  integer, parameter :: nGC_6212 = 144
  integer, parameter :: nGC_6215 = 145
  integer, parameter :: nGC_6214 = 146
  integer, parameter :: nGC_6217 = 147
  integer, parameter :: nGC_6218 = 148
  integer, parameter :: nGC_6353 = 149
  integer, parameter :: nGC_6354 = 150
  integer, parameter :: nGC_4091 = 151
  integer, parameter :: nGC_4090 = 152
  integer, parameter :: nGC_4093 = 153
  integer, parameter :: nGC_4092 = 154
  integer, parameter :: nGC_4095 = 155
  integer, parameter :: nGC_4094 = 156
  integer, parameter :: nGC_155 = 157
  integer, parameter :: nGC_154 = 158
  integer, parameter :: nGC_99 = 159
  integer, parameter :: nGC_98 = 160
  integer, parameter :: nGC_97 = 161
  integer, parameter :: nGC_96 = 162
  integer, parameter :: nGC_95 = 163
  integer, parameter :: nGC_94 = 164
  integer, parameter :: nGC_93 = 165
  integer, parameter :: nGC_92 = 166
  integer, parameter :: nGC_91 = 167
  integer, parameter :: nGC_90 = 168
  integer, parameter :: nGC_1603 = 169
  integer, parameter :: nGC_75 = 170
  integer, parameter :: nGC_74 = 171
  integer, parameter :: nGC_77 = 172
  integer, parameter :: nGC_76 = 173
  integer, parameter :: nGC_6079 = 174
  integer, parameter :: nGC_70 = 175
  integer, parameter :: nGC_73 = 176
  integer, parameter :: nGC_72 = 177
  integer, parameter :: nGC_79 = 178
  integer, parameter :: nGC_78 = 179
  integer, parameter :: nGC_4185 = 180
  integer, parameter :: nGC_4184 = 181
  integer, parameter :: nGC_6676 = 182
  integer, parameter :: nGC_6675 = 183
  integer, parameter :: nGC_100 = 184
  integer, parameter :: nGC_101 = 185
  integer, parameter :: nGC_102 = 186
  integer, parameter :: nGC_103 = 187
  integer, parameter :: nGC_104 = 188
  integer, parameter :: nGC_105 = 189
  integer, parameter :: nGC_106 = 190
  integer, parameter :: nGC_107 = 191
  integer, parameter :: nGC_108 = 192
  integer, parameter :: nGC_109 = 193
  integer, parameter :: nGC_2267 = 194
  integer, parameter :: nGC_1503 = 195
  integer, parameter :: nGC_1505 = 196
  integer, parameter :: nGC_4323 = 197
  integer, parameter :: nGC_4321 = 198
  integer, parameter :: nGC_4320 = 199
  integer, parameter :: nGC_4327 = 200
  integer, parameter :: nGC_4325 = 201
  integer, parameter :: nGC_4324 = 202
  integer, parameter :: nGC_4329 = 203
  integer, parameter :: nGC_4328 = 204
  integer, parameter :: nGC_1187 = 205
  integer, parameter :: nGC_6158 = 206
  integer, parameter :: nGC_6159 = 207
  integer, parameter :: nGC_4138 = 208
  integer, parameter :: nGC_4139 = 209
  integer, parameter :: nGC_923 = 210
  integer, parameter :: nGC_6325 = 211
  integer, parameter :: nGC_39 = 212
  integer, parameter :: nGC_38 = 213
  integer, parameter :: nGC_31 = 214
  integer, parameter :: nGC_30 = 215
  integer, parameter :: nGC_33 = 216
  integer, parameter :: nGC_32 = 217
  integer, parameter :: nGC_35 = 218
  integer, parameter :: nGC_34 = 219
  integer, parameter :: nGC_37 = 220
  integer, parameter :: nGC_36 = 221
  integer, parameter :: nGC_144 = 222
  integer, parameter :: nGC_145 = 223
  integer, parameter :: nGC_146 = 224
  integer, parameter :: nGC_147 = 225
  integer, parameter :: nGC_140 = 226
  integer, parameter :: nGC_141 = 227
  integer, parameter :: nGC_142 = 228
  integer, parameter :: nGC_143 = 229
  integer, parameter :: nGC_148 = 230
  integer, parameter :: nGC_149 = 231
  integer, parameter :: nGC_6184 = 232
  integer, parameter :: nGC_6181 = 233
  integer, parameter :: nGC_781 = 234
  integer, parameter :: nGC_MI = 235
  integer, parameter :: nGC_MC = 236
  integer, parameter :: nGC_MB = 237
  integer, parameter :: nGC_61 = 238
  integer, parameter :: nGC_MD = 239
  integer, parameter :: nGC_MS = 240
  integer, parameter :: nGC_MU = 241
  integer, parameter :: nGC_MT = 242
  integer, parameter :: nGC_6112 = 243
  integer, parameter :: nGC_6298 = 244
  integer, parameter :: nGC_6110 = 245
  integer, parameter :: nGC_6111 = 246
  integer, parameter :: nGC_6290 = 247
  integer, parameter :: nGC_6292 = 248
  integer, parameter :: nGC_6297 = 249
  integer, parameter :: nGC_4172 = 250
  integer, parameter :: nGC_4173 = 251
  integer, parameter :: nGC_4176 = 252
  integer, parameter :: nGC_4177 = 253
  integer, parameter :: nGC_4174 = 254
  integer, parameter :: nGC_4175 = 255
  integer, parameter :: nGC_6366 = 256
  integer, parameter :: nGC_327 = 257
  integer, parameter :: nGC_249 = 258
  integer, parameter :: nGC_6165 = 259
  integer, parameter :: nGC_4299 = 260
  integer, parameter :: nGC_4297 = 261
  integer, parameter :: nGC_4295 = 262
  integer, parameter :: nGC_4293 = 263
  integer, parameter :: nGC_4292 = 264
  integer, parameter :: nGC_4291 = 265
  integer, parameter :: nGC_4290 = 266
  integer, parameter :: nGC_4109 = 267
  integer, parameter :: nGC_4108 = 268
  integer, parameter :: nGC_4107 = 269
  integer, parameter :: nGC_4106 = 270
  integer, parameter :: nGC_4105 = 271
  integer, parameter :: nGC_4104 = 272
  integer, parameter :: nGC_4103 = 273
  integer, parameter :: nGC_4102 = 274
  integer, parameter :: nGC_4101 = 275
  integer, parameter :: nGC_4100 = 276
  integer, parameter :: nGC_189 = 277
  integer, parameter :: nGC_1203 = 278
  integer, parameter :: nGC_88 = 279
  integer, parameter :: nGC_89 = 280
  integer, parameter :: nGC_80 = 281
  integer, parameter :: nGC_81 = 282
  integer, parameter :: nGC_82 = 283
  integer, parameter :: nGC_83 = 284
  integer, parameter :: nGC_84 = 285
  integer, parameter :: nGC_85 = 286
  integer, parameter :: nGC_86 = 287
  integer, parameter :: nGC_87 = 288
  integer, parameter :: nGC_66 = 289
  integer, parameter :: nGC_67 = 290
  integer, parameter :: nGC_64 = 291
  integer, parameter :: nGC_65 = 292
  integer, parameter :: nGC_62 = 293
  integer, parameter :: nGC_63 = 294
  integer, parameter :: nGC_60 = 295
  integer, parameter :: nGC_68 = 296
  integer, parameter :: nGC_69 = 297
  integer, parameter :: nGC_2175 = 298
  integer, parameter :: nGC_119 = 299
  integer, parameter :: nGC_118 = 300
  integer, parameter :: nGC_117 = 301
  integer, parameter :: nGC_116 = 302
  integer, parameter :: nGC_115 = 303
  integer, parameter :: nGC_114 = 304
  integer, parameter :: nGC_113 = 305
  integer, parameter :: nGC_112 = 306
  integer, parameter :: nGC_111 = 307
  integer, parameter :: nGC_110 = 308
  integer, parameter :: nGC_4322 = 309
  integer, parameter :: nGC_4326 = 310
  integer, parameter :: nGC_4129 = 311
  integer, parameter :: nGC_4128 = 312
  integer, parameter :: nGC_4136 = 313
  integer, parameter :: nGC_281 = 314
  integer, parameter :: nGC_4125 = 315
  integer, parameter :: nGC_4124 = 316
  integer, parameter :: nGC_4127 = 317
  integer, parameter :: nGC_4126 = 318
  integer, parameter :: nGC_1185 = 319
  integer, parameter :: nGC_6394 = 320
  integer, parameter :: nGC_6395 = 321
  integer, parameter :: nGC_6396 = 322
  integer, parameter :: nGC_6397 = 323
  integer, parameter :: nGC_6259 = 324
  integer, parameter :: nGC_211 = 325
  integer, parameter :: nGC_1823 = 326
  integer, parameter :: nGC_1821 = 327
  integer, parameter :: nGC_7221 = 328
  integer, parameter :: nGC_4330 = 329
  integer, parameter :: nGC_4137 = 330
  integer, parameter :: nGC_4130 = 331
  integer, parameter :: nGC_4131 = 332
  integer, parameter :: nGC_1401 = 333
  integer, parameter :: nGC_1403 = 334
  integer, parameter :: nGC_1405 = 335
  integer, parameter :: nGC_1407 = 336
  integer, parameter :: nGC_6131 = 337
  integer, parameter :: nGC_209 = 338
  integer, parameter :: nGC_6246 = 339
  integer, parameter :: nGC_6245 = 340
  integer, parameter :: nGC_6084 = 341
  integer, parameter :: nGC_6085 = 342
  integer, parameter :: nGC_6086 = 343
  integer, parameter :: nGC_6120 = 344
  integer, parameter :: nGC_6126 = 345
  integer, parameter :: nGC_4143 = 346
  integer, parameter :: nGC_4141 = 347
  integer, parameter :: nGC_4140 = 348
  integer, parameter :: nGC_4147 = 349
  integer, parameter :: nGC_4146 = 350
  integer, parameter :: nGC_4145 = 351
  integer, parameter :: nGC_4144 = 352
  integer, parameter :: nGC_4304 = 353
  integer, parameter :: nGC_4149 = 354
  integer, parameter :: nGC_4148 = 355
  integer, parameter :: nGC_387 = 356
  integer, parameter :: nGC_385 = 357
  integer, parameter :: nGC_4153 = 358
  integer, parameter :: nGC_1935 = 359
  integer, parameter :: nGC_4155 = 360
  integer, parameter :: nGC_1327 = 361
  integer, parameter :: nGC_713 = 362
  integer, parameter :: nGC_4906 = 363
  integer, parameter :: nGC_4318 = 364
  integer, parameter :: nGC_4157 = 365
  integer, parameter :: nGC_6129 = 366
  integer, parameter :: nGC_6138 = 367
  integer, parameter :: nGC_6139 = 368
  integer, parameter :: nGC_6232 = 369
  integer, parameter :: nGC_6338 = 370
  integer, parameter :: nGC_6130 = 371
  integer, parameter :: nGC_6337 = 372
  integer, parameter :: nGC_6132 = 373
  integer, parameter :: nGC_6133 = 374
  integer, parameter :: nGC_6332 = 375
  integer, parameter :: nGC_6331 = 376
  integer, parameter :: nGC_4150 = 377
  integer, parameter :: nGC_2531 = 378
  integer, parameter :: nGC_4152 = 379
  integer, parameter :: nGC_2533 = 380
  integer, parameter :: nGC_4154 = 381
  integer, parameter :: nGC_2535 = 382
  integer, parameter :: nGC_4156 = 383
  integer, parameter :: nGC_2537 = 384
  integer, parameter :: nGC_4158 = 385
  integer, parameter :: nGC_551 = 386
  integer, parameter :: nGC_1399 = 387
  integer, parameter :: nGC_6261 = 388
  integer, parameter :: nGC_825 = 389
  integer, parameter :: nGC_6185 = 390
  integer, parameter :: nGC_6186 = 391
  integer, parameter :: nGC_6579 = 392
  integer, parameter :: nGC_6107 = 393
  integer, parameter :: nGC_6106 = 394
  integer, parameter :: nGC_4097 = 395
  integer, parameter :: nGC_4096 = 396
  integer, parameter :: nGC_4099 = 397
  integer, parameter :: nGC_4098 = 398
  integer, parameter :: nGC_7219 = 399
  integer, parameter :: nGC_6109 = 400
  integer, parameter :: nGC_6108 = 401
  integer, parameter :: nGC_6576 = 402
  integer, parameter :: nGC_6577 = 403
  integer, parameter :: nGC_5867 = 404
  integer, parameter :: nGC_4151 = 405
  integer, parameter :: nGC_4169 = 406
  integer, parameter :: nGC_541 = 407
  integer, parameter :: nGC_4161 = 408
  integer, parameter :: nGC_3341 = 409
  integer, parameter :: nGC_4162 = 410
  integer, parameter :: nGC_6544 = 411
  integer, parameter :: nGC_543 = 412
  integer, parameter :: nGC_6541 = 413
  integer, parameter :: nGC_6542 = 414
  integer, parameter :: nGC_6192 = 415
  integer, parameter :: nGC_6191 = 416
  integer, parameter :: nGC_6196 = 417
  integer, parameter :: nGC_6195 = 418
  integer, parameter :: nGC_6117 = 419
  integer, parameter :: nGC_4088 = 420
  integer, parameter :: nGC_1307 = 421
  integer, parameter :: nGC_6118 = 422
  integer, parameter :: nGC_4298 = 423
  integer, parameter :: nGC_4082 = 424
  integer, parameter :: nGC_6095 = 425
  integer, parameter :: nGC_4080 = 426
  integer, parameter :: nGC_4081 = 427
  integer, parameter :: nGC_6213 = 428
  integer, parameter :: nGC_4296 = 429
  integer, parameter :: nGC_795 = 430
  integer, parameter :: nGC_417 = 431
  integer, parameter :: nGC_715 = 432
  integer, parameter :: nGC_4073 = 433
  integer, parameter :: nGC_4072 = 434
  integer, parameter :: nGC_4178 = 435
  integer, parameter :: nGC_4179 = 436
  integer, parameter :: nGC_4077 = 437
  integer, parameter :: nGC_4076 = 438
  integer, parameter :: nGC_4075 = 439
  integer, parameter :: nGC_4074 = 440
  integer, parameter :: nGC_4170 = 441
  integer, parameter :: nGC_4171 = 442
  integer, parameter :: nGC_2637 = 443
  integer, parameter :: nGC_4300 = 444
  integer, parameter :: nGC_5498 = 445
  integer, parameter :: nGC_6285 = 446
  integer, parameter :: nGC_6282 = 447
  integer, parameter :: nGC_6283 = 448
  integer, parameter :: nGC_6280 = 449
  integer, parameter :: nGC_6289 = 450
  integer, parameter :: nGC_6102 = 451
  integer, parameter :: nGC_6167 = 452
  integer, parameter :: nGC_405 = 453
  integer, parameter :: nGC_2297 = 454
  integer, parameter :: nGC_4060 = 455
  integer, parameter :: nGC_4061 = 456
  integer, parameter :: nGC_4062 = 457
  integer, parameter :: nGC_4063 = 458
  integer, parameter :: nGC_4064 = 459
  integer, parameter :: nGC_4065 = 460
  integer, parameter :: nGC_4066 = 461
  integer, parameter :: nGC_4067 = 462
  integer, parameter :: nGC_4068 = 463
  integer, parameter :: nGC_4069 = 464
  integer, parameter :: nGC_4294 = 465
  integer, parameter :: nGC_4071 = 466
  integer, parameter :: nGC_4070 = 467
  integer, parameter :: nGC_6075 = 468
  integer, parameter :: nGC_6077 = 469
  integer, parameter :: nGC_6076 = 470
  integer, parameter :: nGC_6408 = 471
  integer, parameter :: nGC_6409 = 472
  integer, parameter :: nGC_6370 = 473
  integer, parameter :: nGC_6371 = 474
  integer, parameter :: nGC_4183 = 475
  integer, parameter :: nGC_4182 = 476
  integer, parameter :: nGC_4181 = 477
  integer, parameter :: nGC_4180 = 478
  integer, parameter :: nGC_239 = 479
  integer, parameter :: nGC_4079 = 480
  integer, parameter :: nGC_1685 = 481
  integer, parameter :: nGC_6279 = 482
  integer, parameter :: nGC_6273 = 483
  integer, parameter :: nGC_435 = 484
  integer, parameter :: nGC_6274 = 485
  integer, parameter :: nGC_1933 = 486
  integer, parameter :: nGC_4078 = 487
  integer, parameter :: nGC_4059 = 488
  integer, parameter :: nGC_4058 = 489
  integer, parameter :: nGC_4284 = 490
  integer, parameter :: nGC_4057 = 491
  integer, parameter :: nGC_545 = 492
  integer, parameter :: nGC_4118 = 493
  integer, parameter :: nGC_4119 = 494
  integer, parameter :: nGC_4449 = 495
  integer, parameter :: nGC_4114 = 496
  integer, parameter :: nGC_4115 = 497
  integer, parameter :: nGC_4116 = 498
  integer, parameter :: nGC_4117 = 499
  integer, parameter :: nGC_4110 = 500
  integer, parameter :: nGC_4111 = 501
  integer, parameter :: nGC_4112 = 502
  integer, parameter :: nGC_4113 = 503
  integer, parameter :: nGC_1699 = 504
  integer, parameter :: nGC_6147 = 505
  integer, parameter :: nGC_6300 = 506
  integer, parameter :: nGC_347 = 507
  integer, parameter :: nGC_6264 = 508
  integer, parameter :: nGC_6309 = 509
  integer, parameter :: nGC_4142 = 510
  integer, parameter :: nGC_4160 = 511
  integer, parameter :: nGC_6545 = 512
  integer, parameter :: nGC_4120 = 513
  integer, parameter :: nGC_4121 = 514
  integer, parameter :: nGC_6580 = 515
  integer, parameter :: nGC_4123 = 516
  integer, parameter :: nGC_4122 = 517
  integer, parameter :: nGC_6291 = 518
  integer, parameter :: nGC_6314 = 519
  integer, parameter :: nGC_6302 = 520
  integer, parameter :: nGC_4134 = 521
  integer, parameter :: nGC_4135 = 522
  integer, parameter :: nGC_4132 = 523
  integer, parameter :: nGC_4133 = 524
  integer, parameter :: nGC_4159 = 525
  integer, parameter :: nGC_6286 = 526
  integer, parameter :: nGC_6419 = 527
  integer, parameter :: nGC_6303 = 528
  integer, parameter :: nGC_6081 = 529
  integer, parameter :: nGC_6327 = 530
  integer, parameter :: nGC_6326 = 531
  integer, parameter :: nGC_6125 = 532
  integer, parameter :: nGC_6420 = 533
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
