!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:47             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl1()
    coupl(nGC_4331) = -sqrt(2d0)*cima/2d0
    coupl(nGC_4333) = -sqrt(2d0)*cima/2d0
    coupl(nGC_28) = -cima*ee/(2d0*sw)
    coupl(nGC_29) = cima*ee/(2d0*sw)
    coupl(nGC_22) = -cima*ee**2d0/sw**2d0
    coupl(nGC_23) = 2d0*cima*ee**2d0/sw**2d0
    coupl(nGC_20) = -3d0*CWWWL2*cima*cw*ee**3d0/(2d0*qeddim**2d0*sw**3d0)
    coupl(nGC_21) = cima*ee**2d0/(2d0*sw**2d0)
    coupl(nGC_26) = -CPWWWL2*cima*ee**3d0/(4d0*qeddim**2d0*sw**2d0)
    coupl(nGC_27) = 3d0*CWWWL2*cima*ee**3d0/(2d0*qeddim**2d0*sw**2d0)
    coupl(nGC_24) = cima*cw**2d0*ee**2d0/sw**2d0
    coupl(nGC_25) = -2d0*cima*cw**2d0*ee**2d0/sw**2d0
    coupl(nGC_153) = -cima*ytau
    coupl(nGC_152) = sqrt(2d0)*yt/2d0
    coupl(nGC_151) = -sqrt(2d0)*cima*yt/2d0
    coupl(nGC_150) = -sqrt(2d0)*yt/2d0
    coupl(nGC_157) = cima*yup
    coupl(nGC_156) = sqrt(2d0)*ytau/2d0
    coupl(nGC_159) = -sqrt(2d0)*cima*yup/2d0
    coupl(nGC_158) = -sqrt(2d0)*yup/2d0
    coupl(nGC_126) = 2d0*CBBL4*cw**2d0*ee*qeddim**2d0*vev**2d0 + 2d0*CBBL4*ee* &
                     qeddim**2d0*sw**2d0*vev**2d0 + CBWL4*cw**3d0*ee*qeddim**  &
                     2d0*vev**2d0/(2d0*sw) - CBWL4*ee*qeddim**2d0*sw**3d0*vev**&
                     2d0/(2d0*cw) - CWWL4*cw**2d0*ee*qeddim**2d0*vev**2d0/2d0  &
                      - CWWL4*ee*qeddim**2d0*sw**2d0*vev**2d0/2d0
    coupl(nGC_127) = CBBL4*cw**3d0*ee*qeddim**2d0*vev**2d0/sw + CBBL4*cw*ee*   &
                     qeddim**2d0*sw*vev**2d0 - CBWL4*cw**2d0*ee*qeddim**2d0*vev&
                     **2d0/2d0 - CBWL4*ee*qeddim**2d0*sw**2d0*vev**2d0/2d0 +   &
                     CWWL4*cw*ee*qeddim**2d0*sw*vev**2d0/4d0 + CWWL4*ee*qeddim &
                     **2d0*sw**3d0*vev**2d0/(4d0*cw)
    coupl(nGC_124) = CBtWL4*cw**2d0*ee*qeddim**2d0*vev**2d0/4d0 + CBtWL4*ee*   &
                     qeddim**2d0*sw**2d0*vev**2d0/4d0
    coupl(nGC_125) = 3d0*CBBL4*cw*ee*qeddim**2d0*sw*vev**2d0 + 3d0*CBBL4*ee*   &
                     qeddim**2d0*sw**3d0*vev**2d0/cw + 3d0*CBWL4*cw**2d0*ee*   &
                     qeddim**2d0*vev**2d0/2d0 + 3d0*CBWL4*ee*qeddim**2d0*sw**  &
                     2d0*vev**2d0/2d0 + 3d0*CWWL4*cw**3d0*ee*qeddim**2d0*vev** &
                     2d0/(4d0*sw) + 3d0*CWWL4*cw*ee*qeddim**2d0*sw*vev**2d0/4d0
    coupl(nGC_122) = CWWL4*cw*ee*qeddim**2d0*vev**2d0/(4d0*sw) + CWWL4*ee*     &
                     qeddim**2d0*sw*vev**2d0/(4d0*cw)
    coupl(nGC_123) = -CBtWL4*cw**2d0*ee*qeddim**2d0*vev**2d0/2d0 - CBtWL4*ee*  &
                     qeddim**2d0*sw**2d0*vev**2d0/2d0
    coupl(nGC_120) = -4d0*CBBL4*cima*cw**2d0*qeddim**2d0*vev + 2d0*CBWL4*cima* &
                     cw*qeddim**2d0*sw*vev - CWWL4*cima*qeddim**2d0*sw**2d0*vev
    coupl(nGC_121) = -CBL2*cima*ee**3d0*vev**2d0/(8d0*sw**2d0) - CWL2*cima*ee**&
                     3d0*vev**2d0/(8d0*sw**2d0)
    coupl(nGC_128) = -cima*yb
    coupl(nGC_129) = -sqrt(2d0)*yb/2d0
    coupl(nGC_71) = CBtWL4*cw*qeddim**2d0*vev
    coupl(nGC_4285) = 2d0*G**2d0*cima
    coupl(nGC_4283) = -G
    coupl(nGC_3) = -cima*ee
    coupl(nGC_2) = -2d0*cima*ee/3d0
    coupl(nGC_1) = cima*ee/3d0
    coupl(nGC_7) = CPWL2*ee/4d0
    coupl(nGC_6) = CPWL2*cima*ee/2d0
    coupl(nGC_5) = -CPWL2*cima*ee/4d0
    coupl(nGC_4) = cima*ee
    coupl(nGC_9) = -2d0*cima*ee**2d0
    coupl(nGC_8) = cima*ee**2d0
    coupl(nGC_53) = cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
    coupl(nGC_52) = -cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
    coupl(nGC_51) = -cw*ee/(2d0*sw) - ee*sw/(2d0*cw)
    coupl(nGC_50) = cima*ee*sw/cw
    coupl(nGC_57) = CBL2*ee*sw/(2d0*cw) + CWL2*cw*ee/(2d0*sw)
    coupl(nGC_56) = -CBL2*cima*ee*sw/(2d0*cw) + CWL2*cima*cw*ee/(2d0*sw)
    coupl(nGC_55) = cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
    coupl(nGC_54) = -cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
    coupl(nGC_59) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0 + cima*ee&
                    **2d0*sw**2d0/(2d0*cw**2d0)
    coupl(nGC_58) = -cima*cw*ee**2d0/sw + cima*ee**2d0*sw/cw
    coupl(nGC_169) = G*cima
    coupl(nGC_160) = sqrt(2d0)*yup/2d0
    coupl(nGC_2895) = -2d0*coupl(nGC_7)
    coupl(nGC_4301) = -sqrt(2d0)*cima/2d0
    coupl(nGC_4303) = -sqrt(2d0)*cima/2d0
    coupl(nGC_17) = G*cima
    coupl(nGC_16) = -G
    coupl(nGC_15) = -CBL2*cima*ee/2d0 - CWL2*cima*ee/2d0
    coupl(nGC_14) = CBL2*ee/2d0 - CWL2*ee/2d0
    coupl(nGC_13) = ee**2d0/(2d0*cw)
    coupl(nGC_12) = -cima*ee**2d0/(2d0*cw)
    coupl(nGC_11) = -ee**2d0/(2d0*cw)
    coupl(nGC_10) = 2d0*cima*ee**2d0
    coupl(nGC_19) = CPWWWL2*cima*cw*ee**3d0/(4d0*qeddim**2d0*sw**3d0)
    coupl(nGC_18) = G**2d0*cima
    coupl(nGC_135) = -cima*ydo
    coupl(nGC_134) = sqrt(2d0)*yc/2d0
    coupl(nGC_137) = -sqrt(2d0)*cima*ydo/2d0
    coupl(nGC_136) = -sqrt(2d0)*ydo/2d0
    coupl(nGC_647) = -coupl(nGC_54)
    coupl(nGC_130) = -sqrt(2d0)*cima*yb/2d0
    coupl(nGC_133) = -sqrt(2d0)*cima*yc/2d0
    coupl(nGC_132) = -sqrt(2d0)*yc/2d0
    coupl(nGC_2295) = -coupl(nGC_19)
    coupl(nGC_139) = -sqrt(2d0)*ye/2d0
    coupl(nGC_138) = -cima*ye
    coupl(nGC_2293) = -coupl(nGC_20)
    coupl(nGC_1515) = -2d0*coupl(nGC_18)
    coupl(nGC_2977) = -coupl(nGC_121)
    coupl(nGC_2121) = -coupl(nGC_124)
    coupl(nGC_48) = cima*ee*sw/(3d0*cw)
    coupl(nGC_49) = -2d0*cima*ee*sw/(3d0*cw)
    coupl(nGC_44) = -cima*ee**2d0/(2d0*sw)
    coupl(nGC_45) = ee**2d0/(2d0*sw)
    coupl(nGC_46) = -cima*cw*ee**2d0/sw
    coupl(nGC_47) = 2d0*cima*cw*ee**2d0/sw
    coupl(nGC_40) = -CWL2*ee/(2d0*sw)
    coupl(nGC_41) = -CWL2*cima*ee/(2d0*sw)
    coupl(nGC_42) = CWL2*cima*ee/(2d0*sw)
    coupl(nGC_43) = -ee**2d0/(2d0*sw)
    coupl(nGC_681) = -coupl(nGC_41)
    coupl(nGC_131) = cima*yc
    coupl(nGC_4319) = sqrt(2d0)/2d0
    coupl(nGC_827) = -coupl(nGC_51)
    coupl(nGC_4317) = -sqrt(2d0)/2d0
    coupl(nGC_2429) = 2d0*coupl(nGC_7)
    coupl(nGC_2427) = -coupl(nGC_14)
    coupl(nGC_851) = -coupl(nGC_15)
    coupl(nGC_1305) = -coupl(nGC_26)
    coupl(nGC_1303) = -coupl(nGC_27)
    coupl(nGC_155) = -sqrt(2d0)*cima*ytau/2d0
    coupl(nGC_154) = -sqrt(2d0)*ytau/2d0
    coupl(nGC_99) = CWL2*cima*cw*ee**3d0*vev**2d0/(8d0*sw**3d0)
    coupl(nGC_98) = -CPWL2*cima*cw*ee**3d0*vev**2d0/(8d0*sw**3d0)
    coupl(nGC_97) = CBWL4*ee*qeddim**2d0*vev**2d0/2d0
    coupl(nGC_96) = -CBtWL4*ee*qeddim**2d0*vev**2d0/2d0
    coupl(nGC_95) = CBtWL4*cima*qeddim**2d0*sw**2d0*vev
    coupl(nGC_94) = CBtWL4*cima*cw*qeddim**2d0*sw*vev
    coupl(nGC_93) = -CBtWL4*cima*cw*qeddim**2d0*sw*vev
    coupl(nGC_92) = CBWL4*qeddim**2d0*sw*vev
    coupl(nGC_91) = -CBWL4*qeddim**2d0*sw*vev
    coupl(nGC_90) = CBtWL4*qeddim**2d0*sw*vev
    coupl(nGC_1603) = -coupl(nGC_56)
    coupl(nGC_75) = -CWWL4*cima*qeddim**2d0*vev
    coupl(nGC_74) = -CBtWL4*cima*cw**2d0*qeddim**2d0*vev
    coupl(nGC_77) = -cima*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_76) = -ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_70) = -CBtWL4*cw*qeddim**2d0*vev
    coupl(nGC_73) = CBWL4*cw*qeddim**2d0*vev
    coupl(nGC_72) = -CBWL4*cw*qeddim**2d0*vev
    coupl(nGC_79) = ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_78) = cima*ee**2d0*vev/(2d0*sw**2d0)
    coupl(nGC_100) = CPWL2*cima*ee**3d0*vev**2d0/(8d0*sw**2d0)
    coupl(nGC_101) = -CBL2*cima*ee**3d0*vev**2d0/(8d0*cw*sw)
    coupl(nGC_102) = -CPWL2*cima*ee**3d0*vev**2d0/(8d0*cw*sw)
    coupl(nGC_103) = CWL2*cima*ee**3d0*vev**2d0/(8d0*cw*sw)
    coupl(nGC_104) = CBtWL4*cw*ee*qeddim**2d0*vev**2d0/(2d0*sw)
    coupl(nGC_105) = CBWL4*cw*ee*qeddim**2d0*vev**2d0/(2d0*sw)
    coupl(nGC_106) = CBtWL4*cw**3d0*ee*qeddim**2d0*vev**2d0/(2d0*sw)
    coupl(nGC_107) = CBtWL4*cw*ee*qeddim**2d0*sw*vev**2d0/4d0
    coupl(nGC_108) = CBtWL4*ee*qeddim**2d0*sw**3d0*vev**2d0/(4d0*cw)
    coupl(nGC_109) = -cima*cw*ee**2d0*vev/(4d0*sw**2d0) + cima*ee**2d0*vev/(4d0&
                     *cw)
    coupl(nGC_2267) = -coupl(nGC_6)
    coupl(nGC_1503) = -coupl(nGC_18)
    coupl(nGC_1505) = 2d0*coupl(nGC_18)
    coupl(nGC_4323) = -sqrt(2d0)/2d0
    coupl(nGC_4321) = sqrt(2d0)/2d0
    coupl(nGC_4327) = -sqrt(2d0)/2d0
    coupl(nGC_4325) = sqrt(2d0)/2d0
    coupl(nGC_4329) = -sqrt(2d0)*cima/2d0
    coupl(nGC_1187) = -coupl(nGC_29)
    coupl(nGC_923) = -coupl(nGC_57)
    coupl(nGC_39) = -CPWL2*cima*cw*ee/(2d0*sw)
    coupl(nGC_38) = CPWL2*cima*cw*ee/(4d0*sw)
    coupl(nGC_31) = sqrt(2d0)*cima*ee/(2d0*sw)
    coupl(nGC_30) = ee/(2d0*sw)
    coupl(nGC_33) = -CPWL2*cima*ee/(2d0*sw)
    coupl(nGC_32) = -CPWL2*ee/(2d0*sw)
    coupl(nGC_35) = -cima*cw*ee/sw
    coupl(nGC_34) = CPWL2*ee/(2d0*sw)
    coupl(nGC_37) = -CPWL2*cw*ee/(4d0*sw)
    coupl(nGC_36) = cima*cw*ee/sw
    coupl(nGC_144) = -sqrt(2d0)*cima*ym/2d0
    coupl(nGC_145) = sqrt(2d0)*ym/2d0
    coupl(nGC_146) = -cima*ys
    coupl(nGC_147) = -sqrt(2d0)*ys/2d0
    coupl(nGC_140) = -sqrt(2d0)*cima*ye/2d0
    coupl(nGC_141) = sqrt(2d0)*ye/2d0
    coupl(nGC_142) = -cima*ym
    coupl(nGC_143) = -sqrt(2d0)*ym/2d0
    coupl(nGC_148) = -sqrt(2d0)*cima*ys/2d0
    coupl(nGC_149) = cima*yt
    coupl(nGC_781) = -coupl(nGC_40)
    coupl(nGC_MI) = -cima
    coupl(nGC_MC) = -cMC*cima
    coupl(nGC_MB) = -cMB*cima
    coupl(nGC_61) = -cMH**2d0*cima/vev**2d0
    coupl(nGC_MD) = -cMD*cima
    coupl(nGC_MS) = -cMS*cima
    coupl(nGC_MU) = -cMU*cima
    coupl(nGC_MT) = -cMT*cima
    coupl(nGC_327) = -coupl(nGC_147)
    coupl(nGC_249) = -coupl(nGC_3)
    coupl(nGC_4299) = -sqrt(2d0)*cima/2d0
    coupl(nGC_4297) = -sqrt(2d0)/2d0
    coupl(nGC_4295) = -sqrt(2d0)/2d0
    coupl(nGC_4293) = -sqrt(2d0)/2d0
    coupl(nGC_189) = -coupl(nGC_36)
    coupl(nGC_1203) = -coupl(nGC_16)
    coupl(nGC_88) = -CPWL2*cima*ee**2d0*vev/(4d0*sw)
    coupl(nGC_89) = -CBtWL4*qeddim**2d0*sw*vev
    coupl(nGC_80) = -CPWL2*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_81) = CPWL2*cima*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_82) = -CPWL2*cima*cw*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_83) = -CWL2*cima*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_84) = CWL2*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_85) = CWL2*cima*cw*ee**2d0*vev/(4d0*sw**2d0)
    coupl(nGC_86) = -cima*ee**2d0*vev/(2d0*sw)
    coupl(nGC_87) = cima*ee**2d0*vev/(2d0*sw)
    coupl(nGC_66) = -cima*ee**2d0*vev/(2d0*cw)
    coupl(nGC_67) = CBL2*cima*ee**2d0*vev/(4d0*cw)
    coupl(nGC_64) = -cMH**2d0*cima/vev
    coupl(nGC_65) = -3d0*cMH**2d0*cima/vev
    coupl(nGC_62) = -2d0*cMH**2d0*cima/vev**2d0
    coupl(nGC_63) = -3d0*cMH**2d0*cima/vev**2d0
    coupl(nGC_60) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0 + cima*ee&
                    **2d0*sw**2d0/(2d0*cw**2d0)
    coupl(nGC_68) = -CPWL2*cima*ee**2d0*vev/(4d0*cw)
  end subroutine fill_couplings_mdl1
end module fill_couplings1
