!******************************************************************************!
!                                                                              !
!    fill_couplings2.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings2.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:47             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl2()
    coupl(nGC_69) = CWL2*cima*ee**2d0*vev/(4d0*cw)
    coupl(nGC_2175) = -coupl(nGC_28)
    coupl(nGC_119) = -4d0*CBBL4*cima*cw*qeddim**2d0*sw*vev - CBWL4*cima*cw**2d0&
                     *qeddim**2d0*vev + CBWL4*cima*qeddim**2d0*sw**2d0*vev +   &
                     CWWL4*cima*cw*qeddim**2d0*sw*vev
    coupl(nGC_118) = -4d0*CBBL4*cima*qeddim**2d0*sw**2d0*vev - 2d0*CBWL4*cima* &
                     cw*qeddim**2d0*sw*vev - CWWL4*cima*cw**2d0*qeddim**2d0*vev
    coupl(nGC_117) = -CBL2*cima*ee**2d0*vev/4d0 - CBL2*cima*ee**2d0*sw**2d0*vev&
                     /(4d0*cw**2d0) - CWL2*cima*cw**2d0*ee**2d0*vev/(4d0*sw**  &
                     2d0) - CWL2*cima*ee**2d0*vev/4d0
    coupl(nGC_116) = cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) + cima*ee**2d0*vev &
                      + cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
    coupl(nGC_115) = -cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) - cima*ee**2d0*vev&
                     /2d0 - cima*ee**2d0*sw**2d0*vev/(4d0*cw**2d0)
    coupl(nGC_114) = -CBL2*cima*cw*ee**2d0*vev/(4d0*sw) - CBL2*cima*ee**2d0*sw*&
                     vev/(4d0*cw) + CWL2*cima*cw*ee**2d0*vev/(4d0*sw) + CWL2*  &
                     cima*ee**2d0*sw*vev/(4d0*cw)
    coupl(nGC_113) = -CPWL2*cima*cw*ee**2d0*vev/(4d0*sw) - CPWL2*cima*ee**2d0* &
                     sw*vev/(4d0*cw)
    coupl(nGC_112) = CBL2*cima*ee**2d0*vev/(4d0*sw) + CWL2*cima*ee**2d0*vev/(  &
                     4d0*sw)
    coupl(nGC_111) = CPWL2*cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) + CPWL2*cima*&
                     ee**2d0*vev/4d0
    coupl(nGC_110) = cima*cw*ee**2d0*vev/(4d0*sw**2d0) + cima*ee**2d0*vev/(4d0*&
                     cw)
    coupl(nGC_281) = -coupl(nGC_114)
    coupl(nGC_1185) = -coupl(nGC_33)
    coupl(nGC_211) = -coupl(nGC_88)
    coupl(nGC_1823) = coupl(nGC_106) + 2d0*coupl(nGC_107)
    coupl(nGC_1821) = coupl(nGC_107) + coupl(nGC_108)
    coupl(nGC_1401) = coupl(nGC_103) + coupl(nGC_99)
    coupl(nGC_1403) = coupl(nGC_102) + coupl(nGC_98)
    coupl(nGC_1405) = coupl(nGC_122) + coupl(nGC_97)
    coupl(nGC_1407) = coupl(nGC_122) - coupl(nGC_97)
    coupl(nGC_209) = -coupl(nGC_112)
    coupl(nGC_387) = -coupl(nGC_30)
    coupl(nGC_385) = -coupl(nGC_32)
    coupl(nGC_1935) = -coupl(nGC_82)
    coupl(nGC_1327) = -coupl(nGC_42)
    coupl(nGC_713) = -coupl(nGC_84)
    coupl(nGC_4906) = -coupl(nGC_69) - coupl(nGC_85)
    coupl(nGC_2531) = -coupl(nGC_101) - coupl(nGC_99)
    coupl(nGC_2533) = -coupl(nGC_103) - coupl(nGC_99)
    coupl(nGC_2535) = -coupl(nGC_98)
    coupl(nGC_2537) = -coupl(nGC_102) - coupl(nGC_98)
    coupl(nGC_551) = -coupl(nGC_136)
    coupl(nGC_1399) = coupl(nGC_101) + coupl(nGC_99)
    coupl(nGC_825) = 2d0*coupl(nGC_37)
    coupl(nGC_5867) = -coupl(nGC_117)
    coupl(nGC_541) = coupl(nGC_67) - coupl(nGC_85)
    coupl(nGC_3341) = -coupl(nGC_104)
    coupl(nGC_543) = coupl(nGC_69) + coupl(nGC_85)
    coupl(nGC_1307) = -coupl(nGC_100)
    coupl(nGC_795) = -coupl(nGC_129)
    coupl(nGC_417) = -coupl(nGC_34)
    coupl(nGC_715) = -coupl(nGC_80)
    coupl(nGC_2637) = -coupl(nGC_111)
    coupl(nGC_5498) = -coupl(nGC_83)
    coupl(nGC_405) = -coupl(nGC_4)
    coupl(nGC_2297) = -coupl(nGC_122) + coupl(nGC_97)
    coupl(nGC_239) = -2d0*coupl(nGC_37)
    coupl(nGC_1685) = -coupl(nGC_39)
    coupl(nGC_435) = -coupl(nGC_113)
    coupl(nGC_1933) = -coupl(nGC_68) - coupl(nGC_82)
    coupl(nGC_545) = coupl(nGC_68) + coupl(nGC_82)
    coupl(nGC_4449) = -coupl(nGC_67) + coupl(nGC_85)
    coupl(nGC_1699) = -coupl(nGC_81)
    coupl(nGC_347) = -coupl(nGC_35)
  end subroutine fill_couplings_mdl2
end module fill_couplings2
