!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:47             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl2()
    coupl(nGC_4090) = cMU*cima*(-coupl(nGC_2)**2d0 - coupl(nGC_49)*coupl(nGC_53&
                      ))/(8d0*pi**2d0)
    coupl(nGC_4093) = cMC*cima*(-coupl(nGC_2)**2d0 - coupl(nGC_49)*coupl(nGC_53&
                      ))/(8d0*pi**2d0)
    coupl(nGC_4092) = cMC*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4095) = cMT*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4094) = cMT*cima*(-coupl(nGC_2)**2d0 - coupl(nGC_49)*coupl(nGC_53&
                      ))/(8d0*pi**2d0)
    coupl(nGC_6079) = coupl(nGC_130)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_4185) = -3d0*cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc** &
                      3d0)
    coupl(nGC_4184) = cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc**2d0)
    coupl(nGC_6676) = coupl(nGC_2)*dZuR_QCD2
    coupl(nGC_6675) = coupl(nGC_2)*dZuL_QCD2
    coupl(nGC_4320) = coupl(nGC_4319)*dyc_QED1_QCD2
    coupl(nGC_4324) = coupl(nGC_4323)*dyt_QED1_QCD2
    coupl(nGC_4328) = coupl(nGC_4327)*dyup_QED1_QCD2
    coupl(nGC_6158) = coupl(nGC_159)*(dZuL_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_6159) = coupl(nGC_4334) + coupl(nGC_6158)
    coupl(nGC_4138) = sq2**3d0*(-11d0*Nc*cima*coupl(nGC_16)**3d0 - 48d0*coupl( &
                      nGC_17)**3d0)/(768d0*pi**2d0)
    coupl(nGC_4139) = sq2**3d0*(11d0*Nc*cima*coupl(nGC_16)**3d0 + 48d0*coupl(  &
                      nGC_17)**3d0)/(768d0*pi**2d0)
    coupl(nGC_6325) = coupl(nGC_129)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_6184) = coupl(nGC_17)*dZsR_QCD2
    coupl(nGC_6181) = coupl(nGC_17)*dZsL_QCD2
    coupl(nGC_6112) = coupl(nGC_53)*dZuL_QCD2
    coupl(nGC_6298) = coupl(nGC_48)*dZsR_QCD2
    coupl(nGC_6110) = coupl(nGC_31)*(dZbL_QCD2 + dZtL_QCD2)/2d0
    coupl(nGC_6111) = coupl(nGC_49)*dZuR_QCD2
    coupl(nGC_6290) = coupl(nGC_17)*dZbL_QCD2
    coupl(nGC_6292) = coupl(nGC_6146) + coupl(nGC_6290)
    coupl(nGC_6297) = coupl(nGC_52)*dZsL_QCD2
    coupl(nGC_4172) = (3d0*Nc*cima*coupl(nGC_1503)*coupl(nGC_1505) - 3d0*Nc*   &
                      cima*coupl(nGC_1505)*coupl(nGC_18) + 5d0*Nc*cima*coupl(  &
                      nGC_16)**4d0*sq2**4d0 + 3d0*Nc*coupl(nGC_1503)*coupl(    &
                      nGC_16)**2d0*sq2**2d0 - 3d0*Nc*coupl(nGC_1505)*coupl(    &
                      nGC_16)**2d0*sq2**2d0 - 6d0*Nc*coupl(nGC_16)**2d0*coupl( &
                      nGC_18)*sq2**2d0 - 3d0*cima*coupl(nGC_17)**4d0*sq2**4d0  &
                      )/(192d0*pi**2d0*Nc)
    coupl(nGC_4173) = (6d0*Nc*cima*coupl(nGC_1503)*coupl(nGC_1505) - 6d0*Nc*   &
                      cima*coupl(nGC_1505)*coupl(nGC_18) + 10d0*Nc*cima*coupl( &
                      nGC_16)**4d0*sq2**4d0 + 9d0*Nc*coupl(nGC_1503)*coupl(    &
                      nGC_16)**2d0*sq2**2d0 - 9d0*Nc*coupl(nGC_1505)*coupl(    &
                      nGC_16)**2d0*sq2**2d0 - 3d0*Nc*coupl(nGC_1515)*coupl(    &
                      nGC_16)**2d0*sq2**2d0 - 9d0*Nc*coupl(nGC_16)**2d0*coupl( &
                      nGC_18)*sq2**2d0 - 6d0*cima*coupl(nGC_17)**4d0*sq2**4d0  &
                      )/(384d0*pi**2d0*Nc)
    coupl(nGC_4176) = (6d0*cima*coupl(nGC_1505)**2d0 - 10d0*cima*coupl(nGC_16  &
                      )**4d0*sq2**4d0 + 3d0*coupl(nGC_1503)*coupl(nGC_16)**2d0*&
                      sq2**2d0 + 15d0*coupl(nGC_1505)*coupl(nGC_16)**2d0*sq2** &
                      2d0 + 3d0*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**2d0)/(   &
                      192d0*pi**2d0)
    coupl(nGC_4177) = (6d0*cima*coupl(nGC_1505)**2d0 - 10d0*cima*coupl(nGC_16  &
                      )**4d0*sq2**4d0 + 18d0*coupl(nGC_1505)*coupl(nGC_16)**2d0&
                      *sq2**2d0 + 3d0*coupl(nGC_1515)*coupl(nGC_16)**2d0*sq2** &
                      2d0)/(192d0*pi**2d0)
    coupl(nGC_4174) = (12d0*cima*coupl(nGC_1505)**2d0 - 20d0*cima*coupl(nGC_16 &
                      )**4d0*sq2**4d0 + 3d0*coupl(nGC_1503)*coupl(nGC_16)**2d0*&
                      sq2**2d0 + 33d0*coupl(nGC_1505)*coupl(nGC_16)**2d0*sq2** &
                      2d0 + 3d0*coupl(nGC_1515)*coupl(nGC_16)**2d0*sq2**2d0 +  &
                      3d0*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**2d0)/(384d0*pi &
                      **2d0)
    coupl(nGC_4175) = (3d0*cima*coupl(nGC_1503)**2d0 - 6d0*cima*coupl(nGC_1503 &
                      )*coupl(nGC_18) - 5d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + &
                      3d0*cima*coupl(nGC_18)**2d0 - 6d0*coupl(nGC_1503)*coupl( &
                      nGC_16)**2d0*sq2**2d0 + 9d0*coupl(nGC_16)**2d0*coupl(    &
                      nGC_18)*sq2**2d0)/(96d0*pi**2d0)
    coupl(nGC_6366) = coupl(nGC_17)*dZuL_QCD2
    coupl(nGC_6165) = coupl(nGC_133)*(dZcL_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_4292) = cima*dyc_QED1_QCD2
    coupl(nGC_4291) = -cima*dys_QED1_QCD2
    coupl(nGC_4290) = -cima*dydo_QED1_QCD2
    coupl(nGC_4109) = coupl(nGC_17)**2d0*coupl(nGC_48)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4108) = coupl(nGC_17)**2d0*coupl(nGC_52)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4107) = coupl(nGC_17)**2d0*coupl(nGC_49)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4106) = coupl(nGC_17)**2d0*coupl(nGC_53)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4105) = coupl(nGC_1)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4104) = coupl(nGC_17)**2d0*coupl(nGC_2)*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4103) = cMB*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)*coupl(nGC_52&
                      ))/(8d0*pi**2d0)
    coupl(nGC_4102) = cMB*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4101) = cMS*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)*coupl(nGC_52&
                      ))/(8d0*pi**2d0)
    coupl(nGC_4100) = cMS*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4322) = coupl(nGC_4321)*dyt_QED1_QCD2
    coupl(nGC_4326) = coupl(nGC_4325)*dyup_QED1_QCD2
  end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
