!******************************************************************************!
!                                                                              !
!    fill_ctcouplings3.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings3.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:47             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings3
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl3()
    coupl(nGC_4129) = coupl(nGC_17)*sq2*(-coupl(nGC_149)**2d0 - coupl(nGC_150)*&
                      coupl(nGC_152) - coupl(nGC_151)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_4128) = coupl(nGC_17)*sq2*(-coupl(nGC_128)**2d0 - coupl(nGC_150)*&
                      coupl(nGC_152) - coupl(nGC_151)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0*Nc)
    coupl(nGC_4136) = coupl(nGC_17)**2d0*sq2**2d0*(-cMB*coupl(nGC_130) - cMC*  &
                      coupl(nGC_133) - cMD*coupl(nGC_137) - cMS*coupl(nGC_148  &
                      ) - cMT*coupl(nGC_151) - cMU*coupl(nGC_159))/(16d0*pi**  &
                      2d0)
    coupl(nGC_4125) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(nGC_146&
                      )**2d0 - coupl(nGC_147)*coupl(nGC_327) - coupl(nGC_148)**&
                      2d0 - 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_4124) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(nGC_131&
                      )**2d0 - coupl(nGC_147)*coupl(nGC_327) - coupl(nGC_148)**&
                      2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_52)**2d0)/( &
                      64d0*pi**2d0*Nc)
    coupl(nGC_4127) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(nGC_146 &
                      )**2d0 + coupl(nGC_147)*coupl(nGC_327) + coupl(nGC_148)**&
                      2d0 + 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0)
    coupl(nGC_4126) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(nGC_131 &
                      )**2d0 + coupl(nGC_147)*coupl(nGC_327) + coupl(nGC_148)**&
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_52)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_6394) = coupl(nGC_MI)*dZbL_QCD2
    coupl(nGC_6395) = coupl(nGC_MB)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_6396) = coupl(nGC_MI)*dZbR_QCD2
    coupl(nGC_6397) = coupl(nGC_4369) + coupl(nGC_6395)
    coupl(nGC_6259) = coupl(nGC_148)*(dZsL_QCD2 + dZsR_QCD2)/2d0
    coupl(nGC_7221) = -coupl(nGC_4139)
    coupl(nGC_4330) = coupl(nGC_4329)*dyc_QED1_QCD2
    coupl(nGC_4137) = coupl(nGC_17)**2d0*sq2**2d0*(cMB*coupl(nGC_130) + cMC*   &
                      coupl(nGC_133) + cMD*coupl(nGC_137) + cMS*coupl(nGC_148  &
                      ) + cMT*coupl(nGC_151) + cMU*coupl(nGC_159))/(16d0*pi**  &
                      2d0*Nc)
    coupl(nGC_4130) = coupl(nGC_17)*sq2*(coupl(nGC_128)**2d0 + coupl(nGC_150)* &
                      coupl(nGC_152) + coupl(nGC_151)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_4131) = coupl(nGC_17)*sq2*(coupl(nGC_149)**2d0 + coupl(nGC_150)* &
                      coupl(nGC_152) + coupl(nGC_151)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0)
    coupl(nGC_6131) = coupl(nGC_MI)*dZuR_QCD2
    coupl(nGC_6246) = coupl(nGC_49)*dZcR_QCD2
    coupl(nGC_6245) = coupl(nGC_53)*dZcL_QCD2
    coupl(nGC_6084) = 2d0*coupl(nGC_18)*dZg_QCD2 + coupl(nGC_4286)
    coupl(nGC_6085) = -coupl(nGC_6084)
    coupl(nGC_6086) = 2d0*coupl(nGC_6084)
    coupl(nGC_6120) = coupl(nGC_1)*dZsR_QCD2
    coupl(nGC_6126) = coupl(nGC_134)*dZcL_QCD2/2d0 + coupl(nGC_134)*dZcR_QCD2/ &
                      2d0 + coupl(nGC_4320)
    coupl(nGC_4143) = coupl(nGC_129)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4141) = coupl(nGC_130)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4140) = coupl(nGC_151)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4147) = coupl(nGC_149)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4146) = coupl(nGC_17)**2d0*coupl(nGC_31)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4145) = coupl(nGC_152)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4144) = coupl(nGC_150)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4304) = coupl(nGC_4303)*dys_QED1_QCD2
    coupl(nGC_4149) = cima*coupl(nGC_17)**2d0*coupl(nGC_31)**2d0*sq2**2d0/(32d0&
                      *pi**2d0)
    coupl(nGC_4148) = coupl(nGC_128)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4153) = cima*coupl(nGC_17)**2d0*sq2**2d0*(coupl(nGC_1)**2d0 +    &
                      coupl(nGC_2)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4155) = cima*coupl(nGC_17)**2d0*sq2**2d0*(coupl(nGC_1)*coupl(    &
                      nGC_48) + coupl(nGC_1)*coupl(nGC_52) + coupl(nGC_2)*coupl&
                      (nGC_49) + coupl(nGC_2)*coupl(nGC_53))/(32d0*pi**2d0)
    coupl(nGC_4318) = coupl(nGC_4317)*dyc_QED1_QCD2
    coupl(nGC_4157) = cima*coupl(nGC_17)**2d0*sq2**2d0*(coupl(nGC_48)**2d0 +   &
                      coupl(nGC_49)**2d0 + coupl(nGC_52)**2d0 + coupl(nGC_53)**&
                      2d0)/(32d0*pi**2d0)
    coupl(nGC_6129) = coupl(nGC_MI)*dZuL_QCD2
    coupl(nGC_6138) = coupl(nGC_160)*dZuL_QCD2/2d0 + coupl(nGC_160)*dZuR_QCD2/ &
                      2d0 + coupl(nGC_4326)
    coupl(nGC_6139) = coupl(nGC_158)*dZuL_QCD2/2d0 + coupl(nGC_158)*dZuR_QCD2/ &
                      2d0 + coupl(nGC_4328)
    coupl(nGC_6232) = coupl(nGC_48)*dZdR_QCD2
    coupl(nGC_6338) = coupl(nGC_2)*dZtL_QCD2
    coupl(nGC_6130) = coupl(nGC_MU)*(dZuL_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_6337) = coupl(nGC_2)*dZtR_QCD2
    coupl(nGC_6132) = coupl(nGC_4365) + coupl(nGC_6130)
    coupl(nGC_6133) = coupl(nGC_31)*(dZcL_QCD2 + dZsL_QCD2)/2d0
    coupl(nGC_6332) = coupl(nGC_2)*dZcL_QCD2
    coupl(nGC_6331) = coupl(nGC_2)*dZcR_QCD2
  end subroutine fill_CTcouplings_mdl3
end module fill_ctcouplings3
