!******************************************************************************!
!                                                                              !
!    fill_ctcouplings4.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings4.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:47             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings4
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl4()
    coupl(nGC_4150) = -cima*coupl(nGC_17)**2d0*coupl(nGC_31)**2d0*sq2**2d0/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4152) = cima*coupl(nGC_17)**2d0*sq2**2d0*(coupl(nGC_130)**2d0 +  &
                      coupl(nGC_133)**2d0 + coupl(nGC_137)**2d0 + coupl(nGC_148&
                      )**2d0 + coupl(nGC_151)**2d0 + coupl(nGC_159)**2d0)/(16d0&
                      *pi**2d0*Nc)
    coupl(nGC_4154) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_1)**2d0 -   &
                      coupl(nGC_2)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_4156) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_1)*coupl(   &
                      nGC_48) - coupl(nGC_1)*coupl(nGC_52) - coupl(nGC_2)*coupl&
                      (nGC_49) - coupl(nGC_2)*coupl(nGC_53))/(32d0*pi**2d0*Nc)
    coupl(nGC_4158) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_48)**2d0 -  &
                      coupl(nGC_49)**2d0 - coupl(nGC_52)**2d0 - coupl(nGC_53)**&
                      2d0)/(32d0*pi**2d0*Nc)
    coupl(nGC_6261) = coupl(nGC_4304) + coupl(nGC_6259)
    coupl(nGC_6185) = coupl(nGC_6146) + coupl(nGC_6184)
    coupl(nGC_6186) = coupl(nGC_6146) + coupl(nGC_6181)
    coupl(nGC_6579) = coupl(nGC_MI)*dZdR_QCD2
    coupl(nGC_6107) = coupl(nGC_MT)*(dZtL_QCD2 + dZtR_QCD2)/2d0
    coupl(nGC_6106) = coupl(nGC_MI)*dZtL_QCD2
    coupl(nGC_4097) = cMD*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4096) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_31)**2d0 - coupl(   &
                      nGC_52)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4099) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)**2d0)/(16d0*pi**&
                      2d0)
    coupl(nGC_4098) = cMD*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_48)*coupl(nGC_52&
                      ))/(8d0*pi**2d0)
    coupl(nGC_7219) = -coupl(nGC_4138)
    coupl(nGC_6109) = coupl(nGC_4364) + coupl(nGC_6107)
    coupl(nGC_6108) = coupl(nGC_MI)*dZtR_QCD2
    coupl(nGC_6576) = coupl(nGC_MI)*dZdL_QCD2
    coupl(nGC_6577) = coupl(nGC_MD)*(dZdL_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_4151) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_130)**2d0 - &
                      coupl(nGC_133)**2d0 - coupl(nGC_137)**2d0 - coupl(nGC_148&
                      )**2d0 - coupl(nGC_151)**2d0 - coupl(nGC_159)**2d0)/(16d0&
                      *pi**2d0)
    coupl(nGC_4169) = sq2**2d0*(-2d0*Nc*cima*coupl(nGC_16)**4d0*sq2**2d0 - 3d0*&
                      Nc*coupl(nGC_1505)*coupl(nGC_16)**2d0 + 3d0*Nc*coupl(    &
                      nGC_1515)*coupl(nGC_16)**2d0 - 30d0*cima*coupl(nGC_17)** &
                      4d0*sq2**2d0)/(384d0*pi**2d0)
    coupl(nGC_4161) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_128)**2d0 - &
                      coupl(nGC_131)**2d0 - coupl(nGC_135)**2d0 - coupl(nGC_146&
                      )**2d0 - coupl(nGC_149)**2d0 - coupl(nGC_157)**2d0)/(32d0&
                      *pi**2d0)
    coupl(nGC_4162) = cima*coupl(nGC_17)**2d0*sq2**2d0*(coupl(nGC_128)**2d0 +  &
                      coupl(nGC_131)**2d0 + coupl(nGC_135)**2d0 + coupl(nGC_146&
                      )**2d0 + coupl(nGC_149)**2d0 + coupl(nGC_157)**2d0)/(32d0&
                      *pi**2d0*Nc)
    coupl(nGC_6544) = coupl(nGC_MI)*dZsR_QCD2
    coupl(nGC_6541) = coupl(nGC_MI)*dZsL_QCD2
    coupl(nGC_6542) = coupl(nGC_MS)*(dZsL_QCD2 + dZsR_QCD2)/2d0
    coupl(nGC_6192) = coupl(nGC_17)*dZdR_QCD2
    coupl(nGC_6191) = coupl(nGC_17)*dZdL_QCD2
    coupl(nGC_6196) = coupl(nGC_6146) + coupl(nGC_6191)
    coupl(nGC_6195) = coupl(nGC_6146) + coupl(nGC_6192)
    coupl(nGC_6117) = coupl(nGC_146)*dZcL_QCD2/2d0 + coupl(nGC_146)*dZsR_QCD2/ &
                      2d0 + coupl(nGC_4291)
    coupl(nGC_4088) = cima*(-coupl(nGC_2)**2d0 - coupl(nGC_31)**2d0 - coupl(   &
                      nGC_53)**2d0)/(16d0*pi**2d0)
    coupl(nGC_6118) = coupl(nGC_131)*dZcR_QCD2/2d0 + coupl(nGC_131)*dZsL_QCD2/ &
                      2d0 + coupl(nGC_4292)
    coupl(nGC_4298) = coupl(nGC_4297)*dys_QED1_QCD2
    coupl(nGC_4082) = cima*(-coupl(nGC_31)**2d0 - coupl(nGC_4)**2d0 - coupl(   &
                      nGC_54)**2d0)/(16d0*pi**2d0)
    coupl(nGC_6095) = -2d0*coupl(nGC_6084)
    coupl(nGC_4080) = (2d0*Nc*cMB**2d0*cima*coupl(nGC_48)**2d0 + 2d0*Nc*cMB**  &
                      2d0*cima*coupl(nGC_52)**2d0 + 2d0*Nc*cMC**2d0*cima*coupl(&
                      nGC_49)**2d0 + 2d0*Nc*cMC**2d0*cima*coupl(nGC_53)**2d0 + &
                      2d0*Nc*cMD**2d0*cima*coupl(nGC_48)**2d0 + 2d0*Nc*cMD**2d0&
                      *cima*coupl(nGC_52)**2d0 + 2d0*Nc*cMS**2d0*cima*coupl(   &
                      nGC_48)**2d0 + 2d0*Nc*cMS**2d0*cima*coupl(nGC_52)**2d0 + &
                      2d0*Nc*cMT**2d0*cima*coupl(nGC_49)**2d0 + 2d0*Nc*cMT**2d0&
                      *cima*coupl(nGC_53)**2d0 + 2d0*Nc*cMU**2d0*cima*coupl(   &
                      nGC_49)**2d0 + 2d0*Nc*cMU**2d0*cima*coupl(nGC_53)**2d0 + &
                      2d0*cME**2d0*cima*coupl(nGC_50)**2d0 + 2d0*cME**2d0*cima*&
                      coupl(nGC_54)**2d0 + 2d0*cMM**2d0*cima*coupl(nGC_50)**2d0&
                       + 2d0*cMM**2d0*cima*coupl(nGC_54)**2d0 + 2d0*cMTA**2d0* &
                      cima*coupl(nGC_50)**2d0 + 2d0*cMTA**2d0*cima*coupl(nGC_54&
                      )**2d0 + 3d0*cMW**2d0*cima*coupl(nGC_189)**2d0 + 3d0*cMW &
                      **2d0*cima*coupl(nGC_36)**2d0 - 2d0*cMW**2d0*coupl(nGC_25&
                      ))/(16d0*pi**2d0)
    coupl(nGC_4081) = cima*(-coupl(nGC_31)**2d0 - coupl(nGC_55)**2d0)/(16d0*pi &
                      **2d0)
    coupl(nGC_6213) = coupl(nGC_31)*(dZdL_QCD2 + dZuL_QCD2)/2d0
    coupl(nGC_4296) = coupl(nGC_4295)*dydo_QED1_QCD2
    coupl(nGC_4073) = cima*(coupl(nGC_189)*coupl(nGC_249) + coupl(nGC_3)*coupl(&
                      nGC_36))/(48d0*pi**2d0)
    coupl(nGC_4072) = cima*(-2d0*Nc*coupl(nGC_1)*coupl(nGC_48) - 2d0*Nc*coupl( &
                      nGC_1)*coupl(nGC_52) - 2d0*Nc*coupl(nGC_2)*coupl(nGC_49  &
                      ) - 2d0*Nc*coupl(nGC_2)*coupl(nGC_53) - coupl(nGC_189)*  &
                      coupl(nGC_249) - coupl(nGC_3)*coupl(nGC_36) - 2d0*coupl( &
                      nGC_4)*coupl(nGC_50) - 2d0*coupl(nGC_4)*coupl(nGC_54))/( &
                      32d0*pi**2d0)
    coupl(nGC_4178) = (-12d0*Nc*cima*coupl(nGC_1503)*coupl(nGC_18) - 4d0*Nc*   &
                      cima*coupl(nGC_16)**4d0*sq2**4d0 - 9d0*Nc*coupl(nGC_1503 &
                      )*coupl(nGC_16)**2d0*sq2**2d0 + 12d0*Nc*coupl(nGC_16)**  &
                      2d0*coupl(nGC_18)*sq2**2d0 + 18d0*cima*coupl(nGC_17)**4d0&
                      *sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_4179) = (12d0*Nc*cima*coupl(nGC_1503)**2d0 - 8d0*Nc*cima*coupl(  &
                      nGC_16)**4d0*sq2**4d0 + 12d0*Nc*cima*coupl(nGC_18)**2d0  &
                       - 3d0*Nc*coupl(nGC_1503)*coupl(nGC_16)**2d0*sq2**2d0 +  &
                      39d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**2d0 + 36d0*&
                      cima*coupl(nGC_17)**4d0*sq2**4d0)/(768d0*pi**2d0)
    coupl(nGC_4077) = (4d0*Nc*cMB**2d0*cima*coupl(nGC_1)**2d0 + 4d0*Nc*cMC**2d0&
                      *cima*coupl(nGC_2)**2d0 + 4d0*Nc*cMD**2d0*cima*coupl(    &
                      nGC_1)**2d0 + 4d0*Nc*cMS**2d0*cima*coupl(nGC_1)**2d0 +   &
                      4d0*Nc*cMT**2d0*cima*coupl(nGC_2)**2d0 + 4d0*Nc*cMU**2d0*&
                      cima*coupl(nGC_2)**2d0 + 4d0*cME**2d0*cima*coupl(nGC_4)**&
                      2d0 + 4d0*cMM**2d0*cima*coupl(nGC_4)**2d0 + 4d0*cMTA**2d0&
                      *cima*coupl(nGC_4)**2d0 + 3d0*cMW**2d0*cima*coupl(nGC_249&
                      )**2d0 + 3d0*cMW**2d0*cima*coupl(nGC_3)**2d0 - 2d0*cMW** &
                      2d0*coupl(nGC_9))/(16d0*pi**2d0)
    coupl(nGC_4076) = cima*(coupl(nGC_249)**2d0 + coupl(nGC_3)**2d0)/(48d0*pi**&
                      2d0)
    coupl(nGC_4075) = cima*(-4d0*Nc*coupl(nGC_1)**2d0 - 4d0*Nc*coupl(nGC_2)**  &
                      2d0 - coupl(nGC_249)**2d0 - coupl(nGC_3)**2d0 - 4d0*coupl&
                      (nGC_4)**2d0)/(32d0*pi**2d0)
    coupl(nGC_4074) = (2d0*Nc*cMB**2d0*cima*coupl(nGC_1)*coupl(nGC_48) + 2d0*Nc&
                      *cMB**2d0*cima*coupl(nGC_1)*coupl(nGC_52) + 2d0*Nc*cMC** &
                      2d0*cima*coupl(nGC_2)*coupl(nGC_49) + 2d0*Nc*cMC**2d0*   &
                      cima*coupl(nGC_2)*coupl(nGC_53) + 2d0*Nc*cMD**2d0*cima*  &
                      coupl(nGC_1)*coupl(nGC_48) + 2d0*Nc*cMD**2d0*cima*coupl( &
                      nGC_1)*coupl(nGC_52) + 2d0*Nc*cMS**2d0*cima*coupl(nGC_1)*&
                      coupl(nGC_48) + 2d0*Nc*cMS**2d0*cima*coupl(nGC_1)*coupl( &
                      nGC_52) + 2d0*Nc*cMT**2d0*cima*coupl(nGC_2)*coupl(nGC_49 &
                      ) + 2d0*Nc*cMT**2d0*cima*coupl(nGC_2)*coupl(nGC_53) + 2d0&
                      *Nc*cMU**2d0*cima*coupl(nGC_2)*coupl(nGC_49) + 2d0*Nc*cMU&
                      **2d0*cima*coupl(nGC_2)*coupl(nGC_53) + 2d0*cME**2d0*cima&
                      *coupl(nGC_4)*coupl(nGC_50) + 2d0*cME**2d0*cima*coupl(   &
                      nGC_4)*coupl(nGC_54) + 2d0*cMM**2d0*cima*coupl(nGC_4)*   &
                      coupl(nGC_50) + 2d0*cMM**2d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_54) + 2d0*cMTA**2d0*cima*coupl(nGC_4)*coupl(nGC_50   &
                      ) + 2d0*cMTA**2d0*cima*coupl(nGC_4)*coupl(nGC_54) + 3d0* &
                      cMW**2d0*cima*coupl(nGC_189)*coupl(nGC_249) + 3d0*cMW**  &
                      2d0*cima*coupl(nGC_3)*coupl(nGC_36) - 2d0*cMW**2d0*coupl(&
                      nGC_47))/(16d0*pi**2d0)
    coupl(nGC_4170) = (12d0*Nc*cima*coupl(nGC_1503)**2d0 - 8d0*Nc*cima*coupl(  &
                      nGC_16)**4d0*sq2**4d0 + 12d0*Nc*cima*coupl(nGC_18)**2d0  &
                       - 21d0*Nc*coupl(nGC_1503)*coupl(nGC_16)**2d0*sq2**2d0 + &
                      21d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**2d0 + 36d0*&
                      cima*coupl(nGC_17)**4d0*sq2**4d0)/(768d0*pi**2d0)
  end subroutine fill_CTcouplings_mdl4
end module fill_ctcouplings4
