!******************************************************************************!
!                                                                              !
!    ctparameter36.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter36.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:47             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter36
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter36()
  if (dZbL_QCD2_scheme .eq. 0) then
    dZbL_QCD2 = (pi**2d0*(-Nc*coupl(nGC_17)**2d0/(2d0*pi**2d0) + coupl(nGC_17  &
                )**2d0/(2d0*pi**2d0*Nc)) + Ten62*coupl(nGC_17)**2d0*(Nc**2d0 - &
                1d0)/Nc + Ten63*coupl(nGC_17)**2d0*(Nc**2d0 - 1d0)/Nc + 2d0*   &
                Ten64*coupl(nGC_17)**2d0*rMB*(-2d0*Nc**2d0*cMB + Nc**2d0*rMB + &
                2d0*cMB - rMB)/Nc + 2d0*Ten65*coupl(nGC_17)**2d0*rMB**2d0*(Nc**&
                2d0 - 1d0)/Nc)/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZbL_QCD2 = cone*real(dZbL_QCD2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter36
end module ctparameter36
