!******************************************************************************!
!                                                                              !
!    tcFVFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFVFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:45             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFVFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeFVFa(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FVFa0)
!       GammaM(2,3,1)*c0
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = cima*w2(2)
      x1 = co(0)*m
      wout(0) = x1*(-w1(2)*(w2(0) + w2(3)) + w1(3)*(-w2(1) + x0))
      wout(1) = -x1*(w1(2)*(w2(1) + x0) + w1(3)*(w2(0) - w2(3)))
      wout(2) = -co(0)*(w1(2)*(-pl(1)*w2(0) - pl(1)*w2(3) + pl(3)*w2(1) + pl(3 &
                )*x0) + w1(3)*(-pl(1)*w2(1) + pl(1)*x0 + pl(3)*w2(0) - pl(3)*w2&
                (3)))
      wout(3) = co(0)*(w1(2)*(pl(0)*w2(1) + pl(0)*x0 - pl(2)*w2(0) - pl(2)*w2(3&
                )) + w1(3)*(pl(0)*w2(0) - pl(0)*w2(3) - pl(2)*w2(1) + pl(2)*x0 &
                ))
    else
      x0 = cima*w2(2)
      wout(0) = co(0)*(-w1(2)*(w2(0) + w2(3)) + w1(3)*(-w2(1) + x0))
      wout(1) = -co(0)*(w1(2)*(w2(1) + x0) + w1(3)*(w2(0) - w2(3)))
      wout(2) = 0
      wout(3) = 0
    end if 
      case(FVFa1)
!       GammaP(2,3,1)*c0
!       GammaM(2,3,1)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(3)*w2(0)
      x1 = pl(3)*w2(3)
      x2 = pl(0)*w2(1)
      x3 = cima*w2(2)
      x4 = pl(0)*x3
      x5 = co(0)*w1(1)
      x6 = pl(0)*w2(3)
      x7 = pl(0)*w2(0)
      x8 = pl(3)*w2(1) + pl(3)*x3
      x9 = co(0)*w1(0)
      x10 = co(1)*w1(3)
      x11 = m*(-w2(1) + x3)
      x12 = co(1)*w1(2)
      x13 = m*(w2(0) + w2(3))
      x14 = pl(1)*w2(0)
      x15 = pl(1)*w2(3)
      x16 = -pl(2)*w2(1) + pl(2)*x3
      x17 = pl(1)*w2(1)
      x18 = pl(2)*w2(3)
      x19 = -pl(2)*w2(0)
      x20 = pl(1)*x3
      x21 = m*(w2(1) + x3)
      x22 = m*(w2(0) - w2(3))
      wout(0) = x10*x11 - x12*x13 + x5*(x0 + x1 - x2 + x4) - x9*(x6 - x7 + x8)
      wout(1) = -x10*x22 - x12*x21 + x5*(x14 + x15 + x16) - x9*(x17 + x18 + x19&
                 + x20)
      wout(2) = -x10*(x0 - x1 - x17 + x20) - x11*x5 - x12*(-x14 - x15 + x8) -  &
                x22*x9
      wout(3) = x10*(x16 - x6 + x7) + x12*(-x18 + x19 + x2 + x4) - x13*x5 + x21&
                *x9
    else
      x0 = cima*w2(2)
      x1 = -w2(1) + x0
      x2 = w2(0) + w2(3)
      x3 = w2(1) + x0
      x4 = w2(0) - w2(3)
      wout(0) = co(1)*(-w1(2)*x2 + w1(3)*x1)
      wout(1) = -co(1)*(w1(2)*x3 + w1(3)*x4)
      wout(2) = -co(0)*(w1(0)*x4 + w1(1)*x1)
      wout(3) = co(0)*(w1(0)*x3 - w1(1)*x2)
    end if 
      end select 
    end subroutine treeFVFa
end module tcFVFa
