!******************************************************************************!
!                                                                              !
!    tcSVV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:45             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeSVV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVV0)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
!       c2*(Epsilon(-1,-2,-3,2)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,1) - Epsilon(-1,-2,-3
!       ,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(2,1) + Epsilon(-1,-3,2,3)*P(-1,1)*P(-2,1)*P
!       (-2,3)*P(-3,2) - Epsilon(-2,-3,2,3)*P(-1,1)*P(-1,2)*P(-2,1)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P1(2)*w2(3) - P1(3)*w2(2)
        x1 = P1(1)*w2(2) - P1(2)*w2(1)
        x2 = P1(1)*w2(3) - P1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(2)*x4
        x6 = P2(2)*w2(3) - P2(3)*w2(2)
        x7 = P2(1)*w2(2) - P2(2)*w2(1)
        x8 = P2(1)*w2(3) - P2(3)*w2(1)
        x9 = P2(1)*x6 - P2(2)*x8 + P2(3)*x7
        x10 = P1(0)*w2(2) - P1(2)*w2(0)
        x11 = P1(0)*w2(3) - P1(3)*w2(0)
        x12 = P2(0)*x0 - P2(2)*x11 + P2(3)*x10
        x13 = P1(0)*P1(1)*co(2)
        x14 = P2(0)*w2(2) - P2(2)*w2(0)
        x15 = P2(0)*w2(3) - P2(3)*w2(0)
        x16 = P2(0)*x6 - P2(2)*x15 + P2(3)*x14
        x17 = P1(0)*w2(1) - P1(1)*w2(0)
        x18 = P2(0)*x1 - P2(1)*x10 + P2(2)*x17
        x19 = P1(0)*P1(3)*co(2)
        x20 = P2(0)*w2(1) - P2(1)*w2(0)
        x21 = P2(0)*x7 - P2(1)*x14 + P2(2)*x20
        x22 = P2(1)**2
        x23 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x24 = co(0)*x22*x23
        x25 = P2(2)**2
        x26 = co(0)*x23*x25
        x27 = P2(3)**2
        x28 = co(0)*x23*x27
        x29 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x30 = P1(1)*P2(1)*co(2)
        x31 = P1(1)*x6
        x32 = P1(3)*x7
        x33 = P1(2)*x8
        x34 = x31 + x32 - x33
        x35 = P1(2)*P2(2)*co(2)
        x36 = P1(1)*P2(3) - P1(3)*P2(1)
        x37 = P1(2)*co(2)*x23
        x38 = P1(1)**2
        x39 = P1(2)**2
        x40 = P1(3)**2
        x41 = co(2)*(x38 + x39 - x4 + x40)
        x42 = P1(1)*P2(1)
        x43 = P1(2)*P2(2)
        x44 = P1(3)*P2(3)
        x45 = P1(0)*P2(0)
        x46 = x42 + x43 + x44 - x45
        x47 = co(2)*x46
        x48 = P1(3)*P2(3)*co(2)
        x49 = co(0)*x23*x4
        x50 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x51 = co(0)*x50
        x52 = P2(0)**2
        x53 = x22 + x25 + x27 - x52
        x54 = co(1)*w2(0)*x53
        x55 = co(1)*w2(0)*x46
        x56 = P2(0)*x2 - P2(1)*x11 + P2(3)*x17
        x57 = P1(0)*P1(2)*co(2)
        x58 = P2(0)*x8 - P2(1)*x15 + P2(3)*x20
        x59 = P1(0)*P2(0)*co(2)
        x60 = x23*(P1(2)*P2(3) - P1(3)*P2(2))
        x61 = P1(1)*co(2)
        x62 = P1(1)*P2(2)
        x63 = -P1(2)*P2(1) + x62
        x64 = P1(3)*co(2)*x23
        x65 = P2(0)*co(0)*x23
        x66 = P1(0)*co(0)*x50
        x67 = co(2)*x38
        x68 = P1(1)*P1(3)*co(2)
        x69 = P1(0)*x0 - P1(2)*x11 + P1(3)*x10
        x70 = P1(0)*x6
        x71 = P1(3)*x14
        x72 = P1(2)*x15
        x73 = x70 + x71 - x72
        x74 = P1(3)*P2(0)
        x75 = x23*(P1(0)*P2(3) - x74)
        x76 = co(1)*w2(1)*x53
        x77 = co(1)*x38*x46
        x78 = co(1)*x39*x46
        x79 = co(1)*x46
        x80 = P1(2)*x56
        x81 = P1(1)*P1(2)*co(2)
        x82 = co(0)*x23*x52
        x83 = P1(0)*P2(2) - P1(2)*P2(0)
        x84 = P2(1)*co(0)*x23
        x85 = co(1)*x4*x46
        x86 = P1(1)*co(0)*x50
        x87 = P1(0)*P2(1)
        x88 = P1(2)*co(0)*x50
        x89 = co(2)*x39
        x90 = P1(0)*x2 - P1(1)*x11 + P1(3)*x17
        x91 = P1(0)*x8
        x92 = P1(3)*x20
        x93 = P1(1)*x15
        x94 = x91 + x92 - x93
        x95 = P1(0)*co(2)*x23
        x96 = P1(2)*P1(3)*co(2)
        x97 = -P1(1)*P2(0) + x87
        x98 = co(1)*x53
        x99 = co(1)*x39*x53
        x100 = w2(2)*x40
        x101 = P2(2)*co(0)*x23
        x102 = co(0)*x23
        x103 = P2(2)*x39
        x104 = co(1)*x4*x53
        x105 = co(2)*x40
        x106 = co(2)*(P1(0)*x1 - P1(1)*x10 + P1(2)*x17)
        x107 = P1(0)*x7
        x108 = P1(2)*x20
        x109 = P1(1)*x14
        x110 = x107 + x108 - x109
        x111 = w2(3)*x38
        x112 = w2(3)*x40
        x113 = P2(3)*co(0)*x23
        x114 = P2(3)*x40
        x115 = P1(3)*co(0)*x50
        wout(0) = w1(0)*(P1(0)*x24 + P1(0)*x26 + P1(0)*x28 + P2(0)*x4*x51 + P2(&
                  0)*x49 + x12*x13 + x13*x16 + x18*x19 + x19*x21 + x29*x30 +   &
                  x29*x35 + x29*x48 - x29*x59 - x3*x5 + x30*x34 - x31*x41 - x31&
                  *x47 - x32*x41 - x32*x47 + x33*x41 + x33*x47 + x34*x35 + x34*&
                  x48 - x34*x59 + x36*x37 + x38*x54 + x38*x55 - x38*x65 + x39* &
                  x54 + x39*x55 - x39*x65 - x4*x54 - x4*x55 + x40*x54 + x40*x55&
                   - x40*x65 - x42*x65 - x42*x66 - x43*x65 - x43*x66 - x44*x65 &
                   - x44*x66 - x5*x9 - x56*x57 - x57*x58 - x60*x61 - x63*x64)
        wout(1) = w1(0)*(-P1(0)*co(2)*x60 + P1(1)*x26 + P1(1)*x28 - P1(1)*x82  &
                   + P1(2)*co(2)*x75 - P2(1)*x38*x51 + P2(1)*x49 + w2(1)*x40*  &
                  x79 + w2(1)*x77 + w2(1)*x78 - w2(1)*x85 + x12*x67 - x13*x3 - &
                  x13*x9 + x16*x67 + x18*x68 + x21*x68 + x30*x69 + x30*x73 +   &
                  x35*x69 + x35*x73 + x38*x76 - x38*x84 + x39*x76 - x39*x84 -  &
                  x4*x76 + x40*x76 - x40*x84 - x41*x70 - x41*x71 + x41*x72 -   &
                  x43*x84 - x44*x84 - x44*x86 + x45*x86 - x47*x70 - x47*x71 +  &
                  x47*x72 + x48*x69 + x48*x73 - x58*x81 - x59*x69 - x59*x73 -  &
                  x61*x80 - x62*x88 - x64*x83 + x65*x87)
        wout(2) = w1(0)*(P1(2)*x24 + P1(2)*x28 - P1(2)*x82 + P2(2)*x49 - w2(2)*&
                  x104 + w2(2)*x38*x98 + w2(2)*x77 + w2(2)*x78 - w2(2)*x85 + w2&
                  (2)*x99 + x100*x79 + x100*x98 - x101*x38 - x101*x40 - x101*  &
                  x42 - x101*x44 + x101*x45 - x102*x103 - x103*x51 + x12*x81 + &
                  x16*x81 + x18*x96 + x21*x96 - x3*x57 - x30*x90 - x30*x94 -   &
                  x35*x90 - x35*x94 + x36*x95 + x41*x91 + x41*x92 - x41*x93 -  &
                  x42*x88 - x44*x88 + x45*x88 + x47*x91 + x47*x92 - x47*x93 -  &
                  x48*x90 - x48*x94 - x56*x89 - x57*x9 - x58*x89 + x59*x90 +   &
                  x59*x94 - x61*x75 + x64*x97)
        wout(3) = w1(0)*(-P1(3)*co(2)*x80 + P1(3)*x24 + P1(3)*x26 - P1(3)*x82  &
                   + P2(3)*x49 - w2(3)*x104 + w2(3)*x78 - w2(3)*x85 + w2(3)*x99&
                   - x102*x114 + x105*x18 + x105*x21 + x106*x42 + x106*x43 +   &
                  x106*x44 - x106*x45 - x107*x41 - x107*x47 - x108*x41 - x108* &
                  x47 + x109*x41 + x109*x47 + x110*x30 + x110*x35 + x110*x48 - &
                  x110*x59 + x111*x79 + x111*x98 + x112*x79 + x112*x98 - x113* &
                  x38 - x113*x39 - x113*x42 - x113*x43 + x113*x45 - x114*x51 - &
                  x115*x42 - x115*x43 + x12*x68 + x16*x68 - x19*x3 - x19*x9 +  &
                  x23*x61*x83 - x37*x97 - x58*x96 - x63*x95 + x66*x74)
      case(SVV1)
!       P(2,1)*P(3,2)*c0
!       -P(2,3)*P(3,1)*c1
!       -Metric(2,3)*P(-1,1)*P(-1,2)*c2
!       Metric(2,3)*P(-1,1)*P(-1,3)*c3
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*c4
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*c5
        if (last) VB_last = .true.
        x0 = P1(2)*w2(3)
        x1 = P1(3)*w2(2)
        x2 = co(4)*(x0 - x1)
        x3 = P2(2)*w2(3)
        x4 = P2(3)*w2(2)
        x5 = x3 - x4
        x6 = P1(1)*co(4)
        x7 = P2(1)*w2(3)
        x8 = P2(3)*w2(1)
        x9 = x7 - x8
        x10 = P1(2)*co(5)
        x11 = P1(1)*w2(2)
        x12 = P1(2)*w2(1)
        x13 = x11 - x12
        x14 = P1(3)*co(4)
        x15 = P2(1)*w2(2)
        x16 = P2(2)*w2(1)
        x17 = x15 - x16
        x18 = P1(0)**2
        x19 = co(3)*x18
        x20 = P1(1)*co(5)
        x21 = P1(1)*w2(3)
        x22 = P1(3)*w2(1)
        x23 = x21 - x22
        x24 = P1(2)*co(4)
        x25 = P1(3)*co(5)
        x26 = co(1)*w2(0)
        x27 = P1(1)**2
        x28 = co(3)*x27
        x29 = P1(2)**2
        x30 = co(3)*x29
        x31 = P1(3)**2
        x32 = co(3)*x31
        x33 = P1(0)*w2(1)
        x34 = P1(1)*co(1)
        x35 = P1(0)*w2(2)
        x36 = P1(2)*co(1)
        x37 = P1(0)*w2(3)
        x38 = P1(3)*co(1)
        x39 = P1(0)*P2(0)*w2(0)
        x40 = P2(1)*co(1)
        x41 = P2(2)*co(1)
        x42 = P2(3)*co(1)
        x43 = P2(0)*w2(1)
        x44 = P1(1)*co(0)
        x45 = P2(0)*w2(2)
        x46 = P1(2)*co(0)
        x47 = P2(0)*w2(3)
        x48 = P1(3)*co(0)
        x49 = P1(1)*P2(1)*w2(0)
        x50 = P1(2)*P2(2)*w2(0)
        x51 = P2(3)*w2(0)
        x52 = P1(3)*co(2)
        x53 = P1(3)*co(3)
        x54 = P1(0)*x5
        x55 = x47 - x51
        x56 = co(5)*x55
        x57 = P1(2)*w2(0)
        x58 = co(4)*(x35 - x57)
        x59 = P2(2)*w2(0)
        x60 = x45 - x59
        x61 = co(4)*x60
        x62 = co(1)*w2(1)
        x63 = P1(3)*w2(0)
        x64 = x37 - x63
        x65 = co(4)*x55
        x66 = P1(0)*P2(0)*w2(1)
        x67 = P1(1)*P2(1)*w2(1)
        x68 = P1(1)*w2(0)
        x69 = P1(0)*co(1)
        x70 = P2(1)*w2(0)
        x71 = P1(0)*co(0)
        x72 = P2(0)*co(1)
        x73 = P2(2)*co(2)
        x74 = P2(2)*co(3)
        x75 = P1(0)*co(5)
        x76 = x43 - x70
        x77 = co(1)*w2(2)
        x78 = P1(0)*co(4)
        x79 = co(4)*(x33 - x68)
        x80 = co(4)*x76
        x81 = P2(0)*co(2)
        x82 = P2(0)*co(3)
        x83 = P1(2)*P2(2)*w2(2)
        x84 = P1(1)*co(2)
        x85 = P1(1)*co(3)
        x86 = P2(3)*co(2)
        x87 = w2(3)*x31
        x88 = P2(3)*w2(3)
        x89 = P1(3)*w2(3)
        wout(0) = w1(0)*(-P1(0)*P2(0)*x26 + P1(1)*x2 - co(0)*x39 + co(2)*x39 - &
                  co(2)*x49 - co(2)*x50 + co(3)*x39 - co(3)*x49 - co(3)*x50 +  &
                  w2(0)*x19 - w2(0)*x28 - w2(0)*x30 - w2(0)*x32 + x10*x9 + x13*&
                  x14 + x14*x17 - x17*x25 - x18*x26 - x20*x5 - x23*x24 - x24*x9&
                   + x33*x34 + x33*x40 + x35*x36 + x35*x41 + x37*x38 + x37*x42 &
                   + x43*x44 + x45*x46 + x47*x48 + x5*x6 - x51*x52 - x51*x53)
        wout(1) = w1(0)*(P1(0)*x2 + P1(1)*P2(1)*x62 + P1(2)*x56 - P1(2)*x65 +  &
                  P1(3)*x58 + P1(3)*x61 + co(0)*x67 + co(2)*x66 - co(2)*x67 +  &
                  co(3)*x66 - co(3)*x67 + co(4)*x54 - co(5)*x54 + w2(1)*x19 -  &
                  w2(1)*x28 - w2(1)*x30 - w2(1)*x32 + x11*x36 + x11*x41 - x12* &
                  x73 - x12*x74 + x15*x46 + x21*x38 + x21*x42 - x24*x64 - x25* &
                  x60 + x27*x62 + x48*x7 - x52*x8 - x53*x8 - x68*x69 - x68*x72 &
                   - x70*x71)
        wout(2) = w1(0)*(-P1(1)*x56 + P1(1)*x65 + P1(2)*P2(2)*x77 - P1(3)*x79  &
                   - P1(3)*x80 - P2(3)*co(3)*x1 + co(0)*x83 - co(2)*x83 - co(3 &
                  )*x83 + w2(2)*x19 - w2(2)*x28 - w2(2)*x30 - w2(2)*x32 + x0*  &
                  x38 + x0*x42 - x1*x86 + x12*x34 + x12*x40 - x15*x84 - x15*x85&
                   + x16*x44 - x23*x78 + x25*x76 + x29*x77 + x3*x48 + x35*x81  &
                   + x35*x82 - x57*x69 - x57*x72 - x59*x71 + x6*x64 + x75*x9 - &
                  x78*x9)
        wout(3) = w1(0)*(-P1(1)*x58 - P1(1)*x61 + P1(2)*x79 + P1(2)*x80 + co(1 &
                  )*x87 - co(3)*x87 + w2(3)*x19 - w2(3)*x28 - w2(3)*x30 - x0*  &
                  x73 - x0*x74 + x1*x36 + x1*x41 - x10*x76 + x13*x78 - x17*x75 &
                   + x17*x78 + x20*x60 + x22*x34 + x22*x40 + x37*x81 + x37*x82 &
                   + x4*x46 + x42*x89 + x44*x8 + x48*x88 - x51*x71 - x53*x88 - &
                  x63*x69 - x63*x72 - x7*x84 - x7*x85 - x86*x89)
      case(SVV2)
!       Metric(2,3)*c0
        if (last) VB_last = .true.
        wout = -co(0)*w1(0)*w2(:)
      case(SVV3)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
!       c2*(-Epsilon(-1,-2,-3,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(2,1) - Epsilon(-2,-3,2
!       ,3)*P(-1,1)*P(-1,2)*P(-2,1)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x2 = co(0)*x0*x1
        x3 = P2(2)**2
        x4 = co(0)*x1*x3
        x5 = P2(3)**2
        x6 = co(0)*x1*x5
        x7 = P1(2)*w2(3) - P1(3)*w2(2)
        x8 = P1(1)*w2(2) - P1(2)*w2(1)
        x9 = P1(1)*w2(3) - P1(3)*w2(1)
        x10 = P1(1)*x7 - P1(2)*x9 + P1(3)*x8
        x11 = P1(1)*P2(1)*co(2)
        x12 = P2(2)*w2(3) - P2(3)*w2(2)
        x13 = P2(1)*w2(2) - P2(2)*w2(1)
        x14 = P2(1)*w2(3) - P2(3)*w2(1)
        x15 = P1(1)*x12 - P1(2)*x14 + P1(3)*x13
        x16 = P1(2)*P2(2)*co(2)
        x17 = P1(1)*P2(3) - P1(3)*P2(1)
        x18 = P1(2)*co(2)*x1
        x19 = P1(3)*P2(3)*co(2)
        x20 = P1(0)**2
        x21 = co(0)*x1*x20
        x22 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x23 = co(0)*x22
        x24 = P1(1)**2
        x25 = P2(0)**2
        x26 = x0 - x25 + x3 + x5
        x27 = co(1)*w2(0)*x26
        x28 = P1(1)*P2(1)
        x29 = P1(2)*P2(2)
        x30 = P1(3)*P2(3)
        x31 = P1(0)*P2(0)
        x32 = x28 + x29 + x30 - x31
        x33 = co(1)*w2(0)*x32
        x34 = P1(2)**2
        x35 = P1(3)**2
        x36 = P1(0)*P2(0)*co(2)
        x37 = co(2)*x1*(P1(2)*P2(3) - P1(3)*P2(2))
        x38 = P1(1)*P2(2)
        x39 = -P1(2)*P2(1) + x38
        x40 = P1(3)*co(2)*x1
        x41 = P2(0)*co(0)*x1
        x42 = P1(0)*co(0)*x22
        x43 = P1(0)*w2(2) - P1(2)*w2(0)
        x44 = P1(0)*w2(3) - P1(3)*w2(0)
        x45 = P1(0)*x7 - P1(2)*x44 + P1(3)*x43
        x46 = P2(0)*w2(2) - P2(2)*w2(0)
        x47 = P2(0)*w2(3) - P2(3)*w2(0)
        x48 = P1(0)*x12 - P1(2)*x47 + P1(3)*x46
        x49 = P1(3)*P2(0)
        x50 = co(2)*x1*(P1(0)*P2(3) - x49)
        x51 = co(1)*w2(1)*x26
        x52 = co(1)*w2(1)*x32
        x53 = co(1)*x32*x34
        x54 = co(0)*x1*x25
        x55 = P1(0)*P2(2) - P1(2)*P2(0)
        x56 = P2(1)*co(0)*x1
        x57 = P1(1)*co(0)*x22
        x58 = P1(0)*P2(1)
        x59 = P1(2)*co(0)*x22
        x60 = P1(0)*w2(1) - P1(1)*w2(0)
        x61 = P1(0)*x9 - P1(1)*x44 + P1(3)*x60
        x62 = P2(0)*w2(1) - P2(1)*w2(0)
        x63 = P1(0)*x14 - P1(1)*x47 + P1(3)*x62
        x64 = P1(0)*co(2)*x1
        x65 = -P1(1)*P2(0) + x58
        x66 = co(1)*x26
        x67 = co(1)*w2(2)*x32
        x68 = co(1)*x26*x34
        x69 = w2(2)*x35
        x70 = co(1)*x32
        x71 = P2(2)*co(0)*x1
        x72 = P2(2)*co(0)*x34
        x73 = co(1)*x20*x26
        x74 = co(2)*(P1(0)*x8 - P1(1)*x43 + P1(2)*x60)
        x75 = P1(0)*x13 - P1(1)*x46 + P1(2)*x62
        x76 = w2(3)*x24
        x77 = w2(3)*x35
        x78 = P2(3)*co(0)*x1
        x79 = P2(3)*x35
        x80 = P1(3)*co(0)*x22
        wout(0) = w1(0)*(P1(0)*x2 + P1(0)*x4 + P1(0)*x6 - P1(1)*x37 + P2(0)*x20&
                  *x23 + P2(0)*x21 + x10*x11 + x10*x16 + x10*x19 - x10*x36 +   &
                  x11*x15 + x15*x16 + x15*x19 - x15*x36 + x17*x18 - x20*x27 -  &
                  x20*x33 + x24*x27 + x24*x33 - x24*x41 + x27*x34 + x27*x35 -  &
                  x28*x41 - x28*x42 - x29*x41 - x29*x42 - x30*x41 - x30*x42 +  &
                  x33*x34 + x33*x35 - x34*x41 - x35*x41 - x39*x40)
        wout(1) = w1(0)*(-P1(0)*x37 + P1(1)*x4 - P1(1)*x54 + P1(1)*x6 + P1(2)* &
                  x50 + P2(1)*x21 - P2(1)*x23*x24 + w2(1)*x53 + x11*x45 + x11* &
                  x48 + x16*x45 + x16*x48 + x19*x45 + x19*x48 - x20*x51 - x20* &
                  x52 + x24*x51 + x24*x52 - x24*x56 - x29*x56 - x30*x56 - x30* &
                  x57 + x31*x57 + x34*x51 - x34*x56 + x35*x51 + x35*x52 - x35* &
                  x56 - x36*x45 - x36*x48 - x38*x59 - x40*x55 + x41*x58)
        wout(2) = w1(0)*(-P1(1)*x50 + P1(2)*x2 - P1(2)*x54 + P1(2)*x6 + P2(2)* &
                  x21 + w2(2)*x24*x66 + w2(2)*x53 + w2(2)*x68 - w2(2)*x73 - x1*&
                  x72 - x11*x61 - x11*x63 - x16*x61 - x16*x63 + x17*x64 - x19* &
                  x61 - x19*x63 - x20*x67 - x22*x72 + x24*x67 - x24*x71 - x28* &
                  x59 - x28*x71 - x30*x59 - x30*x71 + x31*x59 + x31*x71 - x35* &
                  x71 + x36*x61 + x36*x63 + x40*x65 + x66*x69 + x69*x70)
        wout(3) = w1(0)*(P1(1)*co(2)*x1*x55 + P1(3)*x2 + P1(3)*x4 - P1(3)*x54  &
                   + P2(3)*x21 - co(0)*x1*x79 - w2(3)*x20*x70 + w2(3)*x53 + w2(&
                  3)*x68 - w2(3)*x73 + x11*x75 + x16*x75 - x18*x65 + x19*x75 - &
                  x23*x79 - x24*x78 + x28*x74 - x28*x78 - x28*x80 + x29*x74 -  &
                  x29*x78 - x29*x80 + x30*x74 - x31*x74 + x31*x78 - x34*x78 -  &
                  x36*x75 - x39*x64 + x42*x49 + x66*x76 + x66*x77 + x70*x76 +  &
                  x70*x77)
      case(SVV4)
!       P(2,3)*P(3,1)*c0
!       Metric(2,3)*P(-1,1)*P(-1,3)*c1
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*c2
        if (last) VB_last = .true.
        x0 = P1(2)*w2(3)
        x1 = P1(3)*w2(2)
        x2 = x0 - x1
        x3 = P1(1)*co(2)
        x4 = P2(2)*w2(3)
        x5 = -P2(3)*w2(2) + x4
        x6 = P1(1)*w2(2)
        x7 = P1(2)*w2(1)
        x8 = x6 - x7
        x9 = P1(3)*co(2)
        x10 = P2(1)*w2(2) - P2(2)*w2(1)
        x11 = P1(0)**2
        x12 = w2(0)*x11
        x13 = P1(1)*w2(3)
        x14 = P1(3)*w2(1)
        x15 = x13 - x14
        x16 = P1(2)*co(2)
        x17 = P2(1)*w2(3)
        x18 = P2(3)*w2(1)
        x19 = x17 - x18
        x20 = P1(1)**2
        x21 = co(1)*w2(0)
        x22 = P1(2)**2
        x23 = P1(3)**2
        x24 = P2(0)*co(0)
        x25 = P1(0)*co(0)*w2(1)
        x26 = P1(0)*w2(2)
        x27 = P1(2)*co(0)
        x28 = P1(0)*co(0)*w2(3)
        x29 = P2(2)*co(0)
        x30 = P1(1)*w2(0)
        x31 = P2(1)*co(1)
        x32 = P2(2)*w2(0)
        x33 = P1(2)*co(1)
        x34 = P1(3)*w2(0)
        x35 = P2(3)*co(1)
        x36 = P1(0)*co(2)
        x37 = -P1(2)*w2(0) + x26
        x38 = P2(0)*w2(2) - x32
        x39 = co(1)*x11
        x40 = P1(0)*w2(3)
        x41 = -x34 + x40
        x42 = P2(0)*w2(3) - P2(3)*w2(0)
        x43 = co(0)*w2(1)
        x44 = co(1)*w2(1)
        x45 = P1(0)*co(0)
        x46 = P2(0)*w2(1)
        x47 = P1(3)*co(0)
        x48 = P1(1)*P2(1)
        x49 = P2(3)*co(0)
        x50 = P1(0)*w2(1) - x30
        x51 = -P2(1)*w2(0) + x46
        x52 = w2(2)*x22
        x53 = co(1)*w2(2)
        x54 = P1(2)*co(0)*w2(0)
        x55 = P2(0)*co(1)
        x56 = P1(1)*co(0)
        x57 = P2(1)*co(0)
        x58 = co(0)*w2(3)
        x59 = co(1)*w2(3)
        x60 = P1(3)*P2(3)
        wout(0) = w1(0)*(P1(0)*P2(0)*x21 + P1(0)*w2(0)*x24 - P1(1)*x25 - P1(3)*&
                  x28 - P2(1)*x25 - P2(3)*x28 + co(0)*x12 + co(1)*x12 + x10*x9 &
                   - x15*x16 - x16*x19 + x2*x3 - x20*x21 - x21*x22 - x21*x23 - &
                  x26*x27 - x26*x29 + x3*x5 - x30*x31 - x32*x33 - x34*x35 + x8*&
                  x9)
        wout(1) = w1(0)*(P1(0)*co(1)*x46 - P1(3)*co(1)*x18 - P2(2)*co(1)*x7 +  &
                  w2(1)*x39 - x13*x47 - x13*x49 - x16*x41 - x16*x42 + x2*x36 - &
                  x20*x43 - x20*x44 - x22*x44 - x23*x44 + x24*x30 - x27*x6 -   &
                  x29*x6 + x30*x45 + x36*x5 + x37*x9 + x38*x9 - x43*x48 - x44* &
                  x48)
        wout(2) = w1(0)*(P1(0)*x54 - P1(2)*P2(2)*x53 - P1(2)*w2(2)*x29 + P2(0)*&
                  x54 - co(0)*x52 - co(1)*x52 + w2(2)*x39 - x0*x47 - x0*x49 -  &
                  x1*x35 - x15*x36 - x19*x36 - x20*x53 - x23*x53 + x26*x55 + x3&
                  *x41 + x3*x42 - x31*x6 - x50*x9 - x51*x9 - x56*x7 - x57*x7)
        wout(3) = w1(0)*(-P1(1)*co(1)*x17 + w2(3)*x39 - x1*x27 - x1*x29 + x10* &
                  x36 - x14*x56 - x14*x57 + x16*x50 + x16*x51 - x20*x59 - x22* &
                  x59 - x23*x58 - x23*x59 + x24*x34 - x3*x37 - x3*x38 - x33*x4 &
                   + x34*x45 + x36*x8 + x40*x55 - x58*x60 - x59*x60)
      case(SVV5)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
!       c2*(Epsilon(-1,-2,-3,2)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,1) + Epsilon(-1,-3,2,
!       3)*P(-1,1)*P(-2,1)*P(-2,3)*P(-3,2))
!       c3*(-Epsilon(-1,-2,-3,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(2,1) - Epsilon(-2,-3,2
!       ,3)*P(-1,1)*P(-1,2)*P(-2,1)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P1(2)*w2(3) - P1(3)*w2(2)
        x1 = P1(1)*w2(2) - P1(2)*w2(1)
        x2 = P1(1)*w2(3) - P1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(2)*x4
        x6 = P2(2)*w2(3) - P2(3)*w2(2)
        x7 = P2(1)*w2(2) - P2(2)*w2(1)
        x8 = P2(1)*w2(3) - P2(3)*w2(1)
        x9 = P2(1)*x6 - P2(2)*x8 + P2(3)*x7
        x10 = P1(0)*w2(2) - P1(2)*w2(0)
        x11 = P1(0)*w2(3) - P1(3)*w2(0)
        x12 = P2(0)*x0 - P2(2)*x11 + P2(3)*x10
        x13 = P1(0)*P1(1)*co(2)
        x14 = P2(0)*w2(2) - P2(2)*w2(0)
        x15 = P2(0)*w2(3) - P2(3)*w2(0)
        x16 = P2(0)*x6 - P2(2)*x15 + P2(3)*x14
        x17 = P1(0)*w2(1) - P1(1)*w2(0)
        x18 = P2(0)*x1 - P2(1)*x10 + P2(2)*x17
        x19 = P1(0)*P1(3)*co(2)
        x20 = P2(0)*w2(1) - P2(1)*w2(0)
        x21 = P2(0)*x7 - P2(1)*x14 + P2(2)*x20
        x22 = P2(1)**2
        x23 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x24 = co(0)*x22*x23
        x25 = P2(2)**2
        x26 = co(0)*x23*x25
        x27 = P2(3)**2
        x28 = co(0)*x23*x27
        x29 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x30 = P1(1)*P2(1)*co(3)
        x31 = P1(1)*x6
        x32 = P1(3)*x7
        x33 = P1(2)*x8
        x34 = x31 + x32 - x33
        x35 = P1(2)*P2(2)*co(3)
        x36 = P1(1)**2
        x37 = P1(2)**2
        x38 = P1(3)**2
        x39 = co(2)*(x36 + x37 + x38 - x4)
        x40 = P1(1)*P2(1)
        x41 = P1(2)*P2(2)
        x42 = P1(3)*P2(3)
        x43 = P1(0)*P2(0)
        x44 = x40 + x41 + x42 - x43
        x45 = co(2)*x44
        x46 = P1(1)*P2(3) - P1(3)*P2(1)
        x47 = P1(2)*co(3)*x23
        x48 = P1(3)*P2(3)*co(3)
        x49 = co(0)*x23*x4
        x50 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x51 = co(0)*x50
        x52 = P2(0)**2
        x53 = x22 + x25 + x27 - x52
        x54 = co(1)*w2(0)*x53
        x55 = co(1)*w2(0)*x44
        x56 = P2(0)*x2 - P2(1)*x11 + P2(3)*x17
        x57 = P1(0)*P1(2)*co(2)
        x58 = P2(0)*x8 - P2(1)*x15 + P2(3)*x20
        x59 = P1(0)*P2(0)*co(3)
        x60 = co(3)*x23*(P1(2)*P2(3) - P1(3)*P2(2))
        x61 = P1(1)*P2(2)
        x62 = -P1(2)*P2(1) + x61
        x63 = P1(3)*co(3)*x23
        x64 = P2(0)*co(0)*x23
        x65 = P1(0)*co(0)*x50
        x66 = P1(3)*P2(3)*co(0)*x50
        x67 = co(2)*x36
        x68 = P1(1)*P1(3)*co(2)
        x69 = P1(0)*x0 - P1(2)*x11 + P1(3)*x10
        x70 = P1(0)*x6
        x71 = P1(3)*x14
        x72 = P1(2)*x15
        x73 = co(3)*(x70 + x71 - x72)
        x74 = P1(3)*P2(0)
        x75 = co(3)*x23*(P1(0)*P2(3) - x74)
        x76 = co(1)*w2(1)*x53
        x77 = co(1)*x36*x44
        x78 = co(1)*x37*x44
        x79 = co(1)*x44
        x80 = P1(1)*P1(2)*co(2)
        x81 = co(0)*x23*x52
        x82 = P1(0)*P2(2) - P1(2)*P2(0)
        x83 = co(0)*x23
        x84 = P2(1)*x36
        x85 = P2(1)*co(0)*x23
        x86 = co(1)*x4*x44
        x87 = P1(0)*P2(1)
        x88 = P1(2)*co(0)*x50
        x89 = co(2)*x37
        x90 = P1(0)*x2 - P1(1)*x11 + P1(3)*x17
        x91 = P1(0)*x8
        x92 = P1(3)*x20
        x93 = P1(1)*x15
        x94 = x91 + x92 - x93
        x95 = P1(0)*co(3)*x23
        x96 = P1(2)*P1(3)*co(2)
        x97 = -P1(1)*P2(0) + x87
        x98 = co(1)*x53
        x99 = co(1)*x37*x53
        x100 = w2(2)*x38
        x101 = P2(2)*co(0)*x23
        x102 = P2(2)*x37
        x103 = co(1)*x4*x53
        x104 = co(2)*x38
        x105 = P1(0)*x1 - P1(1)*x10 + P1(2)*x17
        x106 = P1(0)*x7
        x107 = P1(2)*x20
        x108 = P1(1)*x14
        x109 = x106 + x107 - x108
        x110 = w2(3)*x36
        x111 = w2(3)*x38
        x112 = P2(3)*co(0)*x23
        x113 = P2(3)*x38
        x114 = P1(3)*co(0)*x50
        wout(0) = w1(0)*(P1(0)*x24 + P1(0)*x26 + P1(0)*x28 - P1(0)*x66 - P1(1)*&
                  x60 + P2(0)*x4*x51 + P2(0)*x49 + x12*x13 + x13*x16 + x18*x19 &
                   + x19*x21 + x29*x30 + x29*x35 + x29*x48 - x29*x59 - x3*x5 + &
                  x30*x34 - x31*x39 - x31*x45 - x32*x39 - x32*x45 + x33*x39 +  &
                  x33*x45 + x34*x35 + x34*x48 - x34*x59 + x36*x54 + x36*x55 -  &
                  x36*x64 + x37*x54 + x37*x55 - x37*x64 + x38*x54 + x38*x55 -  &
                  x38*x64 - x4*x54 - x4*x55 - x40*x64 - x40*x65 - x41*x64 - x41&
                  *x65 - x42*x64 + x46*x47 - x5*x9 - x56*x57 - x57*x58 - x62*  &
                  x63)
        wout(1) = w1(0)*(P1(0)*P1(1)*P2(0)*x51 - P1(0)*x60 + P1(1)*x26 + P1(1)*&
                  x28 - P1(1)*x66 - P1(1)*x81 + P1(2)*x75 + P2(1)*x49 + w2(1)* &
                  x38*x79 + w2(1)*x77 + w2(1)*x78 - w2(1)*x86 + x12*x67 - x13* &
                  x3 - x13*x9 + x16*x67 + x18*x68 + x21*x68 + x30*x69 + x35*x69&
                   + x36*x76 + x37*x76 - x37*x85 + x38*x76 - x38*x85 - x39*x70 &
                   - x39*x71 + x39*x72 - x4*x76 + x40*x73 + x41*x73 - x41*x85  &
                   + x42*x73 - x42*x85 - x43*x73 - x45*x70 - x45*x71 + x45*x72 &
                   + x48*x69 - x51*x84 - x56*x80 - x58*x80 - x59*x69 - x61*x88 &
                   - x63*x82 + x64*x87 - x83*x84)
        wout(2) = w1(0)*(-P1(1)*x75 + P1(2)*x24 + P1(2)*x28 - P1(2)*x81 + P2(2 &
                  )*x49 - w2(2)*x103 + w2(2)*x36*x98 + w2(2)*x77 + w2(2)*x78 - &
                  w2(2)*x86 + w2(2)*x99 + x100*x79 + x100*x98 - x101*x36 - x101&
                  *x38 - x101*x40 - x101*x42 + x101*x43 - x102*x51 - x102*x83  &
                   + x12*x80 + x16*x80 + x18*x96 + x21*x96 - x3*x57 - x30*x90  &
                   - x30*x94 - x35*x90 - x35*x94 + x39*x91 + x39*x92 - x39*x93 &
                   - x40*x88 - x42*x88 + x43*x88 + x45*x91 + x45*x92 - x45*x93 &
                   + x46*x95 - x48*x90 - x48*x94 - x56*x89 - x57*x9 - x58*x89  &
                   + x59*x90 + x59*x94 + x63*x97)
        wout(3) = w1(0)*(P1(1)*co(3)*x23*x82 + P1(3)*x24 + P1(3)*x26 - P1(3)*  &
                  x81 + P2(3)*x49 - w2(3)*x103 + w2(3)*x78 - w2(3)*x86 + w2(3)*&
                  x99 + x104*x18 + x104*x21 + x105*x30 + x105*x35 + x105*x48 - &
                  x105*x59 - x106*x39 - x106*x45 - x107*x39 - x107*x45 + x108* &
                  x39 + x108*x45 + x109*x30 + x109*x35 + x109*x48 - x109*x59 + &
                  x110*x79 + x110*x98 + x111*x79 + x111*x98 - x112*x36 - x112* &
                  x37 - x112*x40 - x112*x41 + x112*x43 - x113*x51 - x113*x83 - &
                  x114*x40 - x114*x41 + x12*x68 + x16*x68 - x19*x3 - x19*x9 -  &
                  x47*x97 - x56*x96 - x58*x96 - x62*x95 + x65*x74)
      case(SVV6)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
!       c2*(Epsilon(-1,-2,-3,2)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,1) + Epsilon(-1,-3,2,
!       3)*P(-1,1)*P(-2,1)*P(-2,3)*P(-3,2))
        if (last) VB_last = .true.
        x0 = P1(2)*w2(3) - P1(3)*w2(2)
        x1 = P1(1)*w2(2) - P1(2)*w2(1)
        x2 = P1(1)*w2(3) - P1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(2)*x4
        x6 = P2(2)*w2(3) - P2(3)*w2(2)
        x7 = P2(1)*w2(2) - P2(2)*w2(1)
        x8 = P2(1)*w2(3) - P2(3)*w2(1)
        x9 = P2(1)*x6 - P2(2)*x8 + P2(3)*x7
        x10 = P1(0)*w2(2) - P1(2)*w2(0)
        x11 = P1(0)*w2(3) - P1(3)*w2(0)
        x12 = P2(0)*x0 - P2(2)*x11 + P2(3)*x10
        x13 = P1(0)*P1(1)*co(2)
        x14 = P2(0)*w2(2) - P2(2)*w2(0)
        x15 = P2(0)*w2(3) - P2(3)*w2(0)
        x16 = P2(0)*x6 - P2(2)*x15 + P2(3)*x14
        x17 = P1(0)*w2(1) - P1(1)*w2(0)
        x18 = P2(0)*x1 - P2(1)*x10 + P2(2)*x17
        x19 = P1(0)*P1(3)*co(2)
        x20 = P2(0)*w2(1) - P2(1)*w2(0)
        x21 = P2(0)*x7 - P2(1)*x14 + P2(2)*x20
        x22 = P2(1)**2
        x23 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x24 = co(0)*x22*x23
        x25 = P2(2)**2
        x26 = co(0)*x23*x25
        x27 = P2(3)**2
        x28 = co(0)*x23*x27
        x29 = P1(1)**2
        x30 = P1(2)**2
        x31 = P1(3)**2
        x32 = x29 + x30 + x31 - x4
        x33 = P1(2)*co(2)*x32
        x34 = P1(1)*P2(1)
        x35 = P1(2)*P2(2)
        x36 = P1(3)*P2(3)
        x37 = P1(0)*P2(0)
        x38 = x34 + x35 + x36 - x37
        x39 = P1(2)*co(2)*x38
        x40 = co(0)*x23*x4
        x41 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x42 = co(0)*x41
        x43 = P2(0)**2
        x44 = x22 + x25 + x27 - x43
        x45 = co(1)*w2(0)*x44
        x46 = co(1)*w2(0)*x38
        x47 = P2(0)*x2 - P2(1)*x11 + P2(3)*x17
        x48 = P1(0)*P1(2)*co(2)
        x49 = P2(0)*x8 - P2(1)*x15 + P2(3)*x20
        x50 = P1(1)*co(2)*x6
        x51 = P1(3)*co(2)*x32
        x52 = P1(3)*co(2)*x38
        x53 = co(0)*x23*x29
        x54 = co(0)*x23*x30
        x55 = co(0)*x23*x31
        x56 = P1(0)*co(0)*x41
        x57 = P2(0)*co(0)*x23
        x58 = co(2)*x29
        x59 = P1(1)*P1(3)*co(2)
        x60 = co(1)*w2(1)*x44
        x61 = co(1)*x29*x38
        x62 = co(1)*x30*x38
        x63 = co(1)*x38
        x64 = P1(0)*co(2)*x32
        x65 = P1(0)*co(2)*x38
        x66 = P1(1)*P1(2)*co(2)
        x67 = co(0)*x23*x43
        x68 = x14*x32
        x69 = P2(1)*x29
        x70 = co(1)*x38*x4
        x71 = P1(1)*co(0)*x41
        x72 = P2(1)*co(0)*x23
        x73 = co(2)*x30
        x74 = P1(2)*P1(3)*co(2)
        x75 = co(1)*x44
        x76 = co(1)*x30*x44
        x77 = w2(2)*x31
        x78 = P1(1)*co(2)*x15
        x79 = co(1)*x4*x44
        x80 = P1(2)*co(0)*x41
        x81 = P2(2)*co(0)*x23
        x82 = co(2)*x31
        x83 = P1(1)*co(2)
        x84 = w2(3)*x29
        x85 = w2(3)*x31
        x86 = P1(3)*co(0)*x41
        x87 = P2(3)*co(0)*x23
        wout(0) = w1(0)*(P1(0)*x24 + P1(0)*x26 + P1(0)*x28 + P2(0)*x4*x42 + P2(&
                  0)*x40 - P2(0)*x53 - P2(0)*x54 - P2(0)*x55 + x12*x13 + x13*  &
                  x16 + x18*x19 + x19*x21 + x29*x45 + x29*x46 - x3*x5 + x30*x45&
                   + x30*x46 + x31*x45 + x31*x46 - x32*x50 + x33*x8 - x34*x56  &
                   - x34*x57 - x35*x56 - x35*x57 - x36*x56 - x36*x57 - x38*x50 &
                   + x39*x8 - x4*x45 - x4*x46 - x47*x48 - x48*x49 - x5*x9 - x51&
                  *x7 - x52*x7)
        wout(1) = w1(0)*(P1(1)*x26 + P1(1)*x28 - P1(1)*x67 - P1(3)*co(2)*x68 + &
                  P2(1)*x40 - P2(1)*x54 - P2(1)*x55 - co(0)*x23*x69 + w2(1)*x31&
                  *x63 + w2(1)*x61 + w2(1)*x62 - w2(1)*x70 + x12*x58 - x13*x3  &
                   - x13*x9 - x14*x52 + x15*x33 + x15*x39 + x16*x58 + x18*x59  &
                   + x21*x59 + x29*x60 + x30*x60 + x31*x60 - x35*x71 - x35*x72 &
                   - x36*x71 - x36*x72 + x37*x71 + x37*x72 - x4*x60 - x42*x69  &
                   - x47*x66 - x49*x66 - x6*x64 - x6*x65)
        wout(2) = w1(0)*(P1(2)*x24 + P1(2)*x28 - P1(2)*x67 - P2(2)*x30*x42 + P2&
                  (2)*x40 - P2(2)*x53 - P2(2)*x54 - P2(2)*x55 + w2(2)*x29*x75  &
                   + w2(2)*x61 + w2(2)*x62 - w2(2)*x70 + w2(2)*x76 - w2(2)*x79 &
                   + x12*x66 + x16*x66 + x18*x74 + x20*x51 + x20*x52 + x21*x74 &
                   - x3*x48 - x32*x78 - x34*x80 - x34*x81 - x36*x80 - x36*x81  &
                   + x37*x80 + x37*x81 - x38*x78 - x47*x73 - x48*x9 - x49*x73  &
                   + x63*x77 + x64*x8 + x65*x8 + x75*x77)
        wout(3) = w1(0)*(P1(3)*x24 + P1(3)*x26 - P1(3)*x67 - P2(3)*x31*x42 + P2&
                  (3)*x40 - P2(3)*x53 - P2(3)*x54 - P2(3)*x55 + w2(3)*x62 - w2(&
                  3)*x70 + w2(3)*x76 - w2(3)*x79 + x12*x59 + x14*x38*x83 + x16*&
                  x59 + x18*x82 - x19*x3 - x19*x9 - x20*x33 - x20*x39 + x21*x82&
                   - x34*x86 - x34*x87 - x35*x86 - x35*x87 + x37*x86 + x37*x87 &
                   - x47*x74 - x49*x74 + x63*x84 + x63*x85 - x64*x7 - x65*x7 + &
                  x68*x83 + x75*x84 + x75*x85)
      case(SVV7)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x0vec = P1(:)*co(0)*x1
        x2 = P2(2)**2
        x3 = P2(3)**2
        x4 = P1(0)**2
        x1vec = P2(:)*co(0)*x1
        x5 = P2(0)**2
        x6 = x0 + x2 + x3 - x5
        x7 = P1(1)**2
        x2vec = co(1)*w2(:)*x7
        x8 = P1(1)*P2(1)
        x9 = P1(2)*P2(2)
        x10 = P1(3)*P2(3)
        x11 = P1(0)*P2(0)
        x12 = x10 - x11 + x8 + x9
        x13 = P1(2)**2
        x3vec = co(1)*w2(:)*x6
        x4vec = co(1)*w2(:)*x12
        x14 = P1(3)**2
        x5vec = P1(:)*co(0)*(-P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)* &
        w2(3))
        wout = w1(0)*(x0*x0vec + x0vec*x2 + x0vec*x3 - x0vec*x5 - x10*x1vec -  &
               x10*x5vec + x11*x1vec + x11*x5vec + x12*x2vec - x13*x1vec + x13*&
               x3vec + x13*x4vec - x14*x1vec + x14*x3vec + x14*x4vec + x1vec*x4&
                - x1vec*x7 - x1vec*x8 - x1vec*x9 + x2vec*x6 - x3vec*x4 - x4*   &
               x4vec - x5vec*x8 - x5vec*x9)
      case(SVV8)
!       P(2,1)*P(3,2)*c0
!       Metric(2,3)*P(-1,1)*P(-1,2)*c1
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*c2
        if (last) VB_last = .true.
        x0 = P2(1)*w2(3)
        x1 = P2(3)*w2(1)
        x2 = x0 - x1
        x3 = P1(2)*co(2)
        x4 = P2(2)*w2(3)
        x5 = P2(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*co(2)
        x8 = P2(1)*w2(2)
        x9 = P2(2)*w2(1)
        x10 = x8 - x9
        x11 = P1(3)*co(2)
        x12 = P2(0)*w2(1)
        x13 = P1(1)*co(0)
        x14 = P2(1)*w2(0)
        x15 = P1(1)*co(1)
        x16 = P2(0)*w2(2)
        x17 = P1(2)*co(0)
        x18 = P2(2)*w2(0)
        x19 = P1(2)*co(1)
        x20 = P2(0)*w2(3)
        x21 = P1(3)*co(0)
        x22 = P2(3)*w2(0)
        x23 = P1(3)*co(1)
        x24 = P1(0)*co(0)
        x25 = P2(0)*w2(0)
        x26 = P1(0)*co(1)
        x27 = co(2)*(x20 - x22)
        x28 = P1(0)*co(2)
        x29 = x16 - x18
        x30 = P2(1)*w2(1)
        x31 = x12 - x14
        x32 = P2(2)*w2(2)
        x33 = P2(3)*w2(3)
        wout(0) = w1(0)*(-x10*x11 + x12*x13 + x14*x15 + x16*x17 + x18*x19 + x2*&
                  x3 + x20*x21 + x22*x23 - x24*x25 - x25*x26 - x6*x7)
        wout(1) = w1(0)*(P1(2)*x27 + x0*x21 + x1*x23 - x11*x29 - x12*x26 + x13*&
                  x30 - x14*x24 + x15*x30 + x17*x8 + x19*x9 - x28*x6)
        wout(2) = w1(0)*(-P1(1)*x27 + x11*x31 + x13*x9 + x15*x8 - x16*x26 + x17&
                  *x32 - x18*x24 + x19*x32 + x2*x28 + x21*x4 + x23*x5)
        wout(3) = w1(0)*(x0*x15 + x1*x13 - x10*x28 + x17*x5 + x19*x4 - x20*x26 &
                   + x21*x33 - x22*x24 + x23*x33 + x29*x7 - x3*x31)
      end select 
    end subroutine treeSVV
end module tcSVV
