!******************************************************************************!
!                                                                              !
!    tcVVV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-29 19:45             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeVVV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVV0)
!       c0*(-P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon
!       (-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon(-1,-2,-3,3)*
!       Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - 2*Epsilon(-1,-2,1,2)*P
!       (-1,2)*P(-2,3)*P(3,1) + 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Metric(1,3)*P(2,3) - Metric(2,3)*P(1,3))
!       c5*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (2,3)*P(1,2))
!       Epsilon(-1,1,2,3)*P(-1,3)*c6
!       c7*(Epsilon(-1,1,2,3)*P(-1,1) + Epsilon(-1,1,2,3)*P(-1,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3)
        x1 = w1(3)*w2(2)
        x2 = x0 - x1
        x3 = P1(1)*x2
        x4 = w1(1)*w2(3)
        x5 = -w1(3)*w2(1) + x4
        x6 = P1(2)*x5
        x7 = w1(1)*w2(2)
        x8 = -w1(2)*w2(1) + x7
        x9 = P1(3)*x8
        x10 = w1(3)*w2(3)
        x11 = w1(0)*w2(0)
        x12 = w1(1)*w2(1) + w1(2)*w2(2) + x10 - x11
        x13 = co(5)*x12
        x14 = P2(1)*x2
        x15 = P2(2)*x5
        x16 = P2(3)*x8
        x17 = x14 - x15 + x16
        x18 = P1(0)**2
        x19 = 2*co(3)*x18
        x20 = P1(1)**2
        x21 = 2*co(3)*x20
        x22 = P1(2)**2
        x23 = 2*co(3)*x22
        x24 = P1(3)**2
        x25 = 2*co(3)*x24
        x26 = w1(0)*w2(1)
        x27 = P1(1)*co(4)
        x28 = co(5)*w1(0)*w2(1)
        x29 = P1(2)*w1(0)
        x30 = co(4)*w2(2)
        x31 = P1(3)*w1(0)
        x32 = co(4)*w2(3)
        x33 = P2(0)*co(1)*x12
        x34 = co(1)*x12*x22
        x35 = P2(0)*co(5)
        x36 = P2(2)*w1(0)
        x37 = w1(0)*w2(3)
        x38 = P2(3)*co(4)
        x39 = P2(0)**2
        x40 = P1(1)*w2(1)
        x41 = P1(2)*w2(2)
        x42 = P1(3)*w2(3)
        x43 = P1(0)*w2(0)
        x44 = x40 + x41 + x42 - x43
        x45 = w1(0)*x39*x44
        x46 = w1(0)*x44
        x47 = P2(1)**2
        x48 = co(1)*x47
        x49 = P2(2)**2
        x50 = co(1)*x49
        x51 = P2(3)**2
        x52 = co(1)*x51
        x53 = P2(2)*w1(2)
        x54 = P2(3)*w1(3)
        x55 = -P2(0)*w1(0) + P2(1)*w1(1) + x53 + x54
        x56 = co(1)*x18*x55
        x57 = co(1)*x12*x47
        x58 = co(1)*x12*x49
        x59 = co(1)*x12*x51
        x60 = P1(0)*w1(0)
        x61 = co(5)*w2(0)
        x62 = P1(1)*w1(1)
        x63 = co(4)*w2(0)
        x64 = P1(2)*w2(0)
        x65 = co(4)*w1(2)
        x66 = P1(3)*w2(0)
        x67 = co(4)*w1(3)
        x68 = P2(1)*w2(0)
        x69 = co(4)*w1(1)
        x70 = co(5)*w1(1)
        x71 = P2(2)*co(5)*w1(2)
        x72 = P2(3)*w2(0)
        x73 = co(5)*w1(3)
        x74 = co(1)*x20*x55
        x75 = co(1)*x22*x55
        x76 = co(1)*x24*x55
        x77 = 8*co(3)
        x78 = x3 - x6 + x9
        x79 = 6*co(3)
        x80 = P2(1)*w2(3)
        x81 = P2(3)*w2(1)
        x82 = x80 - x81
        x83 = 4*P1(2)*co(3)*x55
        x84 = P1(0)*P2(2)
        x85 = P1(0)*x5
        x86 = -w1(1)*w2(0) + x26
        x87 = P1(3)*x86
        x88 = w1(3)*w2(0)
        x89 = x37 - x88
        x90 = P1(1)*x89
        x91 = x85 + x87 - x90
        x92 = 2*co(3)*x91
        x93 = P2(0)*x5
        x94 = P2(3)*x86
        x95 = P2(1)*x89
        x96 = x93 + x94 - x95
        x97 = 2*co(3)*x96
        x98 = P1(1)*w1(0)
        x99 = P1(2)*w2(3)
        x100 = P1(3)*w2(2)
        x101 = -x100 + x99
        x102 = P1(0)*w2(2)
        x103 = x102 - x64
        x104 = P1(0)*w2(3)
        x105 = x104 - x66
        x106 = 2*co(2)*(P2(0)*x101 - P2(2)*x105 + P2(3)*x103)
        x107 = P2(2)*w2(3) - P2(3)*w2(2)
        x108 = P2(0)*w2(2)
        x109 = -P2(2)*w2(0) + x108
        x110 = P2(0)*w2(3) - x72
        x111 = 2*co(2)*(P2(0)*x107 - P2(2)*x110 + P2(3)*x109)
        x112 = P1(1)*w2(0)
        x113 = P1(2)*w1(3)
        x114 = P1(3)*w1(2)
        x115 = x113 - x114
        x116 = P2(0)*x115
        x117 = P1(0)*w1(2)
        x118 = x117 - x29
        x119 = P2(3)*x118
        x120 = P1(0)*w1(3)
        x121 = x120 - x31
        x122 = P2(2)*x121
        x123 = 2*co(2)*(x116 + x119 - x122)
        x124 = P2(2)*w1(3)
        x125 = P2(3)*w1(2)
        x126 = x124 - x125
        x127 = P2(0)*x126
        x128 = P2(0)*w1(2) - x36
        x129 = P2(3)*x128
        x130 = P2(3)*w1(0)
        x131 = P2(0)*w1(3) - x130
        x132 = P2(2)*x131
        x133 = 2*co(2)*(x127 + x129 - x132)
        x134 = P1(2)*P2(3)
        x135 = P1(3)*P2(2)
        x136 = x134 - x135
        x137 = 2*P1(1)*co(2)*x12
        x138 = P1(2)*P2(0)
        x139 = P1(1)*w2(3)
        x140 = P1(3)*w2(1)
        x141 = x139 - x140
        x142 = 2*P1(2)*co(3)*x55
        x143 = P2(3)*w1(1)
        x144 = P2(1)*w1(3) - x143
        x145 = 2*P1(2)*co(3)*x44
        x146 = P2(1)*w2(1)
        x147 = P2(0)*w2(0)
        x148 = P2(2)*w2(2) + P2(3)*w2(3) + x146 - x147
        x149 = 2*P1(2)*co(3)*x148
        x150 = P1(2)*w1(2)
        x151 = P1(3)*w1(3)
        x152 = x150 + x151 - x60 + x62
        x153 = 2*P1(2)*co(3)*x152
        x154 = 2*co(3)*(-x39 + x47 + x49 + x51)
        x155 = P1(1)*P2(1)
        x156 = P1(2)*P2(2)
        x157 = P1(3)*P2(3)
        x158 = P1(0)*P2(0)
        x159 = 2*co(3)*(x155 + x156 + x157 - x158)
        x160 = P1(1)*w2(2)
        x161 = P1(2)*w2(1)
        x162 = x160 - x161
        x163 = P1(0)*w2(1)
        x164 = -x112 + x163
        x165 = 2*co(2)*(P2(0)*x162 - P2(1)*x103 + P2(2)*x164)
        x166 = P2(1)*w2(2) - P2(2)*w2(1)
        x167 = P2(0)*w2(1) - x68
        x168 = 2*co(2)*(P2(0)*x166 - P2(1)*x109 + P2(2)*x167)
        x169 = P1(1)*w1(2)
        x170 = P1(2)*w1(1)
        x171 = x169 - x170
        x172 = P2(0)*x171
        x173 = P1(0)*w1(1)
        x174 = x173 - x98
        x175 = P2(2)*x174
        x176 = P2(1)*x118
        x177 = 2*co(2)*(x172 + x175 - x176)
        x178 = P2(1)*w1(2)
        x179 = P2(2)*w1(1)
        x180 = x178 - x179
        x181 = P2(0)*x180
        x182 = P2(0)*w1(1)
        x183 = P2(1)*w1(0)
        x184 = x182 - x183
        x185 = P2(2)*x184
        x186 = P2(1)*x128
        x187 = 2*co(2)*(x181 + x185 - x186)
        x188 = P1(1)*P2(2)
        x189 = P1(2)*P2(1)
        x190 = x188 - x189
        x191 = 2*P1(3)*co(2)*x12
        x192 = P2(1)*x115
        x193 = 2*co(3)*x44
        x194 = P2(1)*x126
        x195 = P2(3)*x171
        x196 = P2(3)*x180
        x197 = P1(0)*P2(1)
        x198 = P1(0)*x2
        x199 = w1(0)*w2(2) - w1(2)*w2(0)
        x200 = P1(3)*x199
        x201 = P1(2)*x89
        x202 = x198 + x200 - x201
        x203 = 2*co(3)*x202
        x204 = P2(0)*x2
        x205 = P2(3)*x199
        x206 = P2(2)*x89
        x207 = x204 + x205 - x206
        x208 = 2*co(3)*x207
        x209 = P1(0)*P2(3)
        x210 = P1(0)*x8
        x211 = P1(2)*x86
        x212 = P1(1)*x199
        x213 = x210 + x211 - x212
        x214 = 2*co(3)*x213
        x215 = P2(0)*x8
        x216 = P2(2)*x86
        x217 = P2(1)*x199
        x218 = x215 + x216 - x217
        x219 = 2*co(3)*x218
        x220 = 2*co(2)*(P2(1)*x101 - P2(2)*x141 + P2(3)*x162)
        x221 = 2*co(2)*(P2(1)*x107 - P2(2)*x82 + P2(3)*x166)
        x222 = P1(1)*w1(3)
        x223 = P1(3)*w1(1)
        x224 = x222 - x223
        x225 = P2(2)*x224
        x226 = 2*co(2)*(x192 + x195 - x225)
        x227 = P2(2)*x144
        x228 = 2*co(2)*(x194 + x196 - x227)
        x229 = P1(1)*P2(0)
        x230 = 2*co(3)*x78
        x231 = 2*P1(1)*co(3)*x55
        x232 = P1(1)*x126
        x233 = 2*co(3)*x148
        x234 = 2*co(3)*x152
        x235 = P1(1)*x107
        x236 = P2(0)*x141 - P2(1)*x105 + P2(3)*x164
        x237 = 2*co(2)*x236
        x238 = P2(0)*x82 - P2(1)*x110 + P2(3)*x167
        x239 = 2*co(2)*x238
        x240 = P2(0)*x224
        x241 = P2(3)*x174
        x242 = P2(1)*x121
        x243 = 2*co(2)*(x240 + x241 - x242)
        x244 = P2(0)*x144
        x245 = P2(3)*x184
        x246 = P2(1)*x131
        x247 = 2*co(2)*(x244 + x245 - x246)
        x248 = P1(1)*P2(3)
        x249 = P1(3)*P2(1)
        x250 = x248 - x249
        x251 = 2*P1(2)*co(2)*x12
        x252 = P1(3)*P2(0)
        x253 = 2*P1(3)*co(3)*x55
        x254 = 2*P1(3)*co(3)*x148
        x255 = 2*P1(3)*co(3)*x152
        x256 = 4*P1(1)*P2(1)*co(3)
        x257 = 4*co(3)*x55
        x258 = 4*co(3)*x17
        x259 = 4*P1(3)*co(3)*x55
        x260 = co(1)*w1(0)*x148
        x261 = co(0)*w1(1)*x44
        x262 = co(0)*x148
        x263 = co(0)*x44
        x264 = P1(0)*P2(2)*w1(2)
        x265 = P2(3)*co(0)*x44
        x266 = P2(3)*co(0)*x148
        x267 = P1(1)*co(1)*x152
        x268 = P1(2)*P2(2)*co(1)*x152
        x269 = P2(3)*co(1)*x12
        x270 = P2(3)*co(1)*x152
        x271 = P1(0)*co(1)*x12
        x272 = co(0)*w1(0)*x148
        x273 = P1(0)*P2(0)*co(1)*x152
        x274 = P1(1)*co(0)*x44
        x275 = w1(2)*x44
        x276 = co(0)*w1(3)*x44
        x277 = P2(1)*co(0)*x44
        x278 = P2(0)*co(0)*x44
        x279 = co(4)*w2(1)
        x280 = co(1)*x12*x39
        x281 = P1(3)*w1(1)*w2(3)
        x282 = P2(0)*co(4)
        x283 = P2(1)*co(1)*x12
        x284 = w1(1)*x44
        x285 = co(1)*x39
        x286 = 4*co(3)*x207
        x287 = 4*co(3)*x110*x55
        x288 = 2*co(3)*x17
        x289 = 2*P1(0)*co(2)*x12
        x290 = 2*co(3)*x131*x148
        x291 = -x138 + x84
        x292 = 2*P1(0)*co(3)*x55
        x293 = 2*P1(0)*co(3)*x44
        x294 = 2*P1(0)*co(3)*x148
        x295 = 2*P1(0)*co(3)*x152
        x296 = 2*co(2)*x12*(x209 - x252)
        x297 = 2*co(3)*x128*x44
        x298 = 4*P1(0)*co(3)*x55
        x299 = 4*co(3)*x109*x55
        x300 = P1(0)*P2(0)*co(1)*x12
        x301 = co(1)*w1(1)*x148
        x302 = P1(1)*P2(1)*w1(1)
        x303 = co(1)*x152
        x304 = P1(1)*P2(2)*w1(2)
        x305 = P1(1)*co(1)*x12
        x306 = co(0)*w1(0)*x44
        x307 = co(1)*x148
        x308 = P1(2)*co(0)*x44
        x309 = P2(2)*co(0)*x44
        x310 = co(4)*w1(0)
        x311 = P1(1)*w1(2)*w2(1)
        x312 = co(5)*w1(2)
        x313 = P1(3)*w1(2)*w2(3)
        x314 = P2(2)*co(1)*x12
        x315 = w1(2)*x44*x49
        x316 = P2(1)*w1(1)*w2(2)
        x317 = P2(3)*co(5)
        x318 = P1(0)*x82
        x319 = 4*co(3)*x96
        x320 = P1(3)*x184
        x321 = 2*P1(1)*co(3)*x152
        x322 = 2*P1(2)*co(2)*w1(2)
        x323 = x197 - x229
        x324 = co(1)*w2(2)*x152
        x325 = P1(2)*P2(1)*w1(1)
        x326 = P1(2)*P2(2)*w1(2)
        x327 = P2(0)*co(1)*x152
        x328 = P1(3)*co(1)*x12
        x329 = P1(3)*co(0)*x44
        x330 = w1(3)*x44
        x331 = 4*co(3)*x218
        x332 = 2*P1(3)*P2(2)*co(3)
        x333 = co(1)*w2(3)*x152
        wout(0) = -P1(0)*P2(0)*x17*x77 - P1(0)*P2(0)*x78*x79 + P1(0)*P2(1)*w1(1&
                  )*x262 - P1(0)*x13 - P1(0)*x57 - P1(0)*x58 - P1(0)*x59 + P1(1&
                  )*x28 - P1(2)*P2(0)*co(0)*x275 + P1(3)*x180*x193 + P2(0)*x13 &
                   + P2(0)*x34 + P2(1)*co(4)*x26 + co(0)*x45 - co(1)*x45 + co(5&
                  )*w2(2)*x29 + co(5)*w2(3)*x31 - co(6)*x14 + co(6)*x15 - co(6 &
                  )*x16 - co(6)*x3 + co(6)*x6 - co(6)*x9 + co(7)*x14 - co(7)*  &
                  x15 + co(7)*x16 + co(7)*x3 - co(7)*x6 + co(7)*x9 + w2(0)*x268&
                   - w2(0)*x273 + w2(0)*x56 - w2(0)*x71 - w2(0)*x74 - w2(0)*x75&
                   - w2(0)*x76 + x101*x231 - x106*x98 + x11*x35 - x111*x98 -   &
                  x112*x123 - x112*x133 + x120*x265 + x120*x266 - x136*x137 -  &
                  x138*x92 - x138*x97 - x141*x142 - x144*x145 - x144*x149 -    &
                  x153*x82 + x154*x3 - x154*x6 + x154*x9 + x155*x230 - x155*   &
                  x260 - x155*x271 + x155*x33 + x156*x230 + x156*x258 - x156*  &
                  x260 - x156*x271 + x156*x33 + x157*x230 + x157*x258 - x157*  &
                  x260 - x157*x271 + x158*x260 - x158*x272 + x159*x3 - x159*x6 &
                   + x159*x9 + x162*x253 - x165*x31 + x166*x255 + x166*x259 -  &
                  x168*x31 - x17*x19 + x17*x21 + x17*x23 + x17*x25 + x17*x256  &
                   - x177*x66 + x180*x254 - x182*x274 - x182*x277 - x187*x66 - &
                  x190*x191 - x192*x193 - x193*x194 - x193*x195 - x193*x196 +  &
                  x193*x225 + x193*x227 + x193*x232 + x197*x203 + x197*x208 +  &
                  x197*x261 + x20*x33 + x203*x229 + x208*x229 + x209*x214 +    &
                  x209*x219 + x214*x252 + x219*x252 + x220*x60 + x221*x60 +    &
                  x226*x43 + x228*x43 + x232*x233 + x234*x235 + x235*x257 +    &
                  x237*x29 + x239*x29 + x24*x33 + x243*x64 + x247*x64 + x250*  &
                  x251 + x252*x269 - x252*x276 + x26*x27 + x262*x264 + x263*   &
                  x264 + x267*x68 + x270*x66 - x278*x53 - x278*x54 + x29*x30 + &
                  x30*x36 + x31*x32 + x37*x38 + x46*x48 + x46*x50 + x46*x52 -  &
                  x53*x63 - x60*x61 - x62*x63 - x64*x65 - x66*x67 - x67*x72 -  &
                  x68*x69 - x68*x70 - x72*x73 - x82*x83 - x84*x92 - x84*x97
        wout(1) = P1(1)*P2(1)*w2(1)*x303 + P1(1)*P2(1)*x202*x79 + P1(1)*P2(1)* &
                  x207*x77 - P1(1)*x13 + P1(1)*x280 + P1(1)*x300 - P1(1)*x58 - &
                  P1(1)*x59 - P1(2)*x287 - P1(2)*x290 + P1(2)*x296 + P1(3)*P2(3&
                  )*w2(1)*x303 + P1(3)*x297 + P1(3)*x299 + P2(0)*x28 + P2(1)*  &
                  x13 + P2(1)*x34 + P2(2)*co(4)*x7 + co(4)*x281 + co(5)*x281 - &
                  co(6)*x198 - co(6)*x200 + co(6)*x201 - co(6)*x204 - co(6)*   &
                  x205 + co(6)*x206 + co(7)*x198 + co(7)*x200 - co(7)*x201 + co&
                  (7)*x204 + co(7)*x205 - co(7)*x206 + w2(1)*x268 - w2(1)*x273 &
                   + w2(1)*x56 - w2(1)*x71 - w2(1)*x74 - w2(1)*x75 - w2(1)*x76 &
                   + x101*x292 + x103*x253 - x105*x142 - x106*x62 + x107*x295  &
                   + x107*x298 + x109*x255 - x110*x153 - x111*x62 - x116*x193  &
                   - x119*x193 + x122*x193 - x123*x40 + x126*x293 + x126*x294  &
                   - x127*x193 + x128*x254 - x129*x193 - x131*x145 + x132*x193 &
                   - x133*x40 - x136*x289 - x140*x177 - x140*x187 - x146*x70 - &
                  x150*x279 - x151*x277 - x151*x279 + x154*x198 + x154*x200 -  &
                  x154*x201 + x156*x203 + x156*x283 + x156*x286 - x156*x301 -  &
                  x156*x305 + x157*x203 + x157*x283 + x157*x286 - x157*x301 -  &
                  x157*x305 - x158*x203 - x158*x283 - x158*x286 + x158*x301 +  &
                  x159*x198 + x159*x200 - x159*x201 + x161*x243 + x161*x247 +  &
                  x163*x226 + x163*x228 - x165*x223 - x168*x223 + x170*x237 +  &
                  x170*x239 + x173*x220 + x173*x221 - x178*x308 - x178*x309 -  &
                  x18*x283 - x182*x63 + x183*x278 - x188*x92 - x188*x97 - x189*&
                  x92 - x189*x97 - x19*x207 - x191*x291 - x197*x230 - x197*x288&
                   + x207*x21 + x207*x23 + x207*x25 + x214*x248 + x214*x249 +  &
                  x219*x248 + x219*x249 + x222*x265 + x222*x266 - x229*x230 -  &
                  x229*x272 - x229*x288 - x229*x306 + x24*x283 + x26*x282 -    &
                  x261*x47 + x262*x302 + x262*x304 + x263*x304 - x277*x54 +    &
                  x277*x60 - x279*x53 + x279*x60 - x284*x285 + x284*x48 + x284*&
                  x50 + x284*x52 - x302*x307 + x38*x4 + x40*x70 + x41*x69 + x41&
                  *x70 - x43*x69 - x43*x70 - x67*x81 - x73*x81
        wout(2) = P1(0)*P2(0)*w1(2)*x307 - P1(1)*P1(2)*P2(1)*co(1)*x12 - P1(1)*&
                  P2(1)*w1(2)*x307 + P1(1)*x131*x193 + P1(1)*x287 + P1(1)*x290 &
                   - P1(1)*x296 - P1(2)*P2(0)*w1(0)*x262 - P1(2)*P2(2)*x77*x96 &
                   - P1(2)*P2(2)*x79*x91 - P1(2)*x13 + P1(2)*x280 + P1(2)*x300 &
                   - P1(2)*x57 - P1(2)*x59 - P1(3)*P2(3)*w1(2)*x307 - P1(3)*co(&
                  4)*x1 + P2(2)*x13 - co(0)*x315 + co(1)*x315 + co(4)*x311 + co&
                  (4)*x313 - co(4)*x316 + co(5)*w1(0)*x108 + co(5)*x311 + co(5 &
                  )*x313 - co(5)*x316 + co(6)*x85 + co(6)*x87 - co(6)*x90 + co(&
                  6)*x93 + co(6)*x94 - co(6)*x95 - co(7)*x85 - co(7)*x87 + co(7&
                  )*x90 - co(7)*x93 - co(7)*x94 + co(7)*x95 + w2(2)*x56 - w2(2 &
                  )*x71 - w2(2)*x74 - w2(2)*x75 - w2(2)*x76 - x1*x317 - x1*x38 &
                   - x100*x177 - x100*x187 + x100*x270 + x102*x226 + x102*x228 &
                   + x102*x310 - x102*x327 + x105*x231 - x106*x169 + x108*x310 &
                   + x110*x321 - x111*x169 + x113*x265 + x113*x266 - x114*x165 &
                   - x114*x168 + x117*x220 + x117*x221 - x123*x160 - x124*x265 &
                   - x124*x329 + x125*x32 - x133*x160 + x134*x214 + x134*x219  &
                   - x134*x328 + x135*x214 + x135*x219 - x138*x230 - x138*x288 &
                   - x141*x292 - x144*x293 - x144*x294 - x147*x65 - x154*x85 - &
                  x154*x87 + x154*x90 + x155*x314 + x155*x324 - x155*x92 + x156&
                  *x324 + x157*x314 - x157*x319 - x157*x92 - x158*x314 + x158* &
                  x319 + x158*x92 - x159*x85 - x159*x87 + x159*x90 - x164*x253 &
                   - x167*x255 - x167*x259 + x178*x279 - x179*x277 - x18*x314  &
                   + x188*x203 + x188*x208 + x189*x203 + x189*x208 + x19*x96 + &
                  x191*x323 + x193*x240 + x193*x241 - x193*x242 + x193*x244 +  &
                  x193*x245 - x193*x246 - x193*x320 + x20*x314 - x21*x96 - x23*&
                  x96 - x230*x84 - x233*x320 - x234*x318 + x236*x322 + x238*   &
                  x322 + x24*x314 + x243*x41 + x247*x41 - x25*x96 + x250*x289  &
                   - x256*x96 - x257*x318 + x262*x325 + x262*x326 + x263*x325  &
                   - x275*x285 + x275*x48 + x275*x52 - x278*x29 + x278*x36 -   &
                  x288*x84 - x30*x62 - x307*x326 + x309*x60 - x309*x62 + x312* &
                  x41 - x312*x43 - x43*x65
        wout(3) = P1(0)*P2(0)*w1(3)*x307 - P1(1)*P2(1)*w1(3)*x307 - P1(1)*x128*&
                  x233 - P1(1)*x297 - P1(1)*x299 - P1(2)*P2(2)*w1(3)*x307 - P1(&
                  2)*co(4)*x0 + P1(3)*P2(1)*w1(1)*x262 + P1(3)*P2(2)*w1(2)*x262&
                   - P1(3)*P2(3)*w1(3)*x307 + P1(3)*P2(3)*x213*x79 + P1(3)*P2(3&
                  )*x218*x77 + P1(3)*co(5)*x10 - P1(3)*x13 + P1(3)*x280 - P1(3 &
                  )*x57 - P1(3)*x58 + P2(3)*x13 + P2(3)*x34 - co(6)*x210 - co(6&
                  )*x211 + co(6)*x212 - co(6)*x215 - co(6)*x216 + co(6)*x217 + &
                  co(7)*x210 + co(7)*x211 - co(7)*x212 + co(7)*x215 + co(7)*   &
                  x216 - co(7)*x217 + w2(3)*x56 - w2(3)*x71 - w2(3)*x74 - w2(3 &
                  )*x75 - w2(3)*x76 - x10*x317 - x103*x231 + x104*x226 + x104* &
                  x228 + x104*x310 - x104*x327 - x106*x222 - x109*x321 - x111* &
                  x222 + x113*x237 + x113*x239 + x120*x220 + x120*x221 - x120* &
                  x61 - x120*x63 - x123*x139 + x124*x30 - x125*x308 - x125*x309&
                   + x130*x278 - x133*x139 - x134*x92 - x134*x97 + x137*x291 + &
                  x142*x164 - x143*x274 - x143*x277 + x145*x184 + x146*x67 +   &
                  x149*x184 - x151*x165 - x151*x168 + x151*x266 + x153*x167 +  &
                  x154*x210 + x154*x211 - x154*x212 + x155*x214 + x155*x269 -  &
                  x155*x328 + x155*x331 + x156*x214 + x156*x269 - x156*x328 +  &
                  x156*x331 + x156*x333 + x157*x333 - x158*x214 - x158*x269 -  &
                  x158*x331 + x159*x210 + x159*x211 - x159*x212 + x162*x292 +  &
                  x166*x295 + x166*x298 + x167*x83 - x172*x193 - x175*x193 +   &
                  x176*x193 - x177*x42 - x18*x269 + x180*x293 + x180*x294 -    &
                  x181*x193 - x185*x193 + x186*x193 - x187*x42 - x19*x218 -    &
                  x190*x289 + x20*x269 + x203*x248 + x203*x249 + x208*x248 +   &
                  x208*x249 - x209*x230 - x209*x288 + x21*x218 + x218*x23 +    &
                  x218*x25 + x223*x277 - x230*x252 + x243*x99 + x247*x99 - x251&
                  *x323 + x252*x271 - x252*x272 - x252*x288 - x252*x306 + x265*&
                  x60 + x267*x80 - x27*x4 - x276*x51 + x282*x37 - x282*x88 -   &
                  x285*x330 - x32*x53 + x329*x53 + x330*x48 + x330*x50 + x330* &
                  x52 - x332*x91 - x332*x96 + x35*x37 + x40*x67 + x40*x73 + x41&
                  *x67 + x41*x73 - x69*x80 - x70*x80
      case(VVV1)
!       c0*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (1,3)*P(2,3) + Metric(2,3)*P(1,2) - Metric(2,3)*P(1,3))
        if (last) VB_last = .true.
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x0vec = w1(0)*w2(:)
        x1vec = w1(:)*w2(1)
        x2vec = w1(:)*w2(2)
        x3vec = w1(:)*w2(3)
        x4vec = w1(1)*w2(:)
        x5vec = w1(2)*w2(:)
        x6vec = w1(3)*w2(:)
        x7vec = w1(:)*w2(0)
        wout = co(0)*(P1(0)*x0vec - 2*P1(0)*x7vec + 2*P1(1)*x1vec - P1(1)*x4vec&
                + 2*P1(2)*x2vec - P1(2)*x5vec + 2*P1(3)*x3vec - P1(3)*x6vec -  &
               P1(:)*x0 + 2*P2(0)*x0vec - P2(0)*x7vec + P2(1)*x1vec - 2*P2(1)* &
               x4vec + P2(2)*x2vec - 2*P2(2)*x5vec + P2(3)*x3vec - 2*P2(3)*    &
               x6vec + P2(:)*x0)
      case(VVV2)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(2,3)*P(-1,1)*P(-1,2)*P(
!       1,3))
!       c2*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       c3*(-Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - Epsilon(-1,-2,2,3)*P(-1,
!       1)*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x2 = P1(0)*co(1)*x1
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P1(1)*w2(3) - P1(3)*w2(1)
        x6 = P2(2)*w1(2)
        x7 = P2(3)*w1(3)
        x8 = P2(0)*w1(0)
        x9 = P2(1)*w1(1) + x6 + x7 - x8
        x10 = P1(2)*co(3)*x9
        x11 = P2(1)*w2(3) - P2(3)*w2(1)
        x12 = P1(1)**2
        x13 = P2(0)*co(1)*x1
        x14 = P1(2)**2
        x15 = co(1)*x1*x14
        x16 = P1(3)**2
        x17 = P1(1)*w1(3)
        x18 = P1(3)*w1(1)
        x19 = x17 - x18
        x20 = P1(2)*w2(2)
        x21 = P1(3)*w2(3)
        x22 = P1(0)*w2(0)
        x23 = P1(1)*w2(1) + x20 + x21 - x22
        x24 = P2(2)*co(3)*x23
        x25 = P2(3)*w1(1)
        x26 = P2(1)*w1(3) - x25
        x27 = P2(0)**2
        x28 = w1(0)*x23*x27
        x29 = co(2)*x0*x23
        x30 = co(2)*x23*x3
        x31 = co(2)*x23*x4
        x32 = co(2)*x12*x9
        x33 = co(2)*x14*x9
        x34 = co(2)*x16*x9
        x35 = P1(3)*w2(2)
        x36 = P1(2)*w2(3) - x35
        x37 = P1(1)*co(3)*x9
        x38 = P2(2)*w2(3) - P2(3)*w2(2)
        x39 = P1(2)*w2(1)
        x40 = P1(1)*w2(2) - x39
        x41 = P1(3)*co(3)*x9
        x42 = P2(1)*w2(2) - P2(2)*w2(1)
        x43 = P1(2)*w1(3)
        x44 = -P1(3)*w1(2) + x43
        x45 = P2(1)*co(3)*x23
        x46 = P2(2)*w1(3)
        x47 = P2(3)*w1(2)
        x48 = x46 - x47
        x49 = P1(2)*w1(1)
        x50 = P1(1)*w1(2) - x49
        x51 = P2(3)*co(3)*x23
        x52 = P2(1)*w1(2)
        x53 = P2(2)*w1(1)
        x54 = x52 - x53
        x55 = P1(0)**2
        x56 = co(2)*x55*x9
        x57 = co(1)*x1*x27
        x58 = P1(1)*P2(1)
        x59 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x60 = co(0)*x59
        x61 = P1(0)*P2(0)*w1(0)
        x62 = P1(1)*P2(1)*co(1)*x1
        x63 = co(1)*x23
        x64 = P1(1)*P2(1)*w1(0)
        x65 = co(1)*x59
        x66 = P1(1)*P2(1)*w2(0)
        x67 = P1(1)*w1(1)
        x68 = P1(2)*w1(2)
        x69 = P1(3)*w1(3)
        x70 = P1(0)*w1(0)
        x71 = x67 + x68 + x69 - x70
        x72 = co(1)*x71
        x73 = co(1)*x9
        x74 = P1(1)*w1(0)
        x75 = P2(1)*co(2)*x23
        x76 = co(2)*x9
        x77 = P1(2)*P2(2)*co(1)*x1
        x78 = P1(2)*P2(2)*w1(0)
        x79 = P1(2)*P2(2)*w2(0)
        x80 = co(2)*x23
        x81 = P1(3)*P2(3)*co(1)*x1
        x82 = P1(3)*P2(3)*w1(0)
        x83 = P1(3)*P2(3)*w2(0)
        x84 = P2(0)*co(1)*x59
        x85 = P1(0)*P2(0)*w2(0)
        x86 = P2(0)*co(1)*x9
        x87 = P1(0)*w1(1)
        x88 = P2(1)*co(0)*x23
        x89 = P2(1)*co(0)*x59
        x90 = co(0)*x23
        x91 = P1(0)*P2(2)*w1(2)
        x92 = P1(0)*w1(3)
        x93 = P2(3)*co(0)*x23
        x94 = P2(3)*co(0)*x59
        x95 = P2(0)*co(0)*x23
        x96 = P2(0)*w1(1)
        x97 = P1(1)*co(1)*x1
        x98 = P1(0)*w2(3)
        x99 = -P1(3)*w2(0) + x98
        x100 = P2(0)*w2(3) - P2(3)*w2(0)
        x101 = P2(1)*co(1)*x1
        x102 = -P1(3)*w1(0) + x92
        x103 = P2(3)*w1(0)
        x104 = P2(0)*w1(3) - x103
        x105 = co(2)*w1(1)*x23
        x106 = P1(0)*co(3)*x9
        x107 = P1(0)*w2(2)
        x108 = -P1(2)*w2(0) + x107
        x109 = P2(0)*w2(2) - P2(2)*w2(0)
        x110 = P2(0)*co(3)*x23
        x111 = P1(2)*w1(0)
        x112 = P1(0)*w1(2) - x111
        x113 = P2(0)*w1(2)
        x114 = P2(2)*w1(0)
        x115 = x113 - x114
        x116 = P1(1)*co(0)*x23
        x117 = P1(1)*co(0)*x59
        x118 = P1(1)*P2(1)*w1(1)
        x119 = P1(1)*P2(1)*w2(1)
        x120 = P1(2)*P2(2)*w1(1)
        x121 = P2(2)*co(1)*x71
        x122 = P2(2)*co(1)*x9
        x123 = P2(2)*co(2)*x9
        x124 = P1(3)*co(1)*x23
        x125 = P1(3)*co(1)*x59
        x126 = P1(3)*P2(3)*w2(1)
        x127 = P1(3)*co(2)*x23
        x128 = P1(0)*P2(0)*co(1)*x1
        x129 = P1(0)*co(1)*x23
        x130 = P1(0)*co(1)*x59
        x131 = P1(0)*P2(0)*w2(1)
        x132 = P1(0)*co(2)*x23
        x133 = P1(2)*co(0)*x23
        x134 = P2(2)*co(0)*x23
        x135 = 2*co(0)*x23
        x136 = P1(2)*co(1)*x1
        x137 = P1(0)*w2(1) - P1(1)*w2(0)
        x138 = P2(0)*w2(1) - P2(1)*w2(0)
        x139 = P2(2)*co(1)*x1
        x140 = -x74 + x87
        x141 = -P2(1)*w1(0) + x96
        x142 = w1(2)*x3
        x143 = co(2)*x23*x27
        x144 = P1(1)*P2(1)*w1(2)
        x145 = P1(1)*P2(1)*w2(2)
        x146 = P1(2)*P1(3)*co(1)*x1
        x147 = P1(2)*P2(2)*w1(2)
        x148 = P2(3)*co(1)*x71
        x149 = P2(3)*co(1)*x9
        x150 = P2(3)*co(2)*x9
        x151 = P2(0)*co(1)*x71
        x152 = P2(0)*co(2)*x9
        x153 = P1(3)*co(0)*x23
        x154 = P1(3)*co(1)*x1
        x155 = P2(3)*co(1)*x1
        x156 = P1(1)*P2(1)*w1(3)
        x157 = P1(1)*P2(1)*w2(3)
        x158 = P1(2)*P2(2)*w1(3)
        x159 = P1(2)*P2(2)*w2(3)
        x160 = P1(3)*P2(0)*w1(0)
        x161 = P1(3)*P2(3)*w1(3)
        x162 = P1(0)*P2(0)*w1(3)
        wout(0) = 2*P1(0)*w1(0)*x95 - 2*P1(0)*x57 + P1(2)*P2(2)*x2 + P1(3)*P2(3&
                  )*x2 + P2(0)*x15 + P2(0)*x62 + P2(0)*x77 + P2(0)*x81 + co(0)*&
                  x28 - co(2)*x28 + w1(0)*x29 + w1(0)*x30 + w1(0)*x31 + w2(0)* &
                  x32 + w2(0)*x33 + w2(0)*x34 - w2(0)*x56 + x0*x2 + x10*x11 +  &
                  x10*x5 + x12*x13 + x13*x16 - 2*x13*x55 + x19*x24 + x2*x3 + x2&
                  *x4 + x2*x58 - x22*x86 + x24*x26 - x36*x37 - x37*x38 - x40*  &
                  x41 - x41*x42 - x44*x45 - x45*x48 - x50*x51 - x51*x54 - x6*  &
                  x95 + x60*x61 - x60*x91 - x61*x63 - x61*x80 + x63*x64 + x63* &
                  x78 + x63*x82 + x64*x65 + x65*x78 + x65*x82 + x66*x72 + x66* &
                  x73 + x66*x76 - x67*x95 - x68*x95 - x69*x95 - x7*x95 - x70*  &
                  x84 + x72*x79 + x72*x83 - x72*x85 + x73*x79 + x73*x83 + x74* &
                  x75 + x76*x79 + x76*x83 - x76*x85 + x78*x80 + x80*x82 - x87* &
                  x88 - x87*x89 - x88*x96 - x90*x91 - x92*x93 - x92*x94
        wout(1) = -P1(1)*x128 - P1(1)*x57 + P1(1)*x77 + P1(1)*x81 - P2(1)*x128 &
                   + P2(1)*x15 + P2(1)*x77 + P2(1)*x81 - w1(1)*x0*x90 + w1(1)* &
                  x29 + w2(1)*x32 + w2(1)*x33 + w2(1)*x34 - w2(1)*x56 + 2*x0*  &
                  x97 + x10*x100 + x10*x99 + 2*x101*x12 + x101*x16 - x101*x55  &
                   + x102*x24 + x104*x24 - x105*x27 + x105*x3 + x105*x4 - x106*&
                  x36 - x106*x38 - x108*x41 - x109*x41 - x110*x44 - x110*x48 - &
                  x112*x51 - x115*x51 - x116*x6 + x116*x8 - x117*x6 + x117*x8  &
                   - x118*x135 + x118*x63 + x118*x65 + x118*x80 + x119*x72 +   &
                  x119*x73 + x119*x76 + x120*x63 + x120*x65 + x120*x80 + x121* &
                  x39 + x122*x39 + x123*x39 + x124*x25 + x125*x25 + x126*x72 + &
                  x126*x73 + x126*x76 + x127*x25 - x129*x96 - x130*x96 - x131* &
                  x72 - x131*x73 - x131*x76 - x132*x96 - x133*x52 - x134*x52 - &
                  x17*x93 - x17*x94 + x3*x97 + x4*x97 - x67*x89 - x69*x88 - x7*&
                  x88 + x70*x88 + x8*x88
        wout(2) = P1(2)*P2(0)*w1(0)*x60 - P1(2)*x128 - P1(2)*x57 - P2(2)*x128  &
                   + 2*P2(2)*x15 + P2(2)*x81 + P2(3)*x146 - w1(2)*x143 + w1(2)*&
                  x29 + w1(2)*x31 + w2(2)*x32 + w2(2)*x33 + w2(2)*x34 - w2(2)* &
                  x56 + x0*x136 - x100*x37 - x102*x45 - x104*x45 + x106*x11 +  &
                  x106*x5 - x107*x151 - x107*x152 - x107*x86 + x110*x19 + x110*&
                  x26 + x111*x95 - x113*x129 - x113*x130 - x113*x132 + x114*x95&
                   + x12*x139 + x121*x20 + x122*x20 + x123*x20 + x124*x47 +    &
                  x125*x47 + x127*x47 - x134*x67 + x134*x70 - x135*x147 + 2*   &
                  x136*x3 + x136*x4 + x136*x58 + x137*x41 + x138*x41 + x139*x16&
                   - x139*x55 + x139*x58 + x140*x51 + x141*x51 + x142*x80 -    &
                  x142*x90 + x144*x63 + x144*x65 + x144*x80 + x145*x72 + x145* &
                  x73 + x145*x76 - x147*x60 + x147*x63 + x147*x65 + x147*x80 + &
                  x148*x35 + x149*x35 + x150*x35 - x153*x46 - x37*x99 - x43*x93&
                   - x43*x94 - x46*x93 - x49*x88 - x49*x89 - x53*x88
        wout(3) = -P1(3)*P2(2)*w1(2)*x60 - 2*P1(3)*w1(3)*x93 - P1(3)*x128 - P1(&
                  3)*x57 + P2(2)*x146 - P2(3)*x128 + P2(3)*x15 + P2(3)*x62 + P2&
                  (3)*x77 - w1(3)*x143 + w1(3)*x29 + w1(3)*x30 + w1(3)*x31 - w1&
                  (3)*x4*x90 + w2(3)*x32 + w2(3)*x33 + w2(3)*x34 - w2(3)*x56 + &
                  x0*x154 - x10*x137 - x10*x138 + x103*x95 - x106*x40 - x106*  &
                  x42 + x108*x37 + x109*x37 - x110*x50 - x110*x54 + x112*x45 + &
                  x115*x45 + x12*x155 - x133*x47 - x134*x47 - x140*x24 - x141* &
                  x24 + x148*x21 + x149*x21 + x150*x21 - x151*x98 - x152*x98 - &
                  x153*x6 + x154*x3 + 2*x154*x4 + x154*x58 + 2*x155*x16 - x155*&
                  x55 + x156*x63 + x156*x65 + x157*x72 + x157*x73 + x157*x76 + &
                  x158*x63 + x158*x65 + x158*x80 + x159*x72 + x159*x73 + x159* &
                  x76 + x160*x60 + x160*x90 + x161*x63 + x161*x65 + x161*x80 - &
                  x162*x63 - x162*x80 + x17*x75 - x18*x88 - x18*x89 - x25*x88  &
                   - x67*x93 - x69*x94 + x70*x93 - x84*x92 - x86*x98
      case(VVV3)
!       c0*(-P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon
!       (-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon(-1,-2,-3,3)*
!       Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - 2*Epsilon(-1,-2,1,2)*P
!       (-1,2)*P(-2,3)*P(3,1) + 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(-Metric(1,2)*P(3,2) + Metric(2,3)*P(1,2))
!       c5*(Metric(1,2)*P(3,1) - Metric(1,3)*P(2,1) + Metric(1,3)*P(2,3) - Metric
!       (2,3)*P(1,3))
!       Epsilon(-1,1,2,3)*P(-1,2)*c6
!       c7*(Epsilon(-1,1,2,3)*P(-1,1) + Epsilon(-1,1,2,3)*P(-1,3))
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(4)*x2
        x4 = w1(3)*w2(2)
        x5 = w1(2)*w2(3) - x4
        x6 = P2(1)*x5
        x7 = w1(1)*w2(3)
        x8 = -w1(3)*w2(1) + x7
        x9 = P2(2)*x8
        x10 = w1(1)*w2(2)
        x11 = -w1(2)*w2(1) + x10
        x12 = P2(3)*x11
        x13 = co(5)*x2
        x14 = x12 + x6 - x9
        x15 = P1(0)**2
        x16 = 2*co(3)*x15
        x17 = P1(1)**2
        x18 = 2*co(3)*x17
        x19 = P1(2)**2
        x20 = 2*co(3)*x19
        x21 = P1(3)**2
        x22 = 2*co(3)*x21
        x23 = P2(0)*co(1)*x2
        x24 = co(1)*x19*x2
        x25 = P2(0)*co(4)
        x26 = w1(0)*w2(1)
        x27 = w1(0)*w2(2)
        x28 = P2(3)*w2(3)
        x29 = co(5)*w1(0)
        x30 = P2(0)**2
        x31 = P1(1)*w2(1)
        x32 = P1(2)*w2(2)
        x33 = P1(3)*w2(3)
        x34 = P1(0)*w2(0)
        x35 = x31 + x32 + x33 - x34
        x36 = w1(0)*x30*x35
        x37 = w1(0)*x35
        x38 = P2(1)**2
        x39 = co(1)*x38
        x40 = P2(2)**2
        x41 = co(1)*x40
        x42 = P2(3)**2
        x43 = co(1)*x42
        x44 = P2(2)*w1(2)
        x45 = P2(3)*w1(3)
        x46 = -P2(0)*w1(0) + P2(1)*w1(1) + x44 + x45
        x47 = co(1)*x15*x46
        x48 = co(1)*x2*x38
        x49 = co(1)*x2*x40
        x50 = co(1)*x2*x42
        x51 = P1(0)*w1(0)
        x52 = co(5)*w2(0)
        x53 = P1(1)*w2(0)
        x54 = co(5)*w1(1)
        x55 = P1(2)*w2(0)
        x56 = co(5)*w1(2)
        x57 = P1(3)*w1(3)
        x58 = P2(1)*w2(0)
        x59 = co(4)*w1(1)
        x60 = P2(2)*co(4)*w1(2)
        x61 = P2(3)*w2(0)
        x62 = co(5)*w1(3)
        x63 = co(1)*x17*x46
        x64 = co(1)*x19*x46
        x65 = co(1)*x21*x46
        x66 = 8*co(3)
        x67 = P1(1)*x5
        x68 = P1(3)*x11
        x69 = P1(2)*x8
        x70 = x67 + x68 - x69
        x71 = 6*co(3)
        x72 = P2(1)*w2(3)
        x73 = -P2(3)*w2(1) + x72
        x74 = 4*P1(2)*co(3)*x46
        x75 = P1(0)*P2(2)
        x76 = P1(0)*x8
        x77 = -w1(1)*w2(0) + x26
        x78 = P1(3)*x77
        x79 = w1(3)*w2(0)
        x80 = w1(0)*w2(3) - x79
        x81 = P1(1)*x80
        x82 = x76 + x78 - x81
        x83 = 2*co(3)*x82
        x84 = P2(0)*x8
        x85 = P2(3)*x77
        x86 = P2(1)*x80
        x87 = x84 + x85 - x86
        x88 = 2*co(3)*x87
        x89 = P1(1)*w1(0)
        x90 = P1(2)*w2(3)
        x91 = P1(3)*w2(2)
        x92 = x90 - x91
        x93 = P1(0)*w2(2)
        x94 = -x55 + x93
        x95 = P1(0)*w2(3)
        x96 = P1(3)*w2(0)
        x97 = x95 - x96
        x98 = 2*co(2)*(P2(0)*x92 - P2(2)*x97 + P2(3)*x94)
        x99 = P2(2)*w2(3) - P2(3)*w2(2)
        x100 = P2(0)*w2(2) - P2(2)*w2(0)
        x101 = P2(0)*w2(3) - x61
        x102 = 2*co(2)*(P2(0)*x99 - P2(2)*x101 + P2(3)*x100)
        x103 = P1(2)*w1(3)
        x104 = P1(3)*w1(2)
        x105 = x103 - x104
        x106 = P2(0)*x105
        x107 = P1(0)*w1(2)
        x108 = P1(2)*w1(0)
        x109 = x107 - x108
        x110 = P2(3)*x109
        x111 = P1(0)*w1(3)
        x112 = P1(3)*w1(0)
        x113 = x111 - x112
        x114 = P2(2)*x113
        x115 = 2*co(2)*(x106 + x110 - x114)
        x116 = P2(2)*w1(3)
        x117 = P2(3)*w1(2)
        x118 = x116 - x117
        x119 = P2(0)*x118
        x120 = P2(2)*w1(0)
        x121 = P2(0)*w1(2) - x120
        x122 = P2(3)*x121
        x123 = P2(3)*w1(0)
        x124 = P2(0)*w1(3) - x123
        x125 = P2(2)*x124
        x126 = 2*co(2)*(x119 + x122 - x125)
        x127 = P1(2)*P2(3)
        x128 = P1(3)*P2(2)
        x129 = x127 - x128
        x130 = 2*P1(1)*co(2)*x2
        x131 = P1(2)*P2(0)
        x132 = P1(1)*w2(3)
        x133 = P1(3)*w2(1)
        x134 = x132 - x133
        x135 = 2*P1(2)*co(3)*x46
        x136 = P2(3)*w1(1)
        x137 = P2(1)*w1(3) - x136
        x138 = 2*P1(2)*co(3)*x35
        x139 = P2(1)*w2(1)
        x140 = P2(0)*w2(0)
        x141 = P2(2)*w2(2) + x139 - x140 + x28
        x142 = 2*P1(2)*co(3)*x141
        x143 = P1(1)*w1(1)
        x144 = P1(2)*w1(2)
        x145 = x143 + x144 - x51 + x57
        x146 = 2*P1(2)*co(3)*x145
        x147 = 2*co(3)*(-x30 + x38 + x40 + x42)
        x148 = P1(1)*P2(1)
        x149 = P1(2)*P2(2)
        x150 = P1(3)*P2(3)
        x151 = P1(0)*P2(0)
        x152 = 2*co(3)*(x148 + x149 + x150 - x151)
        x153 = P1(1)*w2(2)
        x154 = P1(2)*w2(1)
        x155 = x153 - x154
        x156 = P1(0)*w2(1)
        x157 = x156 - x53
        x158 = 2*co(2)*(P2(0)*x155 - P2(1)*x94 + P2(2)*x157)
        x159 = P2(1)*w2(2) - P2(2)*w2(1)
        x160 = P2(0)*w2(1) - x58
        x161 = 2*co(2)*(P2(0)*x159 - P2(1)*x100 + P2(2)*x160)
        x162 = P1(1)*w1(2)
        x163 = P1(2)*w1(1)
        x164 = x162 - x163
        x165 = P2(0)*x164
        x166 = P1(0)*w1(1)
        x167 = x166 - x89
        x168 = P2(2)*x167
        x169 = P2(1)*x109
        x170 = 2*co(2)*(x165 + x168 - x169)
        x171 = P2(1)*w1(2)
        x172 = P2(2)*w1(1)
        x173 = x171 - x172
        x174 = P2(0)*x173
        x175 = P2(0)*w1(1)
        x176 = P2(1)*w1(0)
        x177 = x175 - x176
        x178 = P2(2)*x177
        x179 = P2(1)*x121
        x180 = 2*co(2)*(x174 + x178 - x179)
        x181 = P1(1)*P2(2)
        x182 = P1(2)*P2(1)
        x183 = x181 - x182
        x184 = 2*P1(3)*co(2)*x2
        x185 = P2(1)*x105
        x186 = 2*co(3)*x35
        x187 = P2(1)*x118
        x188 = P2(3)*x164
        x189 = P2(3)*x173
        x190 = P1(0)*P2(1)
        x191 = P1(0)*x5
        x192 = -w1(2)*w2(0) + x27
        x193 = P1(3)*x192
        x194 = P1(2)*x80
        x195 = x191 + x193 - x194
        x196 = 2*co(3)*x195
        x197 = P2(0)*x5
        x198 = P2(3)*x192
        x199 = P2(2)*x80
        x200 = x197 + x198 - x199
        x201 = 2*co(3)*x200
        x202 = P1(0)*P2(3)
        x203 = P1(0)*x11
        x204 = P1(2)*x77
        x205 = P1(1)*x192
        x206 = x203 + x204 - x205
        x207 = 2*co(3)*x206
        x208 = P2(0)*x11
        x209 = P2(2)*x77
        x210 = P2(1)*x192
        x211 = x208 + x209 - x210
        x212 = 2*co(3)*x211
        x213 = 2*co(2)*(P2(1)*x92 - P2(2)*x134 + P2(3)*x155)
        x214 = 2*co(2)*(P2(1)*x99 - P2(2)*x73 + P2(3)*x159)
        x215 = P1(1)*w1(3)
        x216 = P1(3)*w1(1)
        x217 = x215 - x216
        x218 = P2(2)*x217
        x219 = 2*co(2)*(x185 + x188 - x218)
        x220 = P2(2)*x137
        x221 = 2*co(2)*(x187 + x189 - x220)
        x222 = P1(1)*P2(0)
        x223 = 2*co(3)*x70
        x224 = 2*P1(1)*co(3)*x46
        x225 = P1(1)*x118
        x226 = 2*co(3)*x141
        x227 = 2*co(3)*x145
        x228 = P1(1)*x99
        x229 = P1(1)*co(5)
        x230 = P2(0)*x134 - P2(1)*x97 + P2(3)*x157
        x231 = 2*co(2)*x230
        x232 = P2(0)*x73 - P2(1)*x101 + P2(3)*x160
        x233 = 2*co(2)*x232
        x234 = P2(0)*x217
        x235 = P2(3)*x167
        x236 = P2(1)*x113
        x237 = 2*co(2)*(x234 + x235 - x236)
        x238 = P2(0)*x137
        x239 = P2(3)*x177
        x240 = P2(1)*x124
        x241 = 2*co(2)*(x238 + x239 - x240)
        x242 = P1(1)*P2(3)
        x243 = P1(3)*P2(1)
        x244 = x242 - x243
        x245 = 2*P1(2)*co(2)*x2
        x246 = co(5)*w2(2)
        x247 = P1(3)*P2(0)
        x248 = 2*P1(3)*co(3)*x46
        x249 = 2*P1(3)*co(3)*x141
        x250 = 2*P1(3)*co(3)*x145
        x251 = co(5)*w2(3)
        x252 = 4*P1(1)*P2(1)*co(3)
        x253 = 4*co(3)*x46
        x254 = 4*co(3)*x14
        x255 = 4*P1(3)*co(3)*x46
        x256 = co(1)*w1(0)*x141
        x257 = co(0)*w1(1)*x35
        x258 = co(0)*x141
        x259 = co(0)*x35
        x260 = P1(0)*P2(2)*w1(2)
        x261 = P2(3)*co(0)*x35
        x262 = P2(3)*co(0)*x141
        x263 = co(1)*x145
        x264 = co(1)*w2(0)*x145
        x265 = P2(3)*co(1)*x2
        x266 = P1(0)*co(1)*x2
        x267 = co(0)*w1(0)*x141
        x268 = P1(0)*P2(0)*co(1)*x145
        x269 = P2(0)*co(0)*x35
        x270 = w1(2)*x35
        x271 = co(0)*w1(3)*x35
        x272 = P2(1)*co(0)*x35
        x273 = co(5)*w2(1)
        x274 = co(1)*x2*x30
        x275 = P2(0)*co(5)
        x276 = P2(1)*co(1)*x2
        x277 = co(5)*w1(1)*w2(2)
        x278 = P2(3)*co(5)
        x279 = co(1)*x35*x38
        x280 = w1(1)*x35
        x281 = P2(3)*w1(3)*w2(1)
        x282 = co(1)*x30
        x283 = 4*co(3)*x200
        x284 = 4*co(3)*x101*x46
        x285 = 2*co(3)*x14
        x286 = 2*P1(0)*co(2)*x2
        x287 = 2*co(5)*w1(1)
        x288 = 2*co(3)*x124*x141
        x289 = -x131 + x75
        x290 = 2*P1(0)*co(3)*x46
        x291 = 2*P1(0)*co(3)*x35
        x292 = 2*P1(0)*co(3)*x141
        x293 = 2*P1(0)*co(3)*x145
        x294 = 2*co(2)*x2*(x202 - x247)
        x295 = 2*co(3)*x121*x35
        x296 = P1(3)*co(5)
        x297 = 4*P1(0)*co(3)*x46
        x298 = 4*co(3)*x100*x46
        x299 = P1(0)*P2(0)*co(1)*x2
        x300 = co(1)*w1(1)*x141
        x301 = P2(1)*co(0)*x141
        x302 = P1(1)*co(1)*x145
        x303 = P1(1)*P2(2)*w1(2)
        x304 = P1(1)*co(1)*x2
        x305 = P1(1)*P2(0)*co(0)
        x306 = P1(2)*co(0)*x35
        x307 = P2(2)*co(0)*x35
        x308 = P2(2)*co(1)*x2
        x309 = w1(2)*x35*x40
        x310 = P2(3)*co(4)
        x311 = P1(0)*x73
        x312 = 4*co(3)*x87
        x313 = P1(3)*x177
        x314 = 2*P1(1)*co(3)*x145
        x315 = 2*P1(2)*co(2)*w1(2)
        x316 = x190 - x222
        x317 = co(5)*w1(2)*w2(3)
        x318 = co(1)*x141
        x319 = co(1)*w2(2)*x145
        x320 = P1(2)*P2(2)*w1(2)
        x321 = P2(0)*co(1)*x145
        x322 = P1(3)*co(1)*x2
        x323 = P1(3)*co(0)*x35
        x324 = P2(0)*w1(0)*w2(3)
        x325 = w1(3)*x35
        x326 = 4*co(3)*x211
        x327 = 2*P1(3)*P2(2)*co(3)
        x328 = 2*co(5)*w1(3)
        x329 = co(1)*w2(3)*x145
        wout(0) = -P1(0)*P2(0)*x14*x66 - P1(0)*P2(0)*x70*x71 + P1(0)*P2(1)*w1(1&
                  )*x258 - P1(0)*x13 - P1(0)*x48 - P1(0)*x49 - P1(0)*x50 + P1(1&
                  )*P2(1)*w2(0)*x263 - P1(2)*P2(0)*co(0)*x270 + 2*P1(2)*w1(0)* &
                  x246 + 2*P1(3)*w1(0)*x251 + P1(3)*x173*x186 + P2(0)*x24 + P2(&
                  0)*x3 + P2(1)*co(5)*x26 + P2(2)*co(5)*x27 + co(0)*x36 - co(1 &
                  )*x36 - co(4)*w1(3)*x61 + co(6)*x12 + co(6)*x6 - co(6)*x9 -  &
                  co(7)*x12 - co(7)*x6 + co(7)*x9 + 2*w1(0)*w2(1)*x229 - w2(0)*&
                  x268 + w2(0)*x47 - w2(0)*x60 - w2(0)*x63 - w2(0)*x64 - w2(0)*&
                  x65 + x1*x25 - x102*x89 + x108*x231 + x108*x233 + x111*x261  &
                   + x111*x262 - x112*x158 - x112*x161 - x115*x53 - x126*x53 - &
                  x129*x130 - x131*x83 - x131*x88 - x134*x135 - x137*x138 -    &
                  x137*x142 - x14*x16 + x14*x18 + x14*x20 + x14*x22 + x14*x252 &
                   - x143*x269 - x146*x73 + x147*x67 + x147*x68 - x147*x69 +   &
                  x148*x223 + x148*x23 - x148*x256 - x148*x266 + x149*x223 +   &
                  x149*x23 + x149*x254 - x149*x256 + x149*x264 - x149*x266 +   &
                  x150*x223 + x150*x254 - x150*x256 + x150*x264 - x150*x266 +  &
                  x151*x256 - x151*x267 + x152*x67 + x152*x68 - x152*x69 + x155&
                  *x248 + x159*x250 + x159*x255 + x17*x23 - x170*x96 + x173*   &
                  x249 - x175*x272 - x180*x96 - x183*x184 - x185*x186 - x186*  &
                  x187 - x186*x188 - x186*x189 + x186*x218 + x186*x220 + x186* &
                  x225 + x190*x196 + x190*x201 + x190*x257 + x196*x222 + x201* &
                  x222 + x202*x207 + x202*x212 + x207*x247 + x21*x23 + x212*   &
                  x247 + x213*x51 + x214*x51 + x219*x34 + x221*x34 + x224*x92  &
                   + x225*x226 + x227*x228 + x228*x253 + x237*x55 + x241*x55 + &
                  x244*x245 + x247*x265 - x247*x271 + x258*x260 + x259*x260 -  &
                  x269*x44 - x269*x45 + x28*x29 + x37*x39 + x37*x41 + x37*x43  &
                   - x44*x52 - x51*x52 - x52*x57 - x53*x54 - x54*x58 - x55*x56 &
                   - x58*x59 - x61*x62 - x73*x74 - x75*x83 - x75*x88 - x89*x98
        wout(1) = -P1(1)*P2(1)*co(1)*w1(1)*x141 + P1(1)*P2(1)*x195*x71 + P1(1)*&
                  P2(1)*x200*x66 - P1(1)*x13 + P1(1)*x274 + P1(1)*x299 - P1(1)*&
                  x49 - P1(1)*x50 + P1(2)*P2(2)*w2(1)*x263 - P1(2)*x284 - P1(2 &
                  )*x288 + P1(2)*x294 + P1(3)*P2(3)*w2(1)*x263 + P1(3)*x295 +  &
                  P1(3)*x298 + P2(1)*x24 + P2(1)*x3 + P2(2)*x277 - co(4)*x281  &
                   - co(5)*x281 + co(6)*x197 + co(6)*x198 - co(6)*x199 - co(7)*&
                  x197 - co(7)*x198 + co(7)*x199 - w1(0)*x141*x305 + 2*w1(1)*w2&
                  (3)*x296 + w1(1)*x279 - w2(1)*x268 + w2(1)*x47 - w2(1)*x60 - &
                  w2(1)*x63 - w2(1)*x64 - w2(1)*x65 + x100*x250 - x101*x146 -  &
                  x102*x143 - x106*x186 - x110*x186 + x114*x186 - x115*x31 +   &
                  x118*x291 + x118*x292 - x119*x186 + x121*x249 - x122*x186 -  &
                  x124*x138 + x125*x186 - x126*x31 - x129*x286 - x133*x170 -   &
                  x133*x180 - x135*x97 + x139*x302 - x139*x59 + x143*x273 +    &
                  x143*x301 - x143*x98 - x144*x273 + x147*x191 + x147*x193 -   &
                  x147*x194 + x149*x196 + x149*x276 + x149*x283 - x149*x300 -  &
                  x149*x304 - x15*x276 + x150*x196 + x150*x276 + x150*x283 -   &
                  x150*x300 - x150*x304 - x151*x196 - x151*x276 - x151*x283 +  &
                  x151*x300 + x152*x191 + x152*x193 - x152*x194 + x154*x237 +  &
                  x154*x241 + x156*x219 + x156*x221 - x158*x216 - x16*x200 -   &
                  x161*x216 + x163*x231 + x163*x233 + x166*x213 + x166*x214 -  &
                  x171*x306 - x171*x307 - x175*x52 + x176*x269 + x18*x200 -    &
                  x181*x83 - x181*x88 - x182*x83 - x182*x88 - x184*x289 - x190*&
                  x223 - x190*x285 + x20*x200 + x200*x22 + x207*x242 + x207*   &
                  x243 + x21*x276 + x212*x242 + x212*x243 + x215*x261 + x215*  &
                  x262 - x222*x223 - x222*x285 + x248*x94 + x25*x26 - x257*x38 &
                   + x258*x303 + x259*x303 + x26*x275 - x272*x45 + x272*x51 -  &
                  x272*x57 - x273*x44 + x273*x51 - x273*x57 + x278*x7 - x280*  &
                  x282 + x280*x41 + x280*x43 + x287*x32 - x287*x34 + x290*x92  &
                   + x293*x99 + x297*x99 - x305*x37
        wout(2) = P1(0)*P2(0)*w1(2)*x318 - 2*P1(0)*w2(0)*x56 - P1(1)*P1(2)*P2(1&
                  )*co(1)*x2 - P1(1)*P2(1)*w1(2)*x318 + 2*P1(1)*w1(2)*x273 + P1&
                  (1)*x124*x186 + P1(1)*x284 + P1(1)*x288 - P1(1)*x294 - P1(2)*&
                  P2(0)*w1(0)*x258 - P1(2)*P2(2)*x66*x87 - P1(2)*P2(2)*x71*x82 &
                   - P1(2)*x13 + P1(2)*x274 + P1(2)*x299 - P1(2)*x48 - P1(2)*  &
                  x50 - P1(3)*P2(3)*w1(2)*x318 + P1(3)*P2(3)*w2(2)*x263 + 2*P1(&
                  3)*x317 - P2(1)*co(4)*x10 - P2(1)*x277 + P2(2)*x3 - co(0)*   &
                  x309 + co(1)*x309 - co(6)*x84 - co(6)*x85 + co(6)*x86 + co(7 &
                  )*x84 + co(7)*x85 - co(7)*x86 + w2(2)*x47 - w2(2)*x60 - w2(2 &
                  )*x63 - w2(2)*x64 - w2(2)*x65 + x101*x314 - x102*x162 + x103*&
                  x261 + x103*x262 - x104*x158 - x104*x161 + x107*x213 + x107* &
                  x214 - x108*x269 - x115*x153 - x116*x261 - x116*x323 + x117* &
                  x251 + x120*x269 - x126*x153 + x127*x207 + x127*x212 - x127* &
                  x322 + x128*x207 + x128*x212 - x131*x223 - x131*x285 - x134* &
                  x290 - x137*x291 - x137*x292 - x140*x56 - x143*x246 - x143*  &
                  x307 - x147*x76 - x147*x78 + x147*x81 + x148*x308 + x148*x319&
                   - x148*x83 + x149*x319 - x15*x308 + x150*x308 - x150*x312 - &
                  x150*x83 - x151*x308 + x151*x312 + x151*x83 - x152*x76 - x152&
                  *x78 + x152*x81 - x157*x248 + x16*x87 - x160*x250 - x160*x255&
                   - x162*x98 + x163*x272 + x163*x301 + x17*x308 - x170*x91 +  &
                  x171*x273 - x172*x272 - x18*x87 - x180*x91 + x181*x196 + x181&
                  *x201 + x182*x196 + x182*x201 + x184*x316 + x186*x234 + x186*&
                  x235 - x186*x236 + x186*x238 + x186*x239 - x186*x240 - x186* &
                  x313 - x20*x87 + x21*x308 + x219*x93 - x22*x87 + x221*x93 -  &
                  x223*x75 + x224*x97 - x226*x313 - x227*x311 + x230*x315 +    &
                  x232*x315 + x237*x32 + x241*x32 + x244*x286 + x25*x27 - x252*&
                  x87 - x253*x311 + x258*x320 + x27*x275 - x270*x282 + x270*x39&
                   + x270*x43 - x278*x4 - x285*x75 + x29*x93 - x296*x4 + x307* &
                  x51 - x310*x4 - x318*x320 + x32*x56 - x321*x93
        wout(3) = P1(0)*P2(0)*w1(3)*x318 - 2*P1(0)*w1(3)*x52 - P1(1)*P2(1)*w1(3&
                  )*x318 - P1(1)*x121*x226 - P1(1)*x295 - P1(1)*x298 - P1(2)*P2&
                  (2)*w1(3)*x318 - P1(2)*x317 - P1(3)*P2(0)*co(0)*x37 + P1(3)* &
                  P2(2)*w1(2)*x258 - P1(3)*P2(3)*w1(3)*x318 + P1(3)*P2(3)*x206*&
                  x71 + P1(3)*P2(3)*x211*x66 - P1(3)*x13 + P1(3)*x274 - P1(3)* &
                  x48 - P1(3)*x49 + P2(3)*x24 + P2(3)*x3 + co(4)*x324 + co(5)* &
                  x324 + co(6)*x208 + co(6)*x209 - co(6)*x210 - co(7)*x208 - co&
                  (7)*x209 + co(7)*x210 + w1(3)*x279 + w2(3)*x47 - w2(3)*x60 - &
                  w2(3)*x63 - w2(3)*x64 - w2(3)*x65 + x0*x296 - x0*x310 - x100*&
                  x314 - x102*x215 + x103*x231 + x103*x233 + x111*x213 + x111* &
                  x214 - x115*x132 + x116*x246 - x117*x306 - x117*x307 + x123* &
                  x269 - x126*x132 - x127*x83 - x127*x88 + x130*x289 + x135*   &
                  x157 - x136*x272 + x138*x177 + x139*x62 + x142*x177 - x143*  &
                  x261 + x146*x160 + x147*x203 + x147*x204 - x147*x205 + x148* &
                  x207 + x148*x265 - x148*x322 + x148*x326 + x149*x207 + x149* &
                  x265 - x149*x322 + x149*x326 + x149*x329 - x15*x265 + x150*  &
                  x329 - x151*x207 - x151*x265 - x151*x326 + x152*x203 + x152* &
                  x204 - x152*x205 + x155*x290 - x158*x57 + x159*x293 + x159*  &
                  x297 - x16*x211 + x160*x74 - x161*x57 - x165*x186 - x168*x186&
                   + x169*x186 + x17*x265 - x170*x33 + x173*x291 + x173*x292 - &
                  x174*x186 - x178*x186 + x179*x186 + x18*x211 - x180*x33 -    &
                  x183*x286 + x196*x242 + x196*x243 + x20*x211 + x201*x242 +   &
                  x201*x243 - x202*x223 - x202*x285 + x211*x22 - x215*x98 +    &
                  x216*x272 + x216*x301 + x219*x95 + x221*x95 - x223*x247 -    &
                  x224*x94 - x229*x7 + x237*x90 + x241*x90 - x245*x316 + x247* &
                  x266 - x247*x267 - x247*x285 - x251*x44 + x261*x51 + x262*x57&
                   - x271*x42 - x275*x79 - x282*x325 + x29*x95 + x302*x72 + x31&
                  *x328 + x32*x328 - x321*x95 + x323*x44 + x325*x41 + x325*x43 &
                   - x327*x82 - x327*x87 - x54*x72 - x59*x72
      case(VVV4)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,
!       3))
!       c3*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,2)*P(1,3))
        if (last) VB_last = .true.
        x0 = P1(0)*co(3)
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = w1(1)*w2(2) - w1(2)*w2(1)
        x3 = w1(1)*w2(3) - w1(3)*w2(1)
        x4 = P2(0)*(P1(1)*x1 - P1(2)*x3 + P1(3)*x2)
        x5 = P2(0)*(P2(1)*x1 - P2(2)*x3 + P2(3)*x2)
        x6 = w1(0)*w2(1) - w1(1)*w2(0)
        x7 = w1(0)*w2(3) - w1(3)*w2(0)
        x8 = P2(2)*co(3)*(P1(0)*x3 - P1(1)*x7 + P1(3)*x6)
        x9 = P2(2)*co(3)*(P2(0)*x3 - P2(1)*x7 + P2(3)*x6)
        x10 = P2(0)**2
        x11 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x12 = P1(0)*co(2)*x11
        x13 = P2(2)*w2(3)
        x14 = P2(3)*w2(2)
        x15 = x13 - x14
        x16 = P1(1)*w1(1)
        x17 = P1(2)*w1(2)
        x18 = P1(3)*w1(3)
        x19 = P1(0)*w1(0)
        x20 = x16 + x17 + x18 - x19
        x21 = P1(1)*co(3)*x20
        x22 = P2(1)*w1(1)
        x23 = P2(2)*w1(2)
        x24 = P2(3)*w1(3)
        x25 = P2(0)*w1(0)
        x26 = x22 + x23 + x24 - x25
        x27 = P1(1)*co(3)*x26
        x28 = P2(1)*w2(2)
        x29 = P2(2)*w2(1)
        x30 = x28 - x29
        x31 = P1(3)*co(3)*x20
        x32 = P1(3)*co(3)*x26
        x33 = P1(1)**2
        x34 = P2(0)*co(1)*x11
        x35 = P1(2)**2
        x36 = co(1)*x11*x35
        x37 = P1(3)**2
        x38 = co(2)*x11
        x39 = P1(0)**2
        x40 = P2(0)*x39
        x41 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x42 = w1(0)*x10*x41
        x43 = P2(1)**2
        x44 = co(1)*x43
        x45 = w1(0)*x41
        x46 = P2(2)**2
        x47 = co(1)*x46
        x48 = P2(3)**2
        x49 = co(1)*x48
        x50 = co(1)*x26*x33
        x51 = co(1)*x26*x35
        x52 = co(1)*x26*x37
        x53 = w1(0)*w2(2) - w1(2)*w2(0)
        x54 = P2(1)*(P1(0)*x1 - P1(2)*x7 + P1(3)*x53)
        x55 = P2(1)*co(3)*(P2(0)*x1 - P2(2)*x7 + P2(3)*x53)
        x56 = P1(0)*x2 - P1(1)*x53 + P1(2)*x6
        x57 = P1(0)*P2(3)*co(3)
        x58 = P2(0)*x2 - P2(1)*x53 + P2(2)*x6
        x59 = co(1)*x10
        x60 = P2(1)*w2(3)
        x61 = P2(3)*w2(1)
        x62 = x60 - x61
        x63 = P1(2)*co(3)*x62
        x64 = co(1)*x11
        x65 = co(1)*x26*x39
        x66 = P2(1)*w2(1)
        x67 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x66
        x68 = co(0)*x67
        x69 = P1(0)*P2(0)*w1(0)
        x70 = co(2)*x20
        x71 = P1(0)*P2(0)*w2(0)
        x72 = co(2)*x26
        x73 = P1(1)*P2(1)*co(1)*x11
        x74 = P1(1)*P2(1)*co(1)*x67
        x75 = P2(1)*w2(0)
        x76 = P1(1)*co(1)*x26
        x77 = P1(2)*P2(2)*co(1)*x11
        x78 = P1(2)*P2(2)*co(1)*x67
        x79 = P2(2)*w2(0)
        x80 = P1(2)*co(1)*x26
        x81 = P2(3)*co(1)*x11
        x82 = P1(3)*P2(3)*co(1)*x67
        x83 = P2(3)*w2(0)
        x84 = P1(3)*co(1)*x26
        x85 = P1(1)*P2(1)
        x86 = P1(3)*P2(3)
        x87 = co(1)*x26
        x88 = P1(0)*co(0)*x41
        x89 = P2(1)*co(0)*w1(1)*x67
        x90 = P2(2)*co(0)*w1(2)*x67
        x91 = P2(3)*co(0)*w1(3)*x41
        x92 = P2(3)*co(0)*w1(3)*x67
        x93 = P2(0)*co(0)*x41
        x94 = P1(1)*co(2)*x20
        x95 = P1(1)*co(2)*x26
        x96 = P1(2)*co(2)*x20
        x97 = P1(2)*co(2)*x26
        x98 = P1(3)*co(2)*x20
        x99 = P1(3)*co(2)*x26
        x100 = 2*co(1)*x41
        x101 = 2*co(0)*x41
        x102 = 2*co(1)*w1(0)*x41
        x103 = 2*P1(2)*P2(2)*co(1)
        x104 = P1(0)*co(3)*x20
        x105 = P1(0)*co(3)*x26
        x106 = P1(1)*co(3)
        x107 = P1(1)*co(2)*x11
        x108 = P2(0)*w2(2)
        x109 = x108 - x79
        x110 = P2(1)*x33
        x111 = P2(1)*co(1)*x11
        x112 = w1(1)*x41
        x113 = P1(1)*P2(3)*co(3)
        x114 = P1(2)*co(3)
        x115 = P2(0)*w2(3)
        x116 = x115 - x83
        x117 = x116*x20
        x118 = x116*x26
        x119 = co(1)*x10*x41
        x120 = P1(0)*P2(0)*co(2)*x11
        x121 = P2(0)*w2(1)
        x122 = P1(0)*co(2)*x20
        x123 = P1(0)*co(2)*x26
        x124 = P2(1)*co(0)*x41
        x125 = P1(1)*co(0)*x41
        x126 = P2(0)*co(0)*w1(0)*x67
        x127 = co(1)*x67
        x128 = P1(1)*P2(1)*w1(1)
        x129 = P1(0)*P2(0)
        x130 = P1(0)*P2(0)*co(1)*x67
        x131 = P1(0)*co(1)*x26
        x132 = P1(2)*P2(2)*co(2)*x11
        x133 = 2*co(1)*w1(1)*x41
        x134 = P1(2)*co(2)*x11
        x135 = P2(2)*co(1)*x11
        x136 = w1(2)*x41
        x137 = w1(2)*x41*x46
        x138 = co(1)*w2(2)*x26
        x139 = P1(2)*P2(3)*co(3)
        x140 = x121 - x75
        x141 = P2(2)*co(0)*x41
        x142 = P1(2)*co(0)*x41
        x143 = P1(2)*P2(2)*w1(2)
        x144 = P1(2)*P2(2)*w2(2)
        x145 = 2*co(1)*w1(2)*x41
        x146 = P1(0)*co(3)*x30
        x147 = P1(2)*co(3)*x140
        x148 = P1(3)*co(3)
        x149 = P1(3)*co(2)*x11
        x150 = P2(3)*x37
        x151 = w1(3)*x41
        x152 = co(1)*w2(3)*x26
        x153 = P1(3)*P2(3)*co(3)
        x154 = P2(3)*co(0)*x41
        x155 = P1(3)*co(0)*x41
        x156 = P1(3)*P2(3)*w1(3)
        x157 = P1(3)*P2(3)*w2(3)
        x158 = 2*co(1)*w1(3)*x41
        wout(0) = -P1(0)*x11*x59 - P1(0)*x55 + P1(0)*x8 - P1(0)*x89 + P1(0)*x9 &
                   - P1(0)*x90 - P1(0)*x91 - P1(0)*x92 - P1(2)*P2(2)*x12 + P1(3&
                  )*P2(0)*x81 - P2(0)*co(1)*x19*x67 + P2(0)*x36 + P2(0)*x73 +  &
                  P2(0)*x77 - P2(0)*x91 + co(0)*x42 - co(1)*x42 + w1(0)*x74 +  &
                  w1(0)*x78 + w1(0)*x82 + w2(0)*x50 + w2(0)*x51 + w2(0)*x52 -  &
                  w2(0)*x65 + x0*x4 + x0*x5 - x0*x54 + x10*x12 - x100*x69 +    &
                  x101*x69 + x102*x85 + x102*x86 + x103*x45 - x12*x43 - x12*x46&
                   - x12*x48 - x12*x85 - x12*x86 + x15*x21 + x15*x27 - x16*x93 &
                   - x17*x93 - x18*x93 - x20*x63 - x22*x88 - x22*x93 - x23*x88 &
                   - x23*x93 - x26*x63 + x30*x31 + x30*x32 + x33*x34 + x34*x37 &
                   + x38*x40 - x40*x64 + x44*x45 + x45*x47 + x45*x49 - x56*x57 &
                   - x57*x58 + x68*x69 + x70*x71 + x71*x72 - x71*x87 + x75*x76 &
                   - x75*x94 - x75*x95 + x79*x80 - x79*x96 - x79*x97 + x83*x84 &
                   - x83*x98 - x83*x99
        wout(1) = P1(1)*x11*x44 + P1(1)*x120 + P1(1)*x126 - P1(1)*x132 - P1(1)*&
                  x55 + P1(1)*x8 + P1(1)*x9 - P1(1)*x90 - P1(1)*x91 - P1(1)*x92&
                   + P2(1)*x36 + P2(1)*x77 - co(0)*x112*x43 - w1(1)*x119 - w1(1&
                  )*x130 + w1(1)*x78 + w1(1)*x82 + w2(1)*x50 + w2(1)*x51 + w2(1&
                  )*x52 - w2(1)*x65 + x10*x107 + x100*x128 - x101*x128 + x103* &
                  x112 + x104*x15 + x105*x15 + x106*x4 + x106*x5 - x106*x54 -  &
                  x107*x43 - x107*x46 - x107*x48 - x107*x86 + x109*x31 + x109* &
                  x32 - x110*x38 + x110*x64 - x111*x129 + x111*x37 - x111*x39  &
                   + x111*x86 + x112*x44 + x112*x47 + x112*x49 - x113*x56 -    &
                  x113*x58 - x114*x117 - x114*x118 + x121*x122 + x121*x123 -   &
                  x121*x131 - x124*x17 - x124*x18 + x124*x19 - x124*x23 - x124*&
                  x24 + x124*x25 - x125*x23 + x125*x25 + x127*x128 - x128*x68  &
                   - x129*x133 + x133*x86 + x29*x80 - x29*x96 - x29*x97 + x61* &
                  x84 - x61*x98 - x61*x99 + x66*x76 - x66*x94 - x66*x95
        wout(2) = P1(1)*P2(1)*P2(2)*co(1)*x11 + P1(2)*x11*x47 + P1(2)*x120 + P1&
                  (2)*x126 - P1(2)*x55 + P1(2)*x8 - P1(2)*x89 + P1(2)*x9 - P1(2&
                  )*x90 - P1(2)*x92 - 2*P2(2)*w1(2)*x142 - P2(2)*x35*x38 + P2(2&
                  )*x36 - co(0)*x137 + co(1)*x137 - w1(2)*x130 + w1(2)*x74 + w1&
                  (2)*x82 + w2(2)*x51 + x10*x134 + x100*x143 - x104*x62 - x105*&
                  x62 + x106*x117 + x106*x118 + x108*x122 + x108*x123 - x108*  &
                  x131 + x114*x4 + x114*x5 - x114*x54 + x127*x143 - x129*x135  &
                   - x129*x145 - x134*x43 - x134*x46 - x134*x48 - x134*x85 -   &
                  x134*x86 + x135*x33 + x135*x37 - x135*x39 + x135*x86 + x136* &
                  x44 + x136*x49 - x136*x59 + x138*x33 + x138*x37 - x138*x39 - &
                  x139*x56 - x139*x58 + x14*x84 - x14*x98 - x14*x99 - x140*x31 &
                   - x140*x32 - x141*x16 - x141*x18 + x141*x19 - x141*x22 -    &
                  x141*x24 + x141*x25 - x142*x22 - x142*x24 + x142*x25 - x144* &
                  x70 - x144*x72 + x144*x87 + x145*x85 + x145*x86 + x28*x76 -  &
                  x28*x94 - x28*x95
        wout(3) = -P1(3)*P2(1)*x107 - 2*P1(3)*w1(3)*x154 + P1(3)*x11*x49 + P1(3&
                  )*x120 + P1(3)*x126 - P1(3)*x132 - P1(3)*x55 + P1(3)*x8 - P1(&
                  3)*x89 + P1(3)*x9 - P1(3)*x90 + P2(3)*x36 + P2(3)*x73 + P2(3 &
                  )*x77 - co(0)*x151*x48 - w1(3)*x119 - w1(3)*x130 + w1(3)*x74 &
                   + w1(3)*x78 + w2(3)*x51 + x10*x149 + x100*x156 + x103*x151  &
                   - x109*x21 - x109*x27 + x115*x122 + x115*x123 - x115*x131 + &
                  x127*x156 - x129*x158 - x129*x81 + x13*x80 - x13*x96 - x13*  &
                  x97 + x146*x20 + x146*x26 + x147*x20 + x147*x26 + x148*x4 +  &
                  x148*x5 - x148*x54 - x149*x43 - x149*x46 - x149*x48 - x150*  &
                  x38 + x150*x64 + x151*x44 + x151*x47 + x151*x49 + x152*x33 + &
                  x152*x37 - x152*x39 - x153*x56 - x153*x58 - x154*x16 - x154* &
                  x17 + x154*x19 - x154*x22 - x154*x23 + x154*x25 - x155*x22 - &
                  x155*x23 + x155*x25 - x156*x68 - x157*x70 - x157*x72 + x157* &
                  x87 + x158*x85 + x33*x81 - x39*x81 + x60*x76 - x60*x94 - x60*&
                  x95
      case(VVV5)
!       c0*(-P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon
!       (-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon(-1,-2,-3,3)*
!       Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - 2*Epsilon(-1,-2,1,2)*P
!       (-1,2)*P(-2,3)*P(3,1) + 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(-Metric(1,3)*P(2,3) + Metric(2,3)*P(1,3))
!       Epsilon(-1,1,2,3)*P(-1,3)*c5
        if (last) VB_last = .true.
        x0 = w1(1)*w2(3)
        x1 = -w1(3)*w2(1) + x0
        x2 = P1(2)*x1
        x3 = P2(2)*x1
        x4 = w1(2)*w2(3)
        x5 = w1(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*x6
        x8 = w1(1)*w2(2) - w1(2)*w2(1)
        x9 = P1(3)*x8
        x10 = P2(1)*x6
        x11 = P2(3)*x8
        x12 = x10 + x11 - x3
        x13 = P1(0)**2
        x14 = 2*co(3)*x13
        x15 = P1(1)**2
        x16 = 2*co(3)*x15
        x17 = P1(2)**2
        x18 = 2*co(3)*x17
        x19 = P1(3)**2
        x20 = 2*co(3)*x19
        x21 = P1(1)*w1(1)
        x22 = co(4)*w2(0)
        x23 = P1(2)*w1(2)
        x24 = P1(3)*w2(0)
        x25 = co(4)*w1(3)
        x26 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x27 = P2(0)*co(1)*x26
        x28 = co(1)*x17*x26
        x29 = P2(1)*w2(0)
        x30 = co(4)*w1(1)
        x31 = P2(2)*w1(2)
        x32 = P2(3)*w2(0)
        x33 = P2(0)**2
        x34 = P1(1)*w2(1)
        x35 = P1(2)*w2(2)
        x36 = P1(3)*w2(3)
        x37 = P1(0)*w2(0)
        x38 = x34 + x35 + x36 - x37
        x39 = w1(0)*x33*x38
        x40 = P2(1)**2
        x41 = x38*x40
        x42 = P2(2)**2
        x43 = co(1)*x38*x42
        x44 = P2(3)**2
        x45 = co(1)*x38*x44
        x46 = P2(3)*w1(3)
        x47 = -P2(0)*w1(0) + P2(1)*w1(1) + x31 + x46
        x48 = co(1)*x13*x47
        x49 = P1(0)*x26
        x50 = co(1)*x40
        x51 = co(1)*x42
        x52 = co(1)*x44
        x53 = w1(0)*w2(1)
        x54 = P1(1)*co(4)
        x55 = P1(2)*w1(0)
        x56 = co(4)*w2(2)
        x57 = P1(3)*w1(0)
        x58 = co(4)*w2(3)
        x59 = co(4)*w1(0)*w2(1)
        x60 = P2(2)*w1(0)
        x61 = P2(3)*w2(3)
        x62 = co(4)*w1(0)
        x63 = co(1)*x15*x47
        x64 = co(1)*x17*x47
        x65 = co(1)*x19*x47
        x66 = 8*co(3)
        x67 = -x2 + x7 + x9
        x68 = 6*co(3)
        x69 = P2(1)*w2(3)
        x70 = P2(3)*w2(1)
        x71 = x69 - x70
        x72 = 4*P1(2)*co(3)*x47
        x73 = P1(0)*P2(2)
        x74 = P1(0)*x1
        x75 = -w1(1)*w2(0) + x53
        x76 = P1(3)*x75
        x77 = w1(3)*w2(0)
        x78 = w1(0)*w2(3) - x77
        x79 = P1(1)*x78
        x80 = x74 + x76 - x79
        x81 = 2*co(3)*x80
        x82 = P2(0)*x1
        x83 = P2(3)*x75
        x84 = P2(1)*x78
        x85 = x82 + x83 - x84
        x86 = 2*co(3)*x85
        x87 = P1(1)*w1(0)
        x88 = P1(2)*w2(3)
        x89 = P1(3)*w2(2)
        x90 = x88 - x89
        x91 = P1(0)*w2(2)
        x92 = P1(2)*w2(0)
        x93 = x91 - x92
        x94 = P1(0)*w2(3)
        x95 = -x24 + x94
        x96 = 2*co(2)*(P2(0)*x90 - P2(2)*x95 + P2(3)*x93)
        x97 = P2(2)*w2(3) - P2(3)*w2(2)
        x98 = P2(0)*w2(2)
        x99 = -P2(2)*w2(0) + x98
        x100 = P2(0)*w2(3)
        x101 = x100 - x32
        x102 = 2*co(2)*(P2(0)*x97 - P2(2)*x101 + P2(3)*x99)
        x103 = P1(1)*w2(0)
        x104 = P1(2)*w1(3)
        x105 = P1(3)*w1(2)
        x106 = x104 - x105
        x107 = P2(0)*x106
        x108 = P1(0)*w1(2)
        x109 = x108 - x55
        x110 = P2(3)*x109
        x111 = P1(0)*w1(3)
        x112 = x111 - x57
        x113 = P2(2)*x112
        x114 = 2*co(2)*(x107 + x110 - x113)
        x115 = P2(2)*w1(3)
        x116 = P2(3)*w1(2)
        x117 = x115 - x116
        x118 = P2(0)*x117
        x119 = P2(0)*w1(2) - x60
        x120 = P2(3)*x119
        x121 = P2(3)*w1(0)
        x122 = P2(0)*w1(3) - x121
        x123 = P2(2)*x122
        x124 = 2*co(2)*(x118 + x120 - x123)
        x125 = P1(2)*P2(3)
        x126 = P1(3)*P2(2)
        x127 = x125 - x126
        x128 = 2*P1(1)*co(2)*x26
        x129 = P1(2)*P2(0)
        x130 = P1(1)*w2(3)
        x131 = P1(3)*w2(1)
        x132 = x130 - x131
        x133 = 2*P1(2)*co(3)*x47
        x134 = P2(3)*w1(1)
        x135 = P2(1)*w1(3) - x134
        x136 = 2*P1(2)*co(3)*x38
        x137 = P2(1)*w2(1)
        x138 = P2(0)*w2(0)
        x139 = P2(2)*w2(2) + x137 - x138 + x61
        x140 = 2*P1(2)*co(3)*x139
        x141 = P1(3)*w1(3)
        x142 = P1(0)*w1(0)
        x143 = x141 - x142 + x21 + x23
        x144 = 2*P1(2)*co(3)*x143
        x145 = 2*co(3)*(-x33 + x40 + x42 + x44)
        x146 = P1(1)*P2(1)
        x147 = P1(2)*P2(2)
        x148 = P1(3)*P2(3)
        x149 = P1(0)*P2(0)
        x150 = 2*co(3)*(x146 + x147 + x148 - x149)
        x151 = P1(1)*w2(2)
        x152 = P1(2)*w2(1)
        x153 = x151 - x152
        x154 = P1(0)*w2(1)
        x155 = -x103 + x154
        x156 = 2*co(2)*(P2(0)*x153 - P2(1)*x93 + P2(2)*x155)
        x157 = P2(1)*w2(2) - P2(2)*w2(1)
        x158 = P2(0)*w2(1) - x29
        x159 = 2*co(2)*(P2(0)*x157 - P2(1)*x99 + P2(2)*x158)
        x160 = P1(1)*w1(2)
        x161 = P1(2)*w1(1)
        x162 = x160 - x161
        x163 = P2(0)*x162
        x164 = P1(0)*w1(1)
        x165 = x164 - x87
        x166 = P2(2)*x165
        x167 = P2(1)*x109
        x168 = 2*co(2)*(x163 + x166 - x167)
        x169 = P2(1)*w1(2)
        x170 = P2(2)*w1(1)
        x171 = x169 - x170
        x172 = P2(0)*x171
        x173 = P2(0)*w1(1)
        x174 = P2(1)*w1(0)
        x175 = x173 - x174
        x176 = P2(2)*x175
        x177 = P2(1)*x119
        x178 = 2*co(2)*(x172 + x176 - x177)
        x179 = P1(1)*P2(2)
        x180 = P1(2)*P2(1)
        x181 = x179 - x180
        x182 = 2*P1(3)*co(2)*x26
        x183 = P2(1)*x106
        x184 = 2*co(3)*x38
        x185 = P2(1)*x117
        x186 = P2(3)*x162
        x187 = P2(3)*x171
        x188 = P1(0)*P2(1)
        x189 = P1(0)*x6
        x190 = w1(0)*w2(2) - w1(2)*w2(0)
        x191 = P1(3)*x190
        x192 = P1(2)*x78
        x193 = x189 + x191 - x192
        x194 = 2*co(3)*x193
        x195 = P2(0)*x6
        x196 = P2(3)*x190
        x197 = P2(2)*x78
        x198 = x195 + x196 - x197
        x199 = 2*co(3)*x198
        x200 = P1(0)*P2(3)
        x201 = P1(0)*x8
        x202 = P1(2)*x75
        x203 = P1(1)*x190
        x204 = x201 + x202 - x203
        x205 = 2*co(3)*x204
        x206 = P2(0)*x8
        x207 = P2(2)*x75
        x208 = P2(1)*x190
        x209 = x206 + x207 - x208
        x210 = 2*co(3)*x209
        x211 = 2*co(2)*(P2(1)*x90 - P2(2)*x132 + P2(3)*x153)
        x212 = 2*co(2)*(P2(1)*x97 - P2(2)*x71 + P2(3)*x157)
        x213 = P1(1)*w1(3)
        x214 = P1(3)*w1(1)
        x215 = x213 - x214
        x216 = P2(2)*x215
        x217 = 2*co(2)*(x183 + x186 - x216)
        x218 = P2(2)*x135
        x219 = 2*co(2)*(x185 + x187 - x218)
        x220 = P1(1)*P2(0)
        x221 = 2*co(3)*x67
        x222 = 2*P1(1)*co(3)*x47
        x223 = P1(1)*x117
        x224 = 2*co(3)*x139
        x225 = 2*co(3)*x143
        x226 = P1(1)*x97
        x227 = P2(0)*x132 - P2(1)*x95 + P2(3)*x155
        x228 = 2*P1(2)*co(2)*w1(0)
        x229 = P2(0)*x71 - P2(1)*x101 + P2(3)*x158
        x230 = P2(0)*x215
        x231 = P2(3)*x165
        x232 = P2(1)*x112
        x233 = 2*co(2)*(x230 + x231 - x232)
        x234 = P2(0)*x135
        x235 = P2(3)*x175
        x236 = P2(1)*x122
        x237 = 2*co(2)*(x234 + x235 - x236)
        x238 = P1(1)*P2(3)
        x239 = P1(3)*P2(1)
        x240 = x238 - x239
        x241 = 2*P1(2)*co(2)*x26
        x242 = P1(3)*P2(0)
        x243 = 2*P1(3)*co(3)*x47
        x244 = 2*P1(3)*co(3)*x139
        x245 = 2*P1(3)*co(3)*x143
        x246 = 4*P1(1)*P2(1)*co(3)
        x247 = 4*co(3)*x47
        x248 = 4*co(3)*x12
        x249 = 4*P1(3)*co(3)*x47
        x250 = co(1)*w1(0)*x139
        x251 = P1(0)*P2(1)*co(0)*w1(1)
        x252 = co(0)*x38
        x253 = P1(0)*P2(2)*w1(2)
        x254 = co(0)*x139
        x255 = P2(3)*co(0)*x38
        x256 = P2(3)*co(0)*x139
        x257 = P1(1)*co(1)*x143
        x258 = P1(2)*P2(2)*co(1)*x143
        x259 = P2(3)*co(1)*x26
        x260 = P2(3)*co(1)*x143
        x261 = P1(0)*co(1)*x26
        x262 = co(0)*w1(0)*x139
        x263 = P1(0)*P2(0)*co(1)*x143
        x264 = P1(1)*co(0)*x38
        x265 = w1(2)*x38
        x266 = co(0)*w1(3)*x38
        x267 = P2(1)*co(0)*x38
        x268 = P2(0)*co(0)*x38
        x269 = co(1)*x26*x33
        x270 = co(4)*w2(1)
        x271 = P2(1)*co(1)*x26
        x272 = co(1)*w1(1)
        x273 = P1(1)*x26
        x274 = P1(3)*co(4)
        x275 = co(4)*w1(1)*w2(2)
        x276 = P2(3)*co(4)
        x277 = co(0)*w1(1)
        x278 = x33*x38
        x279 = 4*co(3)*x198
        x280 = 4*co(3)*x101*x47
        x281 = 2*co(3)*x12
        x282 = 2*P1(0)*co(2)*x26
        x283 = 2*co(3)*x122*x139
        x284 = -x129 + x73
        x285 = 2*P1(0)*co(3)*x47
        x286 = 2*P1(0)*co(3)*x38
        x287 = 2*P1(0)*co(3)*x139
        x288 = 2*P1(0)*co(3)*x143
        x289 = 2*co(2)*x227
        x290 = 2*co(2)*x229
        x291 = P1(2)*x26
        x292 = 2*co(2)*(x200 - x242)
        x293 = 2*co(3)*x119*x38
        x294 = 4*P1(0)*co(3)*x47
        x295 = 4*co(3)*x47*x99
        x296 = P1(0)*P2(0)*co(1)*x26
        x297 = co(1)*w1(1)*x139
        x298 = P1(1)*P2(1)*x139
        x299 = co(1)*x143
        x300 = P1(1)*P2(2)*w1(2)
        x301 = P1(1)*co(1)*x26
        x302 = co(0)*w1(0)*x38
        x303 = P1(2)*co(0)*x38
        x304 = P2(2)*co(0)*x38
        x305 = co(4)*w1(2)
        x306 = P2(2)*co(1)*x26
        x307 = w1(2)*x38*x42
        x308 = co(1)*w2(2)*x47
        x309 = co(1)*x26*x40
        x310 = P1(0)*x71
        x311 = 4*co(3)*x85
        x312 = P1(3)*x175
        x313 = 2*P1(1)*co(3)*x143
        x314 = 2*P1(2)*co(2)*w1(2)
        x315 = x188 - x220
        x316 = co(1)*x139
        x317 = co(1)*w2(2)*x143
        x318 = P1(2)*P2(1)*w1(1)
        x319 = P1(2)*P2(2)*w1(2)
        x320 = P2(0)*co(1)*x143
        x321 = P1(3)*co(1)*x26
        x322 = P1(3)*co(0)*x38
        x323 = co(1)*w1(3)
        x324 = co(1)*w2(3)*x47
        x325 = 4*co(3)*x209
        x326 = 2*P1(3)*P2(2)*co(3)
        x327 = co(1)*w2(3)*x143
        wout(0) = -P1(0)*P2(0)*x12*x66 - P1(0)*P2(0)*x67*x68 - P1(2)*P2(0)*co(0&
                  )*x265 + P1(3)*x171*x184 + P2(0)*x28 - P2(1)*x59 + co(0)*x39 &
                   + co(1)*w1(0)*x41 - co(1)*x39 - co(5)*x10 - co(5)*x11 + co(5&
                  )*x2 + co(5)*x3 - co(5)*x7 - co(5)*x9 + w1(0)*x43 + w1(0)*x45&
                   + w2(0)*x258 - w2(0)*x263 + w2(0)*x48 - w2(0)*x63 - w2(0)*  &
                  x64 - w2(0)*x65 - x102*x87 - x103*x114 - x103*x124 + x111*   &
                  x255 + x111*x256 - x12*x14 + x12*x16 + x12*x18 + x12*x20 +   &
                  x12*x246 - x127*x128 - x129*x81 - x129*x86 - x132*x133 - x135&
                  *x136 - x135*x140 + x139*x251 + x142*x211 + x142*x212 - x144*&
                  x71 - x145*x2 + x145*x7 + x145*x9 + x146*x221 - x146*x250 -  &
                  x146*x261 + x146*x27 + x147*x221 + x147*x248 - x147*x250 -   &
                  x147*x261 + x147*x27 + x148*x221 + x148*x248 - x148*x250 -   &
                  x148*x261 + x149*x250 - x149*x262 + x15*x27 - x150*x2 + x150*&
                  x7 + x150*x9 + x153*x243 - x156*x57 + x157*x245 + x157*x249  &
                   - x159*x57 - x168*x24 + x171*x244 - x173*x264 - x173*x267 - &
                  x178*x24 - x181*x182 - x183*x184 - x184*x185 - x184*x186 -   &
                  x184*x187 + x184*x216 + x184*x218 + x184*x223 + x188*x194 +  &
                  x188*x199 + x19*x27 + x194*x220 + x199*x220 + x200*x205 +    &
                  x200*x210 + x205*x242 + x21*x22 + x210*x242 + x217*x37 + x219&
                  *x37 + x22*x23 + x22*x31 + x222*x90 + x223*x224 + x225*x226  &
                   + x226*x247 + x227*x228 + x228*x229 + x233*x92 + x237*x92 + &
                  x24*x25 + x24*x260 + x240*x241 + x242*x259 - x242*x266 + x25*&
                  x32 + x251*x38 + x252*x253 + x253*x254 + x257*x29 - x268*x31 &
                   - x268*x46 + x29*x30 - x49*x50 - x49*x51 - x49*x52 - x53*x54&
                   - x55*x56 - x56*x60 - x57*x58 - x61*x62 - x71*x72 - x73*x81 &
                   - x73*x86 - x87*x96
        wout(1) = P1(1)*P2(1)*w2(1)*x299 + P1(1)*P2(1)*x193*x68 + P1(1)*P2(1)* &
                  x198*x66 + P1(1)*x269 + P1(1)*x296 - P1(2)*x280 - P1(2)*x283 &
                   + P1(3)*P2(3)*w2(1)*x299 + P1(3)*x293 + P1(3)*x295 - P2(0)* &
                  x59 + P2(1)*x28 - P2(2)*x275 - co(5)*x189 - co(5)*x191 + co(5&
                  )*x192 - co(5)*x195 - co(5)*x196 + co(5)*x197 + w1(1)*x43 +  &
                  w1(1)*x45 + w2(1)*x258 - w2(1)*x263 + w2(1)*x48 - w2(1)*x63  &
                   - w2(1)*x64 - w2(1)*x65 - x0*x274 - x0*x276 - x101*x144 -   &
                  x102*x21 - x107*x184 - x110*x184 + x113*x184 - x114*x34 +    &
                  x117*x286 + x117*x287 - x118*x184 + x119*x244 - x120*x184 -  &
                  x122*x136 + x123*x184 - x124*x34 - x127*x282 - x13*x271 -    &
                  x131*x168 - x131*x178 - x133*x95 - x14*x198 - x141*x267 +    &
                  x141*x270 + x142*x267 - x142*x270 + x145*x189 + x145*x191 -  &
                  x145*x192 + x147*x194 + x147*x271 + x147*x279 - x147*x297 -  &
                  x147*x301 + x148*x194 + x148*x271 + x148*x279 - x148*x297 -  &
                  x148*x301 - x149*x194 - x149*x271 - x149*x279 + x149*x297 +  &
                  x150*x189 + x150*x191 - x150*x192 + x152*x233 + x152*x237 +  &
                  x154*x217 + x154*x219 - x156*x214 - x159*x214 + x16*x198 +   &
                  x161*x289 + x161*x290 + x164*x211 + x164*x212 - x169*x303 -  &
                  x169*x304 + x173*x22 + x174*x268 - x179*x81 - x179*x86 + x18*&
                  x198 - x180*x81 - x180*x86 - x182*x284 - x188*x221 - x188*   &
                  x281 + x19*x271 + x198*x20 + x205*x238 + x205*x239 - x21*x96 &
                   + x210*x238 + x210*x239 + x213*x255 + x213*x256 - x220*x221 &
                   - x220*x262 - x220*x281 - x220*x302 + x23*x270 + x243*x93 + &
                  x245*x99 + x25*x70 + x252*x300 + x254*x300 - x267*x46 + x270*&
                  x31 - x272*x278 - x272*x298 + x272*x41 - x273*x51 - x273*x52 &
                   + x277*x298 - x277*x41 + x285*x90 + x288*x97 + x291*x292 +  &
                  x294*x97 - x30*x35 + x30*x37
        wout(2) = P1(0)*P2(0)*w1(2)*x316 - P1(1)*P1(2)*P2(1)*co(1)*x26 - P1(1)*&
                  P2(1)*w1(2)*x316 + P1(1)*x122*x184 + P1(1)*x280 + P1(1)*x283 &
                   - P1(2)*P2(0)*w1(0)*x254 - P1(2)*P2(2)*x66*x85 - P1(2)*P2(2 &
                  )*x68*x80 + P1(2)*x269 + P1(2)*x296 - P1(2)*x309 - P1(3)*P2(3&
                  )*w1(2)*x316 + P2(1)*x275 - co(0)*x307 - co(1)*x265*x33 + co(&
                  1)*x307 + co(5)*x74 + co(5)*x76 - co(5)*x79 + co(5)*x82 + co(&
                  5)*x83 - co(5)*x84 - w2(2)*x64 + x101*x313 - x102*x160 + x104&
                  *x255 + x104*x256 - x105*x156 - x105*x159 + x108*x211 + x108*&
                  x212 - x114*x151 - x115*x255 - x115*x322 - x116*x58 - x124*  &
                  x151 + x125*x205 + x125*x210 - x125*x321 + x126*x205 + x126* &
                  x210 - x129*x221 - x129*x281 - x13*x306 + x13*x308 - x132*   &
                  x285 - x135*x286 - x135*x287 + x138*x305 + x14*x85 + x142*   &
                  x304 - x145*x74 - x145*x76 + x145*x79 + x146*x306 + x146*x317&
                   - x146*x81 + x147*x317 + x148*x306 - x148*x311 - x148*x81 - &
                  x149*x306 + x149*x311 + x149*x81 + x15*x306 - x15*x308 - x150&
                  *x74 - x150*x76 + x150*x79 - x155*x243 - x158*x245 - x158*   &
                  x249 - x16*x85 - x160*x270 - x160*x96 - x168*x89 - x169*x270 &
                   - x170*x267 - x178*x89 + x179*x194 + x179*x199 - x18*x85 +  &
                  x180*x194 + x180*x199 + x182*x315 + x184*x230 + x184*x231 -  &
                  x184*x232 + x184*x234 + x184*x235 - x184*x236 - x184*x312 +  &
                  x19*x306 - x19*x308 - x20*x85 - x21*x304 + x21*x56 + x217*x91&
                   + x219*x91 - x221*x73 + x222*x95 - x224*x312 - x225*x310 +  &
                  x227*x314 + x229*x314 + x233*x35 + x237*x35 + x240*x282 -    &
                  x246*x85 - x247*x310 + x252*x318 + x254*x318 + x254*x319 +   &
                  x260*x89 + x265*x50 + x265*x52 - x268*x55 + x268*x60 - x273* &
                  x292 - x274*x4 + x274*x5 + x276*x5 - x281*x73 - x291*x52 +   &
                  x305*x37 - x316*x319 - x320*x91 - x62*x91 - x62*x98
        wout(3) = P1(0)*P2(0)*w1(3)*x316 - P1(1)*x119*x224 - P1(1)*x293 - P1(1 &
                  )*x295 - P1(2)*P2(2)*w1(3)*x316 + P1(2)*co(4)*x4 + P1(3)*P2(1&
                  )*w1(1)*x254 + P1(3)*P2(2)*w1(2)*x254 - P1(3)*P2(3)*w1(3)*   &
                  x316 + P1(3)*P2(3)*x204*x68 + P1(3)*P2(3)*x209*x66 - P1(3)*  &
                  x26*x51 + P1(3)*x269 - P1(3)*x309 + P2(0)*co(4)*x77 + P2(3)* &
                  x28 - co(5)*x201 - co(5)*x202 + co(5)*x203 - co(5)*x206 - co(&
                  5)*x207 + co(5)*x208 + w1(3)*x45 - w2(3)*x64 + x0*x54 - x100*&
                  x62 - x102*x213 + x104*x289 + x104*x290 + x111*x211 + x111*  &
                  x212 + x111*x22 - x114*x130 - x115*x56 - x116*x303 - x116*   &
                  x304 + x121*x268 - x124*x130 - x125*x81 - x125*x86 + x128*   &
                  x284 - x13*x259 + x13*x324 + x133*x155 - x134*x264 - x134*   &
                  x267 + x136*x175 - x137*x25 - x14*x209 + x140*x175 - x141*   &
                  x156 - x141*x159 + x141*x256 + x142*x255 + x144*x158 + x145* &
                  x201 + x145*x202 - x145*x203 + x146*x205 + x146*x259 - x146* &
                  x321 + x146*x325 + x147*x205 + x147*x259 - x147*x321 + x147* &
                  x325 + x147*x327 + x148*x327 - x149*x205 - x149*x259 - x149* &
                  x325 + x15*x259 - x15*x324 + x150*x201 + x150*x202 - x150*   &
                  x203 + x153*x285 + x157*x288 + x157*x294 + x158*x72 + x16*   &
                  x209 - x163*x184 - x166*x184 + x167*x184 - x168*x36 + x171*  &
                  x286 + x171*x287 - x172*x184 - x176*x184 + x177*x184 - x178* &
                  x36 + x18*x209 - x181*x282 - x19*x324 + x194*x238 + x194*x239&
                   + x199*x238 + x199*x239 + x20*x209 - x200*x221 - x200*x281  &
                   - x213*x96 + x214*x267 + x217*x94 + x219*x94 - x221*x242 -  &
                  x222*x93 + x233*x88 + x237*x88 - x241*x315 + x242*x261 - x242&
                  *x262 - x242*x281 - x242*x302 - x25*x34 - x25*x35 + x257*x69 &
                   - x266*x44 - x278*x323 - x298*x323 + x30*x69 + x31*x322 +   &
                  x31*x58 - x313*x99 - x320*x94 + x323*x38*x42 + x323*x41 -    &
                  x326*x80 - x326*x85 - x62*x94
      case(VVV6)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       c2*(-Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - Epsilon(-1,-2,2,3)*P(-1,
!       1)*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = P1(1)*w2(3)
        x1 = -P1(3)*w2(1) + x0
        x2 = P2(1)*w1(1)
        x3 = P2(2)*w1(2)
        x4 = P2(3)*w1(3)
        x5 = P2(0)*w1(0)
        x6 = x2 + x3 + x4 - x5
        x7 = P1(2)*co(2)*x6
        x8 = P2(3)*w2(1)
        x9 = P2(1)*w2(3) - x8
        x10 = P1(1)*w1(3) - P1(3)*w1(1)
        x11 = P1(1)*w2(1)
        x12 = P1(2)*w2(2)
        x13 = P1(0)*w2(0)
        x14 = P1(3)*w2(3) + x11 + x12 - x13
        x15 = P2(2)*co(2)*x14
        x16 = P2(1)*w1(3)
        x17 = P2(3)*w1(1)
        x18 = x16 - x17
        x19 = co(0)*x14
        x20 = P2(0)**2
        x21 = w1(0)*x20
        x22 = P2(1)**2
        x23 = co(1)*x14*x22
        x24 = P2(2)**2
        x25 = co(1)*w1(0)*x14
        x26 = P2(3)**2
        x27 = P1(1)**2
        x28 = co(1)*w2(0)*x6
        x29 = P1(2)**2
        x30 = P1(3)**2
        x31 = P1(3)*w2(2)
        x32 = P1(2)*w2(3) - x31
        x33 = P1(1)*co(2)*x6
        x34 = P2(2)*w2(3)
        x35 = -P2(3)*w2(2) + x34
        x36 = P1(2)*w2(1)
        x37 = P1(1)*w2(2) - x36
        x38 = P1(3)*co(2)*x6
        x39 = P2(1)*w2(2) - P2(2)*w2(1)
        x40 = P1(2)*w1(3) - P1(3)*w1(2)
        x41 = P2(1)*co(2)*x14
        x42 = P2(2)*w1(3)
        x43 = P2(3)*w1(2)
        x44 = x42 - x43
        x45 = P1(1)*w1(2) - P1(2)*w1(1)
        x46 = P2(3)*co(2)*x14
        x47 = P2(1)*w1(2)
        x48 = P2(2)*w1(1)
        x49 = x47 - x48
        x50 = co(1)*x14
        x51 = P1(0)**2*co(1)*x6
        x52 = P2(3)*w2(3)
        x53 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + x52
        x54 = P2(0)*co(0)*w1(0)*x53
        x55 = P1(1)*w2(0)
        x56 = P2(1)*co(1)*x6
        x57 = P2(2)*w1(0)
        x58 = P1(2)*co(1)*x14
        x59 = P2(2)*w2(0)
        x60 = P1(2)*co(1)*x6
        x61 = P1(3)*w2(0)
        x62 = P2(3)*co(1)*x6
        x63 = P1(0)*co(1)*x14
        x64 = P2(0)*co(1)*x6
        x65 = P1(0)*w1(1)
        x66 = P2(1)*co(0)*x14
        x67 = co(0)*x53
        x68 = P1(0)*w1(2)
        x69 = P2(2)*co(0)*x14
        x70 = P1(0)*P2(3)*w1(3)
        x71 = P2(0)*w1(1)
        x72 = P1(1)*co(0)*x14
        x73 = P2(0)*w1(2)
        x74 = P1(2)*co(0)*x14
        x75 = P2(0)*w1(3)
        x76 = P1(3)*co(0)*x14
        x77 = P2(0)*co(0)*x14
        x78 = P1(0)*co(0)*x14
        x79 = P1(0)*w2(3)
        x80 = -x61 + x79
        x81 = P2(0)*w2(3) - P2(3)*w2(0)
        x82 = P1(0)*w1(3)
        x83 = P1(3)*w1(0)
        x84 = x82 - x83
        x85 = P2(3)*w1(0)
        x86 = x75 - x85
        x87 = co(1)*w1(1)*x14
        x88 = co(1)*x27*x6
        x89 = co(1)*x29*x6
        x90 = co(1)*x30*x6
        x91 = P1(0)*co(2)*x6
        x92 = P1(0)*w2(2)
        x93 = -P1(2)*w2(0) + x92
        x94 = P2(0)*w2(2) - x59
        x95 = P2(0)*co(2)*x14
        x96 = -P1(2)*w1(0) + x68
        x97 = -x57 + x73
        x98 = P2(1)*w1(0)
        x99 = P1(1)*w1(0)
        x100 = P2(0)*co(0)*x53
        x101 = P1(1)*co(1)*x14
        x102 = P2(2)*co(1)*x6
        x103 = P1(3)*co(1)*x14
        x104 = P1(3)*co(1)*x6
        x105 = P1(0)*w2(1)
        x106 = P2(1)*co(0)*w1(1)*x53
        x107 = P2(2)*co(0)*w1(2)*x53
        x108 = P2(3)*co(0)*w1(3)*x53
        x109 = x105 - x55
        x110 = P2(0)*w2(1) - P2(1)*w2(0)
        x111 = co(2)*x14*(x65 - x99)
        x112 = x71 - x98
        x113 = co(1)*w1(2)*x14
        x114 = P2(0)*co(1)*x14
        x115 = P2(2)*co(0)*w1(3)*x14
        x116 = co(1)*w1(3)*x14
        wout(0) = -P1(0)*P2(1)*w1(1)*x67 - P1(0)*P2(2)*w1(2)*x67 + P1(0)*x54 + &
                  P1(1)*P2(1)*w1(0)*x50 + P1(3)*P2(3)*w1(0)*x50 + 2*P2(0)*w1(0 &
                  )*x78 + w1(0)*x23 - w2(0)*x51 + x1*x7 + x10*x15 - x13*x64 +  &
                  x15*x18 + x19*x21 - x19*x70 - x21*x50 + x24*x25 + x25*x26 +  &
                  x27*x28 + x28*x29 + x28*x30 - x3*x77 - x32*x33 - x33*x35 -   &
                  x37*x38 - x38*x39 - x4*x77 - x40*x41 - x41*x44 - x45*x46 -   &
                  x46*x49 - x5*x63 + x55*x56 + x57*x58 + x59*x60 + x61*x62 -   &
                  x65*x66 - x66*x71 - x67*x70 - x68*x69 + x7*x9 - x71*x72 - x73&
                  *x74 - x75*x76
        wout(1) = -P1(1)*x106 - P1(1)*x107 - P1(1)*x108 - 2*P2(1)*w1(1)*x72 -  &
                  w1(1)*x19*x22 + w1(1)*x23 - w2(1)*x51 + w2(1)*x88 + w2(1)*x89&
                   + w2(1)*x90 + x100*x99 + x101*x2 + x102*x36 + x103*x17 +    &
                  x104*x8 - x105*x64 + x11*x56 + x15*x84 + x15*x86 - x16*x76 - &
                  x20*x87 + x24*x87 + x26*x87 - x3*x72 - x32*x91 - x35*x91 -   &
                  x38*x93 - x38*x94 - x4*x66 - x4*x72 - x40*x95 - x44*x95 - x46&
                  *x96 - x46*x97 - x47*x69 - x47*x74 + x48*x58 + x5*x66 - x63* &
                  x71 + x7*x80 + x7*x81 + x77*x99 + x78*x98
        wout(2) = P1(1)*P2(1)*co(1)*w2(2)*x6 - P1(2)*x106 - P1(2)*x107 - P1(2)*&
                  x108 + P1(2)*x54 - P1(3)*x115 - 2*P2(2)*w1(2)*x74 + P2(3)*   &
                  x111 - P2(3)*x115 - w1(2)*x19*x24 - w2(2)*x51 + w2(2)*x88 +  &
                  w2(2)*x89 + w2(2)*x90 + x1*x91 + x10*x95 + x101*x47 + x102*  &
                  x12 + x103*x43 + x109*x38 + x110*x38 + x112*x46 - x113*x20 + &
                  x113*x22 + x113*x24 + x113*x26 - x114*x68 + x18*x95 - x2*x74 &
                   + x3*x58 + x31*x62 - x33*x80 - x33*x81 - x4*x74 - x41*x84 - &
                  x41*x86 - x48*x66 - x48*x72 + x5*x74 + x57*x77 + x57*x78 -   &
                  x64*x92 + x9*x91
        wout(3) = -P1(3)*x106 - P1(3)*x107 - P1(3)*x108 - P2(2)*x111 - 2*P2(3)*&
                  w1(3)*x76 - w1(3)*x19*x26 + w1(3)*x23 - w2(3)*x51 + w2(3)*x88&
                   + w2(3)*x89 + w2(3)*x90 + x0*x56 + x100*x83 + x101*x16 +    &
                  x103*x4 + x104*x52 - x109*x7 - x110*x7 - x112*x15 - x114*x82 &
                   - x116*x20 + x116*x24 + x116*x26 - x17*x66 - x17*x72 - x2*  &
                  x76 - x3*x76 + x33*x93 + x33*x94 + x34*x60 - x37*x91 - x39*  &
                  x91 + x41*x96 + x41*x97 + x42*x58 - x43*x69 - x43*x74 - x45* &
                  x95 - x49*x95 - x64*x79 + x77*x83 + x77*x85 + x78*x85
      case(VVV7)
!       c0*(-P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon
!       (-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon(-1,-2,-3,3)*
!       Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - 2*Epsilon(-1,-2,1,2)*P
!       (-1,2)*P(-2,3)*P(3,1) + 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Metric(1,2)*P(3,2) - Metric(1,3)*P(2,3) - Metric(2,3)*P(1,2) + Metric
!       (2,3)*P(1,3))
!       c5*(-Metric(1,2)*P(3,1) + Metric(1,3)*P(2,1))
!       -Epsilon(-1,1,2,3)*P(-1,1)*c6
!       c7*(-Epsilon(-1,1,2,3)*P(-1,2) - Epsilon(-1,1,2,3)*P(-1,3))
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(5)*x2
        x4 = w1(2)*w2(3)
        x5 = w1(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*x6
        x8 = w1(1)*w2(3)
        x9 = -w1(3)*w2(1) + x8
        x10 = P1(2)*x9
        x11 = w1(1)*w2(2) - w1(2)*w2(1)
        x12 = P1(3)*x11
        x13 = co(4)*x2
        x14 = P2(1)*x6 - P2(2)*x9 + P2(3)*x11
        x15 = P1(0)**2
        x16 = 2*co(3)*x15
        x17 = P1(1)**2
        x18 = 2*co(3)*x17
        x19 = P1(2)**2
        x20 = 2*co(3)*x19
        x21 = P1(3)**2
        x22 = 2*co(3)*x21
        x23 = P1(0)*w1(0)
        x24 = co(5)*w2(0)
        x25 = P1(1)*w1(1)
        x26 = co(4)*w2(0)
        x27 = P1(2)*w2(0)
        x28 = co(4)*w1(2)
        x29 = P1(3)*w1(3)
        x30 = P2(0)*co(1)*x2
        x31 = co(1)*x19*x2
        x32 = P2(0)**2
        x33 = P1(1)*w2(1)
        x34 = P1(2)*w2(2)
        x35 = P1(3)*w2(3)
        x36 = P1(0)*w2(0)
        x37 = x33 + x34 + x35 - x36
        x38 = w1(0)*x32*x37
        x39 = P2(1)**2
        x40 = x37*x39
        x41 = P2(2)**2
        x42 = co(1)*x37*x41
        x43 = P2(3)**2
        x44 = co(1)*x37*x43
        x45 = P2(2)*w1(2)
        x46 = P2(3)*w1(3)
        x47 = -P2(0)*w1(0) + P2(1)*w1(1) + x45 + x46
        x48 = co(1)*x15*x47
        x49 = P1(0)*x2
        x50 = co(1)*x39
        x51 = co(1)*x41
        x52 = co(1)*x43
        x53 = co(4)*w1(0)*w2(1)
        x54 = w1(0)*w2(1)
        x55 = P1(2)*w1(0)
        x56 = co(4)*w2(2)
        x57 = P1(3)*w1(0)
        x58 = co(4)*w2(3)
        x59 = P2(0)*co(4)
        x60 = P2(2)*w1(0)
        x61 = P2(3)*w2(3)
        x62 = co(4)*w1(0)
        x63 = co(1)*x17*x47
        x64 = co(1)*x19*x47
        x65 = co(1)*x21*x47
        x66 = 8*co(3)
        x67 = -x10 + x12 + x7
        x68 = 6*co(3)
        x69 = P2(1)*w2(3)
        x70 = P2(3)*w2(1)
        x71 = x69 - x70
        x72 = 4*P1(2)*co(3)*x47
        x73 = P1(0)*P2(2)
        x74 = P1(0)*x9
        x75 = -w1(1)*w2(0) + x54
        x76 = P1(3)*x75
        x77 = w1(3)*w2(0)
        x78 = w1(0)*w2(3) - x77
        x79 = P1(1)*x78
        x80 = x74 + x76 - x79
        x81 = 2*co(3)*x80
        x82 = P2(0)*x9 - P2(1)*x78 + P2(3)*x75
        x83 = 2*co(3)*x82
        x84 = P1(1)*w1(0)
        x85 = P1(2)*w2(3)
        x86 = P1(3)*w2(2)
        x87 = x85 - x86
        x88 = P1(0)*w2(2)
        x89 = -x27 + x88
        x90 = P1(0)*w2(3)
        x91 = P1(3)*w2(0)
        x92 = x90 - x91
        x93 = 2*co(2)*(P2(0)*x87 - P2(2)*x92 + P2(3)*x89)
        x94 = P2(2)*w2(3) - P2(3)*w2(2)
        x95 = P2(0)*w2(2)
        x96 = -P2(2)*w2(0) + x95
        x97 = P2(0)*w2(3)
        x98 = P2(3)*w2(0)
        x99 = x97 - x98
        x100 = 2*co(2)*(P2(0)*x94 - P2(2)*x99 + P2(3)*x96)
        x101 = P1(1)*w2(0)
        x102 = P1(2)*w1(3)
        x103 = P1(3)*w1(2)
        x104 = x102 - x103
        x105 = P2(0)*x104
        x106 = P1(0)*w1(2)
        x107 = x106 - x55
        x108 = P2(3)*x107
        x109 = P1(0)*w1(3)
        x110 = x109 - x57
        x111 = P2(2)*x110
        x112 = 2*co(2)*(x105 + x108 - x111)
        x113 = P2(2)*w1(3)
        x114 = P2(3)*w1(2)
        x115 = x113 - x114
        x116 = P2(0)*x115
        x117 = P2(0)*w1(2) - x60
        x118 = P2(3)*x117
        x119 = P2(3)*w1(0)
        x120 = P2(0)*w1(3) - x119
        x121 = P2(2)*x120
        x122 = 2*co(2)*(x116 + x118 - x121)
        x123 = P1(2)*P2(3)
        x124 = P1(3)*P2(2)
        x125 = x123 - x124
        x126 = 2*P1(1)*co(2)*x2
        x127 = P1(2)*P2(0)
        x128 = P1(1)*w2(3)
        x129 = P1(3)*w2(1)
        x130 = x128 - x129
        x131 = 2*P1(2)*co(3)*x47
        x132 = P2(3)*w1(1)
        x133 = P2(1)*w1(3) - x132
        x134 = 2*P1(2)*co(3)*x37
        x135 = P2(1)*w2(1)
        x136 = P2(0)*w2(0)
        x137 = P2(2)*w2(2) + x135 - x136 + x61
        x138 = 2*P1(2)*co(3)*x137
        x139 = P1(2)*w1(2)
        x140 = x139 - x23 + x25 + x29
        x141 = 2*P1(2)*co(3)*x140
        x142 = 2*co(3)*(-x32 + x39 + x41 + x43)
        x143 = P1(1)*P2(1)
        x144 = P1(2)*P2(2)
        x145 = P1(3)*P2(3)
        x146 = P1(0)*P2(0)
        x147 = 2*co(3)*(x143 + x144 + x145 - x146)
        x148 = P1(1)*w2(2)
        x149 = P1(2)*w2(1)
        x150 = x148 - x149
        x151 = P1(0)*w2(1)
        x152 = -x101 + x151
        x153 = 2*co(2)*(P2(0)*x150 - P2(1)*x89 + P2(2)*x152)
        x154 = P2(1)*w2(2) - P2(2)*w2(1)
        x155 = P2(1)*w2(0)
        x156 = P2(0)*w2(1) - x155
        x157 = 2*co(2)*(P2(0)*x154 - P2(1)*x96 + P2(2)*x156)
        x158 = P1(1)*w1(2)
        x159 = P1(2)*w1(1)
        x160 = x158 - x159
        x161 = P2(0)*x160
        x162 = P1(0)*w1(1)
        x163 = x162 - x84
        x164 = P2(2)*x163
        x165 = P2(1)*x107
        x166 = 2*co(2)*(x161 + x164 - x165)
        x167 = P2(1)*w1(2)
        x168 = P2(2)*w1(1)
        x169 = x167 - x168
        x170 = P2(0)*x169
        x171 = P2(0)*w1(1)
        x172 = P2(1)*w1(0)
        x173 = x171 - x172
        x174 = P2(2)*x173
        x175 = P2(1)*x117
        x176 = 2*co(2)*(x170 + x174 - x175)
        x177 = P1(1)*P2(2)
        x178 = P1(2)*P2(1)
        x179 = x177 - x178
        x180 = 2*P1(3)*co(2)*x2
        x181 = P2(1)*x104
        x182 = 2*co(3)*x37
        x183 = P2(1)*x115
        x184 = P2(3)*x160
        x185 = P2(3)*x169
        x186 = P1(0)*P2(1)
        x187 = P1(0)*x6
        x188 = w1(0)*w2(2) - w1(2)*w2(0)
        x189 = P1(3)*x188
        x190 = P1(2)*x78
        x191 = x187 + x189 - x190
        x192 = 2*co(3)*x191
        x193 = P2(0)*x6 - P2(2)*x78 + P2(3)*x188
        x194 = 2*co(3)*x193
        x195 = P1(0)*P2(3)
        x196 = P1(0)*x11
        x197 = P1(2)*x75
        x198 = P1(1)*x188
        x199 = x196 + x197 - x198
        x200 = 2*co(3)*x199
        x201 = P2(0)*x11 - P2(1)*x188 + P2(2)*x75
        x202 = 2*co(3)*x201
        x203 = 2*co(2)*(P2(1)*x87 - P2(2)*x130 + P2(3)*x150)
        x204 = 2*co(2)*(P2(1)*x94 - P2(2)*x71 + P2(3)*x154)
        x205 = P1(1)*w1(3)
        x206 = P1(3)*w1(1)
        x207 = x205 - x206
        x208 = P2(2)*x207
        x209 = 2*co(2)*(x181 + x184 - x208)
        x210 = P2(2)*x133
        x211 = 2*co(2)*(x183 + x185 - x210)
        x212 = P1(1)*P2(0)
        x213 = 2*co(3)*x67
        x214 = 2*P1(1)*co(3)*x47
        x215 = P1(1)*x115
        x216 = 2*co(3)*x137
        x217 = 2*co(3)*x140
        x218 = P1(1)*x94
        x219 = P2(0)*x130 - P2(1)*x92 + P2(3)*x152
        x220 = 2*co(2)*x219
        x221 = P2(0)*x71 - P2(1)*x99 + P2(3)*x156
        x222 = 2*co(2)*x221
        x223 = P2(0)*x207
        x224 = P2(3)*x163
        x225 = P2(1)*x110
        x226 = 2*co(2)*(x223 + x224 - x225)
        x227 = P2(0)*x133
        x228 = P2(3)*x173
        x229 = P2(1)*x120
        x230 = 2*co(2)*(x227 + x228 - x229)
        x231 = P1(1)*P2(3)
        x232 = P1(3)*P2(1)
        x233 = x231 - x232
        x234 = 2*P1(2)*co(2)*x2
        x235 = P1(3)*P2(0)
        x236 = 2*P1(3)*co(3)*x47
        x237 = 2*P1(3)*co(3)*x137
        x238 = 2*P1(3)*co(3)*x140
        x239 = 2*co(4)*w1(1)
        x240 = 2*P2(2)*w1(2)
        x241 = 2*co(4)*w1(3)
        x242 = 4*P1(1)*P2(1)*co(3)
        x243 = 4*co(3)*x47
        x244 = 4*co(3)*x14
        x245 = 4*P1(3)*co(3)*x47
        x246 = co(1)*w1(0)*x137
        x247 = P1(0)*P2(1)*co(0)*w1(1)
        x248 = co(0)*x37
        x249 = P1(0)*P2(2)*w1(2)
        x250 = co(0)*x137
        x251 = P2(3)*co(0)*x37
        x252 = P2(3)*co(0)*x137
        x253 = P1(1)*co(1)*x140
        x254 = co(1)*w2(0)*x140
        x255 = P2(3)*co(1)*x2
        x256 = P1(0)*co(1)*x2
        x257 = co(0)*w1(0)*x137
        x258 = P1(0)*P2(0)*co(1)*x140
        x259 = P1(1)*co(0)*x37
        x260 = w1(2)*x37
        x261 = co(0)*w1(3)*x37
        x262 = P2(1)*co(0)*x37
        x263 = P2(0)*co(0)*x37
        x264 = co(4)*w1(1)
        x265 = P1(0)*co(5)*w2(0)
        x266 = co(1)*x2*x32
        x267 = co(4)*w2(1)
        x268 = P2(1)*co(1)*x2
        x269 = co(1)*w1(1)
        x270 = P1(1)*x2
        x271 = P1(1)*co(5)*w2(1)
        x272 = P1(2)*w1(1)*w2(2)
        x273 = co(4)*w1(1)*w2(3)
        x274 = P1(3)*co(5)
        x275 = co(4)*w1(1)*w2(2)
        x276 = co(0)*w1(1)
        x277 = x32*x37
        x278 = 4*co(3)*x193
        x279 = 4*co(3)*x47*x99
        x280 = 2*co(3)*x14
        x281 = 2*P1(0)*co(2)*x2
        x282 = 2*co(3)*x120*x137
        x283 = -x127 + x73
        x284 = 2*P1(0)*co(3)*x47
        x285 = 2*P1(0)*co(3)*x37
        x286 = 2*P1(0)*co(3)*x137
        x287 = 2*P1(0)*co(3)*x140
        x288 = P1(2)*x2
        x289 = 2*co(2)*(x195 - x235)
        x290 = 2*co(3)*x117*x37
        x291 = 4*P1(0)*co(3)*x47
        x292 = 4*co(3)*x47*x96
        x293 = P1(0)*P2(0)*co(1)*x2
        x294 = co(1)*w1(1)*x137
        x295 = P1(1)*P2(1)*x137
        x296 = co(1)*x140
        x297 = P1(1)*P2(2)*w1(2)
        x298 = P1(1)*co(1)*x2
        x299 = co(0)*w1(0)*x37
        x300 = P1(2)*co(0)*x37
        x301 = P2(2)*co(0)*x37
        x302 = P2(2)*co(1)*x2
        x303 = w1(2)*x37*x41
        x304 = co(1)*w2(2)*x47
        x305 = P1(1)*w1(2)*w2(1)
        x306 = co(1)*x2*x39
        x307 = P1(3)*w1(2)*w2(3)
        x308 = P1(0)*x71
        x309 = 4*co(3)*x82
        x310 = P1(3)*x173
        x311 = 2*co(4)*w1(0)
        x312 = 2*P1(1)*co(3)*x140
        x313 = 2*P1(2)*co(2)*w1(2)
        x314 = x186 - x212
        x315 = P2(3)*co(4)
        x316 = co(1)*x137
        x317 = co(1)*w2(2)*x140
        x318 = P1(2)*P2(1)*w1(1)
        x319 = P1(2)*P2(2)*w1(2)
        x320 = P2(0)*co(1)*x140
        x321 = P1(3)*co(1)*x2
        x322 = P1(3)*co(0)*x37
        x323 = co(1)*w1(3)
        x324 = co(1)*w2(3)*x47
        x325 = co(4)*w1(3)
        x326 = P1(2)*w1(3)*w2(2)
        x327 = 4*co(3)*x201
        x328 = 2*P1(3)*P2(2)*co(3)
        x329 = co(1)*w2(3)*x140
        wout(0) = -P1(0)*P2(0)*x14*x66 - P1(0)*P2(0)*x67*x68 + P1(0)*x3 - P1(1 &
                  )*co(5)*x54 - P1(1)*x53 - P1(2)*P2(0)*co(0)*x260 + P1(3)*x169&
                  *x182 - P2(0)*x13 + P2(0)*x31 - P2(1)*x53 + co(0)*x38 + co(1 &
                  )*w1(0)*x40 - co(1)*x38 - co(5)*w2(2)*x55 - co(5)*w2(3)*x57  &
                   + co(6)*x10 - co(6)*x12 - co(6)*x7 - co(7)*x10 + co(7)*x12  &
                   + co(7)*x7 + w1(0)*x42 + w1(0)*x44 - w2(0)*x258 + w2(0)*x48 &
                   - w2(0)*x63 - w2(0)*x64 - w2(0)*x65 - x1*x59 - x10*x142 -   &
                  x10*x147 - x100*x84 - x101*x112 - x101*x122 + x109*x251 +    &
                  x109*x252 + x12*x142 + x12*x147 - x125*x126 - x127*x81 - x127&
                  *x83 - x130*x131 - x133*x134 - x133*x138 + x137*x247 - x14*  &
                  x16 + x14*x18 + x14*x20 + x14*x22 + x14*x242 - x141*x71 +    &
                  x142*x7 + x143*x213 - x143*x246 - x143*x256 + x143*x30 + x144&
                  *x213 + x144*x244 - x144*x246 + x144*x254 - x144*x256 + x144*&
                  x30 + x145*x213 + x145*x244 - x145*x246 + x145*x254 - x145*  &
                  x256 + x146*x246 - x146*x257 + x147*x7 + x150*x236 - x153*x57&
                   + x154*x238 + x154*x245 + x155*x239 + x155*x253 - x157*x57  &
                   - x166*x91 + x169*x237 + x17*x30 - x171*x259 - x171*x262 -  &
                  x176*x91 - x179*x180 - x181*x182 - x182*x183 - x182*x184 -   &
                  x182*x185 + x182*x208 + x182*x210 + x182*x215 + x186*x192 +  &
                  x186*x194 + x192*x212 + x194*x212 + x195*x200 + x195*x202 +  &
                  x200*x235 + x202*x235 + x203*x23 + x204*x23 + x209*x36 + x21*&
                  x30 + x211*x36 + x214*x87 + x215*x216 + x217*x218 + x218*x243&
                   + x220*x55 + x222*x55 + x226*x27 + x23*x24 + x230*x27 + x233&
                  *x234 + x235*x255 - x235*x261 + x240*x26 + x241*x98 + x247*  &
                  x37 + x248*x249 + x249*x250 + x25*x26 + x26*x29 - x263*x45 - &
                  x263*x46 + x27*x28 - x49*x50 - x49*x51 - x49*x52 - x55*x56 - &
                  x56*x60 - x57*x58 - x61*x62 - x71*x72 - x73*x81 - x73*x83 -  &
                  x84*x93
        wout(1) = P1(1)*P2(1)*w2(1)*x296 + P1(1)*P2(1)*x191*x68 + P1(1)*P2(1)* &
                  x193*x66 + P1(1)*x266 + P1(1)*x293 + P1(1)*x3 + P1(2)*P2(2)* &
                  w2(1)*x296 - P1(2)*x279 - P1(2)*x282 + P1(3)*P2(3)*w2(1)*x296&
                   - P1(3)*x273 + P1(3)*x290 + P1(3)*x292 - 2*P2(0)*x53 - P2(1 &
                  )*x13 + P2(1)*x31 - P2(2)*x275 - P2(3)*x273 - co(4)*x272 - co&
                  (5)*x272 - co(6)*x187 - co(6)*x189 + co(6)*x190 + co(7)*x187 &
                   + co(7)*x189 - co(7)*x190 + w1(1)*x265 - w1(1)*x271 + w1(1)*&
                  x42 + w1(1)*x44 - w2(1)*x258 + w2(1)*x48 - w2(1)*x63 - w2(1)*&
                  x64 - w2(1)*x65 - x100*x25 - x105*x182 - x108*x182 + x111*   &
                  x182 - x112*x33 + x115*x285 + x115*x286 - x116*x182 + x117*  &
                  x237 - x118*x182 - x120*x134 + x121*x182 - x122*x33 - x125*  &
                  x281 - x129*x166 - x129*x176 - x131*x92 + x135*x264 + x139*  &
                  x267 - x141*x99 + x142*x187 + x142*x189 - x142*x190 + x144*  &
                  x192 + x144*x268 + x144*x278 - x144*x294 - x144*x298 + x145* &
                  x192 + x145*x268 + x145*x278 - x145*x294 - x145*x298 - x146* &
                  x192 - x146*x268 - x146*x278 + x146*x294 + x147*x187 + x147* &
                  x189 - x147*x190 + x149*x226 + x149*x230 - x15*x268 + x151*  &
                  x209 + x151*x211 - x153*x206 - x157*x206 + x159*x220 + x159* &
                  x222 - x16*x193 + x162*x203 + x162*x204 - x167*x300 - x167*  &
                  x301 + x171*x26 + x172*x263 - x177*x81 - x177*x83 - x178*x81 &
                   - x178*x83 + x18*x193 - x180*x283 - x186*x213 - x186*x280 + &
                  x193*x20 + x193*x22 + x200*x231 + x200*x232 + x202*x231 +    &
                  x202*x232 + x205*x251 + x205*x252 + x21*x268 - x212*x213 -   &
                  x212*x257 - x212*x280 - x212*x299 + x23*x262 - x23*x267 +    &
                  x236*x89 + x238*x96 + x240*x267 + x241*x70 + x248*x297 - x25*&
                  x93 + x250*x297 - x262*x29 - x262*x46 + x264*x36 + x267*x29  &
                   - x269*x277 - x269*x295 + x269*x40 - x270*x51 - x270*x52 -  &
                  x274*x8 + x276*x295 - x276*x40 + x284*x87 + x287*x94 + x288* &
                  x289 + x291*x94
        wout(2) = P1(0)*P2(0)*w1(2)*x316 - P1(1)*P1(2)*P2(1)*co(1)*x2 - P1(1)* &
                  P2(1)*w1(2)*x316 + P1(1)*x120*x182 + P1(1)*x279 + P1(1)*x282 &
                   - P1(2)*P2(0)*w1(0)*x250 - P1(2)*P2(2)*x66*x82 - P1(2)*P2(2 &
                  )*x68*x80 + P1(2)*x266 + P1(2)*x293 + P1(2)*x3 - P1(2)*x306  &
                   - P1(3)*P2(3)*w1(2)*x316 + P1(3)*P2(3)*w2(2)*x296 + P1(3)*co&
                  (4)*x5 + 2*P2(1)*x275 - P2(2)*x13 - co(0)*x303 - co(1)*x260* &
                  x32 + co(1)*x303 - co(4)*x305 - co(4)*x307 - co(5)*w1(2)*x34 &
                   - co(5)*x305 - co(5)*x307 + co(6)*x74 + co(6)*x76 - co(6)*  &
                  x79 - co(7)*x74 - co(7)*x76 + co(7)*x79 + w1(2)*x265 + 2*w1(3&
                  )*w2(2)*x315 - w2(2)*x64 - x100*x158 + x102*x251 + x102*x252 &
                   - x103*x153 - x103*x157 + x106*x203 + x106*x204 - x112*x148 &
                   - x113*x251 - x113*x322 - x114*x58 - x122*x148 + x123*x200  &
                   + x123*x202 - x123*x321 + x124*x200 + x124*x202 - x127*x213 &
                   - x127*x280 - x130*x284 - x133*x285 - x133*x286 + x136*x28  &
                   - x142*x74 - x142*x76 + x142*x79 + x143*x302 + x143*x317 -  &
                  x143*x81 + x144*x317 + x145*x302 - x145*x309 - x145*x81 -    &
                  x146*x302 + x146*x309 + x146*x81 - x147*x74 - x147*x76 + x147&
                  *x79 - x15*x302 + x15*x304 - x152*x236 - x156*x238 - x156*   &
                  x245 - x158*x93 + x16*x82 - x166*x86 - x167*x267 - x168*x262 &
                   + x17*x302 - x17*x304 - x176*x86 + x177*x192 + x177*x194 +  &
                  x178*x192 + x178*x194 - x18*x82 + x180*x314 + x182*x223 +    &
                  x182*x224 - x182*x225 + x182*x227 + x182*x228 - x182*x229 -  &
                  x182*x310 - x20*x82 + x209*x88 + x21*x302 - x21*x304 + x211* &
                  x88 - x213*x73 + x214*x92 - x216*x310 - x217*x308 + x219*x313&
                   - x22*x82 + x221*x313 + x226*x34 + x23*x301 + x230*x34 +    &
                  x233*x281 - x242*x82 - x243*x308 + x248*x318 - x25*x301 + x25&
                  *x56 + x250*x318 + x250*x319 + x260*x50 + x260*x52 - x263*x55&
                   + x263*x60 - x270*x289 + x28*x36 - x280*x73 - x288*x52 -    &
                  x311*x95 + x312*x99 - x316*x319 - x320*x88 + x45*x56 - x62*  &
                  x88
        wout(3) = P1(0)*P2(0)*w1(3)*x316 - P1(1)*x117*x216 + P1(1)*x273 - P1(1 &
                  )*x290 - P1(1)*x292 - P1(2)*P2(2)*w1(3)*x316 + P1(2)*co(4)*x4&
                   + P1(3)*P2(1)*w1(1)*x250 + P1(3)*P2(2)*w1(2)*x250 - P1(3)*P2&
                  (3)*w1(3)*x316 + P1(3)*P2(3)*x199*x68 + P1(3)*P2(3)*x201*x66 &
                   - P1(3)*x2*x51 + P1(3)*x266 + P1(3)*x3 - P1(3)*x306 - P2(3)*&
                  x13 + P2(3)*x31 - co(4)*x326 - co(5)*x326 - co(6)*x196 - co(6&
                  )*x197 + co(6)*x198 + co(7)*x196 + co(7)*x197 - co(7)*x198 - &
                  w1(3)*x271 + w1(3)*x44 - w2(3)*x64 - x0*x274 + x0*x315 - x100&
                  *x205 + x102*x220 + x102*x222 + x109*x203 + x109*x204 + x109*&
                  x24 + x109*x26 - x112*x128 - x113*x56 - x114*x300 - x114*x301&
                   + x119*x263 - x122*x128 - x123*x81 - x123*x83 + x126*x283 + &
                  x131*x152 - x132*x259 - x132*x262 + x134*x173 - x135*x325 +  &
                  x138*x173 + x141*x156 + x142*x196 + x142*x197 - x142*x198 +  &
                  x143*x200 + x143*x255 - x143*x321 + x143*x327 + x144*x200 +  &
                  x144*x255 - x144*x321 + x144*x327 + x144*x329 + x145*x329 -  &
                  x146*x200 - x146*x255 - x146*x327 + x147*x196 + x147*x197 -  &
                  x147*x198 - x15*x255 + x15*x324 + x150*x284 - x153*x29 + x154&
                  *x287 + x154*x291 + x156*x72 - x157*x29 - x16*x201 - x161*   &
                  x182 - x164*x182 + x165*x182 - x166*x35 + x169*x285 + x169*  &
                  x286 + x17*x255 - x17*x324 - x170*x182 - x174*x182 + x175*   &
                  x182 - x176*x35 - x179*x281 + x18*x201 + x192*x231 + x192*   &
                  x232 + x194*x231 + x194*x232 - x195*x213 - x195*x280 + x20*  &
                  x201 + x201*x22 - x205*x93 + x206*x262 + x209*x90 - x21*x324 &
                   + x211*x90 - x213*x235 - x214*x89 + x226*x85 + x23*x251 +   &
                  x230*x85 - x234*x314 + x235*x256 - x235*x257 - x235*x280 -   &
                  x235*x299 + x239*x69 + x240*x58 + x252*x29 + x253*x69 - x261*&
                  x43 - x277*x323 - x295*x323 - x311*x97 - x312*x96 - x320*x90 &
                   + x322*x45 + x323*x37*x41 + x323*x40 - x325*x33 - x328*x80  &
                   - x328*x82 + x59*x77 - x62*x90
      case(VVV8)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) - Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x2 = P1(0)*co(1)*x1
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = w1(2)*w2(3) - w1(3)*w2(2)
        x6 = w1(0)*w2(2) - w1(2)*w2(0)
        x7 = w1(0)*w2(3) - w1(3)*w2(0)
        x8 = P1(0)*x5 - P1(2)*x7 + P1(3)*x6
        x9 = P1(1)*co(3)*x8
        x10 = P1(1)*co(3)*(P2(0)*x5 - P2(2)*x7 + P2(3)*x6)
        x11 = P2(1)*w1(3)
        x12 = P2(3)*w1(1)
        x13 = x11 - x12
        x14 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x15 = P1(2)*co(3)*x14
        x16 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x17 = P1(2)*co(3)*x16
        x18 = w1(1)*w2(2) - w1(2)*w2(1)
        x19 = w1(0)*w2(1) - w1(1)*w2(0)
        x20 = P1(0)*x18 - P1(1)*x6 + P1(2)*x19
        x21 = P1(3)*co(3)*x20
        x22 = P1(3)*co(3)*(P2(0)*x18 - P2(1)*x6 + P2(2)*x19)
        x23 = P1(1)**2
        x24 = P2(0)*co(2)*x1
        x25 = P1(2)**2
        x26 = P1(3)**2
        x27 = co(0)*x14
        x28 = P2(0)**2
        x29 = w1(0)*x28
        x30 = co(1)*x0*x14
        x31 = co(1)*x14*x3
        x32 = co(1)*x14*x4
        x33 = P2(1)*w1(1)
        x34 = P2(2)*w1(2)
        x35 = P2(3)*w1(3)
        x36 = P2(0)*w1(0)
        x37 = x33 + x34 + x35 - x36
        x38 = co(1)*x23*x37
        x39 = co(1)*x25*x37
        x40 = co(1)*x26*x37
        x41 = w1(1)*w2(3) - w1(3)*w2(1)
        x42 = P1(1)*x5 - P1(2)*x41 + P1(3)*x18
        x43 = P1(0)*co(3)*x42
        x44 = P2(1)*x5 - P2(2)*x41 + P2(3)*x18
        x45 = P1(0)*co(3)*x44
        x46 = co(1)*x1
        x47 = P1(0)*x28
        x48 = co(2)*x1
        x49 = P2(2)*w1(3)
        x50 = P2(3)*w1(2)
        x51 = x49 - x50
        x52 = P1(1)*co(3)*x51
        x53 = P1(0)*x41 - P1(1)*x7 + P1(3)*x19
        x54 = P1(2)*co(3)*x53
        x55 = P2(0)*x41 - P2(1)*x7 + P2(3)*x19
        x56 = P1(2)*co(3)*x55
        x57 = P2(1)*w1(2)
        x58 = P2(2)*w1(1)
        x59 = x57 - x58
        x60 = P1(3)*co(3)*x59
        x61 = P1(0)**2
        x62 = co(1)*x14
        x63 = co(1)*x37*x61
        x64 = P1(1)*P2(1)*co(1)*x1
        x65 = P1(2)*P2(2)*co(1)*x1
        x66 = P1(3)*co(1)*x1
        x67 = P1(0)*P2(0)*w1(0)
        x68 = co(0)*x16
        x69 = P1(1)*P2(1)
        x70 = P2(1)*w1(0)
        x71 = P1(1)*co(1)*x14
        x72 = P1(1)*w1(1)
        x73 = P1(2)*w1(2)
        x74 = P1(3)*w1(3)
        x75 = P1(0)*w1(0)
        x76 = x72 + x73 + x74 - x75
        x77 = co(1)*w2(0)*x76
        x78 = P1(1)*co(2)*x14
        x79 = P1(1)*co(2)*x16
        x80 = P1(2)*P2(2)
        x81 = P1(2)*P2(2)*w1(0)
        x82 = P2(2)*w1(0)
        x83 = P1(2)*co(2)*x14
        x84 = co(2)*x16
        x85 = P1(3)*P2(3)
        x86 = P2(3)*w1(0)
        x87 = P1(3)*co(1)*x14
        x88 = P1(3)*co(2)*x14
        x89 = P1(3)*co(2)*x16
        x90 = co(1)*x76
        x91 = P1(0)*P2(0)*w2(0)
        x92 = co(2)*x14
        x93 = P1(0)*co(0)*x14
        x94 = P2(1)*co(0)*w1(1)*x16
        x95 = P2(2)*co(0)*w1(2)*x16
        x96 = P2(3)*co(0)*w1(3)*x14
        x97 = P2(0)*co(0)*x14
        x98 = P2(0)*w1(1)
        x99 = P2(1)*co(0)*x14
        x100 = 2*co(1)*x37
        x101 = 2*co(0)*x14
        x102 = 2*P1(1)*P2(1)
        x103 = co(1)*w2(0)*x37
        x104 = 2*P1(2)*P2(2)
        x105 = 2*P1(3)*P2(3)*co(1)*x37
        x106 = P1(1)*co(1)*x1
        x107 = P2(0)*w1(3)
        x108 = x107 - x86
        x109 = P2(1)*co(2)*x1
        x110 = w1(1)*x0
        x111 = P1(0)*co(3)*x51
        x112 = P2(0)*w1(2) - x82
        x113 = P1(3)*co(3)*x112
        x114 = co(1)*x14*x28
        x115 = P1(1)*co(0)*x14
        x116 = P1(1)*co(0)*x16
        x117 = P1(1)*P2(1)*w1(1)
        x118 = P1(1)*P2(1)*w2(1)
        x119 = P1(2)*P2(2)*co(2)*x1
        x120 = P1(2)*co(1)*x14
        x121 = co(1)*w2(1)*x76
        x122 = P1(2)*co(2)*x16
        x123 = P1(3)*P2(3)*w1(1)
        x124 = P1(0)*P2(0)
        x125 = P1(0)*P2(0)*co(2)*x1
        x126 = P1(0)*co(1)*x14
        x127 = P1(0)*P2(0)*co(1)*x76
        x128 = P1(0)*co(2)*x14
        x129 = P1(0)*co(2)*x16
        x130 = P1(2)*co(0)*x14
        x131 = P2(2)*co(0)*x14
        x132 = 2*P1(0)*P2(0)
        x133 = co(1)*w2(1)*x37
        x134 = P1(0)*co(3)*x13
        x135 = P2(2)*co(3)
        x136 = P1(2)*co(1)*x1
        x137 = -x70 + x98
        x138 = P1(3)*co(3)*x137
        x139 = P2(2)*co(2)*x1
        x140 = co(1)*w2(2)*x37
        x141 = P1(1)*co(3)*x108
        x142 = co(1)*w2(2)*x76
        x143 = P1(2)*co(0)*x16
        x144 = P1(2)*P2(2)*w2(2)
        x145 = P1(0)*P2(0)*w1(2)
        x146 = P1(3)*co(0)*x14
        x147 = P2(3)*co(0)*x14
        x148 = P1(1)*co(3)*x112
        x149 = P2(3)*x26
        x150 = P2(3)*co(2)*x1
        x151 = co(1)*w1(3)*x14
        x152 = co(1)*w2(3)*x37
        x153 = P1(0)*co(3)*x59
        x154 = co(1)*w2(3)*x76
        x155 = P1(3)*P2(3)*w1(3)
        x156 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*P2(3)*w1(3)*x68 + P1(0)*P2(3)*x66 + P1(0)*x64 + P1(0)*&
                  x65 - P1(0)*x94 - P1(0)*x95 - P1(0)*x96 + P2(0)*x10 + P2(0)* &
                  x21 + P2(0)*x22 - P2(0)*x43 - P2(0)*x45 - P2(0)*x46*x61 - P2(&
                  0)*x54 - P2(0)*x56 + P2(0)*x9 - P2(0)*x96 + w1(0)*x30 + w1(0 &
                  )*x31 + w1(0)*x32 + w2(0)*x105 + w2(0)*x38 + w2(0)*x39 + w2(0&
                  )*x40 - w2(0)*x63 + x0*x2 - x100*x91 + x101*x67 + x102*x103  &
                   + x103*x104 + x13*x15 + x13*x17 - x14*x52 - x14*x60 - x16*  &
                  x52 - x16*x60 + x2*x3 + x2*x4 + x23*x24 + x24*x25 + x24*x26  &
                   - x24*x61 + x24*x69 + x24*x80 + x24*x85 + x27*x29 - x29*x62 &
                   - x33*x93 - x34*x93 - x34*x97 - x46*x47 - x47*x48 - x62*x67 &
                   + x62*x81 + x67*x68 - x67*x84 - x67*x92 + x69*x77 + x70*x71 &
                   + x70*x78 + x70*x79 - x72*x97 - x73*x97 - x74*x97 + x77*x80 &
                   + x77*x85 + x81*x84 + x82*x83 + x86*x87 + x86*x88 + x86*x89 &
                   - x90*x91 - x98*x99
        wout(1) = P1(1)*x0*x48 - P1(1)*x96 + P2(1)*x10 + P2(1)*x119 - P2(1)*   &
                  x125 + P2(1)*x21 + P2(1)*x22 + P2(1)*x23*x46 - P2(1)*x43 - P2&
                  (1)*x45 - P2(1)*x54 - P2(1)*x56 + P2(1)*x9 - w1(1)*x114 + w1(&
                  1)*x31 + w1(1)*x32 + w2(1)*x105 - w2(1)*x127 + w2(1)*x38 + w2&
                  (1)*x39 + w2(1)*x40 - w2(1)*x63 + x0*x106 + x100*x118 - x101*&
                  x117 + x104*x133 - x106*x124 - x106*x28 + x106*x3 + x106*x4  &
                   + x106*x80 + x106*x85 + x108*x15 + x108*x17 + x109*x23 +    &
                  x109*x25 + x109*x26 - x109*x61 + x109*x85 - x110*x27 + x110* &
                  x62 - x111*x14 - x111*x16 - x113*x14 - x113*x16 - x115*x34 + &
                  x115*x36 - x116*x34 - x116*x35 + x116*x36 + x117*x62 - x117* &
                  x68 + x117*x84 + x117*x92 + x118*x90 + x120*x58 + x121*x80 + &
                  x121*x85 + x122*x58 + x123*x62 + x123*x84 + x123*x92 - x126* &
                  x98 - x128*x98 - x129*x98 - x130*x57 - x131*x57 - x132*x133  &
                   - x35*x99 + x58*x83 + x70*x97 - x74*x99 + x75*x99
        wout(2) = -P1(0)*x135*x42 - P1(0)*x135*x44 + P1(1)*x135*x8 - P1(2)*x135&
                  *x53 - P1(2)*x135*x55 + P1(2)*x3*x48 + P1(2)*x64 - P1(2)*x94 &
                   - P1(2)*x95 + P1(3)*x135*x20 - 2*P2(2)*w1(2)*x130 + P2(2)*  &
                  x10 - P2(2)*x125 + P2(2)*x22 + P2(2)*x25*x46 + 2*co(1)*w2(2)*&
                  x37*x85 - w1(2)*x114 - w1(2)*x27*x3 + w1(2)*x30 + w1(2)*x31  &
                   + w1(2)*x32 - w2(2)*x127 + w2(2)*x39 + x0*x136 + x100*x144  &
                   + x102*x140 + x120*x34 + x122*x34 - x124*x136 - x130*x33 -  &
                  x130*x35 + x130*x36 - x131*x72 + x131*x75 - x132*x140 + x134*&
                  x14 + x134*x16 - x136*x28 + x136*x3 + x136*x4 + x136*x85 +   &
                  x138*x14 + x138*x16 + x139*x23 + x139*x25 + x139*x26 - x139* &
                  x61 + x139*x69 + x139*x85 - x14*x141 + x140*x23 + x140*x26 - &
                  x140*x61 - x141*x16 + x142*x69 + x142*x85 - x143*x35 + x143* &
                  x36 + x144*x90 - x145*x62 - x145*x84 - x145*x92 - x146*x49 - &
                  x147*x49 + x34*x83 + x50*x87 + x50*x88 + x50*x89 + x57*x71 + &
                  x57*x78 + x57*x79 - x58*x99 + x82*x97
        wout(3) = P1(1)*P2(3)*x109 + P1(3)*P2(0)*w1(0)*x68 + P1(3)*x4*x48 + P1(&
                  3)*x64 + P1(3)*x65 - P1(3)*x94 - P1(3)*x95 + P2(3)*x10 + P2(3&
                  )*x119 - P2(3)*x125 + P2(3)*x21 + P2(3)*x22 - P2(3)*x43 - P2(&
                  3)*x45 - P2(3)*x54 - P2(3)*x56 + P2(3)*x9 - w1(3)*x27*x4 + w1&
                  (3)*x32 + w2(3)*x39 + x0*x151 + x0*x66 + x100*x156 - x101*   &
                  x155 + x102*x152 + x104*x152 - x107*x126 - x107*x128 - x107* &
                  x129 + x11*x71 + x11*x78 + x11*x79 - x12*x99 + x120*x49 +    &
                  x122*x49 - x124*x154 - x124*x66 - x130*x50 - x131*x50 - x132*&
                  x152 - x137*x15 - x137*x17 + x14*x148 - x14*x153 - x146*x33  &
                   - x146*x34 + x146*x36 - x147*x72 + x147*x75 + x148*x16 +    &
                  x149*x46 + x149*x48 + x150*x23 + x150*x25 - x150*x61 - x151* &
                  x28 + x151*x3 + x152*x23 + x152*x26 - x152*x61 - x153*x16 +  &
                  x154*x69 + x154*x80 + x155*x62 - x155*x68 + x155*x84 + x155* &
                  x92 + x156*x90 - x28*x66 + x3*x66 + x4*x66 + x49*x83 + x86*  &
                  x97
      case(VVV9)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1
!       ,3))
!       c2*(Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - Epsilon(-1 
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3) - Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3))
!       c4*(-Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,2,3)*P(-1,
!       1)*P(-2,2)*P(1,3))
        if (last) VB_last = .true.
        x0 = P1(0)*P2(1)
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = P1(0)*x1
        x3 = w1(0)*w2(2) - w1(2)*w2(0)
        x4 = P1(3)*x3
        x5 = w1(0)*w2(3) - w1(3)*w2(0)
        x6 = P1(2)*x5
        x7 = x2 + x4 - x6
        x8 = co(4)*x7
        x9 = P2(0)*x1 - P2(2)*x5 + P2(3)*x3
        x10 = co(4)*x9
        x11 = P1(0)*P2(3)
        x12 = w1(1)*w2(2) - w1(2)*w2(1)
        x13 = P1(0)*x12
        x14 = w1(0)*w2(1) - w1(1)*w2(0)
        x15 = P1(2)*x14
        x16 = P1(1)*x3
        x17 = x13 + x15 - x16
        x18 = co(4)*x17
        x19 = P2(0)*x12 - P2(1)*x3 + P2(2)*x14
        x20 = co(4)*x19
        x21 = P2(1)**2
        x22 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x23 = P1(0)*co(1)*x22
        x24 = P2(2)**2
        x25 = P2(3)**2
        x26 = P1(0)*w2(0)
        x27 = P1(2)*w1(3)
        x28 = -P1(3)*w1(2) + x27
        x29 = P2(1)*x28
        x30 = P1(1)*w1(2) - P1(2)*w1(1)
        x31 = P2(3)*x30
        x32 = P1(1)*w1(3)
        x33 = P1(3)*w1(1)
        x34 = x32 - x33
        x35 = P2(2)*x34
        x36 = co(2)*(x29 + x31 - x35)
        x37 = P2(2)*w1(3)
        x38 = P2(3)*w1(2)
        x39 = x37 - x38
        x40 = P2(1)*x39
        x41 = P2(1)*w1(2)
        x42 = P2(2)*w1(1)
        x43 = x41 - x42
        x44 = P2(3)*x43
        x45 = P2(3)*w1(1)
        x46 = P2(1)*w1(3) - x45
        x47 = P2(2)*x46
        x48 = co(2)*(x40 + x44 - x47)
        x49 = P1(1)*P2(0)
        x50 = co(3)*x7
        x51 = co(3)*x9
        x52 = P1(1)*P2(1)
        x53 = P1(1)*x1
        x54 = P1(3)*x12
        x55 = w1(1)*w2(3) - w1(3)*w2(1)
        x56 = P1(2)*x55
        x57 = x53 + x54 - x56
        x58 = co(3)*x57
        x59 = P2(1)*x1 - P2(2)*x55 + P2(3)*x12
        x60 = co(3)*x59
        x61 = P1(2)*P2(3)
        x62 = P1(3)*P2(2)
        x63 = x61 - x62
        x64 = P1(1)*co(2)*x22
        x65 = P1(2)*P2(2)
        x66 = P1(2)*w2(0)
        x67 = P2(0)*x34
        x68 = P1(0)*w1(1) - P1(1)*w1(0)
        x69 = P2(3)*x68
        x70 = P1(0)*w1(3)
        x71 = -P1(3)*w1(0) + x70
        x72 = P2(1)*x71
        x73 = co(2)*(x67 + x69 - x72)
        x74 = P2(0)*x46
        x75 = P2(0)*w1(1)
        x76 = P2(1)*w1(0)
        x77 = x75 - x76
        x78 = P2(3)*x77
        x79 = P2(3)*w1(0)
        x80 = P2(0)*w1(3) - x79
        x81 = P2(1)*x80
        x82 = co(2)*(x74 + x78 - x81)
        x83 = P1(1)*w2(3)
        x84 = -P1(3)*w2(1) + x83
        x85 = P2(2)*w1(2)
        x86 = P2(3)*w1(3)
        x87 = -P2(0)*w1(0) + P2(1)*w1(1) + x85 + x86
        x88 = P1(2)*co(3)*x87
        x89 = P1(1)*w2(1)
        x90 = P1(2)*w2(2)
        x91 = P1(3)*w2(3)
        x92 = -x26 + x89 + x90 + x91
        x93 = P1(2)*co(3)*x92
        x94 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x95 = P1(2)*co(3)*x94
        x96 = P2(1)*w2(3) - P2(3)*w2(1)
        x97 = P2(0)**2
        x98 = co(3)*(x21 + x24 + x25 - x97)
        x99 = P1(3)*P2(3)
        x100 = P1(0)*P2(0)
        x101 = co(3)*(-x100 + x52 + x65 + x99)
        x102 = P1(2)*x96
        x103 = P1(1)*w1(1)
        x104 = P1(3)*w1(3)
        x105 = P1(0)*w1(0)
        x106 = P1(2)*w1(2) + x103 + x104 - x105
        x107 = co(4)*x87
        x108 = P1(3)*P2(0)
        x109 = co(3)*x17
        x110 = co(3)*x19
        x111 = P1(1)*P2(2)
        x112 = P1(2)*P2(1)
        x113 = x111 - x112
        x114 = P1(3)*co(2)*x22
        x115 = co(3)*x92
        x116 = co(0)*w1(0)*x92
        x117 = P1(0)*P2(0)*co(4)
        x118 = P1(0)*P2(2)
        x119 = P1(0)*x55
        x120 = P1(3)*x14
        x121 = P1(1)*x5
        x122 = x119 + x120 - x121
        x123 = co(4)*x122
        x124 = P2(0)*x55 - P2(1)*x5 + P2(3)*x14
        x125 = co(4)*x124
        x126 = P1(1)*w2(0)
        x127 = P2(0)*x28
        x128 = P1(2)*w1(0)
        x129 = P1(0)*w1(2) - x128
        x130 = P2(3)*x129
        x131 = P2(2)*x71
        x132 = co(2)*(x127 + x130 - x131)
        x133 = P2(0)*x39
        x134 = P2(2)*w1(0)
        x135 = P2(0)*w1(2) - x134
        x136 = P2(3)*x135
        x137 = P2(2)*x80
        x138 = co(2)*(x133 + x136 - x137)
        x139 = P1(2)*w2(3)
        x140 = P1(3)*w2(2)
        x141 = x139 - x140
        x142 = P1(1)*co(3)*x87
        x143 = P1(1)*x39
        x144 = co(3)*x94
        x145 = P2(2)*w2(3) - P2(3)*w2(2)
        x146 = P1(1)*co(4)*x106
        x147 = P1(1)*co(4)*x87
        x148 = P1(2)*P2(0)
        x149 = co(3)*x122
        x150 = co(3)*x124
        x151 = P1(1)*P2(3)
        x152 = P1(3)*P2(1)
        x153 = x151 - x152
        x154 = P1(2)*co(2)*x22
        x155 = P1(3)*w2(0)
        x156 = P2(0)*x30
        x157 = P2(2)*x68
        x158 = P2(1)*x129
        x159 = x156 + x157 - x158
        x160 = co(2)*x159
        x161 = P2(0)*x43
        x162 = P2(2)*x77
        x163 = P2(1)*x135
        x164 = x161 + x162 - x163
        x165 = co(2)*x164
        x166 = P1(1)*w2(2)
        x167 = P1(2)*w2(1)
        x168 = x166 - x167
        x169 = P1(3)*co(3)*x87
        x170 = P1(3)*co(3)*x92
        x171 = P1(3)*co(3)*x94
        x172 = P2(1)*w2(2) - P2(2)*w2(1)
        x173 = co(4)*x106*x172
        x174 = P1(3)*co(4)*x87
        x175 = co(1)*x22
        x176 = P1(0)*P2(0)*co(3)
        x177 = 2*P1(0)*P2(0)
        x178 = co(0)*w1(0)*x94
        x179 = P1(1)*P2(1)*co(1)*w2(0)
        x180 = P1(2)*P2(2)*co(1)*x106
        x181 = P1(2)*P2(2)*co(1)*x87
        x182 = P2(3)*co(1)*x106
        x183 = P2(3)*co(1)*x87
        x184 = P1(0)*P2(0)*co(1)*x106
        x185 = P1(0)*P2(0)*co(1)*x87
        x186 = co(0)*w1(1)*x92
        x187 = co(0)*w1(1)*x94
        x188 = P2(2)*co(0)*w1(2)*x92
        x189 = P2(2)*co(0)*w1(2)*x94
        x190 = P2(3)*co(0)*x92
        x191 = P2(3)*co(0)*x94
        x192 = P1(1)*co(0)*x92
        x193 = co(0)*w1(2)*x92
        x194 = P2(0)*co(0)*x92
        x195 = P2(1)*co(0)*x92
        x196 = P1(0)*w2(1)
        x197 = P1(0)*co(2)*x22
        x198 = co(1)*x21*x22
        x199 = co(1)*x22*x24
        x200 = co(1)*x22*x25
        x201 = P1(0)*w2(3)
        x202 = -x155 + x201
        x203 = co(3)*x80*x92
        x204 = P2(0)*w2(3) - P2(3)*w2(0)
        x205 = P1(2)*co(4)*x106
        x206 = co(4)*x204*x87
        x207 = x118 - x148
        x208 = P1(0)*co(3)*x87
        x209 = P1(0)*co(3)*x92
        x210 = P1(0)*co(3)*x94
        x211 = P1(0)*co(4)*x106
        x212 = P1(0)*co(4)*x87
        x213 = P1(1)*P2(0)*co(4)
        x214 = co(1)*x22*x97
        x215 = -x108 + x11
        x216 = P1(3)*co(2)*w2(1)
        x217 = P1(0)*w2(2)
        x218 = x217 - x66
        x219 = P2(0)*w2(2) - P2(2)*w2(0)
        x220 = P1(3)*co(4)*x106
        x221 = 2*P1(1)*P2(1)
        x222 = P1(1)*co(1)*x22
        x223 = co(1)*x106
        x224 = P1(1)*P2(1)*w2(1)
        x225 = co(1)*x87
        x226 = P1(3)*P2(3)*w2(1)
        x227 = P1(0)*P2(0)*co(1)*x22
        x228 = co(0)*x92
        x229 = P1(1)*P2(2)*w1(2)
        x230 = co(0)*x94
        x231 = P1(2)*co(0)*x92
        x232 = P2(2)*co(0)*x92
        x233 = -x126 + x196
        x234 = co(3)*x77*x94
        x235 = P2(0)*w2(1) - P2(1)*w2(0)
        x236 = P1(2)*P2(0)*co(4)
        x237 = x0 - x49
        x238 = 2*P1(2)*P2(2)
        x239 = P1(1)*P2(1)*w2(2)
        x240 = P1(3)*co(1)*x22
        x241 = P2(0)*co(1)*x106
        x242 = P2(0)*co(1)*x87
        x243 = P1(2)*P2(1)*w1(1)
        x244 = P1(1)*x135
        x245 = P1(3)*P2(0)*co(4)
        x246 = 2*P1(3)*P2(3)
        x247 = P1(1)*P2(1)*w2(3)
        wout(0) = -P1(0)**2*P2(0)*x175 - P1(0)*x188 - P1(0)*x189 - P1(3)*x173  &
                   + co(4)*x102*x106 + w2(0)*x180 + w2(0)*x181 - w2(0)*x184 -  &
                  w2(0)*x185 + x0*x10 - x0*x186 - x0*x187 + x0*x8 + x100*x178  &
                   - x101*x53 - x101*x54 + x101*x56 + x102*x107 - x104*x194 +  &
                  x106*x179 + x108*x109 + x108*x110 + x11*x18 + x11*x20 + x113*&
                  x114 - x115*x143 - x115*x29 - x115*x31 + x115*x35 - x115*x40 &
                   - x115*x44 + x115*x47 + x116*x177 + x116*x97 - x117*x57 -   &
                  x117*x59 - x118*x123 - x118*x125 - x126*x132 - x126*x138 -   &
                  x141*x142 - x142*x145 - x143*x144 - x145*x146 - x145*x147 -  &
                  x148*x149 - x148*x150 - x148*x193 - x153*x154 - x155*x160 -  &
                  x155*x165 + x155*x182 + x155*x183 - x168*x169 - x169*x172 -  &
                  x170*x43 - x171*x43 - x172*x174 - x176*(2*P1(1)*x1 - 2*P1(2)*&
                  x55 + 2*P1(3)*x12) - x177*x60 + x179*x87 - x190*x70 - x191*  &
                  x70 - x192*x75 - x194*x85 - x194*x86 - x195*x75 + x21*x23 +  &
                  x23*x24 + x23*x25 + x23*x52 + x23*x65 - x23*x97 + x23*x99 +  &
                  x26*x36 + x26*x48 + x46*x93 + x46*x95 + x49*x50 + x49*x51 +  &
                  x52*x58 + x52*x60 - x53*x98 - x54*x98 + x56*x98 + x58*x65 +  &
                  x58*x99 + x60*x65 + x60*x99 + x63*x64 + x66*x73 + x66*x82 +  &
                  x84*x88 + x88*x96
        wout(1) = P1(1)**2*P2(1)*x175 + P1(1)*x198 + P1(1)*x199 + P1(1)*x200 - &
                  P1(1)*x214 - P1(1)*x227 + P1(2)*x203 + P1(2)*x206 + w2(1)*   &
                  x180 + w2(1)*x181 - w2(1)*x184 - w2(1)*x185 - x0*x58 - x0*x60&
                   + x10*x52 - x100*x51 - x101*x2 - x101*x4 + x101*x6 - x104*  &
                  x195 + x105*x195 + x109*x152 + x110*x152 - x111*x123 - x111* &
                  x125 - x112*x149 - x112*x150 + x114*x207 - x115*x127 - x115* &
                  x130 + x115*x131 - x115*x133 - x115*x136 + x115*x137 + x116* &
                  x49 - x132*x89 - x135*x170 - x135*x171 - x138*x89 - x141*x208&
                   - x145*x208 - x145*x211 - x145*x212 + x151*x18 + x151*x20 - &
                  x154*x215 - x159*x216 - x164*x216 + x167*x73 + x167*x82 -    &
                  x169*x218 - x169*x219 - x174*x219 - x176*x7 + x178*x49 - x186&
                  *x21 - x186*x221 - x187*x52 - x190*x32 - x191*x32 + x194*x76 &
                   - x195*x86 + x196*x36 + x196*x48 + x197*x63 - x2*x98 + x202*&
                  x88 + x204*x205 + x204*x88 - x209*x39 - x210*x39 - x213*x57  &
                   - x213*x59 - x219*x220 + x221*x50 + x221*x51 + x222*x65 +   &
                  x222*x99 + x223*x224 + x223*x226 + x224*x225 + x225*x226 -   &
                  x228*x229 - x229*x230 - x231*x41 - x232*x41 - x4*x98 + x50*  &
                  x65 + x50*x99 + x51*x65 + x51*x99 + x52*x8 + x6*x98 + x80*x95
        wout(2) = P1(1)*P1(2)*P2(1)*x175 - P1(1)*x144*x80 - P1(1)*x203 - P1(1)*&
                  x206 + P1(2)**2*P2(2)*x175 + P1(2)*P2(0)*w1(0)*x230 - P1(2)* &
                  P2(2)*w1(2)*x230 + P1(2)*x198 + P1(2)*x199 + P1(2)*x200 - P1(&
                  2)*x214 - P1(2)*x227 + P1(3)*x234 + w2(2)*x180 + w2(2)*x181  &
                   + x10*x112 + x100*x150 + x101*x119 + x101*x120 - x101*x121  &
                   - x103*x232 - x104*x232 + x105*x232 + x109*x62 + x110*x62 + &
                  x111*x50 + x111*x51 + x112*x8 - x114*x237 + x115*x67 + x115* &
                  x69 - x115*x72 + x115*x74 + x115*x78 - x115*x81 - x118*x58 - &
                  x118*x60 + x119*x98 + x120*x98 - x121*x98 + x122*x176 - x123*&
                  x65 - x125*x65 + x128*x194 - x132*x166 + x134*x194 - x138*   &
                  x166 - x140*x160 - x140*x165 + x140*x182 + x140*x183 - x142* &
                  x202 - x142*x204 - x146*x204 - x149*x238 - x149*x52 - x149*  &
                  x99 - x150*x238 - x150*x52 - x150*x99 - x153*x197 + x169*x233&
                   + x169*x235 + x170*x77 + x174*x235 + x18*x61 - x190*x27 -   &
                  x190*x37 - x191*x27 - x193*x238 - x193*x24 - x195*x42 + x20* &
                  x61 + x208*x84 + x208*x96 + x209*x46 + x210*x46 + x211*x96 + &
                  x212*x96 + x215*x64 - x217*x241 - x217*x242 + x217*x36 + x217&
                  *x48 + x220*x235 + x223*x239 + x225*x239 - x228*x243 - x230* &
                  x243 - x236*x57 - x236*x59 + x240*x61 + x73*x90 + x82*x90
        wout(3) = -P1(0)*x173 - P1(2)*x107*x235 - P1(2)*x234 + P1(3)**2*P2(3)* &
                  x175 - P1(3)*P2(1)*w1(1)*x230 - 2*P1(3)*w1(3)*x190 - P1(3)*  &
                  x188 - P1(3)*x189 + P1(3)*x198 + P1(3)*x199 + P1(3)*x200 - P1&
                  (3)*x214 - w1(3)*x228*x25 + w2(3)*x180 + w2(3)*x181 + x10*   &
                  x152 - x100*x109 - x101*x13 - x101*x15 + x101*x16 - x104*x191&
                   + x105*x190 + x108*x116 + x108*x178 - x108*x23 + x109*x246  &
                   + x109*x52 + x109*x65 - x11*x58 - x11*x60 + x110*x246 + x110&
                  *x52 + x110*x65 + x113*x197 - x115*x156 - x115*x157 + x115*  &
                  x158 - x115*x161 - x115*x162 + x115*x163 + x115*x244 - x123* &
                  x62 - x125*x62 - x13*x98 - x132*x83 - x138*x83 + x139*x73 +  &
                  x139*x82 + x142*x218 + x142*x219 + x144*x244 + x146*x219 +   &
                  x147*x219 - x149*x61 - x15*x98 - x150*x61 + x151*x50 + x151* &
                  x51 + x152*x8 + x154*x237 + x16*x98 - x160*x91 - x165*x91 -  &
                  x168*x208 - x172*x208 - x172*x212 - x176*x19 + x18*x99 + x182&
                  *x91 + x183*x91 - x192*x45 + x194*x79 - x195*x33 - x195*x45  &
                   + x20*x99 - x201*x241 - x201*x242 + x201*x36 + x201*x48 -   &
                  x205*x235 - x207*x64 - x209*x43 - x210*x43 + x223*x247 + x225&
                  *x247 - x231*x38 - x232*x38 - x233*x88 - x235*x88 + x240*x52 &
                   + x240*x65 - x245*x57 - x245*x59 - x77*x93
      case(VVV10)
!       c0*(-P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon
!       (-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon(-1,-2,-3,3)*
!       Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - 2*Epsilon(-1,-2,1,2)*P
!       (-1,2)*P(-2,3)*P(3,1) + 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(-Metric(1,2)*P(3,1) + Metric(1,3)*P(2,1))
!       Epsilon(-1,1,2,3)*P(-1,1)*c5
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + x0
        x2 = co(4)*x1
        x3 = w1(2)*w2(3)
        x4 = -w1(3)*w2(2) + x3
        x5 = P1(1)*x4
        x6 = w1(2)*w2(1)
        x7 = w1(1)*w2(2) - x6
        x8 = P1(3)*x7
        x9 = w1(1)*w2(3)
        x10 = -w1(3)*w2(1) + x9
        x11 = P1(2)*x10
        x12 = P1(0)**2
        x13 = P2(1)*x4 - P2(2)*x10 + P2(3)*x7
        x14 = 2*co(3)*x13
        x15 = P1(1)**2
        x16 = 2*co(3)*x15
        x17 = P1(2)**2
        x18 = 2*co(3)*x17
        x19 = P1(3)**2
        x20 = P1(0)*w1(0)
        x21 = co(4)*w2(0)
        x22 = P2(0)*co(1)*x1
        x23 = co(1)*x1*x17
        x24 = P2(0)**2
        x25 = P1(1)*w2(1)
        x26 = P1(2)*w2(2)
        x27 = P1(3)*w2(3)
        x28 = P1(0)*w2(0)
        x29 = x25 + x26 + x27 - x28
        x30 = w1(0)*x24*x29
        x31 = P2(1)**2
        x32 = x29*x31
        x33 = w1(0)*x29
        x34 = P2(2)**2
        x35 = co(1)*x34
        x36 = P2(3)**2
        x37 = co(1)*x36
        x38 = P2(2)*w1(2)
        x39 = P2(3)*w1(3)
        x40 = -P2(0)*w1(0) + P2(1)*w1(1) + x38 + x39
        x41 = co(1)*x12*x40
        x42 = P1(0)*x1
        x43 = co(1)*x31
        x44 = w1(0)*w2(1)
        x45 = P1(1)*co(4)
        x46 = P1(2)*w1(0)
        x47 = P1(3)*w1(0)
        x48 = co(1)*x15*x40
        x49 = co(1)*x17*x40
        x50 = co(1)*x19*x40
        x51 = 8*co(3)
        x52 = -x11 + x5 + x8
        x53 = 6*co(3)
        x54 = P2(1)*w2(3) - P2(3)*w2(1)
        x55 = 4*P1(2)*co(3)*x40
        x56 = P1(0)*P2(2)
        x57 = P1(0)*x10
        x58 = -w1(1)*w2(0) + x44
        x59 = P1(3)*x58
        x60 = w1(0)*w2(3) - w1(3)*w2(0)
        x61 = P1(1)*x60
        x62 = x57 + x59 - x61
        x63 = 2*co(3)*x62
        x64 = P2(0)*x10 - P2(1)*x60 + P2(3)*x58
        x65 = 2*co(3)*x64
        x66 = P1(1)*w1(0)
        x67 = P1(2)*w2(3)
        x68 = P1(3)*w2(2)
        x69 = x67 - x68
        x70 = P1(0)*w2(2)
        x71 = P1(2)*w2(0)
        x72 = x70 - x71
        x73 = P1(0)*w2(3)
        x74 = P1(3)*w2(0)
        x75 = x73 - x74
        x76 = 2*co(2)*(P2(0)*x69 - P2(2)*x75 + P2(3)*x72)
        x77 = P2(2)*w2(3) - P2(3)*w2(2)
        x78 = P2(0)*w2(2) - P2(2)*w2(0)
        x79 = P2(0)*w2(3) - P2(3)*w2(0)
        x80 = 2*co(2)*(P2(0)*x77 - P2(2)*x79 + P2(3)*x78)
        x81 = P1(1)*w2(0)
        x82 = P1(2)*w1(3)
        x83 = P1(3)*w1(2)
        x84 = x82 - x83
        x85 = P2(0)*x84
        x86 = P1(0)*w1(2)
        x87 = -x46 + x86
        x88 = P2(3)*x87
        x89 = P1(0)*w1(3)
        x90 = -x47 + x89
        x91 = P2(2)*x90
        x92 = 2*co(2)*(x85 + x88 - x91)
        x93 = P2(2)*w1(3)
        x94 = P2(3)*w1(2)
        x95 = x93 - x94
        x96 = P2(0)*x95
        x97 = P2(2)*w1(0)
        x98 = P2(0)*w1(2) - x97
        x99 = P2(3)*x98
        x100 = P2(3)*w1(0)
        x101 = P2(0)*w1(3) - x100
        x102 = P2(2)*x101
        x103 = 2*co(2)*(-x102 + x96 + x99)
        x104 = P1(2)*P2(3)
        x105 = P1(3)*P2(2)
        x106 = x104 - x105
        x107 = 2*P1(1)*co(2)*x1
        x108 = P1(2)*P2(0)
        x109 = P1(1)*w2(3)
        x110 = P1(3)*w2(1)
        x111 = x109 - x110
        x112 = 2*P1(2)*co(3)*x40
        x113 = P2(3)*w1(1)
        x114 = P2(1)*w1(3) - x113
        x115 = 2*P1(2)*co(3)*x29
        x116 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x117 = 2*P1(2)*co(3)*x116
        x118 = P1(1)*w1(1)
        x119 = P1(2)*w1(2)
        x120 = P1(3)*w1(3)
        x121 = x118 + x119 + x120 - x20
        x122 = 2*P1(2)*co(3)*x121
        x123 = 2*co(3)*(-x24 + x31 + x34 + x36)
        x124 = P1(1)*P2(1)
        x125 = P1(2)*P2(2)
        x126 = P1(3)*P2(3)
        x127 = P1(0)*P2(0)
        x128 = 2*co(3)*(x124 + x125 + x126 - x127)
        x129 = P1(1)*w2(2)
        x130 = P1(2)*w2(1)
        x131 = x129 - x130
        x132 = P1(0)*w2(1)
        x133 = x132 - x81
        x134 = 2*co(2)*(P2(0)*x131 - P2(1)*x72 + P2(2)*x133)
        x135 = P2(1)*w2(2) - P2(2)*w2(1)
        x136 = P2(0)*w2(1) - P2(1)*w2(0)
        x137 = 2*co(2)*(P2(0)*x135 - P2(1)*x78 + P2(2)*x136)
        x138 = P1(1)*w1(2)
        x139 = P1(2)*w1(1)
        x140 = x138 - x139
        x141 = P2(0)*x140
        x142 = P1(0)*w1(1)
        x143 = x142 - x66
        x144 = P2(2)*x143
        x145 = P2(1)*x87
        x146 = 2*co(2)*(x141 + x144 - x145)
        x147 = P2(1)*w1(2)
        x148 = P2(2)*w1(1)
        x149 = x147 - x148
        x150 = P2(0)*x149
        x151 = P2(0)*w1(1)
        x152 = P2(1)*w1(0)
        x153 = x151 - x152
        x154 = P2(2)*x153
        x155 = P2(1)*x98
        x156 = 2*co(2)*(x150 + x154 - x155)
        x157 = P1(1)*P2(2)
        x158 = P1(2)*P2(1)
        x159 = x157 - x158
        x160 = 2*P1(3)*co(2)*x1
        x161 = P2(1)*x84
        x162 = 2*co(3)*x29
        x163 = P2(1)*x95
        x164 = P2(3)*x140
        x165 = P2(3)*x149
        x166 = P1(0)*P2(1)
        x167 = P1(0)*x4
        x168 = w1(0)*w2(2) - w1(2)*w2(0)
        x169 = P1(3)*x168
        x170 = P1(2)*x60
        x171 = x167 + x169 - x170
        x172 = 2*co(3)*x171
        x173 = P2(0)*x4 - P2(2)*x60 + P2(3)*x168
        x174 = 2*co(3)*x173
        x175 = P1(0)*P2(3)
        x176 = P1(0)*x7
        x177 = P1(2)*x58
        x178 = P1(1)*x168
        x179 = x176 + x177 - x178
        x180 = 2*co(3)*x179
        x181 = P2(0)*x7 - P2(1)*x168 + P2(2)*x58
        x182 = 2*co(3)*x181
        x183 = 2*co(2)*(P2(1)*x69 - P2(2)*x111 + P2(3)*x131)
        x184 = 2*co(2)*(P2(1)*x77 - P2(2)*x54 + P2(3)*x135)
        x185 = P1(1)*w1(3)
        x186 = P1(3)*w1(1)
        x187 = x185 - x186
        x188 = P2(2)*x187
        x189 = 2*co(2)*(x161 + x164 - x188)
        x190 = P2(2)*x114
        x191 = 2*co(2)*(x163 + x165 - x190)
        x192 = P1(1)*P2(0)
        x193 = 2*co(3)*x52
        x194 = 2*P1(1)*co(3)*x40
        x195 = P1(1)*x95
        x196 = 2*co(3)*x116
        x197 = 2*co(3)*x121
        x198 = P1(1)*x77
        x199 = 2*co(2)*(P2(0)*x111 - P2(1)*x75 + P2(3)*x133)
        x200 = 2*co(2)*(P2(0)*x54 - P2(1)*x79 + P2(3)*x136)
        x201 = P2(0)*x187
        x202 = P2(3)*x143
        x203 = P2(1)*x90
        x204 = 2*co(2)*(x201 + x202 - x203)
        x205 = P2(0)*x114
        x206 = P2(3)*x153
        x207 = P2(1)*x101
        x208 = 2*co(2)*(x205 + x206 - x207)
        x209 = P1(1)*P2(3)
        x210 = P1(3)*P2(1)
        x211 = x209 - x210
        x212 = 2*P1(2)*co(2)*x1
        x213 = P1(3)*P2(0)
        x214 = 2*P1(3)*co(3)*x40
        x215 = 2*P1(3)*co(3)*x116
        x216 = 2*P1(3)*co(3)*x121
        x217 = 4*P1(1)*P2(1)*co(3)
        x218 = 4*co(3)*x40
        x219 = 4*co(3)*x13
        x220 = 4*P1(3)*co(3)*x40
        x221 = co(1)*w1(0)*x116
        x222 = P1(0)*P2(1)*co(0)*w1(1)
        x223 = co(0)*x29
        x224 = P1(0)*P2(2)*w1(2)
        x225 = co(0)*x116
        x226 = P2(3)*co(0)*x29
        x227 = P2(3)*co(0)*x116
        x228 = P2(1)*co(1)*x121
        x229 = P1(2)*P2(2)*co(1)*x121
        x230 = P2(3)*co(1)*x1
        x231 = P2(3)*co(1)*x121
        x232 = P1(0)*co(1)*x1
        x233 = co(0)*w1(0)*x116
        x234 = P1(0)*P2(0)*co(1)*x121
        x235 = w1(2)*x29
        x236 = co(0)*w1(3)*x29
        x237 = P2(1)*co(0)*x29
        x238 = P2(0)*co(0)*x29
        x239 = 2*co(3)*x12
        x240 = 2*co(3)*x19
        x241 = P1(0)*co(4)*w2(0)
        x242 = co(1)*x1*x24
        x243 = P2(1)*co(1)*x1
        x244 = co(1)*w1(1)
        x245 = co(1)*x29*x36
        x246 = P1(1)*x1
        x247 = P1(1)*co(4)*w2(1)
        x248 = P1(2)*co(4)*w2(2)
        x249 = P1(3)*co(4)
        x250 = co(0)*w1(1)
        x251 = x24*x29
        x252 = 4*co(3)*x173
        x253 = 4*co(3)*x40*x79
        x254 = 2*P1(0)*co(2)*x1
        x255 = 2*co(3)*x101*x116
        x256 = -x108 + x56
        x257 = 2*P1(0)*co(3)*x40
        x258 = 2*P1(0)*co(3)*x29
        x259 = 2*P1(0)*co(3)*x116
        x260 = 2*P1(0)*co(3)*x121
        x261 = P1(2)*x1
        x262 = 2*co(2)*(x175 - x213)
        x263 = 2*co(3)*x29*x98
        x264 = 4*P1(0)*co(3)*x40
        x265 = 4*co(3)*x40*x78
        x266 = P1(0)*P2(0)*co(1)*x1
        x267 = co(1)*w1(1)*x116
        x268 = P1(1)*P2(1)*x116
        x269 = P1(1)*P2(2)*w1(2)
        x270 = co(1)*x121
        x271 = co(1)*x1
        x272 = P1(3)*co(1)*x1
        x273 = co(0)*w1(0)*x29
        x274 = P1(2)*co(0)*x29
        x275 = P2(2)*co(0)*x29
        x276 = P2(2)*co(1)*x1
        x277 = w1(2)*x29*x34
        x278 = co(1)*w2(2)*x40
        x279 = co(1)*x1*x31
        x280 = P1(0)*x54
        x281 = 4*co(3)*x64
        x282 = P1(3)*x153
        x283 = 2*P1(1)*co(3)*x121
        x284 = x166 - x192
        x285 = co(1)*x116
        x286 = P1(2)*P2(1)*w1(1)
        x287 = P1(2)*P2(2)*w1(2)
        x288 = P1(2)*P2(3)*w1(3)
        x289 = P2(0)*co(1)*x121
        x290 = P1(3)*co(0)*x29
        x291 = co(1)*w1(3)
        x292 = co(1)*w2(3)*x40
        x293 = 4*co(3)*x181
        x294 = 2*P1(3)*P2(2)*co(3)
        wout(0) = -P1(0)*P2(0)*x13*x51 - P1(0)*P2(0)*x52*x53 + P1(0)*x2 - P1(1 &
                  )*P2(0)*w1(1)*x223 - P1(2)*P2(0)*co(0)*x235 + P1(3)*x149*x162&
                   + P2(0)*x23 + co(0)*x30 + co(1)*w1(0)*x32 - co(1)*x30 - co(4&
                  )*w2(2)*x46 - co(4)*w2(3)*x47 - co(5)*x11 + co(5)*x5 + co(5)*&
                  x8 + w2(0)*x229 - w2(0)*x234 + w2(0)*x41 - w2(0)*x48 - w2(0)*&
                  x49 - w2(0)*x50 - x103*x81 - x106*x107 - x108*x63 - x108*x65 &
                   - x11*x123 - x11*x128 - x111*x112 - x114*x115 - x114*x117 + &
                  x116*x222 - x12*x14 - x122*x54 + x123*x5 + x123*x8 + x124*   &
                  x193 + x124*x22 - x124*x221 - x124*x232 + x125*x193 + x125*  &
                  x219 + x125*x22 - x125*x221 - x125*x232 + x126*x193 + x126*  &
                  x219 - x126*x221 - x126*x232 + x127*x221 - x127*x233 + x128* &
                  x5 + x128*x8 + x13*x16 + x13*x18 + x13*x217 + x131*x214 -    &
                  x134*x47 + x135*x216 + x135*x220 - x137*x47 + x14*x19 - x146*&
                  x74 + x149*x215 + x15*x22 - x151*x237 - x156*x74 - x159*x160 &
                   - x161*x162 - x162*x163 - x162*x164 - x162*x165 + x162*x188 &
                   + x162*x190 + x162*x195 + x166*x172 + x166*x174 + x172*x192 &
                   + x174*x192 + x175*x180 + x175*x182 + x180*x213 + x182*x213 &
                   + x183*x20 + x184*x20 + x189*x28 + x19*x22 + x191*x28 + x194&
                  *x69 + x195*x196 + x197*x198 + x198*x218 + x199*x46 + x20*x21&
                   + x200*x46 + x204*x71 + x208*x71 + x211*x212 + x213*x230 -  &
                  x213*x236 + x222*x29 + x223*x224 + x224*x225 + x226*x89 +    &
                  x227*x89 + x228*x81 + x231*x74 - x238*x38 - x238*x39 + x33*  &
                  x35 + x33*x37 - x35*x42 - x37*x42 - x42*x43 - x44*x45 - x54* &
                  x55 - x56*x63 - x56*x65 - x66*x76 - x66*x80 - x81*x92
        wout(1) = -P1(1)*P1(2)*P2(2)*x271 + P1(1)*P2(1)*x171*x53 + P1(1)*P2(1)*&
                  x173*x51 + P1(1)*P2(3)*w1(3)*x225 + P1(1)*x2 + P1(1)*x242 +  &
                  P1(1)*x266 - P1(2)*x253 - P1(2)*x255 + P1(3)*P2(3)*w2(1)*x270&
                   + P1(3)*x263 + P1(3)*x265 + P2(1)*x23 + co(5)*x167 + co(5)* &
                  x169 - co(5)*x170 + w1(1)*x241 + w1(1)*x245 - w1(1)*x247 - w1&
                  (1)*x248 + w1(1)*x29*x35 + w2(1)*x229 - w2(1)*x234 + w2(1)*  &
                  x41 - w2(1)*x48 - w2(1)*x49 - w2(1)*x50 - x101*x115 + x102*  &
                  x162 - x103*x25 - x106*x254 - x110*x146 - x110*x156 - x112*  &
                  x75 - x118*x76 - x118*x80 - x12*x243 - x120*x237 - x122*x79  &
                   + x123*x167 + x123*x169 - x123*x170 + x125*x172 + x125*x243 &
                   + x125*x252 - x125*x267 + x126*x172 + x126*x243 + x126*x252 &
                   - x126*x267 - x127*x172 - x127*x243 - x127*x252 + x127*x267 &
                   + x128*x167 + x128*x169 - x128*x170 + x130*x204 + x130*x208 &
                   + x132*x189 + x132*x191 - x134*x186 - x137*x186 + x139*x199 &
                   + x139*x200 - x14*x166 - x14*x192 + x142*x183 + x142*x184 - &
                  x147*x274 - x147*x275 + x152*x238 - x157*x63 - x157*x65 -    &
                  x158*x63 - x158*x65 + x16*x173 - x160*x256 - x162*x85 - x162*&
                  x88 + x162*x91 - x162*x96 - x162*x99 - x166*x193 + x173*x18  &
                   - x173*x239 + x173*x240 + x180*x209 + x180*x210 + x182*x209 &
                   + x182*x210 + x19*x243 - x192*x193 - x192*x233 - x192*x273  &
                   + x20*x237 + x209*x236 - x209*x272 + x214*x72 + x215*x98 +  &
                  x216*x78 + x223*x269 + x225*x269 + x228*x25 - x237*x39 - x244&
                  *x251 - x244*x268 + x244*x32 - x246*x35 - x246*x37 - x249*x9 &
                   - x25*x92 + x250*x268 - x250*x32 + x257*x69 + x258*x95 +    &
                  x259*x95 + x260*x77 + x261*x262 + x264*x77
        wout(2) = P1(0)*P2(0)*w1(2)*x285 - P1(1)*P1(2)*P2(1)*x271 - P1(1)*P2(1 &
                  )*w1(2)*x285 + P1(1)*P2(1)*w2(2)*x270 + P1(1)*x101*x162 + P1(&
                  1)*x253 + P1(1)*x255 - P1(2)*P2(0)*w1(0)*x225 - P1(2)*P2(2)* &
                  x51*x64 - P1(2)*P2(2)*x53*x62 + P1(2)*x2 + P1(2)*x242 + P1(2 &
                  )*x266 - P1(2)*x279 - P1(3)*P2(3)*w1(2)*x285 - co(0)*x277 -  &
                  co(1)*x235*x24 + co(1)*x277 - co(5)*x57 - co(5)*x59 + co(5)* &
                  x61 + w1(2)*x241 - w1(2)*x248 + w2(2)*x229 - w2(2)*x49 - x103&
                  *x129 + x104*x180 + x104*x182 - x104*x272 + x105*x180 + x105*&
                  x182 - x108*x14 - x108*x193 - x111*x257 - x114*x258 - x114*  &
                  x259 - x118*x275 + x119*x199 + x119*x200 - x12*x276 + x12*   &
                  x278 - x123*x57 - x123*x59 + x123*x61 + x124*x276 - x124*x63 &
                   + x126*x276 - x126*x281 - x126*x63 - x127*x276 + x127*x281  &
                   + x127*x63 - x128*x57 - x128*x59 + x128*x61 - x129*x92 -    &
                  x133*x214 - x134*x83 - x136*x216 - x136*x220 - x137*x83 -    &
                  x138*x76 - x138*x80 - x14*x56 - x146*x68 - x148*x237 + x15*  &
                  x276 - x15*x278 - x156*x68 + x157*x172 + x157*x174 + x158*   &
                  x172 + x158*x174 - x16*x64 + x160*x284 + x162*x201 + x162*   &
                  x202 - x162*x203 + x162*x205 + x162*x206 - x162*x207 - x162* &
                  x282 - x18*x64 + x183*x86 + x184*x86 + x189*x70 + x19*x276 - &
                  x19*x278 + x191*x70 - x193*x56 + x194*x75 - x196*x282 - x197*&
                  x280 + x20*x275 + x204*x26 + x208*x26 + x211*x254 - x217*x64 &
                   - x218*x280 + x223*x286 + x223*x288 + x225*x286 + x225*x287 &
                   + x225*x288 - x226*x93 + x231*x68 + x235*x37 + x235*x43 -   &
                  x238*x46 + x238*x97 + x239*x64 - x240*x64 - x246*x262 - x249*&
                  x3 - x261*x37 + x283*x79 - x285*x287 - x289*x70 - x290*x93 - &
                  x45*x6
        wout(3) = P1(0)*P2(0)*w1(3)*x285 + P1(1)*P2(1)*w2(3)*x270 - P1(1)*P2(3 &
                  )*x250*x29 - P1(1)*x196*x98 - P1(1)*x263 - P1(1)*x265 - P1(2 &
                  )*P2(2)*w1(3)*x285 + P1(3)*P2(1)*w1(1)*x225 + P1(3)*P2(2)*w1(&
                  2)*x225 - P1(3)*P2(3)*w1(3)*x285 + P1(3)*P2(3)*w2(3)*x270 +  &
                  P1(3)*P2(3)*x179*x53 + P1(3)*P2(3)*x181*x51 - P1(3)*x1*x35 + &
                  P1(3)*x2 + P1(3)*x242 - P1(3)*x279 + P2(3)*x23 + co(5)*x176  &
                   + co(5)*x177 - co(5)*x178 + w1(3)*x245 - w1(3)*x247 - w1(3)*&
                  x248 + w2(3)*x229 - w2(3)*x49 - x0*x249 + x100*x238 - x103*  &
                  x109 - x104*x63 - x104*x65 + x107*x256 - x109*x92 + x112*x133&
                   - x113*x237 + x115*x153 + x117*x153 - x12*x182 - x12*x230 + &
                  x12*x292 - x120*x134 - x120*x137 + x120*x227 + x122*x136 +   &
                  x123*x176 + x123*x177 - x123*x178 + x124*x180 - x124*x272 +  &
                  x124*x293 + x125*x180 + x125*x230 - x125*x272 + x125*x293 -  &
                  x127*x180 - x127*x230 - x127*x293 + x128*x176 + x128*x177 -  &
                  x128*x178 + x131*x257 + x135*x260 + x135*x264 + x136*x55 -   &
                  x14*x175 - x14*x213 - x141*x162 - x144*x162 + x145*x162 -    &
                  x146*x27 + x149*x258 + x149*x259 + x15*x182 + x15*x230 - x15*&
                  x292 - x150*x162 - x154*x162 + x155*x162 - x156*x27 - x159*  &
                  x254 + x17*x182 + x172*x209 + x172*x210 + x174*x209 + x174*  &
                  x210 - x175*x193 + x182*x19 + x183*x89 + x184*x89 - x185*x76 &
                   - x185*x80 + x186*x237 + x189*x73 - x19*x292 + x191*x73 -   &
                  x193*x213 - x194*x72 + x199*x82 + x20*x226 + x200*x82 + x204*&
                  x67 + x208*x67 + x209*x243 + x21*x89 - x212*x284 + x213*x232 &
                   - x213*x233 - x213*x273 - x236*x36 - x251*x291 - x268*x291  &
                   - x274*x94 - x275*x94 - x283*x78 - x289*x73 + x29*x291*x34  &
                   + x290*x38 + x291*x32 - x294*x62 - x294*x64
      case(VVV11)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       c2*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(0)*w2(2) - w1(2)*w2(0)
        x2 = w1(0)*w2(3) - w1(3)*w2(0)
        x3 = P1(0)*x0 - P1(2)*x2 + P1(3)*x1
        x4 = P1(1)*P2(0)*co(2)
        x5 = P2(0)*x0 - P2(2)*x2 + P2(3)*x1
        x6 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x7 = P2(1)*w1(3)
        x8 = P2(3)*w1(1)
        x9 = x7 - x8
        x10 = P1(2)*co(2)*x9
        x11 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x12 = w1(1)*w2(2) - w1(2)*w2(1)
        x13 = w1(0)*w2(1) - w1(1)*w2(0)
        x14 = P1(3)*co(2)*(P1(0)*x12 - P1(1)*x1 + P1(2)*x13)
        x15 = P1(3)*co(2)*(P2(0)*x12 - P2(1)*x1 + P2(2)*x13)
        x16 = P1(1)**2
        x17 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x18 = co(1)*x16*x17
        x19 = P1(2)**2
        x20 = co(1)*x17*x19
        x21 = P1(3)**2
        x22 = co(1)*x17*x21
        x23 = P2(0)**2
        x24 = w1(1)*w2(3) - w1(3)*w2(1)
        x25 = P1(0)*co(2)*(P1(1)*x0 - P1(2)*x24 + P1(3)*x12)
        x26 = P1(0)*co(2)*(P2(1)*x0 - P2(2)*x24 + P2(3)*x12)
        x27 = P1(0)*co(1)*x17
        x28 = P2(2)*w1(3)
        x29 = P2(3)*w1(2)
        x30 = x28 - x29
        x31 = P1(1)*co(2)*x30
        x32 = P1(2)*co(2)*(P1(0)*x24 - P1(1)*x2 + P1(3)*x13)
        x33 = P1(2)*co(2)*(P2(0)*x24 - P2(1)*x2 + P2(3)*x13)
        x34 = P2(1)*w1(2)
        x35 = P2(2)*w1(1)
        x36 = x34 - x35
        x37 = P1(3)*co(2)*x6
        x38 = P1(3)*co(2)*x11
        x39 = P1(0)**2
        x40 = co(1)*x17*x39
        x41 = co(0)*x11
        x42 = P1(0)*P2(0)*w1(0)
        x43 = P1(1)*P2(1)*co(1)*x17
        x44 = P2(1)*w1(0)
        x45 = P1(1)*co(1)*x6
        x46 = P1(1)*co(1)*x11
        x47 = P1(2)*co(1)*x17
        x48 = P2(0)*P2(2)
        x49 = P2(2)*w1(0)
        x50 = P1(2)*co(1)*x6
        x51 = P1(2)*co(1)*x11
        x52 = P2(0)*P2(3)*co(1)*x17
        x53 = P2(3)*w1(0)
        x54 = P1(3)*co(1)*x6
        x55 = P1(3)*co(1)*x11
        x56 = P1(0)*co(1)*x11
        x57 = P2(1)*co(0)*w1(1)*x6
        x58 = P2(1)*co(0)*w1(1)*x11
        x59 = P2(2)*co(0)*w1(2)*x6
        x60 = P2(2)*co(0)*w1(2)*x11
        x61 = P2(3)*co(0)*w1(3)*x6
        x62 = P2(3)*co(0)*w1(3)*x11
        x63 = P2(0)*co(0)*w1(1)*x6
        x64 = P2(0)*w1(2)
        x65 = P1(2)*co(0)*x6
        x66 = P2(0)*co(0)*w1(3)*x6
        x67 = P2(2)*co(0)*x6
        x68 = P2(0)*co(0)*w1(0)*x6
        x69 = P1(1)*co(2)*x3
        x70 = P1(1)*co(2)*x5
        x71 = P2(1)**2
        x72 = P1(2)*co(2)
        x73 = P2(0)*w1(3)
        x74 = -x53 + x73
        x75 = x6*x74
        x76 = P1(0)*co(2)*x6
        x77 = P1(0)*co(2)*x11
        x78 = -x49 + x64
        x79 = co(0)*w1(1)*x6
        x80 = P1(0)*co(0)*x6
        x81 = P2(0)*co(0)*w1(0)*x11
        x82 = P2(1)*w1(1)
        x83 = P2(3)*co(1)*x17
        x84 = P1(3)*P2(1)
        x85 = P2(0)*co(0)*x6
        x86 = P2(0)*w1(1)
        x87 = P1(0)*co(1)*x6
        x88 = P2(1)*co(0)*w1(3)*x6
        x89 = P2(2)**2
        x90 = -x44 + x86
        x91 = P1(1)*co(2)
        x92 = P1(1)*co(2)*x11
        x93 = P2(2)*co(0)*w1(0)*x6
        x94 = P2(2)*w1(2)
        x95 = P2(2)*P2(3)*co(1)*x17
        x96 = P2(2)*co(0)*w1(1)*x6
        x97 = P2(2)*co(0)*w1(3)*x6
        x98 = P2(3)**2
        x99 = P1(2)*co(2)*x90
        x100 = P2(3)*w1(3)
        x101 = P2(3)*co(0)*w1(1)*x6
        x102 = P2(3)*co(0)*w1(2)*x6
        wout(0) = -P1(0)*x57 - P1(0)*x58 - P1(0)*x59 - P1(0)*x60 - P1(0)*x61 - &
                  P1(0)*x62 + 2*P1(0)*x68 - P1(1)*x63 + P1(3)*x52 - P1(3)*x66  &
                   - P2(0)*w1(0)*x56 + P2(0)*x14 + P2(0)*x15 + P2(0)*x18 + P2(0&
                  )*x20 + P2(0)*x22 - P2(0)*x25 - P2(0)*x26 - P2(0)*x32 - P2(0 &
                  )*x33 - P2(0)*x40 + P2(0)*x43 - P2(1)*x63 - P2(3)*x66 + co(0 &
                  )*w1(0)*x23*x6 - co(1)*x42*x6 + x10*x11 + x10*x6 - x11*x31 - &
                  x23*x27 + x3*x4 - x31*x6 - x36*x37 - x36*x38 + x4*x5 + x41*  &
                  x42 + x44*x45 + x44*x46 + x47*x48 + x49*x50 + x49*x51 + x53* &
                  x54 + x53*x55 - x64*x65 - x64*x67
        wout(1) = P1(1)*co(1)*x17*x71 - 2*P1(1)*x57 - P1(1)*x58 - P1(1)*x59 -  &
                  P1(1)*x60 - P1(1)*x61 - P1(1)*x62 + P1(1)*x68 + P1(1)*x81 -  &
                  P1(3)*x88 - P2(0)*P2(1)*x27 + P2(1)*P2(2)*x47 + P2(1)*x14 +  &
                  P2(1)*x15 + P2(1)*x18 + P2(1)*x20 + P2(1)*x22 - P2(1)*x25 -  &
                  P2(1)*x26 - P2(1)*x32 - P2(1)*x33 - P2(1)*x40 + P2(1)*x69 +  &
                  P2(1)*x70 - P2(3)*x88 + x11*x72*x74 - x30*x76 - x30*x77 - x34&
                  *x65 - x34*x67 + x35*x50 + x35*x51 - x37*x78 - x38*x78 + x44*&
                  x80 + x44*x85 + x45*x82 + x46*x82 + x54*x8 + x55*x8 - x56*x86&
                   - x71*x79 + x72*x75 + x83*x84 - x86*x87
        wout(2) = P1(0)*x93 - P1(1)*x96 - P1(2)*x57 - P1(2)*x58 - 2*P1(2)*x59  &
                   - P1(2)*x60 - P1(2)*x61 - P1(2)*x62 + P1(2)*x68 + P1(2)*x81 &
                   + P1(3)*x95 - P1(3)*x97 + P2(0)*x93 - P2(1)*x96 + P2(2)*x14 &
                   + P2(2)*x15 + P2(2)*x18 + P2(2)*x20 + P2(2)*x22 - P2(2)*x25 &
                   - P2(2)*x26 - P2(2)*x32 - P2(2)*x33 - P2(2)*x40 + P2(2)*x43 &
                   + P2(2)*x69 + P2(2)*x70 - P2(3)*x97 - co(0)*w1(2)*x6*x89 -  &
                  x27*x48 + x29*x54 + x29*x55 + x34*x45 + x34*x46 + x37*x90 +  &
                  x38*x90 + x47*x89 + x50*x94 + x51*x94 - x56*x64 - x64*x87 -  &
                  x74*x92 - x75*x91 + x76*x9 + x77*x9
        wout(3) = -P1(0)*x52 - P1(1)*x101 - P1(2)*x102 + P1(2)*x95 - P1(3)*P2(1&
                  )*w1(1)*x41 + P1(3)*co(1)*x17*x98 - P1(3)*x59 - P1(3)*x60 - 2&
                  *P1(3)*x61 - P1(3)*x62 + P1(3)*x68 + P1(3)*x81 - P2(1)*x101  &
                   - P2(2)*x102 + P2(3)*x14 + P2(3)*x15 - P2(3)*x25 - P2(3)*x26&
                   - P2(3)*x32 - P2(3)*x33 + P2(3)*x43 + P2(3)*x69 + P2(3)*x70 &
                   - co(0)*w1(3)*x6*x98 + x100*x54 + x100*x55 - x11*x99 + x16* &
                  x83 + x19*x83 + x21*x83 + x28*x50 + x28*x51 - x36*x76 - x36* &
                  x77 - x39*x83 + x45*x7 + x46*x7 + x53*x80 + x53*x85 - x56*x73&
                   + x6*x78*x91 - x6*x99 - x73*x87 + x78*x92 - x79*x84
      case(VVV12)
!       c0*(-P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(2*Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon
!       (-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + 2*Epsilon(-1,-2,-3,3)*
!       Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-2*Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - 2*Epsilon(-1,-2,1,2)*P
!       (-1,2)*P(-2,3)*P(3,1) + 2*Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - 2* 
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*
!       P(-2,2)*P(1,3) + 2*Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + 2*Epsilon 
!       (-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*
!       P(-2,3) + 2*Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(-Metric(1,2)*P(3,2) + Metric(2,3)*P(1,2))
!       Epsilon(-1,1,2,3)*P(-1,2)*c5
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(4)*x2
        x4 = w1(3)*w2(2)
        x5 = w1(2)*w2(3) - x4
        x6 = P2(1)*x5
        x7 = w1(1)*w2(2)
        x8 = -w1(2)*w2(1) + x7
        x9 = P2(3)*x8
        x10 = w1(1)*w2(3) - w1(3)*w2(1)
        x11 = P2(2)*x10
        x12 = -x11 + x6 + x9
        x13 = P1(0)**2
        x14 = 2*co(3)*x13
        x15 = P1(1)**2
        x16 = 2*co(3)*x15
        x17 = P1(2)**2
        x18 = 2*co(3)*x17
        x19 = P1(3)**2
        x20 = 2*co(3)*x19
        x21 = P2(0)*co(1)*x2
        x22 = co(1)*x17*x2
        x23 = P2(0)*co(4)
        x24 = P2(0)**2
        x25 = P1(1)*w2(1)
        x26 = P1(2)*w2(2)
        x27 = P1(3)*w2(3)
        x28 = P1(0)*w2(0)
        x29 = x25 + x26 + x27 - x28
        x30 = w1(0)*x24*x29
        x31 = P2(1)**2
        x32 = x29*x31
        x33 = w1(0)*x29
        x34 = P2(2)**2
        x35 = co(1)*x34
        x36 = P2(3)**2
        x37 = co(1)*x36
        x38 = P2(2)*w1(2)
        x39 = P2(3)*w1(3)
        x40 = -P2(0)*w1(0) + P2(1)*w1(1) + x38 + x39
        x41 = co(1)*x13*x40
        x42 = P1(0)*x2
        x43 = co(1)*x31
        x44 = P2(1)*w2(0)
        x45 = co(4)*w1(1)
        x46 = P2(2)*co(4)*w1(2)
        x47 = P2(3)*w2(0)
        x48 = co(4)*w1(3)
        x49 = co(1)*x15*x40
        x50 = co(1)*x17*x40
        x51 = co(1)*x19*x40
        x52 = 8*co(3)
        x53 = P1(1)*x5
        x54 = P1(3)*x8
        x55 = P1(2)*x10
        x56 = x53 + x54 - x55
        x57 = 6*co(3)
        x58 = P2(1)*w2(3)
        x59 = P2(3)*w2(1)
        x60 = x58 - x59
        x61 = 4*P1(2)*co(3)*x40
        x62 = P1(0)*P2(2)
        x63 = P1(0)*x10
        x64 = w1(0)*w2(1)
        x65 = -w1(1)*w2(0) + x64
        x66 = P1(3)*x65
        x67 = w1(0)*w2(3)
        x68 = -w1(3)*w2(0) + x67
        x69 = P1(1)*x68
        x70 = x63 + x66 - x69
        x71 = 2*co(3)*x70
        x72 = P2(0)*x10
        x73 = P2(3)*x65
        x74 = P2(1)*x68
        x75 = x72 + x73 - x74
        x76 = 2*co(3)*x75
        x77 = P1(1)*w1(0)
        x78 = P1(2)*w2(3)
        x79 = P1(3)*w2(2)
        x80 = x78 - x79
        x81 = P1(0)*w2(2)
        x82 = P1(2)*w2(0)
        x83 = x81 - x82
        x84 = P1(0)*w2(3)
        x85 = P1(3)*w2(0)
        x86 = x84 - x85
        x87 = 2*co(2)*(P2(0)*x80 - P2(2)*x86 + P2(3)*x83)
        x88 = P2(2)*w2(3) - P2(3)*w2(2)
        x89 = P2(0)*w2(2)
        x90 = -P2(2)*w2(0) + x89
        x91 = P2(0)*w2(3) - x47
        x92 = 2*co(2)*(P2(0)*x88 - P2(2)*x91 + P2(3)*x90)
        x93 = P1(1)*w2(0)
        x94 = P1(2)*w1(3)
        x95 = P1(3)*w1(2)
        x96 = x94 - x95
        x97 = P2(0)*x96
        x98 = P1(0)*w1(2)
        x99 = P1(2)*w1(0)
        x100 = x98 - x99
        x101 = P2(3)*x100
        x102 = P1(0)*w1(3)
        x103 = P1(3)*w1(0)
        x104 = x102 - x103
        x105 = P2(2)*x104
        x106 = 2*co(2)*(x101 - x105 + x97)
        x107 = P2(2)*w1(3)
        x108 = P2(3)*w1(2)
        x109 = x107 - x108
        x110 = P2(0)*x109
        x111 = P2(2)*w1(0)
        x112 = P2(0)*w1(2) - x111
        x113 = P2(3)*x112
        x114 = P2(3)*w1(0)
        x115 = P2(0)*w1(3) - x114
        x116 = P2(2)*x115
        x117 = 2*co(2)*(x110 + x113 - x116)
        x118 = P1(2)*P2(3)
        x119 = P1(3)*P2(2)
        x120 = x118 - x119
        x121 = 2*P1(1)*co(2)*x2
        x122 = P1(2)*P2(0)
        x123 = P1(1)*w2(3)
        x124 = P1(3)*w2(1)
        x125 = x123 - x124
        x126 = 2*P1(2)*co(3)*x40
        x127 = P2(3)*w1(1)
        x128 = P2(1)*w1(3) - x127
        x129 = 2*P1(2)*co(3)*x29
        x130 = P2(1)*w2(1)
        x131 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x130
        x132 = 2*P1(2)*co(3)*x131
        x133 = P1(1)*w1(1)
        x134 = P1(2)*w1(2)
        x135 = P1(3)*w1(3)
        x136 = P1(0)*w1(0)
        x137 = x133 + x134 + x135 - x136
        x138 = 2*P1(2)*co(3)*x137
        x139 = 2*co(3)*(-x24 + x31 + x34 + x36)
        x140 = P1(1)*P2(1)
        x141 = P1(2)*P2(2)
        x142 = P1(3)*P2(3)
        x143 = P1(0)*P2(0)
        x144 = 2*co(3)*(x140 + x141 + x142 - x143)
        x145 = P1(1)*w2(2)
        x146 = P1(2)*w2(1)
        x147 = x145 - x146
        x148 = P1(0)*w2(1)
        x149 = x148 - x93
        x150 = 2*co(2)*(P2(0)*x147 - P2(1)*x83 + P2(2)*x149)
        x151 = P2(1)*w2(2) - P2(2)*w2(1)
        x152 = P2(0)*w2(1) - x44
        x153 = 2*co(2)*(P2(0)*x151 - P2(1)*x90 + P2(2)*x152)
        x154 = P1(1)*w1(2)
        x155 = P1(2)*w1(1)
        x156 = x154 - x155
        x157 = P2(0)*x156
        x158 = P1(0)*w1(1)
        x159 = x158 - x77
        x160 = P2(2)*x159
        x161 = P2(1)*x100
        x162 = 2*co(2)*(x157 + x160 - x161)
        x163 = P2(1)*w1(2)
        x164 = P2(2)*w1(1)
        x165 = x163 - x164
        x166 = P2(0)*x165
        x167 = P2(0)*w1(1)
        x168 = P2(1)*w1(0)
        x169 = x167 - x168
        x170 = P2(2)*x169
        x171 = P2(1)*x112
        x172 = 2*co(2)*(x166 + x170 - x171)
        x173 = P1(1)*P2(2)
        x174 = P1(2)*P2(1)
        x175 = x173 - x174
        x176 = 2*P1(3)*co(2)*x2
        x177 = P2(1)*x96
        x178 = 2*co(3)*x29
        x179 = P2(1)*x109
        x180 = P2(3)*x156
        x181 = P2(3)*x165
        x182 = P1(0)*P2(1)
        x183 = P1(0)*x5
        x184 = w1(0)*w2(2) - w1(2)*w2(0)
        x185 = P1(3)*x184
        x186 = P1(2)*x68
        x187 = x183 + x185 - x186
        x188 = 2*co(3)*x187
        x189 = P2(0)*x5
        x190 = P2(3)*x184
        x191 = P2(2)*x68
        x192 = x189 + x190 - x191
        x193 = 2*co(3)*x192
        x194 = P1(0)*P2(3)
        x195 = P1(0)*x8
        x196 = P1(2)*x65
        x197 = P1(1)*x184
        x198 = x195 + x196 - x197
        x199 = 2*co(3)*x198
        x200 = P2(0)*x8
        x201 = P2(2)*x65
        x202 = P2(1)*x184
        x203 = x200 + x201 - x202
        x204 = 2*co(3)*x203
        x205 = 2*co(2)*(P2(1)*x80 - P2(2)*x125 + P2(3)*x147)
        x206 = 2*co(2)*(P2(1)*x88 - P2(2)*x60 + P2(3)*x151)
        x207 = P1(1)*w1(3)
        x208 = P1(3)*w1(1)
        x209 = x207 - x208
        x210 = P2(2)*x209
        x211 = 2*co(2)*(x177 + x180 - x210)
        x212 = P2(2)*x128
        x213 = 2*co(2)*(x179 + x181 - x212)
        x214 = P1(1)*P2(0)
        x215 = 2*co(3)*x56
        x216 = 2*P1(1)*co(3)*x40
        x217 = P1(1)*x109
        x218 = 2*co(3)*x131
        x219 = 2*co(3)*x137
        x220 = P1(1)*x88
        x221 = 2*co(2)*(P2(0)*x125 - P2(1)*x86 + P2(3)*x149)
        x222 = 2*co(2)*(P2(0)*x60 - P2(1)*x91 + P2(3)*x152)
        x223 = P2(0)*x209
        x224 = P2(3)*x159
        x225 = P2(1)*x104
        x226 = 2*co(2)*(x223 + x224 - x225)
        x227 = P2(0)*x128
        x228 = P2(3)*x169
        x229 = P2(1)*x115
        x230 = 2*co(2)*(x227 + x228 - x229)
        x231 = P1(1)*P2(3)
        x232 = P1(3)*P2(1)
        x233 = x231 - x232
        x234 = 2*P1(2)*co(2)*x2
        x235 = P1(3)*P2(0)
        x236 = 2*P1(3)*co(3)*x40
        x237 = 2*P1(3)*co(3)*x131
        x238 = 2*P1(3)*co(3)*x137
        x239 = 4*P1(1)*P2(1)*co(3)
        x240 = 4*co(3)*x40
        x241 = 4*co(3)*x12
        x242 = 4*P1(3)*co(3)*x40
        x243 = co(1)*w1(0)*x131
        x244 = P1(0)*P2(1)*co(0)*w1(1)
        x245 = co(0)*x29
        x246 = P1(0)*P2(2)*w1(2)
        x247 = co(0)*x131
        x248 = P2(3)*co(0)*x29
        x249 = P2(3)*co(0)*x131
        x250 = P2(1)*co(1)*x137
        x251 = P1(2)*P2(2)*co(1)*x137
        x252 = P2(3)*co(1)*x2
        x253 = P1(3)*P2(3)*co(1)*x137
        x254 = P1(0)*co(1)*x2
        x255 = co(0)*w1(0)*x131
        x256 = P1(0)*P2(0)*co(1)*x137
        x257 = P2(0)*co(0)*x29
        x258 = w1(2)*x29
        x259 = co(0)*w1(3)*x29
        x260 = P2(1)*co(0)*x29
        x261 = co(1)*x2*x24
        x262 = P2(1)*co(1)*x2
        x263 = co(1)*w1(1)
        x264 = co(1)*x29*x36
        x265 = P1(1)*x2
        x266 = x24*x29
        x267 = 4*co(3)*x192
        x268 = 4*co(3)*x40*x91
        x269 = 2*co(3)*x12
        x270 = 2*P1(0)*co(2)*x2
        x271 = 2*co(3)*x115*x131
        x272 = -x122 + x62
        x273 = 2*P1(0)*co(3)*x40
        x274 = 2*P1(0)*co(3)*x29
        x275 = 2*P1(0)*co(3)*x131
        x276 = 2*P1(0)*co(3)*x137
        x277 = P1(2)*x2
        x278 = 2*co(2)*(x194 - x235)
        x279 = 2*co(3)*x112*x29
        x280 = 4*P1(0)*co(3)*x40
        x281 = 4*co(3)*x40*x90
        x282 = P1(0)*P2(0)*co(1)*x2
        x283 = co(1)*w1(1)*x131
        x284 = P2(1)*co(0)*x131
        x285 = P1(1)*P2(2)*w1(2)
        x286 = co(1)*x137
        x287 = P1(1)*co(1)*x2
        x288 = co(0)*w1(0)*x29
        x289 = P1(2)*co(0)*x29
        x290 = P2(2)*co(0)*x29
        x291 = P2(2)*co(1)*x2
        x292 = w1(2)*x29*x34
        x293 = co(1)*w2(2)*x40
        x294 = co(1)*x2*x31
        x295 = P2(3)*co(4)
        x296 = P1(0)*x60
        x297 = 4*co(3)*x75
        x298 = P1(3)*x169
        x299 = 2*P1(1)*co(3)*x137
        x300 = x182 - x214
        x301 = co(1)*x131
        x302 = P1(2)*P2(2)*w1(2)
        x303 = P2(0)*co(1)*x137
        x304 = P1(3)*co(1)*x2
        x305 = P1(3)*co(0)*x29
        x306 = co(1)*w1(3)
        x307 = co(1)*w2(3)*x40
        x308 = 4*co(3)*x203
        x309 = 2*P1(3)*P2(2)*co(3)
        wout(0) = -P1(0)*P2(0)*x12*x52 - P1(0)*P2(0)*x56*x57 - P1(2)*P2(0)*co(0&
                  )*x258 + P1(3)*x165*x178 + P2(0)*x22 + P2(0)*x3 + co(0)*x30  &
                   + co(1)*w1(0)*x32 - co(1)*x30 - co(5)*x11 + co(5)*x6 + co(5 &
                  )*x9 + w2(0)*x251 + w2(0)*x253 - w2(0)*x256 + w2(0)*x41 - w2(&
                  0)*x46 - w2(0)*x49 - w2(0)*x50 - w2(0)*x51 + x1*x23 + x102*  &
                  x248 + x102*x249 - x103*x150 - x103*x153 - x106*x93 - x117*  &
                  x93 - x12*x14 + x12*x16 + x12*x18 + x12*x20 + x12*x239 - x120&
                  *x121 - x122*x71 - x122*x76 - x125*x126 - x128*x129 - x128*  &
                  x132 + x131*x244 - x133*x257 + x136*x205 + x136*x206 - x138* &
                  x60 + x139*x53 + x139*x54 - x139*x55 + x140*x21 + x140*x215  &
                   - x140*x243 - x140*x254 + x141*x21 + x141*x215 + x141*x241  &
                   - x141*x243 - x141*x254 + x142*x215 + x142*x241 - x142*x243 &
                   - x142*x254 + x143*x243 - x143*x255 + x144*x53 + x144*x54 - &
                  x144*x55 + x147*x236 + x15*x21 + x151*x238 + x151*x242 - x162&
                  *x85 + x165*x237 - x167*x260 - x172*x85 - x175*x176 - x177*  &
                  x178 - x178*x179 - x178*x180 - x178*x181 + x178*x210 + x178* &
                  x212 + x178*x217 + x182*x188 + x182*x193 + x188*x214 + x19*  &
                  x21 + x193*x214 + x194*x199 + x194*x204 + x199*x235 + x204*  &
                  x235 + x211*x28 + x213*x28 + x216*x80 + x217*x218 + x219*x220&
                   + x220*x240 + x221*x99 + x222*x99 + x226*x82 + x230*x82 +   &
                  x233*x234 + x235*x252 - x235*x259 + x244*x29 + x245*x246 +   &
                  x246*x247 + x250*x93 - x257*x38 - x257*x39 + x33*x35 + x33*  &
                  x37 - x35*x42 - x37*x42 - x42*x43 - x44*x45 - x47*x48 - x60* &
                  x61 - x62*x71 - x62*x76 - x77*x87 - x77*x92
        wout(1) = -P1(1)*P2(1)*co(1)*w1(1)*x131 + P1(1)*P2(1)*x187*x57 + P1(1)*&
                  P2(1)*x192*x52 + P1(1)*x261 + P1(1)*x282 - P1(2)*x268 - P1(2 &
                  )*x271 + P1(3)*P2(3)*w2(1)*x286 + P1(3)*x279 + P1(3)*x281 +  &
                  P2(1)*x22 + P2(1)*x3 - co(0)*w1(1)*x32 + co(5)*x189 + co(5)* &
                  x190 - co(5)*x191 + w1(1)*x264 + w1(1)*x29*x35 + w2(1)*x251  &
                   - w2(1)*x256 + w2(1)*x41 - w2(1)*x46 - w2(1)*x49 - w2(1)*x50&
                   - w2(1)*x51 - x101*x178 + x105*x178 - x106*x25 + x109*x274  &
                   + x109*x275 - x110*x178 + x112*x237 - x113*x178 - x115*x129 &
                   + x116*x178 - x117*x25 - x120*x270 - x124*x162 - x124*x172  &
                   - x126*x86 - x13*x262 - x130*x45 + x133*x284 - x133*x87 -   &
                  x133*x92 - x135*x260 + x136*x260 - x138*x91 + x139*x183 +    &
                  x139*x185 - x139*x186 - x14*x192 + x141*x188 + x141*x262 +   &
                  x141*x267 - x141*x283 - x141*x287 + x142*x188 + x142*x262 +  &
                  x142*x267 - x142*x283 - x142*x287 - x143*x188 - x143*x262 -  &
                  x143*x267 + x143*x283 + x144*x183 + x144*x185 - x144*x186 +  &
                  x146*x226 + x146*x230 + x148*x211 + x148*x213 - x150*x208 -  &
                  x153*x208 + x155*x221 + x155*x222 + x158*x205 + x158*x206 +  &
                  x16*x192 - x163*x289 - x163*x290 + x168*x257 - x173*x71 -    &
                  x173*x76 - x174*x71 - x174*x76 - x176*x272 - x178*x97 + x18* &
                  x192 - x182*x215 - x182*x269 + x19*x262 + x192*x20 + x199*   &
                  x231 + x199*x232 + x204*x231 + x204*x232 + x207*x248 + x207* &
                  x249 - x214*x215 - x214*x255 - x214*x269 - x214*x288 + x23*  &
                  x64 + x236*x83 + x238*x90 + x245*x285 + x247*x285 + x25*x250 &
                   - x260*x39 - x263*x266 + x263*x32 - x265*x35 - x265*x37 +   &
                  x273*x80 + x276*x88 + x277*x278 + x280*x88 - x48*x59
        wout(2) = P1(0)*P2(0)*w1(2)*x301 - P1(1)*P1(2)*P2(1)*co(1)*x2 - P1(1)* &
                  P2(1)*w1(2)*x301 + P1(1)*P2(1)*w2(2)*x286 + P1(1)*x115*x178  &
                   + P1(1)*x268 + P1(1)*x271 - P1(2)*P2(0)*w1(0)*x247 - P1(2)* &
                  P2(2)*x52*x75 - P1(2)*P2(2)*x57*x70 + P1(2)*x261 + P1(2)*x282&
                   - P1(2)*x294 - P1(3)*P2(3)*w1(2)*x301 + P1(3)*P2(3)*w2(2)*  &
                  x286 - P2(1)*co(4)*x7 + P2(2)*x3 - co(0)*x292 - co(1)*x24*   &
                  x258 + co(1)*x292 + co(4)*w1(0)*x89 - co(5)*x72 - co(5)*x73  &
                   + co(5)*x74 + w2(2)*x251 - w2(2)*x46 - w2(2)*x50 - x106*x145&
                   - x107*x248 - x107*x305 + x111*x257 - x117*x145 + x118*x199 &
                   + x118*x204 - x118*x304 + x119*x199 + x119*x204 - x122*x215 &
                   - x122*x269 - x125*x273 - x128*x274 - x128*x275 - x13*x291  &
                   + x13*x293 - x133*x290 + x134*x221 + x134*x222 + x136*x290  &
                   - x139*x63 - x139*x66 + x139*x69 + x14*x75 + x140*x291 -    &
                  x140*x71 + x142*x291 - x142*x297 - x142*x71 - x143*x291 +    &
                  x143*x297 + x143*x71 - x144*x63 - x144*x66 + x144*x69 - x149*&
                  x236 + x15*x291 - x15*x293 - x150*x95 - x152*x238 - x152*x242&
                   - x153*x95 - x154*x87 - x154*x92 + x155*x260 + x155*x284 -  &
                  x16*x75 - x162*x79 - x164*x260 - x172*x79 + x173*x188 + x173*&
                  x193 + x174*x188 + x174*x193 + x176*x300 + x178*x223 + x178* &
                  x224 - x178*x225 + x178*x227 + x178*x228 - x178*x229 - x178* &
                  x298 - x18*x75 + x19*x291 - x19*x293 - x20*x75 + x205*x98 +  &
                  x206*x98 + x211*x81 + x213*x81 - x215*x62 + x216*x86 - x218* &
                  x298 - x219*x296 + x226*x26 + x230*x26 + x233*x270 - x239*x75&
                   - x240*x296 + x247*x302 + x248*x94 + x249*x94 - x257*x99 +  &
                  x258*x37 + x258*x43 - x265*x278 - x269*x62 - x277*x37 - x295*&
                  x4 + x299*x91 - x301*x302 - x303*x81
        wout(3) = P1(0)*P2(0)*w1(3)*x301 + P1(1)*P2(1)*w2(3)*x286 - P1(1)*P2(1 &
                  )*x131*x306 - P1(1)*x112*x218 - P1(1)*x279 - P1(1)*x281 - P1(&
                  2)*P2(2)*w1(3)*x301 + P1(3)*P2(2)*w1(2)*x247 - P1(3)*P2(3)*w1&
                  (3)*x301 + P1(3)*P2(3)*x198*x57 + P1(3)*P2(3)*x203*x52 - P1(3&
                  )*x2*x35 + P1(3)*x261 - P1(3)*x294 + P2(3)*x22 + P2(3)*x3 +  &
                  co(5)*x200 + co(5)*x201 - co(5)*x202 + w1(3)*x264 + w2(3)*   &
                  x251 + w2(3)*x253 - w2(3)*x46 - w2(3)*x50 - x0*x295 + x102*  &
                  x205 + x102*x206 - x106*x123 - x108*x289 - x108*x290 + x114* &
                  x257 - x117*x123 - x118*x71 - x118*x76 + x121*x272 + x126*   &
                  x149 - x127*x260 + x129*x169 - x13*x252 + x13*x307 + x132*   &
                  x169 - x133*x248 - x135*x150 - x135*x153 + x135*x249 + x136* &
                  x248 + x138*x152 + x139*x195 + x139*x196 - x139*x197 - x14*  &
                  x203 + x140*x199 + x140*x252 - x140*x304 + x140*x308 + x141* &
                  x199 + x141*x252 - x141*x304 + x141*x308 - x143*x199 - x143* &
                  x252 - x143*x308 + x144*x195 + x144*x196 - x144*x197 + x147* &
                  x273 + x15*x252 - x15*x307 + x151*x276 + x151*x280 + x152*x61&
                   - x157*x178 + x16*x203 - x160*x178 + x161*x178 - x162*x27 + &
                  x165*x274 + x165*x275 - x166*x178 - x170*x178 + x171*x178 -  &
                  x172*x27 - x175*x270 + x18*x203 + x188*x231 + x188*x232 - x19&
                  *x307 + x193*x231 + x193*x232 - x194*x215 - x194*x269 + x20* &
                  x203 - x207*x87 - x207*x92 + x208*x260 + x208*x284 + x211*x84&
                   + x213*x84 - x215*x235 - x216*x83 + x221*x94 + x222*x94 +   &
                  x226*x78 + x23*x67 + x230*x78 - x234*x300 + x235*x254 - x235*&
                  x255 - x235*x269 - x235*x288 - x259*x36 - x266*x306 + x29*   &
                  x306*x34 - x299*x90 - x303*x84 + x305*x38 + x306*x32 - x309* &
                  x70 - x309*x75 - x45*x58
      case(VVV13)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1
!       ,3))
!       c2*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,2)*P(1,3))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(0)*co(2)*(P1(1)*x0 - P1(2)*x2 + P1(3)*x1)
        x4 = P2(0)*co(2)*(P2(1)*x0 - P2(2)*x2 + P2(3)*x1)
        x5 = w1(0)*w2(1) - w1(1)*w2(0)
        x6 = w1(0)*w2(3) - w1(3)*w2(0)
        x7 = P2(2)*co(2)*(P1(0)*x2 - P1(1)*x6 + P1(3)*x5)
        x8 = P2(0)*x2 - P2(1)*x6 + P2(3)*x5
        x9 = P2(2)*co(2)*x8
        x10 = P2(1)**2
        x11 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x12 = co(1)*x10*x11
        x13 = P2(2)**2
        x14 = P1(0)*co(1)*x11
        x15 = P2(3)**2
        x16 = P2(2)*w2(3)
        x17 = P2(3)*w2(2)
        x18 = x16 - x17
        x19 = P1(1)*w1(1)
        x20 = P1(2)*w1(2)
        x21 = P1(3)*w1(3)
        x22 = P1(0)*w1(0)
        x23 = x19 + x20 + x21 - x22
        x24 = P1(1)*co(2)*x23
        x25 = P2(1)*w1(1)
        x26 = P2(2)*w1(2)
        x27 = P2(3)*w1(3)
        x28 = P2(0)*w1(0)
        x29 = x25 + x26 + x27 - x28
        x30 = P1(1)*co(2)*x29
        x31 = P2(1)*w2(2)
        x32 = P2(2)*w2(1)
        x33 = x31 - x32
        x34 = co(2)*x23*x33
        x35 = P1(3)*co(2)*x29
        x36 = P2(0)**2
        x37 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x38 = co(0)*x37
        x39 = w1(0)*w2(2) - w1(2)*w2(0)
        x40 = P1(0)*x0 - P1(2)*x6 + P1(3)*x39
        x41 = P1(0)*P2(1)*co(2)
        x42 = P2(0)*x0 - P2(2)*x6 + P2(3)*x39
        x43 = P1(0)*x1 - P1(1)*x39 + P1(2)*x5
        x44 = P1(0)*P2(3)*co(2)
        x45 = P2(0)*x1 - P2(1)*x39 + P2(2)*x5
        x46 = P2(1)*w2(3)
        x47 = P2(3)*w2(1)
        x48 = x46 - x47
        x49 = co(2)*x23*x48
        x50 = co(2)*x29*x48
        x51 = co(1)*x11
        x52 = P1(1)*P2(1)*co(1)*x11
        x53 = P1(0)*P1(2)*co(1)*x11
        x54 = P1(3)*P2(3)
        x55 = P2(3)*w2(3)
        x56 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + x55
        x57 = co(0)*x56
        x58 = P2(1)*w2(0)
        x59 = P1(1)*co(1)*x23
        x60 = P1(1)*co(1)*x29
        x61 = P2(2)*w2(0)
        x62 = P1(2)*co(1)*x23
        x63 = P1(2)*co(1)*x29
        x64 = P2(3)*w2(0)
        x65 = P1(3)*co(1)*x23
        x66 = P1(3)*co(1)*x29
        x67 = co(1)*x23
        x68 = P1(0)*P2(0)*w2(0)
        x69 = co(1)*x29
        x70 = P2(1)*co(0)*w1(1)*x37
        x71 = P1(0)*P2(2)*w1(2)
        x72 = P2(3)*co(0)*w1(3)*x37
        x73 = P2(3)*co(0)*w1(3)*x56
        x74 = P2(0)*co(0)*x37
        x75 = co(2)*x23
        x76 = P1(0)*x18
        x77 = co(2)*x29
        x78 = P1(1)*co(1)*x11
        x79 = P2(0)*w2(2)
        x80 = -x61 + x79
        x81 = P1(3)*co(2)*x23
        x82 = P2(1)*co(2)*x40
        x83 = P2(1)*co(2)*x42
        x84 = P2(3)*co(2)*x43
        x85 = P2(3)*co(2)*x45
        x86 = P2(0)*w2(3)
        x87 = -x64 + x86
        x88 = co(2)*x23*x87
        x89 = P1(2)*co(2)*x29
        x90 = P2(1)*co(0)*x37
        x91 = P1(1)*P2(0)*w1(0)
        x92 = P1(1)*P2(1)*w2(1)
        x93 = P2(0)*co(0)*w1(0)*x37
        x94 = P2(0)*w2(1)
        x95 = P1(0)*co(1)*x23
        x96 = P1(0)*co(1)*x29
        x97 = P1(1)*P2(1)*w1(1)
        x98 = P1(1)*co(0)*x37
        x99 = 2*co(0)*x37
        x100 = P1(2)*co(1)*x11
        x101 = -x58 + x94
        x102 = P2(2)*co(0)*x37
        x103 = P1(2)*co(0)*x56
        x104 = P1(2)*P2(2)*w2(2)
        x105 = P1(3)*co(1)*x11
        x106 = P1(3)*P2(3)*co(2)
        x107 = P2(3)*co(0)*x37
        x108 = P1(3)*co(0)*x56
        x109 = P1(3)*co(0)*x37
        wout(0) = -P1(0)**2*P2(0)*x51 + P1(0)*P2(0)*w1(0)*x57 - P1(0)*P2(1)*w1(&
                  1)*x57 + 2*P1(0)*w1(0)*x74 + P1(0)*x12 + P1(0)*x3 + P1(0)*x4 &
                   + P1(0)*x52 + P1(0)*x7 - P1(0)*x70 - P1(0)*x72 - P1(0)*x73  &
                   + P1(0)*x9 - P1(2)*x49 - P1(2)*x50 + P1(3)*x34 + P2(2)*x53  &
                   + w1(0)*x36*x38 + x13*x14 + x14*x15 - x14*x36 + x14*x54 +   &
                  x18*x24 + x18*x30 - x19*x74 - x20*x74 - x21*x74 - x25*x74 -  &
                  x26*x74 - x27*x74 + x33*x35 - x38*x71 - x40*x41 - x41*x42 -  &
                  x43*x44 - x44*x45 - x57*x71 + x58*x59 + x58*x60 + x61*x62 +  &
                  x61*x63 + x64*x65 + x64*x66 - x67*x68 - x68*x69
        wout(1) = -P1(0)*P2(0)*x78 + P1(1)**2*P2(1)*x51 - P1(1)*P2(2)*w1(2)*x57&
                   + P1(1)*x12 + P1(1)*x3 + P1(1)*x4 + P1(1)*x7 - P1(1)*x73 -  &
                  P1(1)*x82 - P1(1)*x83 - P1(1)*x84 - P1(1)*x85 + P1(1)*x9 + P1&
                  (2)*P2(2)*x78 - P1(2)*x88 + P2(1)*x93 - w1(1)*x10*x38 + x13* &
                  x78 + x15*x78 - x20*x90 - x21*x90 + x22*x90 - x26*x90 - x26* &
                  x98 - x27*x90 - x27*x98 + x32*x62 + x32*x63 + x35*x80 - x36* &
                  x78 + x38*x91 + x47*x65 + x47*x66 + x54*x78 + x57*x91 - x57* &
                  x97 + x67*x92 + x69*x92 + x75*x76 + x76*x77 + x80*x81 - x87* &
                  x89 - x94*x95 - x94*x96 - x97*x99
        wout(2) = -P1(0)*x49 - P1(0)*x50 + P1(1)*x88 + P1(2)**2*P2(2)*x51 - P1(&
                  2)*P2(2)*w1(2)*x99 + P1(2)*x12 + P1(2)*x3 + P1(2)*x4 + P1(2)*&
                  x52 + P1(2)*x7 - P1(2)*x70 - P1(2)*x72 - P1(2)*x73 - P1(2)*  &
                  x82 - P1(2)*x83 - P1(2)*x84 - P1(2)*x85 + P1(2)*x9 + P1(2)*  &
                  x93 - P2(0)*x53 - w1(2)*x13*x38 + x100*x13 + x100*x15 - x100*&
                  x36 + x100*x54 - x101*x35 - x101*x81 - x102*x19 - x102*x21 + &
                  x102*x22 - x102*x25 - x102*x27 + x102*x28 - x103*x25 - x103* &
                  x26 + x103*x28 + x104*x67 + x104*x69 + x17*x65 + x17*x66 +   &
                  x30*x87 + x31*x59 + x31*x60 - x79*x95 - x79*x96
        wout(3) = P1(0)*x33*x77 + P1(0)*x34 + P1(2)*x101*x75 + P1(3)**2*P2(3)* &
                  x51 - P1(3)*P2(0)*x14 + P1(3)*P2(2)*co(2)*x8 + P1(3)*P2(2)*  &
                  x100 + P1(3)*x12 + P1(3)*x3 + P1(3)*x4 + P1(3)*x52 + P1(3)*x7&
                   - P1(3)*x73 - P1(3)*x82 - P1(3)*x83 + P1(3)*x93 - 2*P2(3)*w1&
                  (3)*x109 - w1(3)*x15*x38 + x101*x89 + x105*x13 + x105*x15 -  &
                  x105*x36 - x106*x43 - x106*x45 - x107*x19 - x107*x20 + x107* &
                  x22 - x107*x25 - x107*x26 + x107*x28 - x108*x25 - x108*x26 + &
                  x108*x28 - x109*x25 - x109*x26 + x16*x62 + x16*x63 - x24*x80 &
                   - x30*x80 + x46*x59 + x46*x60 + x55*x65 + x55*x66 - x86*x95 &
                   - x86*x96
      case(VVV14)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       c2*(-Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,2)*P(-1,
!       2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) + Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
!       c4*(Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1
!       )*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(3)*x4
        x6 = P1(1)**2
        x7 = co(3)*x6
        x8 = P1(2)**2
        x9 = co(3)*x8
        x10 = P1(3)**2
        x11 = co(3)*x10
        x12 = P1(0)*P2(0)
        x13 = co(3)*x3
        x14 = P1(0)*x2
        x15 = w1(0)*w2(1) - w1(1)*w2(0)
        x16 = P1(3)*x15
        x17 = w1(0)*w2(3) - w1(3)*w2(0)
        x18 = P1(1)*x17
        x19 = x14 + x16 - x18
        x20 = P1(0)*P2(2)*co(3)
        x21 = P2(0)*x2 - P2(1)*x17 + P2(3)*x15
        x22 = co(3)*x21
        x23 = P1(0)*w1(0)
        x24 = P1(2)*w2(3)
        x25 = P1(3)*w2(2)
        x26 = x24 - x25
        x27 = P1(1)*w2(2)
        x28 = P1(2)*w2(1)
        x29 = x27 - x28
        x30 = P1(1)*w2(3)
        x31 = P1(3)*w2(1)
        x32 = x30 - x31
        x33 = co(2)*(P2(1)*x26 - P2(2)*x32 + P2(3)*x29)
        x34 = P2(2)*w2(3) - P2(3)*w2(2)
        x35 = P2(1)*w2(2) - P2(2)*w2(1)
        x36 = P2(1)*w2(3)
        x37 = P2(3)*w2(1)
        x38 = x36 - x37
        x39 = co(2)*(P2(1)*x34 - P2(2)*x38 + P2(3)*x35)
        x40 = P1(0)*x0
        x41 = w1(0)*w2(2) - w1(2)*w2(0)
        x42 = P1(3)*x41
        x43 = P1(2)*x17
        x44 = x40 + x42 - x43
        x45 = co(3)*x44
        x46 = P1(1)*P2(0)
        x47 = P2(0)*x0 - P2(2)*x17 + P2(3)*x41
        x48 = co(3)*x47
        x49 = P1(1)*w2(0)
        x50 = P1(2)*w1(3)
        x51 = P1(3)*w1(2)
        x52 = x50 - x51
        x53 = P2(0)*x52
        x54 = P1(0)*w1(2)
        x55 = P1(2)*w1(0)
        x56 = x54 - x55
        x57 = P2(3)*x56
        x58 = P1(0)*w1(3)
        x59 = P1(3)*w1(0)
        x60 = x58 - x59
        x61 = P2(2)*x60
        x62 = co(2)*(x53 + x57 - x61)
        x63 = P2(2)*w1(3)
        x64 = P2(3)*w1(2)
        x65 = x63 - x64
        x66 = P2(0)*x65
        x67 = P2(2)*w1(0)
        x68 = P2(0)*w1(2) - x67
        x69 = P2(3)*x68
        x70 = P2(3)*w1(0)
        x71 = P2(0)*w1(3) - x70
        x72 = P2(2)*x71
        x73 = co(2)*(x66 + x69 - x72)
        x74 = P1(1)*x34
        x75 = P1(1)*w1(1)
        x76 = P1(2)*w1(2)
        x77 = P1(3)*w1(3)
        x78 = -x23 + x75 + x76 + x77
        x79 = P2(2)*w1(2)
        x80 = P2(3)*w1(3)
        x81 = -P2(0)*w1(0) + P2(1)*w1(1) + x79 + x80
        x82 = P1(1)*x0
        x83 = P2(1)**2
        x84 = P2(2)**2
        x85 = P2(3)**2
        x86 = P2(0)**2
        x87 = co(3)*(x83 + x84 + x85 - x86)
        x88 = P1(1)*P2(1)
        x89 = P1(2)*P2(2)
        x90 = P1(3)*P2(3)
        x91 = co(3)*(-x12 + x88 + x89 + x90)
        x92 = P1(1)*co(4)*x81
        x93 = P1(0)*w2(1)
        x94 = -x49 + x93
        x95 = P1(0)*w2(3)
        x96 = P1(3)*w2(0)
        x97 = x95 - x96
        x98 = co(2)*(P2(0)*x32 - P2(1)*x97 + P2(3)*x94)
        x99 = P2(0)*w2(1) - P2(1)*w2(0)
        x100 = P2(3)*w2(0)
        x101 = P2(0)*w2(3) - x100
        x102 = co(2)*(P2(0)*x38 - P2(1)*x101 + P2(3)*x99)
        x103 = P2(3)*w1(1)
        x104 = P2(1)*w1(3) - x103
        x105 = P1(1)*w2(1)
        x106 = P1(2)*w2(2)
        x107 = P1(3)*w2(3)
        x108 = P1(0)*w2(0)
        x109 = x105 + x106 + x107 - x108
        x110 = P1(2)*co(3)*x109
        x111 = P2(1)*w2(1)
        x112 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x111
        x113 = P1(2)*co(3)*x112
        x114 = P1(3)*P2(0)
        x115 = P1(0)*x1
        x116 = P1(2)*x15
        x117 = P1(1)*x41
        x118 = x115 + x116 - x117
        x119 = co(3)*x118
        x120 = P2(0)*x1 - P2(1)*x41 + P2(2)*x15
        x121 = co(3)*x120
        x122 = P1(1)*w1(2)
        x123 = P1(2)*w1(1)
        x124 = x122 - x123
        x125 = P2(0)*x124
        x126 = P1(0)*w1(1)
        x127 = P1(1)*w1(0)
        x128 = x126 - x127
        x129 = P2(2)*x128
        x130 = P2(1)*x56
        x131 = co(2)*(x125 + x129 - x130)
        x132 = P2(1)*w1(2)
        x133 = P2(2)*w1(1)
        x134 = x132 - x133
        x135 = P2(0)*x134
        x136 = P2(0)*w1(1)
        x137 = P2(1)*w1(0)
        x138 = x136 - x137
        x139 = P2(2)*x138
        x140 = P2(1)*x68
        x141 = co(2)*(x135 + x139 - x140)
        x142 = P1(3)*co(3)*x78
        x143 = P1(3)*co(3)*x81
        x144 = P1(3)*x1
        x145 = P1(3)*co(4)*x81
        x146 = P2(1)*x52
        x147 = co(4)*x109
        x148 = P2(1)*x65
        x149 = P2(3)*x124
        x150 = P2(3)*x134
        x151 = w1(0)*x109*x86
        x152 = co(1)*w1(0)*x109
        x153 = co(1)*x85
        x154 = co(1)*x6*x81
        x155 = co(1)*x8*x81
        x156 = co(1)*x10*x81
        x157 = P1(0)*P2(1)*co(3)
        x158 = P2(1)*co(3)*x47
        x159 = P1(0)*P2(3)*co(3)
        x160 = P1(1)*w1(3)
        x161 = P1(3)*w1(1)
        x162 = x160 - x161
        x163 = P2(2)*x162
        x164 = co(2)*(x146 + x149 - x163)
        x165 = P2(2)*x104
        x166 = co(2)*(x148 + x150 - x165)
        x167 = P1(0)*w2(2)
        x168 = P1(2)*w2(0)
        x169 = x167 - x168
        x170 = co(2)*(P2(0)*x26 - P2(2)*x97 + P2(3)*x169)
        x171 = P2(0)*w2(2) - P2(2)*w2(0)
        x172 = co(2)*(P2(0)*x34 - P2(2)*x101 + P2(3)*x171)
        x173 = co(3)*x109
        x174 = P1(1)*x65
        x175 = co(3)*x112
        x176 = P1(2)*co(3)*x19
        x177 = P1(2)*co(3)*x21
        x178 = P2(0)*x162
        x179 = P2(3)*x128
        x180 = P2(1)*x60
        x181 = co(2)*(x178 + x179 - x180)
        x182 = P2(0)*x104
        x183 = P2(3)*x138
        x184 = P2(1)*x71
        x185 = co(2)*(x182 + x183 - x184)
        x186 = P1(2)*co(3)*x78
        x187 = P1(2)*co(3)*x81
        x188 = P1(2)*x2
        x189 = P1(2)*co(4)*x81
        x190 = co(2)*(P2(0)*x29 - P2(1)*x169 + P2(2)*x94)
        x191 = co(2)*(P2(0)*x35 - P2(1)*x171 + P2(2)*x99)
        x192 = P1(3)*x134
        x193 = co(1)*x4*x81
        x194 = co(0)*x112
        x195 = co(1)*x81
        x196 = P1(2)*P2(2)*co(1)*x81
        x197 = P1(3)*co(1)*x81
        x198 = P1(0)*P2(0)*co(1)*x81
        x199 = P2(1)*co(0)*x109
        x200 = P2(1)*co(0)*x112
        x201 = co(0)*x109
        x202 = P1(0)*P2(2)*w1(2)
        x203 = P2(3)*co(0)*x109
        x204 = P2(3)*co(0)*x112
        x205 = P2(0)*co(0)*x109
        x206 = 2*co(0)
        x207 = P1(0)*co(3)*x78
        x208 = P1(0)*co(3)*x81
        x209 = P1(0)*co(4)*x81
        x210 = x144 - x188 + x82
        x211 = co(3)*x210
        x212 = P1(1)*P2(2)
        x213 = co(3)*x19
        x214 = P1(3)*P2(1)
        x215 = w1(1)*x109*x83
        x216 = co(1)*w1(1)*x109
        x217 = w1(1)*x109
        x218 = P1(0)*co(3)*x109
        x219 = P1(0)*co(3)*x112
        x220 = P1(1)*P2(3)
        x221 = P1(2)*P2(1)
        x222 = P1(3)*x68
        x223 = co(1)*x86
        x224 = P1(1)*P2(0)*w1(0)
        x225 = P1(1)*co(1)*x81
        x226 = P2(2)*co(0)*x109
        x227 = P1(2)*co(0)*x109
        x228 = P1(1)*co(3)*x78
        x229 = P1(1)*co(3)*x81
        x230 = P1(2)*P2(0)
        x231 = P1(3)*P2(2)
        x232 = P1(3)*x138
        x233 = co(1)*w1(2)*x109
        x234 = w1(2)*x109*x84
        x235 = w1(2)*x109
        x236 = co(1)*w2(2)*x81
        x237 = P1(1)*x71
        x238 = P1(2)*P2(3)
        x239 = co(1)*x109
        x240 = P2(0)*co(0)*x112
        x241 = P2(0)*co(1)*x81
        x242 = P1(3)*co(0)*x109
        x243 = P1(0)*co(3)*x35
        x244 = P1(1)*x68
        x245 = co(1)*w1(3)*x109
        x246 = w1(3)*x109
        x247 = co(1)*w2(3)*x81
        wout(0) = P1(0)*P2(0)*w1(0)*x109*x206 + P1(0)*P2(0)*w1(0)*x194 + P1(0)*&
                  P2(2)*x22 - P1(0)*x158 + P1(1)*P2(1)*w2(0)*x195 - P2(0)*x176 &
                   - P2(0)*x177 + co(0)*x151 - co(1)*x151 + co(3)*x74*x78 + co(&
                  3)*x74*x81 + w1(0)*x109*x153 + w2(0)*x154 + w2(0)*x155 + w2(0&
                  )*x156 - w2(0)*x193 + w2(0)*x196 - w2(0)*x198 + x100*x197 +  &
                  x102*x55 + x104*x110 + x104*x113 - x108*x164 - x108*x166 -   &
                  x11*x3 + x114*x119 + x114*x121 - x118*x159 + x12*x13 - x12*  &
                  x152 - x120*x159 - x126*x199 - x126*x200 - x127*x170 - x127* &
                  x172 - x13*x88 - x13*x89 - x13*x90 + x131*x96 - x136*x199 +  &
                  x141*x96 + x142*x35 + x143*x35 + x144*x87 + x144*x91 + x145* &
                  x29 + x145*x35 + x146*x147 + x147*x148 + x147*x149 + x147*   &
                  x150 - x147*x163 - x147*x165 + x152*x83 + x152*x84 + x152*x88&
                   + x152*x89 + x152*x90 - x157*x44 - x168*x181 - x168*x185 -  &
                  x173*x174 - x173*x192 - x174*x175 - x175*x192 - x186*x38 -   &
                  x187*x38 - x188*x87 - x188*x91 - x189*x32 - x189*x38 + x19*  &
                  x20 - x190*x59 - x191*x59 - x194*x202 - x201*x202 - x203*x58 &
                   - x204*x58 - x205*x75 - x205*x76 - x205*x77 - x205*x79 -    &
                  x205*x80 + x23*x33 + x23*x39 + x26*x92 + x3*x5 - x3*x7 - x3* &
                  x9 + x34*x92 + x45*x46 + x46*x48 + x49*x62 + x49*x73 + x55*  &
                  x98 + x82*x87 + x82*x91
        wout(1) = -P1(1)*P2(1)*w1(1)*x109*x206 - P1(1)*P2(1)*w1(1)*x194 - P1(1 &
                  )*P2(2)*w1(2)*x194 - P2(1)*x177 - co(0)*x215 + co(1)*x215 +  &
                  w2(1)*x154 + w2(1)*x155 + w2(1)*x156 - w2(1)*x193 + w2(1)*   &
                  x196 - w2(1)*x198 - x101*x186 - x101*x187 - x101*x189 + x102*&
                  x123 + x105*x62 + x105*x73 - x11*x47 + x110*x71 + x111*x225  &
                   + x113*x71 + x119*x214 - x119*x220 - x12*x216 + x12*x48 +   &
                  x121*x214 - x121*x220 - x122*x226 + x123*x98 + x126*x33 +    &
                  x126*x39 + x13*x46 + x131*x31 - x132*x226 - x132*x227 + x137*&
                  x205 + x141*x31 + x142*x171 + x143*x171 + x145*x169 + x145*  &
                  x171 + x147*x53 + x147*x57 - x147*x61 + x147*x66 + x147*x69  &
                   - x147*x72 + x153*x217 - x157*x210 - x157*x3 - x160*x203 -  &
                  x160*x204 - x161*x190 - x161*x191 - x164*x93 - x166*x93 -    &
                  x170*x75 - x172*x75 - x173*x222 - x175*x222 - x181*x28 - x185&
                  *x28 - x189*x97 + x194*x224 + x197*x37 + x199*x23 - x199*x77 &
                   - x199*x80 + x201*x224 + x207*x34 + x208*x34 + x209*x26 +   &
                  x209*x34 + x211*x46 + x212*x213 + x212*x22 - x213*x221 + x216&
                  *x84 + x216*x88 + x216*x89 + x216*x90 - x217*x223 - x218*x65 &
                   - x219*x65 + x40*x87 + x40*x91 + x42*x87 + x42*x91 - x43*x87&
                   - x43*x91 + x47*x5 - x47*x7 - x47*x9 - x48*x88 - x48*x89 -  &
                  x48*x90
        wout(2) = P1(1)*P2(1)*w1(2)*x239 - P1(2)*P2(2)*w1(2)*x109*x206 - P1(2)*&
                  P2(2)*w1(2)*x194 - P1(2)*x158 + P1(3)*P2(3)*w1(2)*x239 + P1(3&
                  )*P2(3)*w2(2)*x195 - co(0)*x234 + co(1)*x234 + w2(2)*x155 +  &
                  x10*x236 + x101*x228 + x101*x229 + x101*x92 + x102*x76 + x104&
                  *x218 + x104*x219 - x106*x181 - x106*x185 + x11*x21 + x119*  &
                  x231 - x119*x238 - x12*x22 - x12*x233 + x121*x231 - x121*x238&
                   - x122*x170 - x122*x172 - x123*x199 - x123*x200 + x13*x230  &
                   + x131*x25 - x133*x199 - x14*x87 - x14*x91 + x141*x25 - x142&
                  *x99 - x143*x99 - x145*x94 - x145*x99 - x147*x178 - x147*x179&
                   + x147*x180 - x147*x182 - x147*x183 + x147*x184 + x153*x235 &
                   - x16*x87 - x16*x91 - x164*x167 - x166*x167 - x167*x241 +   &
                  x173*x232 - x173*x237 + x175*x232 - x175*x237 + x18*x87 + x18&
                  *x91 - x190*x51 - x191*x51 - x20*x210 - x20*x3 - x203*x50 -  &
                  x203*x63 - x204*x50 + x205*x55 + x205*x67 - x207*x38 - x208* &
                  x38 - x209*x32 - x209*x38 - x21*x5 + x21*x7 + x21*x9 + x211* &
                  x230 + x212*x45 + x212*x48 + x22*x88 + x22*x89 + x22*x90 -   &
                  x221*x45 - x223*x235 + x226*x23 - x226*x75 + x233*x83 + x233*&
                  x89 - x236*x4 + x236*x6 + x236*x88 + x236*x89 + x240*x55 -   &
                  x242*x63 + x27*x62 + x27*x73 + x33*x54 + x39*x54 + x76*x98 + &
                  x92*x97
        wout(3) = -P1(0)*P2(0)*w1(3)*x239 - P1(1)*P2(3)*w1(1)*x201 + P1(2)*P2(2&
                  )*w1(3)*x239 - P1(3)*P2(2)*w1(2)*x194 + P1(3)*P2(3)*w1(3)*   &
                  x239 - 2*P1(3)*w1(3)*x203 - P1(3)*x158 - P2(3)*x176 - P2(3)* &
                  x177 - co(0)*x246*x85 + w2(3)*x155 + x10*x247 + x102*x50 -   &
                  x103*x199 + x107*x131 + x107*x141 - x11*x120 - x110*x138 -   &
                  x113*x138 + x114*x13 + x114*x211 + x115*x87 + x115*x91 + x116&
                  *x87 + x116*x91 - x117*x87 - x117*x91 + x12*x121 + x120*x5 - &
                  x120*x7 - x120*x9 - x121*x88 - x121*x89 - x121*x90 + x125*   &
                  x147 + x129*x147 - x130*x147 - x134*x218 - x134*x219 + x135* &
                  x147 + x139*x147 - x140*x147 + x153*x246 - x159*x210 - x159* &
                  x3 - x160*x170 - x160*x172 - x161*x199 - x161*x200 - x164*x95&
                   - x166*x95 - x169*x92 - x171*x228 - x171*x229 - x171*x92 +  &
                  x173*x244 + x175*x244 - x181*x24 - x185*x24 + x186*x99 + x187&
                  *x99 + x189*x94 + x189*x99 - x190*x77 - x191*x77 + x203*x23  &
                   - x204*x77 + x205*x59 + x205*x70 + x209*x29 + x209*x35 +    &
                  x213*x231 - x214*x45 + x22*x231 + x220*x45 + x220*x48 + x225*&
                  x36 - x226*x64 - x227*x64 + x240*x59 - x241*x95 - x242*x79 + &
                  x243*x78 + x243*x81 + x245*x83 + x245*x84 - x245*x86 + x245* &
                  x88 - x247*x4 + x247*x6 + x247*x89 + x247*x90 + x30*x62 + x30&
                  *x73 + x33*x58 + x39*x58 + x50*x98
      case(VVV15)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) + Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) + Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(-Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,2)*P(-1,
!       2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) + Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) - Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(3)*x4
        x6 = P1(2)**2
        x7 = co(3)*x6
        x8 = P1(3)**2
        x9 = co(3)*x8
        x10 = P1(0)**2
        x11 = co(3)*x10
        x12 = P1(0)*x2
        x13 = w1(0)*w2(1) - w1(1)*w2(0)
        x14 = P1(3)*x13
        x15 = w1(0)*w2(3) - w1(3)*w2(0)
        x16 = P1(1)*x15
        x17 = x12 + x14 - x16
        x18 = P1(0)*P2(2)*co(3)
        x19 = P2(0)*x2 - P2(1)*x15 + P2(3)*x13
        x20 = P2(1)**2
        x21 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x22 = co(1)*x20*x21
        x23 = P2(2)**2
        x24 = co(1)*x21*x23
        x25 = P2(3)**2
        x26 = co(1)*x21*x25
        x27 = P1(0)*w1(0)
        x28 = P1(2)*w2(3)
        x29 = P1(3)*w2(2)
        x30 = x28 - x29
        x31 = P1(1)*w2(2)
        x32 = P1(2)*w2(1)
        x33 = x31 - x32
        x34 = P1(1)*w2(3)
        x35 = P1(3)*w2(1)
        x36 = x34 - x35
        x37 = co(2)*(P2(1)*x30 - P2(2)*x36 + P2(3)*x33)
        x38 = P2(2)*w2(3) - P2(3)*w2(2)
        x39 = P2(1)*w2(2) - P2(2)*w2(1)
        x40 = P2(1)*w2(3)
        x41 = P2(3)*w2(1)
        x42 = x40 - x41
        x43 = co(2)*(P2(1)*x38 - P2(2)*x42 + P2(3)*x39)
        x44 = P1(0)*x0
        x45 = w1(0)*w2(2) - w1(2)*w2(0)
        x46 = P1(3)*x45
        x47 = P1(2)*x15
        x48 = x44 + x46 - x47
        x49 = P1(1)*P2(0)*co(3)
        x50 = P2(0)*x0 - P2(2)*x15 + P2(3)*x45
        x51 = co(3)*x50
        x52 = P1(1)*P2(0)
        x53 = P1(1)*P2(1)
        x54 = co(3)*x3
        x55 = P1(1)*w2(0)
        x56 = P1(2)*w1(3)
        x57 = P1(3)*w1(2)
        x58 = x56 - x57
        x59 = P1(0)*w1(2)
        x60 = P1(2)*w1(0)
        x61 = x59 - x60
        x62 = P1(0)*w1(3)
        x63 = P1(3)*w1(0)
        x64 = x62 - x63
        x65 = P2(0)*x58 - P2(2)*x64 + P2(3)*x61
        x66 = co(2)*x65
        x67 = P2(2)*w1(3)
        x68 = P2(3)*w1(2)
        x69 = x67 - x68
        x70 = P2(2)*w1(0)
        x71 = P2(0)*w1(2) - x70
        x72 = P2(3)*w1(0)
        x73 = P2(0)*w1(3) - x72
        x74 = P2(0)*x69 - P2(2)*x73 + P2(3)*x71
        x75 = co(2)*x74
        x76 = P1(1)*w1(1)
        x77 = P1(2)*w1(2)
        x78 = P1(3)*w1(3)
        x79 = -x27 + x76 + x77 + x78
        x80 = P1(1)*co(3)*x38
        x81 = P2(2)*w1(2)
        x82 = P2(3)*w1(3)
        x83 = P2(0)*w1(0)
        x84 = P2(1)*w1(1) + x81 + x82 - x83
        x85 = P1(2)*P2(2)
        x86 = P1(0)*w2(1)
        x87 = -x55 + x86
        x88 = P1(0)*w2(3)
        x89 = P1(3)*w2(0)
        x90 = x88 - x89
        x91 = co(2)*(P2(0)*x36 - P2(1)*x90 + P2(3)*x87)
        x92 = P2(0)*w2(1) - P2(1)*w2(0)
        x93 = P2(3)*w2(0)
        x94 = P2(0)*w2(3) - x93
        x95 = co(2)*(P2(0)*x42 - P2(1)*x94 + P2(3)*x92)
        x96 = P2(3)*w1(1)
        x97 = P2(1)*w1(3) - x96
        x98 = P1(2)*w2(2)
        x99 = P1(3)*w2(3)
        x100 = P1(0)*w2(0)
        x101 = P1(1)*w2(1) - x100 + x98 + x99
        x102 = P1(2)*co(3)*x101
        x103 = P2(1)*w2(1)
        x104 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x103
        x105 = P1(2)*co(3)*x104
        x106 = P1(2)*x2
        x107 = P2(0)**2
        x108 = co(3)*(-x107 + x20 + x23 + x25)
        x109 = P1(3)*P2(3)
        x110 = P1(0)*P2(0)
        x111 = co(3)*(x109 - x110 + x53 + x85)
        x112 = P1(3)*P2(0)
        x113 = P1(0)*x1
        x114 = P1(2)*x13
        x115 = P1(1)*x45
        x116 = x113 + x114 - x115
        x117 = co(3)*x116
        x118 = P2(0)*x1 - P2(1)*x45 + P2(2)*x13
        x119 = co(3)*x118
        x120 = P1(1)*w1(2)
        x121 = P1(2)*w1(1)
        x122 = x120 - x121
        x123 = P1(0)*w1(1)
        x124 = P1(1)*w1(0)
        x125 = x123 - x124
        x126 = co(2)*(P2(0)*x122 - P2(1)*x61 + P2(2)*x125)
        x127 = P2(1)*w1(2)
        x128 = P2(2)*w1(1)
        x129 = x127 - x128
        x130 = P2(0)*w1(1)
        x131 = P2(1)*w1(0)
        x132 = x130 - x131
        x133 = co(2)*(P2(0)*x129 - P2(1)*x71 + P2(2)*x132)
        x134 = P1(3)*co(3)*x79
        x135 = P1(3)*co(3)*x84
        x136 = P2(0)*co(1)*x21
        x137 = co(1)*x21*x6
        x138 = w1(0)*x101*x107
        x139 = co(1)*x10*x84
        x140 = P2(1)*x48
        x141 = P2(1)*co(3)*x50
        x142 = P1(0)*P2(3)*co(3)
        x143 = P1(1)*w1(3)
        x144 = P1(3)*w1(1)
        x145 = x143 - x144
        x146 = co(2)*(P2(1)*x58 - P2(2)*x145 + P2(3)*x122)
        x147 = co(2)*(P2(1)*x69 - P2(2)*x97 + P2(3)*x129)
        x148 = P1(0)*w2(2)
        x149 = P1(2)*w2(0)
        x150 = x148 - x149
        x151 = co(2)*(P2(0)*x30 - P2(2)*x90 + P2(3)*x150)
        x152 = P2(0)*w2(2) - P2(2)*w2(0)
        x153 = co(2)*(P2(0)*x38 - P2(2)*x94 + P2(3)*x152)
        x154 = P1(1)*co(3)*x101
        x155 = P1(1)*co(3)*x104
        x156 = P1(1)*x0
        x157 = P1(2)*co(3)*x17
        x158 = P1(2)*co(3)*x19
        x159 = co(2)*(P2(0)*x145 - P2(1)*x64 + P2(3)*x125)
        x160 = co(2)*(P2(0)*x97 - P2(1)*x73 + P2(3)*x132)
        x161 = P1(2)*co(3)*x79
        x162 = P1(2)*co(3)*x84
        x163 = co(2)*(P2(0)*x33 - P2(1)*x150 + P2(2)*x87)
        x164 = co(2)*(P2(0)*x39 - P2(1)*x152 + P2(2)*x92)
        x165 = P1(3)*co(3)*x129
        x166 = P1(3)*x1
        x167 = w1(0)*x101
        x168 = co(1)*x20
        x169 = co(1)*x23
        x170 = co(1)*x25
        x171 = co(1)*x4*x84
        x172 = co(1)*x6*x84
        x173 = co(1)*x8*x84
        x174 = co(1)*x107*x21
        x175 = P1(1)*P2(1)*co(1)*x21
        x176 = P1(2)*P2(2)*co(1)*x21
        x177 = P1(3)*P2(3)*co(1)*x21
        x178 = co(0)*x104
        x179 = co(1)*w1(0)*x104
        x180 = co(1)*x79
        x181 = P1(2)*P2(2)*co(1)*x79
        x182 = P1(3)*co(1)*x79
        x183 = P1(0)*P2(0)*co(1)*x79
        x184 = P2(1)*co(0)*x101
        x185 = P2(1)*co(0)*x104
        x186 = P1(0)*P2(2)*w1(2)
        x187 = P2(3)*co(0)*x101
        x188 = P2(3)*co(0)*x104
        x189 = P1(1)*co(0)*x101
        x190 = P2(0)*co(0)*x101
        x191 = 2*co(0)
        x192 = P1(0)*co(3)*x79
        x193 = P1(0)*co(3)*x84
        x194 = -x106 + x156 + x166
        x195 = P1(1)*P2(2)*co(3)
        x196 = P1(1)*P2(2)
        x197 = co(3)*x19
        x198 = P1(1)*co(2)*w2(1)
        x199 = P1(3)*co(3)*x116
        x200 = P1(3)*co(3)*x118
        x201 = P2(1)*co(1)*x21
        x202 = w1(1)*x101
        x203 = co(1)*x107
        x204 = P1(0)*P2(1)*co(3)
        x205 = P1(0)*co(3)*x101
        x206 = P1(0)*co(3)*x104
        x207 = P1(1)*P2(3)
        x208 = P1(2)*co(3)
        x209 = x79*x94
        x210 = P1(3)*co(3)*x71
        x211 = co(0)*w1(1)*x101
        x212 = P1(1)*co(0)*x104
        x213 = co(1)*w1(1)*x104
        x214 = P1(1)*co(1)*x79
        x215 = P1(0)*P2(0)*co(1)*x21
        x216 = P1(2)*co(0)*x101
        x217 = P2(2)*co(0)*x101
        x218 = P1(1)*co(3)
        x219 = P1(2)*P2(0)*co(3)
        x220 = P1(3)*co(3)*x132
        x221 = P2(2)*co(1)*x21
        x222 = w1(2)*x101
        x223 = co(1)*w2(2)*x84
        x224 = P1(2)*P2(3)*co(3)
        x225 = w1(2)*x101*x23
        x226 = P1(2)*co(1)*x21
        x227 = co(1)*x104
        x228 = co(1)*w2(2)*x79
        x229 = P2(0)*co(0)*x104
        x230 = P1(2)*P2(2)*w1(2)
        x231 = P2(0)*co(1)*x79
        x232 = P1(3)*co(0)*x101
        x233 = P1(0)*co(3)*x39
        x234 = P1(1)*co(3)*x71
        x235 = P1(3)*P2(2)*co(3)
        x236 = P2(3)*co(1)*x21
        x237 = co(1)*w1(3)*x101
        x238 = co(1)*w2(3)*x84
        x239 = P1(1)*co(3)*x152
        x240 = w1(3)*x101
        x241 = co(1)*w2(3)*x79
        wout(0) = P1(0)*P2(0)*w1(0)*x101*x191 + P1(0)*P2(0)*w1(0)*x178 - P1(0)*&
                  co(3)*x140 - P1(0)*x141 - 2*P1(0)*x174 + P1(0)*x175 + P1(0)* &
                  x176 + P1(0)*x177 + P1(0)*x22 + P1(0)*x24 + P1(0)*x26 + P1(1 &
                  )*P2(1)*w2(0)*x180 + P2(0)*x137 - P2(0)*x157 - P2(0)*x158 -  &
                  co(0)*x101*x186 + co(0)*x138 + co(1)*x138 + w2(0)*x139 - w2(0&
                  )*x171 - w2(0)*x172 - w2(0)*x173 + w2(0)*x181 - w2(0)*x183 - &
                  2*x10*x136 - x100*x146 - x100*x147 - x101*x165 + x102*x97 -  &
                  x104*x165 + x105*x97 + x106*x108 + x106*x111 - x108*x156 -   &
                  x108*x166 + x109*x136 + x109*x179 + x109*x54 - x11*x3 - x110*&
                  x179 - x110*x54 - x111*x156 - x111*x166 + x112*x117 + x112*  &
                  x119 - x116*x142 - x118*x142 - x123*x184 - x123*x185 - x124* &
                  x151 - x124*x153 + x126*x89 - x130*x184 - x130*x189 + x133*  &
                  x89 + x134*x39 + x135*x39 + x136*x4 + x136*x53 + x136*x8 +   &
                  x136*x85 - x149*x159 - x149*x160 - x154*x69 - x155*x69 - x161&
                  *x42 - x162*x42 - x163*x63 - x164*x63 - x167*x168 - x167*x169&
                   - x167*x170 + x17*x18 - x178*x186 + x179*x53 + x179*x85 +   &
                  x18*x19 + x182*x93 - x187*x62 - x188*x62 - x190*x77 - x190*  &
                  x78 - x190*x81 - x190*x82 + x27*x37 + x27*x43 + x3*x5 + x3*x7&
                   + x3*x9 + x48*x49 + x51*x52 + x53*x54 + x54*x85 + x55*x66 + &
                  x55*x75 + x60*x91 + x60*x95 + x79*x80 + x80*x84
        wout(1) = -P1(1)*P2(1)*w1(1)*x178 - 2*P1(1)*P2(1)*x211 - P1(1)*x174 +  &
                  P1(1)*x176 + P1(1)*x177 - P1(1)*x215 + 2*P1(1)*x22 + P1(1)*  &
                  x24 + P1(1)*x26 + P2(1)*x137 - P2(1)*x157 - P2(1)*x158 + P2(1&
                  )*x199 + P2(1)*x200 + w2(1)*x139 - w2(1)*x171 - w2(1)*x172 - &
                  w2(1)*x173 + w2(1)*x181 - w2(1)*x183 - x10*x201 - x101*x210  &
                   + x102*x73 + x103*x214 - x104*x210 + x105*x73 - x108*x44 -  &
                  x108*x46 + x108*x47 + x109*x201 + x109*x213 + x109*x51 - x11*&
                  x50 - x110*x201 - x110*x213 - x110*x51 - x111*x44 - x111*x46 &
                   + x111*x47 - x117*x207 - x119*x207 + x121*x91 + x121*x95 +  &
                  x123*x37 + x123*x43 + x126*x35 - x127*x216 - x127*x217 + x131&
                  *x190 + x133*x35 + x134*x152 + x135*x152 - x143*x187 - x143* &
                  x188 - x144*x163 - x144*x164 - x146*x86 - x147*x86 - x151*x76&
                   - x153*x76 - x159*x32 - x160*x32 - x162*x94 - x168*x202 -   &
                  x169*x202 + x17*x195 - x170*x202 + x182*x41 + x184*x27 - x184&
                  *x78 - x184*x82 - x189*x81 + x189*x83 + x192*x38 + x193*x38  &
                   - x194*x204 + x194*x49 + x196*x197 + x198*x65 + x198*x74 -  &
                  x20*x211 + 2*x201*x4 + x201*x8 + x201*x85 + x202*x203 - x204*&
                  x3 - x205*x69 - x206*x69 - x208*x209 - x212*x81 + x212*x83 + &
                  x213*x53 + x213*x85 + x5*x50 + x50*x7 + x50*x9 + x51*x53 +   &
                  x51*x85 + x52*x54
        wout(2) = -P1(0)*P2(0)*w1(2)*x227 + P1(1)*P2(1)*w1(2)*x227 - P1(2)*P2(2&
                  )*w1(2)*x101*x191 - P1(2)*x174 - P1(2)*x215 + P1(2)*x22 + 2* &
                  P1(2)*x24 + P1(2)*x26 + P1(3)*P2(3)*w1(2)*x227 + P1(3)*P2(3)*&
                  w2(2)*x180 - P2(1)*x208*x50 + 2*P2(2)*x137 + P2(2)*x199 + P2(&
                  2)*x200 - co(0)*x225 - co(1)*x225 - w2(2)*x172 - x10*x221 +  &
                  x10*x223 + x101*x220 + x104*x220 + x108*x12 + x108*x14 - x108&
                  *x16 - x109*x197 + x109*x221 + x109*x226 + x11*x19 + x110*   &
                  x197 - x110*x221 + x111*x12 + x111*x14 - x111*x16 - x116*x224&
                   - x118*x224 - x120*x151 - x120*x153 - x121*x184 - x121*x185 &
                   + x126*x29 - x128*x184 + x133*x29 - x134*x92 - x135*x92 -   &
                  x140*x208 - x146*x148 - x147*x148 - x148*x231 - x154*x73 -   &
                  x155*x73 - x159*x98 - x160*x98 - x163*x57 - x164*x57 - x168* &
                  x222 - x170*x222 - x178*x230 - x18*x194 - x18*x3 - x187*x56  &
                   - x187*x67 - x188*x56 - x19*x5 - x19*x7 - x19*x9 + x190*x60 &
                   + x190*x70 - x192*x42 - x193*x42 + x194*x219 + x195*x48 +   &
                  x196*x51 - x197*x53 - x197*x85 + x203*x222 + x205*x97 + x206*&
                  x97 + x209*x218 + x217*x27 - x217*x76 + x218*x84*x94 + x219* &
                  x3 + x221*x4 + x221*x53 + x221*x8 - x223*x4 - x223*x8 + x226*&
                  x53 + x227*x230 + x228*x53 + x228*x85 + x229*x60 - x232*x67  &
                   + x31*x66 + x31*x75 + x37*x59 + x43*x59 + x77*x91 + x77*x95
        wout(3) = -P1(0)*P2(0)*w1(3)*x227 + P1(1)*P2(1)*w1(3)*x227 + P1(2)*P2(2&
                  )*w1(3)*x227 - P1(3)*P2(2)*w1(2)*x178 + P1(3)*P2(3)*w1(3)*   &
                  x227 - P1(3)*co(3)*x140 - 2*P1(3)*w1(3)*x187 - P1(3)*x141 -  &
                  P1(3)*x174 + P1(3)*x175 + P1(3)*x176 - P1(3)*x215 + P1(3)*x22&
                   + P1(3)*x24 + 2*P1(3)*x26 + P2(3)*x137 - P2(3)*x157 - P2(3)*&
                  x158 + P2(3)*x218*x48 - co(0)*x240*x25 + co(3)*x112*x194 - w2&
                  (3)*x172 - x10*x236 + x10*x238 + x101*x234 - x102*x132 + x104&
                  *x234 - x105*x132 + x107*x237 - x108*x113 - x108*x114 + x108*&
                  x115 + x109*x119 + x109*x241 - x11*x118 - x110*x119 - x110*  &
                  x236 - x111*x113 - x111*x114 + x111*x115 + x112*x54 + x118*x5&
                   + x118*x7 + x118*x9 + x119*x53 + x119*x85 + x126*x99 - x129*&
                  x205 - x129*x206 + x133*x99 - x142*x194 - x142*x3 - x143*x151&
                   - x143*x153 - x144*x184 - x144*x185 - x146*x88 - x147*x88 - &
                  x159*x28 - x160*x28 + x161*x92 + x162*x92 - x163*x78 - x164* &
                  x78 + x17*x235 - x170*x240 - x184*x96 + x187*x27 - x188*x78  &
                   - x189*x96 + x19*x235 + x190*x63 + x190*x72 - x20*x237 +    &
                  x207*x51 + x214*x40 - x216*x68 - x217*x68 + x229*x63 - x23*  &
                  x237 - x231*x88 - x232*x81 + x233*x79 + x233*x84 + x236*x4 + &
                  x236*x53 + 2*x236*x8 + x236*x85 - x238*x4 - x238*x8 - x239*  &
                  x79 - x239*x84 + x241*x85 + x34*x66 + x34*x75 + x37*x62 + x43&
                  *x62 + x56*x91 + x56*x95
      case(VVV16)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       c2*(-Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,3)*P(-1,1
!       )*P(-2,2)*P(2,3))
!       c4*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,2
!       )*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) - Epsilon(-1
!       ,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,
!       3) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(4)*x4
        x6 = P1(2)**2
        x7 = co(4)*x6
        x8 = P1(3)**2
        x9 = co(4)*x8
        x10 = P1(0)**2
        x11 = co(4)*x10
        x12 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x13 = P1(0)*P2(0)*co(3)
        x14 = P1(0)*P2(0)
        x15 = co(4)*x3
        x16 = P1(0)*P2(2)
        x17 = w1(0)*w2(1) - w1(1)*w2(0)
        x18 = w1(0)*w2(3) - w1(3)*w2(0)
        x19 = P1(0)*x2 - P1(1)*x18 + P1(3)*x17
        x20 = co(4)*x19
        x21 = P2(0)*x2 - P2(1)*x18 + P2(3)*x17
        x22 = co(4)*x21
        x23 = P1(1)*w1(0)
        x24 = P1(2)*w2(3) - P1(3)*w2(2)
        x25 = P1(0)*w2(2) - P1(2)*w2(0)
        x26 = P1(0)*w2(3) - P1(3)*w2(0)
        x27 = co(2)*(P2(0)*x24 - P2(2)*x26 + P2(3)*x25)
        x28 = P2(2)*w2(3) - P2(3)*w2(2)
        x29 = P2(0)*w2(2) - P2(2)*w2(0)
        x30 = P2(0)*w2(3) - P2(3)*w2(0)
        x31 = co(2)*(P2(0)*x28 - P2(2)*x30 + P2(3)*x29)
        x32 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x33 = co(3)*x32
        x34 = P2(2)*w1(3)
        x35 = P2(3)*w1(2)
        x36 = x34 - x35
        x37 = P1(1)*x36
        x38 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x39 = co(3)*x38
        x40 = P1(1)*w1(1)
        x41 = P1(2)*w1(2)
        x42 = P1(3)*w1(3)
        x43 = P1(0)*w1(0)
        x44 = x40 + x41 + x42 - x43
        x45 = P1(1)*co(4)*x44
        x46 = P1(2)*P2(0)
        x47 = co(3)*x19
        x48 = co(3)*x21
        x49 = P1(1)*P2(3)
        x50 = P1(3)*P2(1)
        x51 = x49 - x50
        x52 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x53 = P1(2)*co(2)*x52
        x54 = P1(1)*w2(3) - P1(3)*w2(1)
        x55 = P2(2)*w1(2)
        x56 = P2(3)*w1(3)
        x57 = -P2(0)*w1(0) + P2(1)*w1(1) + x55 + x56
        x58 = P1(2)*co(4)*x57
        x59 = P1(3)*w1(0)
        x60 = P1(1)*w2(2) - P1(2)*w2(1)
        x61 = P1(0)*w2(1) - P1(1)*w2(0)
        x62 = co(2)*(P2(0)*x60 - P2(1)*x25 + P2(2)*x61)
        x63 = P2(1)*w2(2) - P2(2)*w2(1)
        x64 = P2(0)*w2(1) - P2(1)*w2(0)
        x65 = co(2)*(P2(0)*x63 - P2(1)*x29 + P2(2)*x64)
        x66 = P2(1)*w1(2)
        x67 = P2(2)*w1(1)
        x68 = x66 - x67
        x69 = P1(3)*x68
        x70 = P1(3)*co(4)*x44
        x71 = P2(0)*co(1)*x52
        x72 = co(1)*x52*x6
        x73 = P1(1)*w1(3)
        x74 = P1(3)*w1(1)
        x75 = x73 - x74
        x76 = P2(2)*co(4)*x32
        x77 = P2(3)*w1(1)
        x78 = P2(1)*w1(3) - x77
        x79 = P2(0)**2
        x80 = co(0)*w1(0)*x32
        x81 = P1(0)*P2(1)
        x82 = w1(0)*w2(2) - w1(2)*w2(0)
        x83 = P1(0)*x0 - P1(2)*x18 + P1(3)*x82
        x84 = co(4)*x83
        x85 = P2(0)*x0 - P2(2)*x18 + P2(3)*x82
        x86 = co(4)*x85
        x87 = P1(0)*P2(3)
        x88 = P1(0)*x1 - P1(1)*x82 + P1(2)*x17
        x89 = co(4)*x88
        x90 = P2(0)*x1 - P2(1)*x82 + P2(2)*x17
        x91 = co(4)*x90
        x92 = co(1)*x52
        x93 = co(2)*(P2(1)*x24 - P2(2)*x54 + P2(3)*x60)
        x94 = P2(1)*w2(3) - P2(3)*w2(1)
        x95 = co(2)*(P2(1)*x28 - P2(2)*x94 + P2(3)*x63)
        x96 = P1(1)*P2(0)
        x97 = co(3)*x83
        x98 = co(3)*x85
        x99 = P1(1)*P2(1)
        x100 = co(4)*x12
        x101 = P1(2)*P2(3)
        x102 = P1(3)*P2(2)
        x103 = x101 - x102
        x104 = P1(1)*co(2)*x52
        x105 = P1(1)*co(4)*x57
        x106 = P1(2)*P2(2)
        x107 = P1(2)*w1(0)
        x108 = co(2)*(P2(0)*x54 - P2(1)*x26 + P2(3)*x61)
        x109 = co(2)*(P2(0)*x94 - P2(1)*x30 + P2(3)*x64)
        x110 = P1(2)*co(3)*x32
        x111 = P1(2)*co(3)*x38
        x112 = P1(2)*co(4)*x44
        x113 = P1(3)*P2(0)*co(3)
        x114 = P1(3)*P2(3)
        x115 = P1(1)*P2(2)
        x116 = P1(2)*P2(1)
        x117 = x115 - x116
        x118 = P1(3)*co(2)*x52
        x119 = P1(3)*co(4)*x57
        x120 = P1(2)*w1(3)
        x121 = P1(3)*w1(2)
        x122 = x120 - x121
        x123 = P2(1)*co(4)*x32
        x124 = P1(1)*w1(2)
        x125 = P1(2)*w1(1)
        x126 = x124 - x125
        x127 = P2(3)*co(4)*x32
        x128 = co(0)*x38
        x129 = P1(0)*P2(0)*w1(0)
        x130 = P2(1)*co(1)*x52
        x131 = P2(1)*w1(0)
        x132 = P1(1)*co(1)*x32
        x133 = P1(1)*co(1)*x38
        x134 = P2(2)*co(1)*x52
        x135 = co(1)*x32
        x136 = P1(2)*P2(2)*w1(0)
        x137 = co(1)*x38
        x138 = P1(3)*P2(0)
        x139 = P2(3)*co(1)*x52
        x140 = P1(3)*P2(3)*w1(0)
        x141 = P2(0)*co(1)*x38
        x142 = co(0)*w1(1)*x32
        x143 = co(0)*x32
        x144 = P2(2)*co(0)*w1(2)*x38
        x145 = P1(0)*w1(3)
        x146 = P2(3)*co(0)*x32
        x147 = P2(3)*co(0)*x38
        x148 = P2(0)*co(0)*x32
        x149 = co(0)*w1(3)*x32
        x150 = P2(0)*w1(1)
        x151 = P2(1)*co(0)*x32
        x152 = co(3)*x12
        x153 = co(3)*x3
        x154 = P1(0)*co(3)*x32
        x155 = P1(0)*co(3)*x38
        x156 = P1(0)*co(4)*x44
        x157 = P2(1)**2
        x158 = -x138 + x87
        x159 = P2(2)*w1(0)
        x160 = P2(0)*w1(2) - x159
        x161 = P1(3)*x160
        x162 = x145 - x59
        x163 = P2(3)*w1(0)
        x164 = P2(0)*w1(3) - x163
        x165 = P1(0)*w1(1)
        x166 = P1(0)*co(2)*x52
        x167 = P1(0)*co(4)*x57
        x168 = co(3)*x88
        x169 = co(3)*x90
        x170 = x16 - x46
        x171 = P2(0)*co(4)*x32
        x172 = P1(0)*w1(2)
        x173 = -x107 + x172
        x174 = co(0)*w1(0)*x38
        x175 = P1(1)*P2(1)*w1(1)
        x176 = P1(2)*P2(2)*w1(1)
        x177 = P1(3)*P2(3)*w1(1)
        x178 = P1(0)*P2(0)*w1(1)
        x179 = P2(1)*co(0)*x38
        x180 = P2(2)*co(0)*x32
        x181 = P1(2)*co(0)*x32
        x182 = P1(1)*x164
        x183 = P1(2)*P2(0)*co(4)
        x184 = P2(2)**2
        x185 = x81 - x96
        x186 = x165 - x23
        x187 = -x131 + x150
        x188 = P1(3)*x187
        x189 = P1(2)*co(1)*x32
        x190 = P1(2)*co(1)*x38
        x191 = P1(3)*P2(3)*w1(2)
        x192 = P2(0)*co(1)*x32
        x193 = P1(3)*co(0)*x32
        x194 = P2(3)**2
        x195 = P1(1)*x160
        x196 = P1(1)*P2(1)*w1(3)
        x197 = P1(3)*P2(3)*w1(3)
        wout(0) = 2*P1(0)*P2(0)*x100 - P1(0)*P2(1)*w1(1)*x128 - P1(0)*P2(2)*w1(&
                  2)*x143 + 2*P1(0)*w1(0)*x148 - P1(0)*x144 - P1(0)*x79*x92 +  &
                  P2(0)*x72 - x10*x71 - x100*x106 - x100*x114 - x100*x99 - x103&
                  *x104 - x105*x24 - x107*x108 - x107*x109 - x11*x3 - x110*x78 &
                   - x111*x78 - x112*x94 - x113*x88 - x113*x90 - x117*x118 -   &
                  x119*x60 + x12*x13 - x122*x123 - x123*x36 - x126*x127 - x127*&
                  x68 + x128*x129 - x129*x135 + x13*x3 + x130*x96 + x131*x132  &
                   + x131*x133 + x134*x46 + x135*x136 + x135*x140 + x136*x137  &
                   + x137*x140 + x138*x139 - x138*x149 + x14*x15 - x141*x43 -  &
                  x142*x81 - x145*x146 - x145*x147 - x148*x40 - x148*x41 - x148&
                  *x55 - x148*x56 - x150*x151 + x16*x20 + x16*x22 + x23*x27 +  &
                  x23*x31 + x28*x45 + x3*x5 + x3*x7 + x3*x9 + x33*x37 + x33*x69&
                   + x37*x39 + x39*x69 + x4*x71 - x43*x93 - x43*x95 + x46*x47  &
                   + x46*x48 + x51*x53 + x54*x58 + x59*x62 + x59*x65 + x63*x70 &
                   + x71*x8 + x75*x76 + x76*x78 + x79*x80 - x81*x84 - x81*x86  &
                   - x87*x89 - x87*x91 - x96*x97 - x96*x98
        wout(1) = -2*P1(1)*P2(1)*x84 - P1(1)*P2(2)*w1(2)*x128 + P1(1)*x157*x92 &
                   + P2(1)*x72 - 2*co(0)*x175*x32 - x10*x130 + x100*x96 - x103*&
                  x166 - x106*x84 - x108*x125 - x109*x125 - x11*x85 - x110*x164&
                   - x111*x164 - x112*x30 - x114*x84 + x115*x20 + x115*x22 +   &
                  x116*x134 + x116*x47 + x116*x48 - x118*x170 - x119*x25 - x122&
                  *x171 - x124*x180 - x127*x160 - x127*x173 + x130*x4 + x130*x8&
                   + x131*x148 + x135*x175 + x135*x176 + x135*x177 - x135*x178 &
                   + x137*x175 + x137*x176 + x137*x177 - x137*x178 + x139*x50  &
                   + x14*x84 - x142*x157 - x146*x73 - x147*x73 + x15*x96 - x151&
                  *x42 + x151*x43 - x151*x56 + x152*x81 + x153*x81 + x154*x36  &
                   + x155*x36 + x156*x28 + x158*x53 + x161*x33 + x161*x39 +    &
                  x162*x76 + x164*x76 - x165*x93 - x165*x95 - x167*x24 - x168* &
                  x50 - x169*x50 - x171*x36 + x174*x96 - x179*x40 - x180*x66 - &
                  x181*x66 + x26*x58 + x27*x40 + x29*x70 + x31*x40 - x49*x89 - &
                  x49*x91 + x5*x85 + x62*x74 + x65*x74 + x7*x85 - x71*x81 + x80&
                  *x96 + x85*x9 - x86*x99 - x97*x99 - x98*x99
        wout(2) = P1(2)*P2(0)*w1(0)*x128 - P1(2)*P2(3)*w1(3)*x128 - P1(2)*x144 &
                   + P1(2)*x184*x92 - 2*P2(2)*w1(2)*x181 + P2(2)*x72 + 2*co(4)*&
                  x106*x19 - w1(2)*x143*x184 - x10*x134 - x101*x149 - x101*x89 &
                   - x101*x91 + x102*x139 - x102*x168 - x102*x169 - x104*x158  &
                   - x105*x26 + x106*x22 + x106*x47 + x106*x48 + x107*x148 -   &
                  x108*x41 - x109*x41 + x11*x21 + x114*x20 + x115*x130 - x115* &
                  x97 - x115*x98 - x116*x84 - x116*x86 + x118*x185 + x119*x61  &
                   + x12*x183 + x121*x62 + x121*x65 - x123*x162 - x123*x164 +  &
                  x124*x27 + x124*x31 - x125*x151 - x125*x179 + x127*x186 +    &
                  x127*x187 + x132*x66 + x133*x66 + x134*x4 + x134*x8 + x135*  &
                  x191 + x137*x191 - x14*x20 - x141*x172 - x146*x34 + x148*x159&
                   - x151*x67 + x152*x16 + x153*x16 - x154*x78 - x155*x78 -    &
                  x156*x94 - x16*x71 + x166*x51 + x167*x54 + x171*x75 + x171*  &
                  x78 - x172*x192 - x172*x93 - x172*x95 - x180*x40 + x180*x43  &
                   + x182*x33 + x182*x39 + x183*x3 - x188*x33 - x188*x39 + x189&
                  *x55 + x190*x55 - x193*x34 + x20*x99 - x21*x5 - x21*x7 - x21*&
                  x9 + x30*x45 - x64*x70
        wout(3) = -2*P1(3)*w1(3)*x146 - P1(3)*x144 + P1(3)*x194*x92 + P2(3)*x72&
                   - 2*co(4)*x114*x88 - x10*x139 + x100*x138 + x101*x134 + x101&
                  *x47 + x101*x48 + x102*x20 + x102*x22 + x104*x170 + x105*x25 &
                   - x106*x89 - x108*x120 - x109*x120 - x11*x90 + x110*x187 +  &
                  x111*x187 + x112*x64 - x114*x168 - x114*x169 - x114*x91 -    &
                  x117*x166 + x123*x160 + x123*x173 - x126*x171 - x128*x197 +  &
                  x130*x49 + x135*x196 + x135*x197 + x137*x196 + x137*x197 +   &
                  x138*x15 + x138*x174 + x138*x80 + x139*x4 + x139*x8 + x14*x89&
                   - x141*x145 - x145*x192 - x145*x93 - x145*x95 - x146*x40 +  &
                  x146*x43 + x148*x163 - x149*x194 - x151*x74 - x151*x77 + x152&
                  *x87 + x153*x87 + x154*x68 + x155*x68 + x156*x63 - x167*x60  &
                   - x171*x68 - x179*x74 - x180*x35 - x181*x35 - x185*x53 -    &
                  x186*x76 - x187*x76 + x189*x34 + x190*x34 - x193*x55 - x195* &
                  x33 - x195*x39 + x27*x73 - x29*x45 + x31*x73 + x42*x62 + x42*&
                  x65 - x49*x97 - x49*x98 + x5*x90 - x50*x84 - x50*x86 - x58*  &
                  x61 + x7*x90 - x71*x87 - x89*x99 + x9*x90
      case(VVV17)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) + Metric(1,2)*P(-1,2)*P(-1,3)*P(3
!       ,1) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(
!       2,1) + Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P
!       (1,2))
!       c2*(Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3) - Epsilon(-1 
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) - Epsilon(-1,-2,1,3)*P(-1,
!       1)*P(-2,2)*P(2,3) - Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) - Epsilon(-
!       1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2
!       ,3) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3))
        if (last) VB_last = .true.
        x0 = P1(0)*w2(0)
        x1 = P1(2)*w1(3) - P1(3)*w1(2)
        x2 = P2(1)*x1
        x3 = P1(1)*w1(2)
        x4 = -P1(2)*w1(1) + x3
        x5 = P2(3)*x4
        x6 = P1(3)*w1(1)
        x7 = P1(1)*w1(3) - x6
        x8 = P2(2)*x7
        x9 = co(2)*(x2 + x5 - x8)
        x10 = P2(2)*w1(3)
        x11 = P2(3)*w1(2)
        x12 = x10 - x11
        x13 = P2(1)*x12
        x14 = P2(1)*w1(2)
        x15 = P2(2)*w1(1)
        x16 = x14 - x15
        x17 = P2(3)*x16
        x18 = P2(3)*w1(1)
        x19 = P2(1)*w1(3) - x18
        x20 = P2(2)*x19
        x21 = co(2)*(x13 + x17 - x20)
        x22 = P1(1)*P2(0)
        x23 = w1(2)*w2(3) - w1(3)*w2(2)
        x24 = P1(0)*x23
        x25 = w1(0)*w2(2) - w1(2)*w2(0)
        x26 = P1(3)*x25
        x27 = w1(0)*w2(3) - w1(3)*w2(0)
        x28 = P1(2)*x27
        x29 = x24 + x26 - x28
        x30 = co(3)*x29
        x31 = co(3)*(P2(0)*x23 - P2(2)*x27 + P2(3)*x25)
        x32 = P1(2)*P2(3)
        x33 = P1(3)*P2(2)
        x34 = x32 - x33
        x35 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x36 = P1(1)*co(2)*x35
        x37 = P1(1)*x23
        x38 = P2(1)**2
        x39 = P2(2)**2
        x40 = P2(3)**2
        x41 = P2(0)**2
        x42 = co(3)*(x38 + x39 + x40 - x41)
        x43 = P1(1)*P2(1)
        x44 = P1(2)*P2(2)
        x45 = P1(3)*P2(3)
        x46 = P1(0)*P2(0)
        x47 = co(3)*(x43 + x44 + x45 - x46)
        x48 = P1(2)*w2(0)
        x49 = P2(0)*x7
        x50 = P1(0)*w1(1) - P1(1)*w1(0)
        x51 = P2(3)*x50
        x52 = P1(0)*w1(3)
        x53 = -P1(3)*w1(0) + x52
        x54 = P2(1)*x53
        x55 = co(2)*(x49 + x51 - x54)
        x56 = P2(0)*x19
        x57 = P2(0)*w1(1)
        x58 = P2(1)*w1(0)
        x59 = x57 - x58
        x60 = P2(3)*x59
        x61 = P2(3)*w1(0)
        x62 = P2(0)*w1(3) - x61
        x63 = P2(1)*x62
        x64 = co(2)*(x56 + x60 - x63)
        x65 = P1(1)*w2(3)
        x66 = -P1(3)*w2(1) + x65
        x67 = P2(2)*w1(2)
        x68 = P2(3)*w1(3)
        x69 = -P2(0)*w1(0) + P2(1)*w1(1) + x67 + x68
        x70 = P1(2)*co(3)*x69
        x71 = P1(1)*w2(1)
        x72 = P1(2)*w2(2)
        x73 = P1(3)*w2(3)
        x74 = -x0 + x71 + x72 + x73
        x75 = P1(2)*co(3)*x74
        x76 = P2(1)*w2(1)
        x77 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x76
        x78 = P1(2)*co(3)*x77
        x79 = P2(1)*w2(3)
        x80 = -P2(3)*w2(1) + x79
        x81 = P1(3)*P2(0)
        x82 = w1(1)*w2(2) - w1(2)*w2(1)
        x83 = P1(0)*x82
        x84 = w1(0)*w2(1) - w1(1)*w2(0)
        x85 = P1(2)*x84
        x86 = P1(1)*x25
        x87 = co(3)*(x83 + x85 - x86)
        x88 = P2(0)*x82 - P2(1)*x25 + P2(2)*x84
        x89 = co(3)*x88
        x90 = P1(1)*P2(2)
        x91 = P1(2)*P2(1)
        x92 = x90 - x91
        x93 = P1(3)*co(2)*x35
        x94 = P1(3)*x82
        x95 = P1(1)**2
        x96 = P2(0)*co(1)*x35
        x97 = P1(2)**2
        x98 = co(1)*x35*x97
        x99 = P1(3)**2
        x100 = co(3)*x74
        x101 = w1(0)*x41*x74
        x102 = co(1)*w1(0)*x74
        x103 = co(1)*x40
        x104 = co(1)*w2(0)*x69
        x105 = co(1)*x69*x97
        x106 = co(1)*x35*x38
        x107 = co(1)*x35*x39
        x108 = w1(1)*w2(3) - w1(3)*w2(1)
        x109 = P1(2)*x108
        x110 = co(3)*(-x109 + x37 + x94)
        x111 = co(3)*(P2(1)*x23 - P2(2)*x108 + P2(3)*x82)
        x112 = P1(1)*w2(0)
        x113 = P2(0)*x1
        x114 = P1(2)*w1(0)
        x115 = P1(0)*w1(2) - x114
        x116 = P2(3)*x115
        x117 = P2(2)*x53
        x118 = co(2)*(x113 + x116 - x117)
        x119 = P2(0)*x12
        x120 = P2(2)*w1(0)
        x121 = P2(0)*w1(2) - x120
        x122 = P2(3)*x121
        x123 = P2(2)*x62
        x124 = co(2)*(x119 + x122 - x123)
        x125 = P1(2)*w2(3)
        x126 = P1(3)*w2(2)
        x127 = x125 - x126
        x128 = P1(1)*co(3)*x69
        x129 = P1(1)*co(3)*x74
        x130 = x12*x77
        x131 = P1(1)*co(3)
        x132 = P2(2)*w2(3) - P2(3)*w2(2)
        x133 = P1(2)*P2(0)
        x134 = P1(0)*x108
        x135 = P1(3)*x84
        x136 = P1(1)*x27
        x137 = x134 + x135 - x136
        x138 = co(3)*x137
        x139 = co(3)*(P2(0)*x108 - P2(1)*x27 + P2(3)*x84)
        x140 = P1(1)*P2(3)
        x141 = P1(3)*P2(1)
        x142 = x140 - x141
        x143 = P1(2)*co(2)*x35
        x144 = P1(3)*w2(0)
        x145 = P2(0)*x4
        x146 = P2(2)*x50
        x147 = P2(1)*x115
        x148 = x145 + x146 - x147
        x149 = co(2)*x148
        x150 = P2(0)*x16
        x151 = P2(2)*x59
        x152 = P2(1)*x121
        x153 = x150 + x151 - x152
        x154 = co(2)*x153
        x155 = P1(1)*w2(2)
        x156 = P1(2)*w2(1)
        x157 = x155 - x156
        x158 = P1(3)*co(3)*x69
        x159 = P1(3)*co(3)*x74
        x160 = P1(3)*co(3)
        x161 = P2(1)*w2(2) - P2(2)*w2(1)
        x162 = P1(0)**2
        x163 = co(0)*w1(0)*x77
        x164 = P1(1)*w1(1)
        x165 = P1(3)*w1(3)
        x166 = P1(0)*w1(0)
        x167 = P1(2)*w1(2) + x164 + x165 - x166
        x168 = P1(0)*P2(0)*co(1)*x167
        x169 = co(1)*w1(0)*x77
        x170 = P2(3)*co(1)*x35
        x171 = P1(1)*P2(1)*co(1)*x35
        x172 = P1(0)*co(1)*x35
        x173 = P1(0)*P2(1)
        x174 = co(0)*w1(1)*x74
        x175 = co(0)*x77
        x176 = co(0)*x74
        x177 = P1(0)*P2(2)*w1(2)
        x178 = P2(3)*co(0)*x74
        x179 = P2(3)*co(0)*x77
        x180 = co(1)*x167
        x181 = co(0)*w1(2)*x74
        x182 = P1(2)*P2(2)*co(1)*x167
        x183 = co(0)*w1(3)*x74
        x184 = P1(3)*P2(3)*co(1)*x167
        x185 = P2(1)*co(0)*x74
        x186 = P2(0)*co(0)*x74
        x187 = 2*co(1)*w1(0)*x74
        x188 = co(0)*w1(0)*x74
        x189 = 2*P1(1)*P2(1)
        x190 = 2*P1(3)*P2(3)
        x191 = P1(0)*P2(0)*co(3)
        x192 = P1(0)*w2(1)
        x193 = P1(0)*co(2)*x35
        x194 = co(1)*x35*x41
        x195 = P1(0)*w2(3)
        x196 = -x144 + x195
        x197 = P2(0)*w2(3) - P2(3)*w2(0)
        x198 = P1(0)*P2(2)
        x199 = -x133 + x198
        x200 = P2(1)*co(1)*x35
        x201 = w1(1)*x38*x74
        x202 = co(1)*w1(1)*x74
        x203 = w1(1)*x74
        x204 = co(1)*w2(1)*x69
        x205 = P1(0)*co(3)*x69
        x206 = P1(0)*co(3)*x74
        x207 = co(1)*x35*x40
        x208 = P1(0)*P2(3)
        x209 = x208 - x81
        x210 = P1(3)*co(2)*w2(1)
        x211 = P1(0)*w2(2)
        x212 = x211 - x48
        x213 = x121*x77
        x214 = P2(0)*w2(2) - P2(2)*w2(0)
        x215 = co(1)*x41
        x216 = P1(0)*P2(0)*co(1)*x35
        x217 = co(1)*x77
        x218 = P1(1)*P2(1)*w1(1)
        x219 = co(1)*w1(1)*x77
        x220 = P1(3)*co(1)*x35
        x221 = P1(1)*co(1)*x167
        x222 = P2(2)*co(0)*x74
        x223 = co(0)*w1(3)*x77
        x224 = P1(2)*co(0)*x74
        x225 = 2*co(1)*w1(1)*x74
        x226 = P1(0)*co(3)*x77
        x227 = -x112 + x192
        x228 = co(3)*x59*x77
        x229 = P2(0)*w2(1) - P2(1)*w2(0)
        x230 = P2(2)*co(1)*x35
        x231 = w1(2)*x39*x74
        x232 = w1(2)*x74
        x233 = co(1)*w2(2)*x69
        x234 = x173 - x22
        x235 = P2(0)*co(1)*x167
        x236 = P1(1)*P2(1)*w1(2)
        x237 = P1(2)*P2(2)*w1(2)
        x238 = P1(3)*P2(3)*w1(2)
        x239 = P1(2)*P2(1)*w1(1)
        x240 = P1(3)*co(0)*x74
        x241 = 2*co(1)*w1(2)*x74
        x242 = 2*co(1)*x74
        x243 = co(1)*w1(3)*x74
        x244 = co(1)*w2(3)*x69
        x245 = P1(2)*P2(2)*w1(3)
        x246 = P1(3)*P2(3)*w1(3)
        x247 = P1(0)*P2(0)*w1(3)
        wout(0) = 2*P1(0)*P2(0)*x188 - P1(0)*P2(1)*w1(1)*x175 - P1(0)*x103*x35 &
                   - P1(0)*x106 - P1(0)*x107 - P1(0)*x171 - P1(1)*P2(0)*w1(1)* &
                  x176 - P1(1)*P2(1)*w2(0)*x180 + P2(0)*x98 + co(0)*x101 - co(1&
                  )*x101 + w1(0)*x103*x74 + w2(0)*x105 + w2(0)*x168 - w2(0)*   &
                  x182 - w2(0)*x184 + x0*x21 + x0*x9 - x100*x13 - x100*x17 -   &
                  x100*x2 + x100*x20 - x100*x5 + x100*x8 + x102*x189 + x102*   &
                  x190 + x102*x38 + x102*x39 - x104*x162 + x104*x95 + x104*x99 &
                   - x109*x42 - x109*x47 - x110*x43 - x110*x44 - x110*x45 -    &
                  x111*x43 - x111*x44 - x111*x45 - x112*x118 - x112*x124 - x12*&
                  x129 - x127*x128 - x128*x132 - x130*x131 - x133*x138 - x133* &
                  x139 - x133*x181 - x142*x143 - x144*x149 - x144*x154 - x157* &
                  x158 - x158*x161 - x159*x16 - x16*x160*x77 + x163*x46 + x169*&
                  x43 + x169*x44 + x169*x45 - x169*x46 + x170*x81 - x172*x44 - &
                  x172*x45 - x173*x174 - x175*x177 - x176*x177 - x178*x52 -    &
                  x179*x52 - x183*x81 - x185*x57 - x186*x67 - x186*x68 + x187* &
                  x44 - x187*x46 + x19*x75 + x19*x78 + x22*x30 + x22*x31 + x34*&
                  x36 + x37*x42 + x37*x47 + x42*x94 + x43*x96 + x44*x96 + x47* &
                  x94 + x48*x55 + x48*x64 + x66*x70 + x70*x80 + x81*x87 + x81* &
                  x89 + x92*x93 + x95*x96 + x96*x99
        wout(1) = -P1(0)*co(3)*x130 - P1(1)*P1(2)*P2(2)*co(1)*x35 - P1(1)*P2(2 &
                  )*w1(2)*x175 - P1(1)*x107 + P1(1)*x194 - P1(1)*x207 + P1(1)* &
                  x216 - P1(3)*P2(3)*w2(1)*x180 + P2(1)*x98 - co(0)*x201 + co(1&
                  )*x201 + w2(1)*x105 + w2(1)*x168 - w2(1)*x182 - x100*x113 -  &
                  x100*x116 + x100*x117 - x100*x119 - x100*x122 + x100*x123 +  &
                  x103*x203 - x110*x173 - x111*x173 - x118*x71 - x12*x206 -    &
                  x121*x159 - x124*x71 - x127*x205 - x132*x205 - x138*x91 -    &
                  x139*x91 - x14*x222 - x14*x224 - x140*x183 - x140*x220 - x140&
                  *x223 + x141*x87 + x141*x89 - x143*x209 - x148*x210 - x153*  &
                  x210 + x156*x55 + x156*x64 - x158*x212 - x158*x214 - x160*   &
                  x213 - x162*x200 - x162*x204 + x163*x22 - x165*x185 + x166*  &
                  x185 - x174*x189 - x175*x218 - x185*x68 + x186*x58 + x188*x22&
                   + x189*x202 + x190*x202 + x191*x29 + x192*x21 + x192*x9 +   &
                  x193*x34 + x196*x70 + x197*x70 + x199*x93 + x200*x44 + x200* &
                  x45 - x200*x46 + x200*x99 + x202*x39 - x203*x215 + x204*x95  &
                   + x204*x99 + x217*x218 + x219*x44 + x219*x45 - x219*x46 -   &
                  x221*x76 - x222*x3 + x225*x44 - x225*x46 + x24*x42 + x24*x47 &
                   + x26*x42 + x26*x47 - x28*x42 - x28*x47 - x30*x44 - x30*x45 &
                   - x31*x44 - x31*x45 + x31*x46 + x62*x75 + x62*x78
        wout(2) = -P1(0)*P2(0)*w1(2)*x217 - P1(1)*P2(1)*w2(2)*x180 + P1(2)*P2(0&
                  )*w1(0)*x175 - 2*P1(2)*P2(2)*x181 - P1(2)*x106 - P1(2)*x171  &
                   + P1(2)*x194 - P1(2)*x207 + P1(2)*x216 - P1(3)*P2(3)*w2(2)* &
                  x180 + P1(3)*x228 - co(0)*x231 + co(1)*w1(2)*x38*x74 + co(1)*&
                  x231 + w2(2)*x105 - w2(2)*x182 - x10*x178 - x10*x240 + x100* &
                  x49 + x100*x51 - x100*x54 + x100*x56 + x100*x60 - x100*x63 + &
                  x103*x232 - x110*x198 - x111*x198 + x114*x186 - x118*x155 +  &
                  x120*x186 - x124*x155 - x126*x149 - x126*x154 - x128*x196 -  &
                  x128*x197 - x129*x62 - x131*x62*x77 - x134*x42 - x134*x47 -  &
                  x135*x42 - x135*x47 + x136*x42 + x136*x47 - x137*x191 + x138*&
                  x43 + x138*x45 + x139*x43 + x139*x45 - x139*x46 - x142*x193  &
                   - x15*x185 + x158*x227 + x158*x229 + x159*x59 - x162*x230 - &
                  x162*x233 - x164*x222 + x166*x222 - x175*x237 - x175*x239 -  &
                  x176*x239 - x183*x32 + x19*x206 + x19*x226 + x205*x66 + x205*&
                  x80 + x209*x36 + x21*x211 + x211*x235 + x211*x9 - x215*x232  &
                   + x217*x236 + x217*x237 + x217*x238 - x220*x32 - x223*x32 + &
                  x230*x43 + x230*x45 - x230*x46 + x230*x95 + x230*x99 + x233* &
                  x95 + x233*x99 - x234*x93 + x236*x242 + x238*x242 + x241*x44 &
                   - x241*x46 + x30*x90 + x31*x90 + x33*x87 + x33*x89 + x55*x72&
                   + x64*x72
        wout(3) = P1(1)*P2(1)*w1(3)*x217 - P1(2)*x228 - P1(3)*P2(1)*w1(1)*x175 &
                   - P1(3)*P2(2)*w1(2)*x175 - 2*P1(3)*w1(3)*x178 - P1(3)*x106  &
                   - P1(3)*x107 - P1(3)*x171 + P1(3)*x194 + P2(3)*x98 + w1(3)* &
                  x103*x74 + w2(3)*x105 - w2(3)*x182 - w2(3)*x184 - x100*x145  &
                   - x100*x146 + x100*x147 - x100*x150 - x100*x151 + x100*x152 &
                   - x11*x222 - x11*x224 - x110*x208 - x111*x208 - x118*x65 +  &
                  x121*x129 - x124*x65 + x125*x55 + x125*x64 + x128*x212 + x128&
                  *x214 + x131*x213 - x138*x32 - x139*x32 - x140*x174 + x140*  &
                  x200 + x140*x30 + x140*x31 + x143*x234 - x149*x73 - x154*x73 &
                   - x157*x205 - x16*x206 - x16*x226 - x161*x205 - x162*x170 - &
                  x162*x244 + x163*x81 - x165*x179 + x166*x178 + x170*x44 -    &
                  x170*x46 + x170*x95 + x172*x81 - x18*x185 - x183*x40 - x185* &
                  x6 + x186*x61 + x188*x81 + x189*x243 + x191*x88 + x193*x92 + &
                  x195*x21 + x195*x235 + x195*x9 - x199*x36 + x217*x245 + x217*&
                  x246 - x217*x247 - x220*x44 - x221*x79 - x227*x70 - x229*x70 &
                   - x240*x67 + x242*x245 + x242*x246 - x242*x247 + x243*x38 + &
                  x243*x39 - x243*x41 + x244*x95 + x244*x99 + x42*x83 + x42*x85&
                   - x42*x86 - x43*x87 - x43*x89 - x44*x87 - x44*x89 + x46*x87 &
                   + x47*x83 + x47*x85 - x47*x86 - x59*x75
      case(VVV18)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)/3 - Metric(1,2)*P(-1,2)*P(-1,3)*P
!       (3,1)/3 - Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)/3 - Metric(1,3)*P(-1,2)*P(-1
!       ,3)*P(2,1)/3 - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)/3 - Metric(2,3)*P(-1,1 
!       )*P(-1,3)*P(1,2)/3)
!       c2*(-Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2) + Epsilon(-1,-2,1,2)*P(-1,
!       2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3) - Epsilon(-
!       1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1
!       ,3) - Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2))
        if (last) VB_last = .true.
        x0 = w1(1)*w2(3) - w1(3)*w2(1)
        x1 = w1(0)*w2(1) - w1(1)*w2(0)
        x2 = w1(0)*w2(3) - w1(3)*w2(0)
        x3 = P1(0)*x0 - P1(1)*x2 + P1(3)*x1
        x4 = P1(0)*P2(2)*co(2)
        x5 = P1(0)*co(2)
        x6 = P2(0)*x0 - P2(1)*x2 + P2(3)*x1
        x7 = P2(2)*x6
        x8 = w1(2)*w2(3) - w1(3)*w2(2)
        x9 = w1(0)*w2(2) - w1(2)*w2(0)
        x10 = P1(0)*x8 - P1(2)*x2 + P1(3)*x9
        x11 = P1(1)*P2(0)*co(2)
        x12 = P2(0)*x8 - P2(2)*x2 + P2(3)*x9
        x13 = P2(2)*w2(3) - P2(3)*w2(2)
        x14 = P1(1)*w1(1)
        x15 = P1(2)*w1(2)
        x16 = P1(3)*w1(3)
        x17 = P1(0)*w1(0)
        x18 = x14 + x15 + x16 - x17
        x19 = P1(1)*co(2)*x18
        x20 = P2(2)*w1(2)
        x21 = P2(3)*w1(3)
        x22 = -P2(0)*w1(0) + P2(1)*w1(1) + x20 + x21
        x23 = x22*(P1(1)*w2(3) - P1(3)*w2(1))
        x24 = P1(2)*co(2)
        x25 = P1(2)*w2(2)
        x26 = P1(0)*w2(0)
        x27 = P1(1)*w2(1) + P1(3)*w2(3) + x25 - x26
        x28 = P2(3)*w1(1)
        x29 = P2(1)*w1(3) - x28
        x30 = P1(2)*co(2)*x29
        x31 = P2(1)*w2(1)
        x32 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x31
        x33 = w1(1)*w2(2) - w1(2)*w2(1)
        x34 = P1(0)*x33 - P1(1)*x9 + P1(2)*x1
        x35 = P1(3)*P2(0)*co(2)
        x36 = P2(0)*x33 - P2(1)*x9 + P2(2)*x1
        x37 = P2(1)*w2(2)
        x38 = -P2(2)*w2(1) + x37
        x39 = P1(3)*co(2)*x18
        x40 = P1(1)*w1(3)
        x41 = P1(3)*w1(1)
        x42 = co(2)*x27*(x40 - x41)
        x43 = P2(2)*co(2)*x27
        x44 = co(0)*x27
        x45 = P2(0)**2
        x46 = w1(0)*x45
        x47 = P1(0)*P2(1)*co(2)
        x48 = P1(0)*P2(3)*co(2)
        x49 = P1(2)*w2(3) - P1(3)*w2(2)
        x50 = P1(1)*co(2)
        x51 = P2(2)*w1(3)
        x52 = P2(3)*w1(2)
        x53 = x51 - x52
        x54 = x27*x53
        x55 = x32*x53
        x56 = P1(2)*P2(0)*co(2)
        x57 = P2(1)*w2(3)
        x58 = P2(3)*w2(1)
        x59 = x18*(x57 - x58)
        x60 = P1(2)*w2(1)
        x61 = P1(1)*w2(2) - x60
        x62 = P1(3)*co(2)
        x63 = P2(1)*w1(2)
        x64 = P2(2)*w1(1)
        x65 = x63 - x64
        x66 = x27*x65
        x67 = x32*x65
        x68 = P1(2)*w1(3)
        x69 = -P1(3)*w1(2) + x68
        x70 = P2(1)*co(2)*x27
        x71 = P1(2)*w1(1)
        x72 = P1(1)*w1(2) - x71
        x73 = P2(3)*co(2)*x27
        x74 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x75 = 2*co(1)*x74/3
        x76 = P1(0)**2
        x77 = co(1)*x27/3
        x78 = co(1)*x22*x76/3
        x79 = P2(1)**2
        x80 = P1(0)*co(1)*x74/3
        x81 = P2(2)**2
        x82 = P2(3)**2
        x83 = P1(1)**2
        x84 = P2(0)*co(1)*x74/3
        x85 = P1(2)**2
        x86 = P1(3)**2
        x87 = co(1)*w1(0)*x27/3
        x88 = co(1)*x27*x82/3
        x89 = co(1)*x22*x83/3
        x90 = co(1)*x22*x85/3
        x91 = co(1)*x22*x86/3
        x92 = P2(0)*co(0)*x32
        x93 = P1(0)*w1(1)
        x94 = P2(1)*co(0)*x27
        x95 = P2(1)*co(0)*x32
        x96 = P2(2)*co(0)*w1(2)*x27
        x97 = P2(2)*co(0)*w1(2)*x32
        x98 = P1(0)*w1(3)
        x99 = P2(3)*co(0)*x27
        x100 = P2(3)*co(0)*x32
        x101 = P2(0)*co(0)*x27
        x102 = P2(0)*w1(1)
        x103 = 2*P2(0)*co(1)*x27/3
        x104 = -2*P2(0)*w1(0)/3 + 2*P2(1)*w1(1)/3 + 2*P2(2)*w1(2)/3 + 2*P2(3)* &
        w1(3)/3
        x105 = P2(0)*co(1)*x104
        x106 = -P2(0)*w2(0)/3 + P2(1)*w2(1)/3 + P2(2)*w2(2)/3 + P2(3)*w2(3)/3
        x107 = P2(0)*co(1)*x106
        x108 = P2(0)*co(1)*x18/3
        x109 = P1(1)*P2(1)
        x110 = P1(2)*P2(2)
        x111 = P1(0)*P1(3)*co(1)*x74/3
        x112 = P1(1)*P2(1)*co(1)*w1(0)
        x113 = co(1)*x18/3
        x114 = P1(1)*P2(1)*w2(0)
        x115 = P1(2)*w1(0)
        x116 = P2(2)*co(1)*x106
        x117 = P1(2)*P2(2)*w2(0)
        x118 = P1(3)*P2(3)
        x119 = co(1)*x106
        x120 = P1(3)*P2(3)*w1(0)
        x121 = P2(3)*w2(0)
        x122 = P1(3)*co(1)*x18/3
        x123 = -2*P1(0)*w2(0)/3 + 2*P1(1)*w2(1)/3 + 2*P1(2)*w2(2)/3 + 2*P1(3)* &
        w2(3)/3
        x124 = co(1)*x104
        x125 = 2*P2(2)*co(1)*x27/3
        x126 = 2*co(1)*x27/3
        x127 = P1(3)*co(1)*x104
        x128 = P1(0)*co(2)*x18
        x129 = P1(1)*x8 - P1(2)*x0 + P1(3)*x33
        x130 = P2(1)*x8 - P2(2)*x0 + P2(3)*x33
        x131 = P1(1)*P2(2)*co(2)
        x132 = P1(0)*w2(3)
        x133 = x22*(-P1(3)*w2(0) + x132)
        x134 = P2(3)*w1(0)
        x135 = P2(0)*w1(3) - x134
        x136 = x135*x27
        x137 = P1(2)*co(2)*x32
        x138 = P1(3)*P2(1)*co(2)
        x139 = P2(0)*w2(2) - P2(2)*w2(0)
        x140 = P1(3)*w1(0)
        x141 = -x140 + x98
        x142 = P1(0)*co(2)*x22
        x143 = P1(1)*P2(3)*co(2)
        x144 = P1(2)*P2(1)*co(2)
        x145 = P2(0)*w2(3) - x121
        x146 = P1(2)*co(2)*x18
        x147 = P1(0)*w2(2)
        x148 = x22*(-P1(2)*w2(0) + x147)
        x149 = P2(0)*w1(2)
        x150 = P2(2)*w1(0)
        x151 = x149 - x150
        x152 = x151*x27
        x153 = P1(3)*co(2)*x32
        x154 = P2(0)*co(2)*x27
        x155 = P1(0)*w1(2) - x115
        x156 = P2(3)*co(2)
        x157 = w1(1)*x79
        x158 = P1(1)*co(1)*x74/3
        x159 = P2(1)*co(1)*x74/3
        x160 = co(1)*w1(1)*x27/3
        x161 = P1(1)*P2(0)*w1(0)
        x162 = P2(1)*w1(0)
        x163 = P1(2)*co(0)*x27
        x164 = P2(2)*co(0)*x27
        x165 = 2*P1(0)*co(1)*x27/3
        x166 = P1(0)*P2(0)*w2(1)
        x167 = P1(0)*P2(0)*co(1)*x74/3
        x168 = P1(0)*co(1)*x106
        x169 = P1(2)*P2(2)*co(1)*x74/3
        x170 = P2(1)*co(1)*x106
        x171 = P1(1)*co(1)*x18/3
        x172 = P2(2)*co(1)*x18/3
        x173 = P1(3)*P2(3)*w1(1)
        x174 = 2*P2(1)*co(1)*x27/3
        x175 = P1(1)*co(1)*x104
        x176 = P2(2)*co(1)*x104
        x177 = P1(0)*co(2)*x29
        x178 = P1(3)*P2(2)*co(2)
        x179 = x22*(P1(0)*w2(1) - P1(1)*w2(0))
        x180 = x102 - x162
        x181 = x180*x27
        x182 = -P1(1)*w1(0) + x93
        x183 = P1(1)*co(2)*x32
        x184 = P1(2)*P2(3)*co(2)
        x185 = P2(0)*w2(1) - P2(1)*w2(0)
        x186 = w1(2)*x81
        x187 = P1(2)*co(1)*x74/3
        x188 = P2(2)*co(1)*x74/3
        x189 = co(1)*w1(2)*x27/3
        x190 = P1(1)*P2(1)*co(1)*x74/3
        x191 = P1(1)*P2(1)*co(1)*w1(2)
        x192 = P1(3)*co(1)*x74/3
        x193 = P1(2)*P2(2)*w1(2)
        x194 = P1(3)*P2(3)*w1(2)
        x195 = P1(3)*P2(3)*w2(2)
        x196 = w1(3)*x82
        x197 = P2(3)*co(1)*x74/3
        x198 = co(1)*w1(3)*x27/3
        x199 = co(1)*w2(3)*x22/3
        x200 = P1(2)*P2(2)*w1(3)
        x201 = P1(2)*P2(2)*w2(3)
        x202 = P1(3)*P2(3)*w1(3)
        x203 = P1(3)*P2(3)*w2(3)
        wout(0) = 2*P1(0)*w1(0)*x101 - P1(0)*x45*x75 - P1(0)*x96 - P1(0)*x97 - &
                  P2(0)*x75*x76 + P2(2)*x42 + P2(3)*x111 + w1(0)*x88 - w2(0)*  &
                  x78 + w2(0)*x89 + w2(0)*x90 + w2(0)*x91 + x10*x11 - x10*x47  &
                   - x100*x98 - x101*x14 - x101*x15 - x101*x16 - x101*x20 -    &
                  x101*x21 - x102*x94 - x103*x17 - x105*x26 + x106*x112 - x107*&
                  x17 - x108*x26 + x109*x80 + x109*x84 + x11*x12 + x110*x80 +  &
                  x110*x84 + x112*x123 + x113*x114 + x113*x117 + x114*x124 +   &
                  x115*x116 + x115*x125 + x117*x124 + x118*x84 + x119*x120 -   &
                  x12*x47 + x120*x126 + x121*x122 + x121*x127 + x13*x19 + x17* &
                  x92 - x22*x49*x50 - x22*x61*x62 + x23*x24 - x24*x59 + x27*x30&
                   + x29*x43 + x3*x4 - x3*x56 + x30*x32 + x34*x35 - x34*x48 +  &
                  x35*x36 - x36*x48 + x38*x39 + x44*x46 - x46*x77 + x5*x7 - x50&
                  *x54 - x50*x55 - x53*x70 - x56*x6 - x62*x66 - x62*x67 - x65* &
                  x73 - x69*x70 - x72*x73 + x79*x80 + x79*x87 + x80*x81 + x80* &
                  x82 + x81*x87 + x83*x84 + x84*x85 + x84*x86 - x93*x94 - x93* &
                  x95 - x98*x99
        wout(1) = -2*P1(1)*w1(1)*x94 - P1(1)*x167 + P1(1)*x169 + P1(1)*x75*x79 &
                   - P1(1)*x96 - P1(1)*x97 - P2(1)*x167 + P2(1)*x169 + P2(1)*  &
                  x75*x83 + co(0)*x161*x32 + w1(1)*x88 - w2(1)*x78 + w2(1)*x89 &
                   + w2(1)*x90 + w2(1)*x91 - x100*x40 + x101*x162 - x102*x165  &
                   - x102*x168 + x11*x129 + x11*x130 - x113*x166 + x116*x71 +  &
                  x118*x158 + x118*x159 + x119*x173 + x122*x58 - x124*x166 +   &
                  x125*x71 + x126*x173 + x127*x58 + x128*x13 - x129*x47 - x130*&
                  x47 + x131*x3 + x133*x24 + x135*x137 + x135*x43 + x136*x24 + &
                  x138*x34 + x138*x36 + x139*x39 + x14*x170 + x14*x174 - x14*  &
                  x95 + x141*x43 - x142*x49 - x143*x34 - x143*x36 - x144*x3 -  &
                  x144*x6 - x145*x146 - x148*x62 - x151*x153 - x152*x156 - x152&
                  *x62 - x154*x53 - x154*x69 - x155*x73 - x157*x44 + x157*x77  &
                   - x158*x45 + x158*x81 + x158*x82 - x159*x76 + x159*x85 +    &
                  x159*x86 - x16*x94 - x160*x45 + x160*x81 + x161*x44 - x163*  &
                  x63 - x164*x63 + x17*x94 + x171*x31 + x172*x60 + x175*x31 +  &
                  x176*x60 - x21*x94 - x40*x99 - x5*x54 - x5*x55 + x50*x7
        wout(2) = P1(2)*P2(3)*x192 - P1(2)*x167 + P1(2)*x190 + P1(2)*x75*x81 - &
                  P1(2)*x97 - P1(3)*P2(2)*w1(3)*x44 + P2(0)*x42 - 2*P2(2)*w1(2 &
                  )*x163 - P2(2)*x167 + P2(2)*x75*x85 + w1(2)*x88 - w2(2)*x78  &
                   + w2(2)*x89 + w2(2)*x90 + w2(2)*x91 + x10*x131 - x10*x144 - &
                  x100*x68 + x101*x115 + x101*x150 - x105*x147 + x106*x191 -   &
                  x108*x147 + x109*x188 + x113*x195 + x115*x92 + x118*x188 +   &
                  x119*x193 + x119*x194 + x12*x131 - x12*x144 + x123*x191 +    &
                  x124*x195 + x126*x193 + x126*x194 - x129*x4 + x129*x56 - x130&
                  *x4 + x130*x56 - x133*x50 - x135*x183 - x135*x70 - x136*x50  &
                   - x14*x164 - x141*x70 + x145*x19 - x149*x165 - x149*x168 +  &
                  x153*x180 + x154*x29 + x156*x181 + x164*x17 + x171*x37 + x172&
                  *x25 + x175*x37 + x176*x25 + x177*x27 + x177*x32 + x178*x34  &
                   + x178*x36 + x179*x62 + x181*x62 + x182*x73 - x184*x34 -    &
                  x184*x36 - x185*x39 - x186*x44 + x186*x77 - x187*x45 + x187* &
                  x79 + x187*x82 - x188*x76 + x188*x83 + x188*x86 - x189*x45 + &
                  x189*x79 + x23*x5 - x5*x59 - x51*x99 - x64*x94 - x68*x99 -   &
                  x71*x94 - x71*x95
        wout(3) = -2*P1(3)*w1(3)*x99 + P1(3)*x169 + P1(3)*x190 + P1(3)*x75*x82 &
                   - P1(3)*x96 - P1(3)*x97 - P2(0)*x111 + P2(1)*co(2)*x152 - P2&
                  (2)*co(2)*x181 - P2(3)*x167 + P2(3)*x169 + P2(3)*x190 + P2(3 &
                  )*x75*x86 - x10*x138 + x10*x143 - x100*x16 + x101*x134 + x101&
                  *x140 - x103*x98 - x105*x132 - x107*x98 - x108*x132 + x113*  &
                  x201 + x113*x203 + x119*x200 + x119*x202 - x12*x138 + x12*   &
                  x143 + x124*x201 + x124*x203 + x126*x200 + x126*x202 + x128* &
                  x38 + x129*x35 - x129*x48 + x130*x35 - x130*x48 - x137*x180  &
                   - x139*x19 - x14*x99 + x140*x92 - x142*x61 + x146*x185 +    &
                  x148*x50 + x151*x183 + x152*x50 - x154*x65 - x154*x72 + x155*&
                  x70 - x163*x52 - x164*x52 + x17*x99 + x170*x40 + x171*x57 +  &
                  x174*x40 + x175*x57 + x178*x3 - x179*x24 - x181*x24 - x182*  &
                  x43 - x184*x3 - x184*x6 - x192*x45 + x192*x79 + x192*x81 -   &
                  x196*x44 + x196*x77 - x197*x76 + x197*x83 + x197*x85 - x198* &
                  x45 + x198*x79 + x198*x81 - x199*x76 + x199*x83 + x199*x85 + &
                  x199*x86 - x28*x94 - x41*x94 - x41*x95 - x5*x66 - x5*x67 +   &
                  x62*x7
      case(VVV19)
!       c0*(P(1,2)*P(2,3)*P(3,1) + P(1,3)*P(2,1)*P(3,2))
!       c1*(Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,2)*P(-1,2)*P(-1,3)*P(3,
!       1) + Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3) - Metric(1,3)*P(-1,2)*P(-1,3)*P(2
!       ,1) - Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3) - Metric(2,3)*P(-1,1)*P(-1,3)*P(
!       1,2))
!       c2*(-Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3) + Epsilon(-1
!       ,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3))
!       c3*(Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1) - Epsilon(-1,-2,1,3)*P(-1,2
!       )*P(-2,3)*P(2,1) + Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3) - Epsilon(-1
!       ,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2) + Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,
!       3) - Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)**2
        x5 = co(3)*x4
        x6 = P1(1)**2
        x7 = co(3)*x6
        x8 = P1(2)**2
        x9 = co(3)*x8
        x10 = P1(3)**2
        x11 = co(3)*x10
        x12 = co(3)*x3
        x13 = P1(0)*P2(2)
        x14 = w1(0)*w2(1) - w1(1)*w2(0)
        x15 = w1(0)*w2(3) - w1(3)*w2(0)
        x16 = P1(0)*x2 - P1(1)*x15 + P1(3)*x14
        x17 = co(3)*x16
        x18 = P2(0)*x2 - P2(1)*x15 + P2(3)*x14
        x19 = co(3)*x18
        x20 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x21 = P1(0)*x20
        x22 = P2(1)**2
        x23 = co(1)*x22
        x24 = P2(2)**2
        x25 = co(1)*x24
        x26 = P2(3)**2
        x27 = co(1)*x26
        x28 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x29 = P1(1)*P2(1)*co(3)
        x30 = P1(1)*w1(0)
        x31 = P1(3)*w2(2)
        x32 = P1(2)*w2(3) - x31
        x33 = P1(0)*w2(2)
        x34 = P1(2)*w2(0)
        x35 = x33 - x34
        x36 = P1(0)*w2(3)
        x37 = -P1(3)*w2(0) + x36
        x38 = co(2)*(P2(0)*x32 - P2(2)*x37 + P2(3)*x35)
        x39 = P2(2)*w2(3) - P2(3)*w2(2)
        x40 = P2(0)*w2(2) - P2(2)*w2(0)
        x41 = P2(3)*w2(0)
        x42 = P2(0)*w2(3) - x41
        x43 = co(2)*(P2(0)*x39 - P2(2)*x42 + P2(3)*x40)
        x44 = P1(1)*w1(1)
        x45 = P1(2)*w1(2)
        x46 = P1(3)*w1(3)
        x47 = P1(0)*w1(0)
        x48 = x44 + x45 + x46 - x47
        x49 = P1(1)*co(3)*x48
        x50 = P1(2)*P2(2)
        x51 = co(3)*x28
        x52 = P1(1)*P2(3)
        x53 = P1(3)*P2(1)
        x54 = x52 - x53
        x55 = P1(2)*co(2)*x20
        x56 = P1(1)*w2(3) - P1(3)*w2(1)
        x57 = P2(2)*w1(2)
        x58 = P2(3)*w1(3)
        x59 = -P2(0)*w1(0) + P2(1)*w1(1) + x57 + x58
        x60 = P1(2)*co(3)*x59
        x61 = P1(3)*P2(3)*co(3)
        x62 = P1(3)*w1(0)
        x63 = P1(1)*w2(2)
        x64 = P1(2)*w2(1)
        x65 = x63 - x64
        x66 = P1(1)*w2(0)
        x67 = P1(0)*w2(1) - x66
        x68 = co(2)*(P2(0)*x65 - P2(1)*x35 + P2(2)*x67)
        x69 = P2(1)*w2(2) - P2(2)*w2(1)
        x70 = P2(0)*w2(1) - P2(1)*w2(0)
        x71 = co(2)*(P2(0)*x69 - P2(1)*x40 + P2(2)*x70)
        x72 = P1(3)*co(3)*x48
        x73 = P1(1)*w1(3)
        x74 = P1(3)*w1(1)
        x75 = x73 - x74
        x76 = P1(2)*w2(2)
        x77 = P1(3)*w2(3)
        x78 = P1(0)*w2(0)
        x79 = P1(1)*w2(1) + x76 + x77 - x78
        x80 = P2(2)*co(3)*x79
        x81 = P2(3)*w1(1)
        x82 = P2(1)*w1(3) - x81
        x83 = P2(0)**2
        x84 = w1(0)*x79*x83
        x85 = w1(0)*x79
        x86 = co(1)*w2(0)*x59
        x87 = w1(0)*w2(2) - w1(2)*w2(0)
        x88 = P1(0)*x0 - P1(2)*x15 + P1(3)*x87
        x89 = P1(0)*P2(1)*co(3)
        x90 = P2(0)*x0 - P2(2)*x15 + P2(3)*x87
        x91 = P1(0)*x1 - P1(1)*x87 + P1(2)*x14
        x92 = P1(0)*P2(3)*co(3)
        x93 = P2(0)*x1 - P2(1)*x87 + P2(2)*x14
        x94 = P2(1)*x32 - P2(2)*x56 + P2(3)*x65
        x95 = P1(0)*co(2)*w1(0)
        x96 = P2(1)*w2(3)
        x97 = P2(3)*w2(1)
        x98 = x96 - x97
        x99 = P2(1)*x39 - P2(2)*x98 + P2(3)*x69
        x100 = P1(2)*P2(3)
        x101 = P1(3)*P2(2)
        x102 = x100 - x101
        x103 = P1(1)*co(2)*x20
        x104 = P1(1)*co(3)*x59
        x105 = P1(2)*w1(0)
        x106 = co(2)*(P2(0)*x56 - P2(1)*x37 + P2(3)*x67)
        x107 = co(2)*(P2(0)*x98 - P2(1)*x42 + P2(3)*x70)
        x108 = P1(2)*co(3)*x48
        x109 = P1(1)*P2(2)
        x110 = P1(2)*P2(1)
        x111 = x109 - x110
        x112 = P1(3)*co(2)*x20
        x113 = P1(3)*co(3)*x59
        x114 = P2(0)*co(1)*x20
        x115 = co(1)*x20*x8
        x116 = P1(2)*w1(3)
        x117 = P1(3)*w1(2)
        x118 = x116 - x117
        x119 = P2(1)*co(3)*x79
        x120 = P2(2)*w1(3)
        x121 = P2(3)*w1(2)
        x122 = x120 - x121
        x123 = P1(1)*w1(2)
        x124 = P1(2)*w1(1)
        x125 = x123 - x124
        x126 = P2(3)*co(3)*x79
        x127 = P2(1)*w1(2)
        x128 = P2(2)*w1(1)
        x129 = x127 - x128
        x130 = P1(0)*P2(1)
        x131 = P1(1)*co(1)*x20
        x132 = P1(2)*co(1)*x20
        x133 = P1(0)*P2(3)
        x134 = P1(3)*co(1)*x20
        x135 = P2(1)*w2(1)
        x136 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x135
        x137 = P2(0)*co(0)*x136
        x138 = P2(0)*co(1)*x136
        x139 = P2(1)*co(1)*x48
        x140 = P2(2)*co(1)*x48
        x141 = P1(3)*co(1)*x48
        x142 = P2(0)*co(1)*x48
        x143 = co(0)*w1(1)*x79
        x144 = co(0)*x136
        x145 = co(0)*x79
        x146 = P2(2)*co(0)*w1(2)*x136
        x147 = P1(0)*w1(3)
        x148 = P2(3)*co(0)*x79
        x149 = P2(3)*co(0)*x136
        x150 = P1(1)*P2(0)
        x151 = P2(1)*co(1)*x20
        x152 = P1(1)*co(0)*w1(1)*x79
        x153 = P2(1)*w1(0)
        x154 = P1(1)*co(1)*x136
        x155 = P1(2)*P2(0)
        x156 = P2(2)*co(1)*x20
        x157 = w1(2)*x79
        x158 = P2(2)*co(1)*x136
        x159 = P1(3)*P2(0)
        x160 = P2(3)*co(1)*x20
        x161 = co(0)*w1(3)*x79
        x162 = P2(3)*co(1)*x136
        x163 = P2(0)*w1(1)
        x164 = P2(1)*co(0)*x79
        x165 = P2(0)*co(0)*x79
        x166 = 2*P2(0)*co(1)*x59
        x167 = 2*P2(1)*co(1)*x59
        x168 = 2*P2(2)*co(1)*x59
        x169 = 2*P1(3)*co(1)*x59
        x170 = P1(0)*co(3)*x48
        x171 = co(1)*x20*x24
        x172 = co(1)*x20*x26
        x173 = co(3)*x88
        x174 = x133 - x159
        x175 = x147 - x62
        x176 = P2(3)*w1(0)
        x177 = P2(0)*w1(3) - x176
        x178 = w1(1)*x79
        x179 = co(1)*w2(1)*x59
        x180 = P1(0)*P2(0)*co(3)
        x181 = P1(0)*w1(1)
        x182 = co(2)*x94
        x183 = co(2)*x99
        x184 = P1(0)*co(2)*x20
        x185 = P1(0)*co(3)*x59
        x186 = co(3)*x91
        x187 = co(3)*x93
        x188 = co(1)*x20*x83
        x189 = x42*x48
        x190 = x13 - x155
        x191 = P2(0)*co(3)*x79
        x192 = P1(0)*w1(2)
        x193 = -x105 + x192
        x194 = P2(0)*w1(2)
        x195 = P2(2)*w1(0)
        x196 = x194 - x195
        x197 = co(1)*x79*x83
        x198 = P1(0)*co(1)*x136
        x199 = co(0)*w1(0)*x79
        x200 = co(0)*w1(0)*x136
        x201 = P1(1)*co(1)*x48
        x202 = P1(0)*co(1)*x20
        x203 = co(1)*x48
        x204 = P1(0)*P2(0)*w2(1)
        x205 = P2(1)*co(0)*x136
        x206 = P2(1)*co(1)*x136
        x207 = P1(1)*P2(2)*w1(2)
        x208 = co(0)*w1(3)*x136
        x209 = P1(2)*co(0)*x79
        x210 = P1(3)*co(1)*x136
        x211 = P2(2)*co(0)*x79
        x212 = 2*co(1)*x59
        x213 = 2*P1(1)*co(1)*x59
        x214 = co(1)*x20*x22
        x215 = x130 - x150
        x216 = x181 - x30
        x217 = -x153 + x163
        x218 = w1(2)*x24*x79
        x219 = co(1)*w2(2)*x59
        x220 = co(3)*x90
        x221 = P2(3)*co(1)*x48
        x222 = P1(2)*co(1)*x136
        x223 = P1(3)*co(0)*x79
        x224 = 2*P2(3)*co(1)*x59
        x225 = co(1)*w1(3)*x79
        x226 = co(1)*w2(3)*x59
        x227 = P1(2)*P2(2)*w2(3)
        wout(0) = P1(0)*P2(0)*x12 - P1(0)*P2(1)*w1(1)*x144 - P1(0)*P2(2)*w1(2)*&
                  x145 + 2*P1(0)*w1(0)*x165 - P1(0)*x146 - P1(2)*P2(0)*co(0)*  &
                  x157 - P2(0)*x115 - P2(0)*x152 + co(0)*x84 - co(1)*x84 - x10*&
                  x114 + x10*x86 - x102*x103 - x104*x32 - x105*x106 - x105*x107&
                   - x105*x158 - x108*x98 - x11*x3 - x111*x112 - x113*x65 -    &
                  x114*x6 - x118*x119 - x119*x122 - x125*x126 - x126*x129 + x13&
                  *x132 + x13*x17 + x13*x19 + x130*x131 - x130*x143 + x133*x134&
                   + x137*x47 + x138*x47 + x139*x66 + x140*x34 + x141*x41 -    &
                  x142*x78 - x147*x148 - x147*x149 - x150*x151 - x153*x154 -   &
                  x155*x156 - x159*x160 - x159*x161 - x162*x62 - x163*x164 -   &
                  x165*x57 - x165*x58 - x166*x78 + x167*x66 + x168*x34 + x169* &
                  x41 + x21*x23 + x21*x25 + x21*x27 + x23*x85 + x25*x85 + x27* &
                  x85 + x28*x29 + x28*x61 + x3*x5 - x3*x7 - x3*x9 + x30*x38 +  &
                  x30*x43 + x39*x49 - x4*x86 + x50*x51 + x54*x55 + x56*x60 + x6&
                  *x86 + x62*x68 + x62*x71 + x69*x72 + x75*x80 + x8*x86 + x80* &
                  x82 - x88*x89 - x89*x90 - x91*x92 - x92*x93 - x94*x95 - x95* &
                  x99
        wout(1) = -2*P1(1)*w1(1)*x164 + P1(1)*x171 + P1(1)*x172 - P1(1)*x188 - &
                  P1(2)*co(3)*x189 - P2(1)*x115 - w1(1)*x197 - x10*x151 + x10* &
                  x179 - x102*x184 - x106*x124 - x107*x124 + x109*x132 + x109* &
                  x17 + x109*x19 - x11*x90 - x110*x156 - x112*x190 - x113*x35  &
                   + x114*x130 - x118*x191 + x12*x150 - x122*x191 - x124*x158  &
                   - x126*x193 - x126*x196 - x127*x209 - x127*x211 + x134*x52  &
                   + x135*x201 + x135*x213 + x140*x64 + x141*x97 - x143*x22 -  &
                  x144*x207 - x145*x207 + x150*x199 + x150*x200 - x150*x202 +  &
                  x150*x51 + x151*x4 + x153*x165 - x160*x53 - x161*x52 + x163* &
                  x198 - x164*x46 + x164*x47 - x164*x58 + x168*x64 + x169*x97  &
                   + x170*x39 + x173*x50 + x174*x55 + x175*x80 + x177*x80 +    &
                  x178*x23 + x178*x25 + x178*x27 - x179*x4 + x179*x6 + x179*x8 &
                   - x180*x88 - x181*x182 - x181*x183 - x185*x32 - x186*x52 -  &
                  x187*x52 - x203*x204 - x204*x212 - x205*x44 - x206*x44 - x208&
                  *x52 - x210*x81 - x29*x90 + x37*x60 + x38*x44 + x40*x72 + x43&
                  *x44 + x5*x90 + x61*x88 + x68*x74 - x7*x90 + x71*x74 - x9*x90
        wout(2) = P1(1)*co(3)*x189 - P1(2)*x146 + P1(2)*x172 - P1(2)*x188 + P1(&
                  2)*x214 - 2*P2(2)*w1(2)*x209 - co(0)*x218 - co(1)*x157*x83 + &
                  co(1)*x218 - x10*x156 + x10*x219 + x100*x134 - x100*x161 -   &
                  x100*x186 - x100*x187 - x100*x208 - x101*x160 - x103*x174 -  &
                  x104*x37 + x105*x137 + x105*x165 - x106*x45 - x107*x45 - x109&
                  *x151 + x11*x18 + x110*x131 - x110*x173 - x110*x220 + x112*  &
                  x215 + x113*x67 + x114*x13 + x117*x68 + x117*x71 - x119*x175 &
                   - x119*x177 + x12*x155 - x120*x148 - x120*x223 - x121*x210  &
                   + x123*x38 + x123*x43 - x124*x164 - x124*x205 + x126*x216 + &
                  x126*x217 - x127*x154 - x128*x164 + x139*x63 + x140*x76 -    &
                  x142*x33 - x155*x202 + x155*x51 + x156*x4 - x156*x6 + x157*  &
                  x23 + x157*x27 + x16*x180 - x16*x29 - x16*x61 + x165*x195 -  &
                  x166*x33 + x167*x63 + x168*x76 - x170*x98 - x18*x5 + x18*x7  &
                   + x18*x9 - x182*x192 - x183*x192 + x184*x54 + x185*x56 + x19&
                  *x50 + x191*x75 + x191*x82 + x194*x198 - x211*x44 + x211*x47 &
                   - x219*x4 + x219*x6 + x219*x8 + x221*x31 - x222*x57 + x224* &
                  x31 - x70*x72
        wout(3) = -2*P1(3)*w1(3)*x148 - P1(3)*x146 + P1(3)*x171 - P1(3)*x188 + &
                  P1(3)*x214 - P2(3)*x115 - P2(3)*x152 - w1(3)*x197 + w1(3)*x27&
                  *x79 + x10*x226 - x100*x156 + x101*x132 + x101*x17 + x101*x19&
                   + x103*x190 + x104*x35 - x106*x116 - x107*x116 + x108*x70 - &
                  x11*x93 - x111*x184 + x114*x133 + x119*x193 + x119*x196 + x12&
                  *x159 - x120*x222 - x121*x209 - x121*x211 - x125*x191 - x129*&
                  x191 + x131*x53 + x138*x147 - x142*x36 - x147*x182 - x147*   &
                  x183 + x148*x47 - x149*x46 - x151*x52 + x159*x199 + x159*x200&
                   - x159*x202 + x159*x51 + x160*x4 - x160*x6 - x161*x26 - x162&
                  *x46 - x164*x74 - x164*x81 + x165*x176 - x166*x36 + x170*x69 &
                   - x173*x53 - x180*x91 - x185*x65 + x186*x50 + x201*x96 +    &
                  x203*x227 - x205*x74 - x206*x73 + x212*x227 + x213*x96 - x215&
                  *x55 - x216*x80 - x217*x80 + x22*x225 - x220*x53 + x221*x77  &
                   - x223*x57 + x224*x77 + x225*x24 - x226*x4 + x226*x6 + x226*&
                  x8 + x29*x91 + x38*x73 - x40*x49 + x43*x73 + x46*x68 + x46*  &
                  x71 + x5*x93 - x60*x67 - x61*x93 - x7*x93 - x9*x93
      end select 
    end subroutine treeVVV
end module tcVVV
